#define MOTOROLA_DSP 1

/* Names to predefine in the preprocessor for this target machine.  */

#define CPP_PREDEFINES "-D" TARGET_PREDEF " -DMOTOROLA_DSP"

/* Print subsidiary information on the compiler version in use.  */
#define TARGET_VERSION fprintf ( stderr, " Motorola " TARGET_NAME " %s", \
				motorola_version_string );

/* Turn on debugging output */

#define SDB_DEBUGGING_INFO

/* Run-time compilation parameters selecting different hardware subsets. */
extern int target_flags;

/* Define this if most significant bit is lowest numbered
   in instructions that operate on numbered bit-fields.  */
#undef BITS_BIG_ENDIAN

/* Define this if most significant byte of a word is the lowest numbered.  */
/* has no byte address but if it did they would look like 3..2..1..0 */
#undef BYTES_BIG_ENDIAN

/* Define this if most significant word of a multiword object has the lowest
   is number. */
#undef WORDS_BIG_ENDIAN 

/* number of bits in an addressible storage unit. */

#if defined( DSP56000 ) || defined( DSP56300 )

#define BITS_PER_UNIT 24
#define CHAR_TYPE_SIZE 24
#define SHORT_TYPE_SIZE 24
#define EXTENDED_TYPE_SIZE 32
#define LONG_TYPE_SIZE 48
#define LONG_LONG_TYPE_SIZE LONG_TYPE_SIZE
#define FLOAT_TYPE_SIZE (( 'l' == memory_model ) ? 24 : 48 )
#define DOUBLE_TYPE_SIZE FLOAT_TYPE_SIZE
#define LONG_DOUBLE_TYPE_SIZE DOUBLE_TYPE_SIZE
#define EXTENDED_LONG_TYPE_SIZE 56

/* Width in bits of a "word", which is the contents of a machine register.
   Note that this is not necessarily the width of data type `int';
   if using 16-bit ints on a 68000, this would still be 32.
   But on a machine with 16-bit registers, this would be 16.  */
#define BITS_PER_WORD 24

#elif defined( DSP56600 )

#define BITS_PER_UNIT 16
#define CHAR_TYPE_SIZE 16
#define SHORT_TYPE_SIZE 16
#define EXTENDED_TYPE_SIZE 24
#define LONG_TYPE_SIZE 32
#define LONG_LONG_TYPE_SIZE LONG_TYPE_SIZE
#define FLOAT_TYPE_SIZE (( 'l' == memory_model ) ? 16 : 32 )
#define DOUBLE_TYPE_SIZE FLOAT_TYPE_SIZE
#define LONG_DOUBLE_TYPE_SIZE DOUBLE_TYPE_SIZE
#define EXTENDED_LONG_TYPE_SIZE 40

/* Width in bits of a "word", which is the contents of a machine register.
   Note that this is not necessarily the width of data type `int';
   if using 16-bit ints on a 68000, this would still be 32.
   But on a machine with 16-bit registers, this would be 16.  */
#define BITS_PER_WORD 16

#elif defined( DSP56100 ) || defined( DSP56400 )

#define BITS_PER_UNIT 16
#define CHAR_TYPE_SIZE 16
#define SHORT_TYPE_SIZE 16
#define LONG_TYPE_SIZE 32
#define LONG_LONG_TYPE_SIZE LONG_TYPE_SIZE
#define FLOAT_TYPE_SIZE 32
#define DOUBLE_TYPE_SIZE FLOAT_TYPE_SIZE
#define LONG_DOUBLE_TYPE_SIZE DOUBLE_TYPE_SIZE

/* Width in bits of a "word", which is the contents of a machine register.
   Note that this is not necessarily the width of data type `int';
   if using 16-bit ints on a 68000, this would still be 32.
   But on a machine with 16-bit registers, this would be 16.  */
#define BITS_PER_WORD 16

#elif defined( DSP96000 )

/* number of bits in an addressible storage unit. m96k has word addressing */
#define BITS_PER_UNIT 32
#define BITS_PER_WORD 32
#define CHAR_TYPE_SIZE 32
#define SHORT_TYPE_SIZE 32
#define FLOAT_TYPE_SIZE 31
#define DOUBLE_TYPE_SIZE (( 'l' == memory_model ) ? 32 : 64 )
#define LONG_DOUBLE_TYPE_SIZE DOUBLE_TYPE_SIZE
/* long long is turned off in the front end. */
#define LONG_LONG_TYPE_SIZE 64

/* Width in bits of a "word", which is the contents of a machine register.
   Note that this is not necessarily the width of data type `int';
   if using 16-bit ints on a 68000, this would still be 32.
   But on a machine with 16-bit registers, this would be 16.  */
#define BITS_PER_WORD 32

#endif

/* Width of a word, in units (bytes).  */
#define UNITS_PER_WORD 1

/* Width in bits of a pointer.
   See also the macro `Pmode' defined below.  */

#if defined( DSP56600 ) || defined( DSP56000 ) || defined( DSP56100 ) || defined( DSP56400 )

#define POINTER_SIZE 16

#elif defined( DSP56300 )

#define POINTER_SIZE 24

#elif defined( DSP96000 )

#define POINTER_SIZE 32

#endif

#if defined( DSP56000 ) || defined( DSP56300 )

/* Allocation boundary (in *bits*) for storing pointers in memory.  */
#define POINTER_BOUNDARY 24

/* Allocation boundary (in *bits*) for storing arguments in argument list.  */
#define PARM_BOUNDARY 24

/* Allocation boundary (in *bits*) for the code of a function.  */
#define FUNCTION_BOUNDARY 24

/* Alignment of field after `int : 0' in a structure.  */
#define EMPTY_FIELD_BOUNDARY 24

/* No data type wants to be aligned rounder than this.  */
#define BIGGEST_ALIGNMENT 24

#elif defined( DSP56600 ) || defined( DSP56100 ) || defined( DSP56400 )

/* Allocation boundary (in *bits*) for storing pointers in memory.  */
#define POINTER_BOUNDARY 16

/* Allocation boundary (in *bits*) for storing arguments in argument list.  */
#define PARM_BOUNDARY 16

/* Allocation boundary (in *bits*) for the code of a function.  */
#define FUNCTION_BOUNDARY 16

/* Alignment of field after `int : 0' in a structure.  */
#define EMPTY_FIELD_BOUNDARY 16

/* No data type wants to be aligned rounder than this.  */
#define BIGGEST_ALIGNMENT 16

#elif defined( DSP96000 )

/* Allocation boundary (in *bits*) for storing pointers in memory.  */
#define POINTER_BOUNDARY 32

/* Allocation boundary (in *bits*) for storing arguments in argument list.  */
#define PARM_BOUNDARY 32

/* Allocation boundary (in *bits*) for the code of a function.  */
#define FUNCTION_BOUNDARY 32

/* Alignment of field after `int : 0' in a structure.  */
#define EMPTY_FIELD_BOUNDARY 32

/* No data type wants to be aligned rounder than this.  */
#define BIGGEST_ALIGNMENT 32

#endif

/* the maximum nesting depth of do-loops allowed. */
#define MAX_DO_LOOP_NESTING 3

/* Define this if move instructions will actually fail to work
   when given unaligned data.  */
#define STRICT_ALIGNMENT
#define PCC_BITFIELD_TYPE_MATTERS "?"

/* Value is 1 if hard register REGNO can hold a value of machine-mode MODE. */

#define HARD_REGNO_MODE_OK( REGNO, MODE )		\
	hard_regno_mode_ok( REGNO, MODE )

/* Value is 1 if it is a good idea to tie two pseudo registers
   when one has mode MODE1 and one has mode MODE2.
   If HARD_REGNO_MODE_OK could produce different values for MODE1 and MODE2,
   for any hard reg, then this must be 0 for correct output.  */

#define MODES_TIEABLE_P(MODE1, MODE2) \
    modes_tieable_p( MODE1, MODE2 )

/* Specify the registers used for certain standard purposes.
   The values of these macros are register numbers.  */
#undef PC_REGNUM

/* Value should be nonzero if functions must have frame pointers.
   Zero means the frame pointer need not be set up (and parms
   may be accessed via the stack pointer) in functions that seem suitable.
   This is computed in `reload', in reload1.c.  */
#define FRAME_POINTER_REQUIRED 1

/* Base register for access to arguments of the function.  */
#define ARG_POINTER_REGNUM FRAME_POINTER_REGNUM

#define N_REG_CLASSES (int) LIM_REG_CLASSES

#define REGNO_REG_CLASS(REGNO)	 \
	regno_reg_class ( REGNO )

/* Get reg_class from a letter such as appears in the machine description.  */

#define REG_CLASS_FROM_LETTER(C)				\
	reg_class_from_letter( C )

/* Given an rtx X being reloaded into a reg required to be
   in class CLASS, return the class of reg to actually use.
   In general this is just CLASS; but on some machines
   in some cases it is preferable to use a more restrictive class.  */
#define PREFERRED_RELOAD_CLASS(X,CLASS) CLASS

/* Return the maximum number of consecutive registers
   needed to represent mode MODE in a register of class CLASS.  */

#define CLASS_MAX_NREGS(CLASS,MODE)					\
	class_max_nregs ( CLASS, MODE )

/* Stack layout; function entry, exit and calling.  */

#define PUSH_ARGS_REVERSED

/* Define this if pushing a word on the stack
   makes the stack pointer a smaller address.  */
#undef STACK_GROWS_DOWNWARD

/* Define this if the nominal address of the stack frame
   is at the high-address end of the local variables;
   that is, each additional local variable allocated
   goes at a more negative offset in the frame. */

#undef FRAME_GROWS_DOWNWARD 

/* Offset within stack frame to start allocating local variables at.
   If FRAME_GROWS_DOWNWARD, this is the offset to the END of the
   first local allocated.  Otherwise, it is the offset to the BEGINNING
   of the first local allocated.  */
#define STARTING_FRAME_OFFSET 0

/* If we generate an insn to push BYTES bytes,
   this says how many the stack pointer really advances by. */
#define PUSH_ROUNDING(BYTES) ( BYTES )

/* If BYTES is the size of arguments for a function call,
   return the size of the argument block (which is BYTES suitably rounded).
   Define this only on machines where the entire call block is allocated
   before the args are stored into it.  */
   
#undef ROUND_CALL_BLOCK_SIZE

/* Value is 1 if returning from a function call automatically
   pops the arguments described by the number-of-args field in the call.
   FUNTYPE is the data type of the function (as a tree),
   or for a library call it is an identifier node for the subroutine name.  */

#define RETURN_POPS_ARGS(FUNTYPE) 1

/* This macro generates the assembly code for function entry.
   FILE is a stdio stream to output the code to.
   SIZE is an int: how many units of temporary storage to allocate.
   Refer to the array `regs_ever_live' to determine which registers
   to save; `regs_ever_live[I]' is nonzero if register number I
   is ever used in the function.  This macro is responsible for
   knowing which registers should not be saved even if used.  */

#define FUNCTION_PROLOGUE(FILE, SIZE) function_logue ( FILE, SIZE, 0 )

/* Output assembler code to FILE to increment profiler label # LABELNO
   for profiling a function entry. */

#define FUNCTION_PROFILER(FILE, LABELNO) 

/* EXIT_IGNORE_STACK should be nonzero if, when returning from a function,
   the stack pointer does not matter.  The value is tested only in
   functions that have frame pointers.
   No definition is equivalent to always zero.  */

#define EXIT_IGNORE_STACK 0

/* This macro generates the assembly code for function exit,
   on machines that need it.  If FUNCTION_EPILOGUE is not defined
   then individual return instructions are generated for each
   return statement.  Args are same as for FUNCTION_PROLOGUE.

   The function epilogue should not depend on the current stack pointer!
   It should use the frame pointer only.  This is mandatory because
   of alloca; we also take advantage of it to omit stack adjustments
   before returning.  */

#define FUNCTION_EPILOGUE(FILE, SIZE) function_logue ( FILE, SIZE, 1 )

/* Nonzero if access to memory by bytes is slow and undesirable.  */
#if defined( DSP56000 ) || defined( DSP56300 ) || defined( DSP56600 ) || defined( DSP96000 )
#define SLOW_BYTE_ACCESS 1
#elif defined( DSP56100 ) || defined( DSP56400 )
#define SLOW_BYTE_ACCESS 0
#endif

/* Do not break .stabs pseudos into continuations.  */
#define DBX_CONTIN_LENGTH 0

/* We assume that the store-condition-codes instructions store 0 for false
   and some other value for true.  This is the value stored for true.  */

#define STORE_FLAG_VALUE 1

/* Define this if addresses of constant functions
   shouldn't be put through pseudo regs where they can be cse'd.
   Desirable on machines where ordinary constants are expensive
   but a CALL with constant address is cheap.  */
#undef NO_FUNCTION_CSE

/* Store in cc_status the expressions
   that the condition codes will describe
   after execution of an instruction whose pattern is EXP.
   Do not alter them if the instruction would not alter the cc's.  */

#define NOTICE_UPDATE_CC(EXP, INSN) notice_update_cc ( EXP, INSN )

#if ! defined( HAVE_UNSIGNED_BRANCH_CODES )

enum mdep_cc_info { CC_UNKNOWN, CC_UNSIGNED, CC_SIGNED };
#define CC_STATUS_MDEP enum mdep_cc_info
#define CC_STATUS_MDEP_INIT CC_UNKNOWN

#endif

/* Control the assembler format that we output.  */

/* Output at beginning of assembler file.  */

#define ASM_FILE_START(FILE) asm_file_start ( FILE ) 

#define ASM_FILE_END(FILE) asm_file_end ( FILE )

/* Output to assembler file text saying following lines
   may contain character constants, extra white space, comments, etc.  */
extern char* asm_app_toggle ();
#define ASM_APP_ON asm_app_toggle ()

/* Output to assembler file text saying following lines
   no longer contain unusual constructs.  */

#define MAX_TEXT_ALIGN 1

#define ASM_APP_OFF asm_app_toggle ()

#define SELECT_RTX_SECTION(MODE,X)\
{\
    data_section ( );\
}

#define SELECT_SECTION(DECL)\
{\
    if ( FUNCTION_DECL == TREE_CODE ( DECL ))\
    {\
	text_section ( );\
    }\
    else\
    {\
	data_section ( );\
    }\
}


/* Output before read-only data.  */

char *text_section_asm_op ( );
#define TEXT_SECTION_ASM_OP text_section_asm_op ( )

/* Output before writable data.  */

char *data_section_asm_op ( );
#define DATA_SECTION_ASM_OP data_section_asm_op ( )

/* Output before run-time initialization addresses. */

char *rti_section_asm_op ( );
#define RTI_SECTION_ASM_OP rti_section_asm_op ( )

#define DBX_REGISTER_NUMBER(REGNO) (REGNO)

/* This is how to output the definition of a user-level label named NAME,
   such as the label on a static function or variable NAME.  */

#define ASM_IDENTIFY_GCC(FILE) fprintf \
    ( FILE, ";*** " TARGET_NAME " %s GNU %s\n", \
     motorola_version_string, version_string );

#define ASM_OUTPUT_LABEL(FILE,NAME)	\
  do { assemble_name (FILE, NAME); fputs ("\n", FILE); } while (0)

/* This is how to output a command to make the user-level label named NAME
   defined for reference from other files.  */

#define ASM_GLOBALIZE_LABEL(FILE,NAME)	\
( fputs ("\tglobal\t", FILE), assemble_name (FILE, NAME), fputs ("\n", FILE) )

/* This is how to output a reference to a user-level label named NAME.
   `assemble_name' uses this.  */

#define ASM_OUTPUT_LABELREF(FILE,NAME)	\
  fprintf (FILE, "F%s", NAME)

/* This is how to output an internal numbered label where
   PREFIX is the class of label and NUM is the number within the class.  */

#define ASM_OUTPUT_INTERNAL_LABEL(FILE,PREFIX,NUM)	\
  fprintf (FILE, "%s%d\n", PREFIX, NUM)

/* This is how to store into the string LABEL
   the symbol_ref name of an internal numbered label where
   PREFIX is the class of label and NUM is the number within the class.
   This is suitable for output with `assemble_name'.  */

#define ASM_GENERATE_INTERNAL_LABEL(LABEL,PREFIX,NUM)	\
  sprintf (LABEL, "*%s%d", PREFIX, NUM)

#if defined( DSP96000 )

/* This is how to output an assembler line defining a `double' constant.  */

#define ASM_OUTPUT_DOUBLE(FILE,VALUE)  \
    (( 'l' == memory_model ) ?\
      (void) fprintf (FILE, "\tdc\t%.20e\n", (VALUE)) :\
      ((void) fprintf (FILE, "\tdc\t(@lfr(%.20e))>>32\n", (VALUE)),\
       (void) fprintf (FILE, "\tdc\t(@lfr(%.20e))&$ffffffff\n", (VALUE))))

/* This is how to output an assembler line defining a `float' constant.  */

#define ASM_OUTPUT_FLOAT(FILE,VALUE)  \
  fprintf (FILE, "\tdc\t@frc(%.12e)\n", (VALUE))

#elif defined( DSP56000 ) || defined( DSP56300 )

/* This is how to output an assembler line defining a `double' constant.  */

void dtok ( );

#define ASM_OUTPUT_DOUBLE(FILE,VALUE)  \
  (dtok( FILE, VALUE ))

/* This is how to output an assembler line defining a `float' constant.  */

#define ASM_OUTPUT_FLOAT(FILE,VALUE)  \
  (dtok( FILE, VALUE ))

/* This is how to output an assembler line defining an `int' constant.  */

#define ASM_OUTPUT_DOUBLE_INT(FILE,VALUE)				  \
    (( 'l' == memory_model ) ?						  \
     (( CONST_INT == GET_CODE( VALUE )) ?				  \
      ( fprintf ( FILE, "\tdc\t$%06x%06x\n",				  \
		 (( INTVAL ( VALUE ) >> 24 ) & 0x0000ff ),                \
		 ( INTVAL ( VALUE ) & 0xffffff ))) :		          \
      ( fprintf ( FILE, "\tdc\t$%06x%06x\n", 				  \
		 ((( CONST_DOUBLE_LOW ( VALUE ) >> 24 ) & 0x0000ff ) |	  \
		  (( CONST_DOUBLE_HIGH ( VALUE ) << 8 ) & 0xffff00 )),    \
		 ( CONST_DOUBLE_LOW ( VALUE ) & 0xffffff )))) :	          \
     (( CONST_INT == GET_CODE( VALUE )) ?				  \
      ( fprintf ( FILE, "\tdc\t$%06x\n\tdc\t$%06x\n",			  \
		 ( INTVAL ( VALUE ) & 0xffffff ),		  	  \
		 (( INTVAL ( VALUE ) >> 24 ) & 0x0000ff ))) :		  \
      ( fprintf ( FILE, "\tdc\t$%06x\n\tdc\t$%06x\n", 		 	  \
		 ( CONST_DOUBLE_LOW ( VALUE ) & 0xffffff ),		  \
		 ((( CONST_DOUBLE_LOW ( VALUE ) >> 24 ) & 0x0000ff ) |	  \
		  (( CONST_DOUBLE_HIGH ( VALUE ) << 8 ) & 0xffff00 ))))))


#elif defined( DSP56100 ) || defined( DSP56400 ) || defined( DSP56600 )

/* This is how to output an assembler line defining a `double' constant.  */

extern void local_output_double ( );

#define ASM_OUTPUT_DOUBLE(FILE,VALUE) \
local_output_double ( FILE, (VALUE))

/* This is how to output an assembler line defining a `float' constant.  */

#define ASM_OUTPUT_FLOAT(FILE,VALUE) ASM_OUTPUT_DOUBLE(FILE,VALUE)

/* This is how to output an assembler line defining an `int' constant.  */

#define ASM_OUTPUT_DOUBLE_INT(FILE,VALUE)				  \
    (( 'l' == memory_model ) ?						  \
     (( CONST_INT == GET_CODE( VALUE )) ?				  \
      ( fprintf ( FILE, "\tdc\t$%04x%04x\n",				  \
                 (( INTVAL ( VALUE ) >> 16 ) & 0xffff ),         	  \
                 ( INTVAL ( VALUE ) & 0xffff ))) :			  \
      ( fprintf ( FILE, "\tdc\t$%04x%04x\n", 			 	  \
                 (( CONST_DOUBLE_LOW ( VALUE ) >> 16 ) & 0xffff ),	  \
                 ( CONST_DOUBLE_LOW ( VALUE ) & 0xffff )))) :		  \
     (( CONST_INT == GET_CODE( VALUE )) ?				  \
      ( fprintf ( FILE, "\tdc\t$%04x\n\tdc\t$%04x\n",			  \
                 ( INTVAL ( VALUE ) & 0xffff ),	  	          	  \
                 (( INTVAL ( VALUE ) >> 16 ) & 0xffff ))) :		  \
      ( fprintf ( FILE, "\tdc\t$%04x\n\tdc\t$%04x\n", 		 	  \
                 ( CONST_DOUBLE_LOW ( VALUE ) & 0xffff ),		  \
                 (( CONST_DOUBLE_LOW ( VALUE ) >> 16 ) & 0xffff )))))

#endif

#define ASM_OUTPUT_INT(FILE,VALUE)  \
( fprintf (FILE, "\tdc\t"),			\
  output_addr_const (FILE, (VALUE)),		\
  fprintf (FILE, "\n"))

/* Likewise for `short' and `char' constants.  */

#define ASM_OUTPUT_SHORT(FILE,VALUE)  \
( fprintf (FILE, "\tdc\t"),			\
  output_addr_const (FILE, (VALUE)),		\
  fprintf (FILE, "\n"))

#define ASM_OUTPUT_CHAR(FILE,VALUE)  \
( fprintf (FILE, "\tdc\t"),			\
  output_addr_const (FILE, (VALUE)),		\
  fprintf (FILE, "\n"))

/* This is how to output an assembler line for a numeric constant byte.  */

#define ASM_OUTPUT_BYTE(FILE,VALUE)  \
  fprintf (FILE, "\tdc\t$%x\n", (VALUE))

#define ASM_OUTPUT_ASCII(FILE, P, SIZE)  \
  output_ascii (FILE, P, SIZE)

/* This is how to output an assembler line
   that says to advance the location counter
   to a multiple of 2**LOG bytes.  */

#define ASM_OUTPUT_ALIGN(FILE,LOG)

#define ASM_OUTPUT_SKIP(FILE,SIZE)  \
  fprintf (FILE, "\tbsc\t%d\n", (SIZE))

/* This says how to output an assembler line
   to define a global common symbol.  */

#define ASM_OUTPUT_COMMON(FILE, NAME, SIZE, ROUNDED)  		\
(  ASM_GLOBALIZE_LABEL((FILE),(NAME)),                          \
   assemble_name ((FILE), (NAME)),                              \
   fprintf ((FILE), "\tbsc\t%d\n", (ROUNDED)))


/* This says how to output an assembler line
   to define a local common symbol.  */

#define ASM_OUTPUT_LOCAL(FILE, NAME, SIZE, ROUNDED)  \
( assemble_name ((FILE), (NAME)),				\
  fprintf ((FILE), "\tbsc\t%d\n", (ROUNDED)))

/* Store in OUTPUT a string (made with alloca) containing
   an assembler-name for a local static variable named NAME.
   LABELNO is an integer which is different for each call.  */

#define ASM_FORMAT_PRIVATE_NAME(OUTPUT, NAME, LABELNO)	\
( (OUTPUT) = (char *) alloca (strlen ((NAME)) + 10),	\
  sprintf ((OUTPUT), "___%s%d", (NAME), (LABELNO)))

/* Define the parentheses used to group arithmetic operations
   in assembler code.  */

#define ASM_OPEN_PAREN "("
#define ASM_CLOSE_PAREN ")"

/* Define results of standard character escape sequences.  */
#define TARGET_BELL 007
#define TARGET_BS 010
#define TARGET_TAB 011
#define TARGET_NEWLINE 012
#define TARGET_VT 013
#define TARGET_FF 014
#define TARGET_CR 015

/* Print operand X (an rtx) in assembler syntax to file FILE.
   CODE is a letter or dot (`z' in `%z0') or 0 if no letter was specified.
   For `%' followed by punctuation, CODE is the punctuation and X is null.
*/

#define PRINT_OPERAND(FILE, X, CODE) print_operand ( FILE, X, CODE )

/* Print a memory address as an operand to reference that memory location.  */

#define PRINT_OPERAND_ADDRESS(FILE, ADDR) print_operand_address ( FILE, ADDR )

#define ASM_OUTPUT_REG_PUSH( FILE, REGNO )
#define ASM_OUTPUT_REG_POP( FILE, REGNO )

#define ASM_OUTPUT_OPCODE( FILE, OPCODE ) 

/* the following definitions and declarations are used to efficiently
   implement the use of either memory space. */

#if defined( HAVE_L_MEMORY )

extern char *fix_mem_space ( );

#endif

/* these force a min number of operands allowed. */
#define MIN_RECOG_OPERANDS 16
#define MIN_DUP_OPERANDS 16

/* we undef abort so that we can print a proper warning message and not dump
   core. (code in rtl.c) */
#undef abort

/* allow certain pragmas. */
int dsp_process_pragma_line ( );

#define TARGET_PROCESS_PRAGMA_LINE( f ) \
dsp_process_pragma_line ( f )

/* tells sdbout which prolog/epilog pair is being used. */
extern int logue_index;

/* this data type is used to pass information about the function to the
   optimizer and code generator, and pro/epilog generators. */

typedef enum 
{
    FUNC_NO_INFO = 0x0000,
    FUNC_ISNT_LEAF = 0x0001,       /* this func makes at least one call */
    FUNC_RETURNS_FLOAT = 0x0002,   /* a float/double value is returned */
    FUNC_HAS_STACK_PARMS = 0x0004, /* this func has at least one stack parm */
    FUNC_RETURNS_VOID =0x0008      /* this function is of type void. */
} func_attributes;

/* a global var used for the aformentioned purpose. */
extern func_attributes current_func_info;

/* this is a kludge. 
   the 56k uses accumulators a and b in weird ways. b can hold either
   a 48 bit or 24 bit value. if it holds a 48 bit value, there is no way
   that ( SUBREG:SI ( REG:DI 1 ) 0 ) can be use as an arithmetic operand. 
   the same rtl expression *can* be used as a move operand, namely b0.
   eventually we might want to rethink the way that we're numbering registers
   and possibly make accumulators look like a series of concatenated registers.
   this, however, would require major rework of the md file, as each
   SImode arith define_insn would need to be transformed into a define_expand
   and define_insn pair (for example, to reflect the clobber of a2 and a0
   in add x0,a). this change could severely inhibit optimization as well. 

   for now: we wll define INSN_MACHINE_INFO to differentiate between insns
   that can and cannot accept the above rtl expression type as an operand.
   */

enum info_spec 
{
    NO_FLAGS = 0,
    CAN_ACCEPT_SUBREG_ACC = 1,
    NO_LATENCY_ADDR_REG_OP = (1<<1),
    IFCCABLE_OP_CODE = (1<<2),
    INPUT_NORM_OPTIONAL = (1<<3),
    OUTPUT_NORM_OPTIONAL = (1<<4),
    CCS_SET_CORRECTLY = (1<<5),
    CCS_NOT_AFFECTED = (1<<6),
    CALL_VALUE = (1<<7),
    BSR_LAST_OP = (1<<8),
};

enum ait /* accumulator instruction type. */
{
    AIT_MOVE,
    AIT_ALU,
    AIT_LOGICAL,
    AIT_MAC,
    AIT_ASR,
    AIT_ALU_ASR,
};

typedef struct
{
    enum info_spec spec_bits;
    enum ait ait_spec;
}
dsp_insn_info;

extern enum info_spec added_flags;
extern enum info_spec get_spec_bits ( );

#define INSN_MACHINE_INFO dsp_insn_info

#if defined( HAVE_L_MEMORY )

/* global memory space indicator - either 'x' or 'y'. */
extern char mem_space;
extern char memory_model;

#define MODE_USES_BOTH_X_AND_Y_P(MODE) \
	(( DImode == (MODE)) || ( DFmode == (MODE)) || (SFmode == (MODE)) || \
	 ( BLKmode == (MODE)) || ( VOIDmode == (MODE)))

#endif

#if defined( DSP56000 ) || defined( DSP56300 )
unsigned int upper_24 ( ), lower_24 ( );
#elif defined( DSP56600 )
unsigned int upper_16 ( ), lower_16 ( );
#endif

#define B "*b"
#define J "*j"
#define BR "*br"
#define BRA "*bra"
#define JMP "*jmp"


#if !defined( MSIL_DISABLE )
#define SELECT_INIT_SECTION(FILE)	\
  select_init_section (FILE)
#define END_INIT_SECTION(FILE)	\
  end_init_section (FILE)
#define START_OF_ZERO_INITIALIZED(FILE)	\
  mark_start_of_zini (FILE)
#define INIT_SECTION_ASM_OP "\torg\tp:"
#endif
