/* subroutines for insn-output.c for motorola DSP56600
   copyright ( c ) 1988 free software foundation, inc.

this file is part of gnu cc.

gnu cc is distributed in the hope that it will be useful,
but without any warranty.  no author or distributor
accepts responsibility to anyone for the consequences of using it
or for whether it serves any particular purpose or works at all,
unless he says so in writing.  refer to the gnu cc general public
license for full details.

everyone is granted permission to copy, modify and redistribute
gnu cc, but only under the conditions described in the
gnu cc general public license.	 a copy of this license is
supposed to have been given to you along with gnu cc so you
can know your rights and responsibilities.  it should be in a
file named copying.  among other things, the copyright notice
and this notice must be preserved on all copies.  */

#define SC "\n\t"
static char* fms ( );

#ifndef file
#include <stdio.h>
#endif

#include <string.h>
#if defined ( _MSDOS )
extern void *malloc( );
#endif

#include <ctype.h>

#include "flags.h"
#include "tree.h"
#if ! defined( _MSDOS )
#include "hard-reg-set.h"
#else
#include "hardrset.h"
#endif

char mem_space = 'y';
char memory_model = 'y';

union real_extract adjusted_dval;
func_attributes current_func_info = FUNC_NO_INFO;

enum reg_class regno_reg_class ( );
char * ( *const insn_outfun[] ) ( );
const INSN_MACHINE_INFO insn_machine_info[];

int FirstSave;


int
fixup_btst_cc_consumer ( insn )
    rtx insn;
{
    rtx peek = NEXT_INSN ( insn );
    
    for ( ; NULL != peek; peek = NEXT_INSN ( peek ))
    {
	if ( JUMP_INSN == GET_CODE ( peek ) ||
	    CALL_INSN == GET_CODE ( peek ) ||
	    CODE_LABEL == GET_CODE ( peek ) ||
	    BARRIER == GET_CODE ( peek ))
	{
	    break;
	}

	if ( INSN == GET_CODE ( peek ) &&
	    PARALLEL == GET_CODE ( PATTERN ( peek )) &&
	    SET == GET_CODE ( XVECEXP ( PATTERN ( peek ), 0, 0 )) &&
	    0 == strcmp 
	    ( GET_RTX_FORMAT
	     ( GET_CODE 
	      ( XEXP ( XVECEXP ( PATTERN ( peek ), 0, 0 ), 1 ))), "ee" ) &&
	    ( cc0_rtx == XEXP
	     ( XEXP ( XVECEXP ( PATTERN ( peek ), 0, 0 ), 1 ), 0 ) ||
	     cc0_rtx == XEXP
	     ( XEXP ( XVECEXP ( PATTERN ( peek ), 0, 0 ), 1 ), 1 )))
	{
	    switch ( GET_CODE 
		    ( XEXP ( XVECEXP ( PATTERN ( peek ), 0, 0 ), 1 )))
	    {
	    case EQ:
	    case EQU:
	    case LE:
	    case LEU:
		PUT_CODE
		    ( XEXP ( XVECEXP ( PATTERN ( peek ), 0, 0 ), 1 ), CC );
		break;
		
	    case NE:
	    case NEU:
	    case GT:
	    case GTU:
		PUT_CODE 
		    ( XEXP ( XVECEXP ( PATTERN ( peek ), 0, 0 ), 1 ), CS );
		break;
		
	    case GE:
	    case GEU:
		/* always true; harden the move. */
		XEXP ( XVECEXP ( PATTERN ( peek ), 0, 0 ), 1 ) = const1_rtx;
		PATTERN ( peek ) = XVECEXP ( PATTERN ( peek ), 0, 0 );
		
		return 0;
		
	    case LT:
	    case LTU:
		/* always false; harden the branch. */
		XEXP ( XVECEXP ( PATTERN ( peek ), 0, 0 ), 1 ) = const0_rtx;
		PATTERN ( peek ) = XVECEXP ( PATTERN ( peek ), 0, 0 );

		return 0;
	    }
	    return 1;
	}
    }

    if (( NULL != peek ) &&
	( JUMP_INSN == GET_CODE ( peek )) &&
	( SET == GET_CODE ( PATTERN ( peek ))) &&
	( IF_THEN_ELSE == GET_CODE ( XEXP ( PATTERN ( peek ), 1 ))))
    {
	switch ( GET_CODE ( XEXP ( XEXP ( PATTERN ( peek ), 1 ), 0 )))
	{
	case EQ:
	case EQU:
	case LE:
	case LEU:
	    PUT_CODE ( XEXP ( XEXP ( PATTERN ( peek ), 1 ), 0 ), CC );
	    break;
	    
	case NE:
	case NEU:
	case GT:
	case GTU:
	    PUT_CODE ( XEXP ( XEXP ( PATTERN ( peek ), 1 ), 0 ), CS );
	    break;
	    
	case GE:
	case GEU:
	    /* always true; harden the branch. */
	    if ( pc_rtx == XEXP ( XEXP ( PATTERN ( peek ), 1 ), 1 ))
	    {
		/* eliminate the branch. */
		PUT_CODE ( peek, NOTE );
		INSN_DELETED_P ( peek ) = 1;
	    }
	    else
	    {
		/* make the branch a hard branch. */
		XEXP ( PATTERN ( peek ), 1 ) = 
		    XEXP ( XEXP ( PATTERN ( peek ), 1 ), 1 );

	    }
	    return 0;
	    
	case LT:
	case LTU:
	    /* always false; harden the branch. */
	    if ( pc_rtx == XEXP ( XEXP ( PATTERN ( peek ), 1 ), 1 ))
	    {
		/* make the branch a hard branch. */
		XEXP ( PATTERN ( peek ), 1 ) = 
		    XEXP ( XEXP ( PATTERN ( peek ), 1 ), 2 );
	    }
	    else
	    {
		/* eliminate the branch. */
		PUT_CODE ( peek, NOTE );
		INSN_DELETED_P ( peek ) = 1;
	    }
	    return 0;
	}
    }
    return 1;
}


void
flip_btst_cc_consumer ( insn )
    rtx insn;
{
    rtx peek = NEXT_INSN ( insn );
    
    for ( ; NULL != peek; peek = NEXT_INSN ( peek ))
    {
	if ( JUMP_INSN == GET_CODE ( peek ) ||
	    CALL_INSN == GET_CODE ( peek ) ||
	    CODE_LABEL == GET_CODE ( peek ) ||
	    BARRIER == GET_CODE ( peek ))
	{
	    break;
	}

	if ( INSN == GET_CODE ( peek ) &&
	    PARALLEL == GET_CODE ( PATTERN ( peek )) &&
	    SET == GET_CODE ( XVECEXP ( PATTERN ( peek ), 0, 0 )) &&
	    0 == strcmp 
	    ( GET_RTX_FORMAT
	     ( GET_CODE 
	      ( XEXP ( XVECEXP ( PATTERN ( peek ), 0, 0 ), 1 ))), "ee" ) &&
	    ( cc0_rtx == XEXP
	     ( XEXP ( XVECEXP ( PATTERN ( peek ), 0, 0 ), 1 ), 0 ) ||
	     cc0_rtx == XEXP
	     ( XEXP ( XVECEXP ( PATTERN ( peek ), 0, 0 ), 1 ), 1 )))
	{
	    PUT_CODE ( XEXP ( XVECEXP ( PATTERN ( peek ), 0, 0 ), 1 ),
		      reverse_condition 
		      ( GET_CODE
		       ( XEXP ( XVECEXP ( PATTERN ( peek ), 0, 0 ), 1 ))));
	}
    }

    if (( NULL != peek ) &&
	( JUMP_INSN == GET_CODE ( peek )) &&
	( SET == GET_CODE ( PATTERN ( peek ))) &&
	( IF_THEN_ELSE == GET_CODE ( XEXP ( PATTERN ( peek ), 1 ))))
    {
	PUT_CODE ( XEXP ( XEXP ( PATTERN ( peek ), 1 ), 0 ), 
		  reverse_condition
		  ( GET_CODE ( XEXP ( XEXP ( PATTERN ( peek ), 1 ), 0 ))));
    }
}


void
harden_btst_cc_consumer ( insn )
    rtx insn;
{
    rtx peek = NEXT_INSN ( insn );
    
    for ( ; NULL != peek; peek = NEXT_INSN ( peek ))
    {
	if ( JUMP_INSN == GET_CODE ( peek ) ||
	    CALL_INSN == GET_CODE ( peek ) ||
	    CODE_LABEL == GET_CODE ( peek ) ||
	    BARRIER == GET_CODE ( peek ))
	{
	    break;
	}

	if ( INSN == GET_CODE ( peek ) &&
	    PARALLEL == GET_CODE ( PATTERN ( peek )) &&
	    SET == GET_CODE ( XVECEXP ( PATTERN ( peek ), 0, 0 )) &&
	    0 == strcmp 
	    ( GET_RTX_FORMAT
	     ( GET_CODE 
	      ( XEXP ( XVECEXP ( PATTERN ( peek ), 0, 0 ), 1 ))), "ee" ) &&
	    ( cc0_rtx == XEXP
	     ( XEXP ( XVECEXP ( PATTERN ( peek ), 0, 0 ), 1 ), 0 ) ||
	     cc0_rtx == XEXP
	     ( XEXP ( XVECEXP ( PATTERN ( peek ), 0, 0 ), 1 ), 1 )))
	{
	    XEXP ( XVECEXP ( PATTERN ( peek ), 0, 0 ), 1 ) = const0_rtx;
	    PATTERN ( peek ) = XVECEXP ( PATTERN ( peek ), 0, 0 );
	}
    }

    if (( NULL != peek ) &&
	( JUMP_INSN == GET_CODE ( peek )) &&
	( SET == GET_CODE ( PATTERN ( peek ))) &&
	( IF_THEN_ELSE == GET_CODE ( XEXP ( PATTERN ( peek ), 1 ))))
    {
	if ( pc_rtx == XEXP ( XEXP ( PATTERN ( peek ), 1 ), 1 ))
	{
	    /* make the branch a hard branch. */
	    XEXP ( PATTERN ( peek ), 1 ) = 
		XEXP ( XEXP ( PATTERN ( peek ), 1 ), 2 );
	}
	else
	{
	    /* eliminate the branch. */
	    PUT_CODE ( peek, NOTE );
	    INSN_DELETED_P ( peek ) = 1;
	}
    }
}

char*
move_single_integer ( operands )
    rtx *operands;
{
    extern char mem_space;
    
    if (( late_rtx_equal_p ( operands[0], operands[1] )) &&
	(( REG != GET_CODE ( operands[0] )) ||
	 ( ! MEM_IN_STRUCT_P ( operands[0] ))) &&
	(( REG != GET_CODE ( operands[1] )) ||
	 ( ! MEM_IN_STRUCT_P ( operands[1] ))))
    {
	/* if we're doing a nop move, return a null string. note that
	   an insn could look like a nop move isasmuchas rtx_equal_p returns
	   true; however the MEM_IN_STRUCT_P kludge used by alter_subreg ( )
	   (final.c) may indicate a move from the LSW of a long to an int
	   in the same accumulator. */

	return "";
    }
    
    switch ( which_alternative )
    {
    case 0:
	if ( MEM_IN_STRUCT_P ( operands[0] ) || 
	    MEM_IN_STRUCT_P ( operands[1] ))
	{
	    return "move	%1,%0";
	}
	else if ( DST_REGS == REGNO_REG_CLASS ( REGNO ( operands[0] )) &&
		 ( DST_REGS == REGNO_REG_CLASS ( REGNO ( operands[1] )) ||
		  IS_SRC_OR_MPY_P ( REGNO ( operands[1] ))))
	{
	    return "tfr	%1,%0";
	}
	return "move	%e1,%0";
	
    case 1:
    case 2:
	return "move	%e1,%0";
	
    case 3:
	if ( 0 == INTVAL ( operands[1] ))
	{
	    if ( DST_REGS == REGNO_REG_CLASS ( REGNO ( operands[0] )))
	    {
		added_flags = (( added_flags & ~ CCS_NOT_AFFECTED ) |
			       CCS_SET_CORRECTLY );

		return "clr	%0";
	    }
	    else
	    {
		return "move	#%1,%0";
	    }
	}
	else if ( 1 == INTVAL ( operands[1] ) && 
		 DSP_A_REGNUM <= REGNO ( operands[0] ) &&
		 DSP_B_REGNUM >= REGNO ( operands[0] ))
	{
	    return "clr	%0" SC
		   "add	#1,%0";
	}
	else
	{
	    return "move	#>%1,%0";
	}
    }
}

char*
move_single_fraction ( operands )
    rtx *operands;
{
    extern char mem_space;
    
    if (( late_rtx_equal_p ( operands[0], operands[1] )) &&
	(( REG != GET_CODE ( operands[0] )) ||
	 ( ! MEM_IN_STRUCT_P ( operands[0] ))) &&
	(( REG != GET_CODE ( operands[1] )) ||
	 ( ! MEM_IN_STRUCT_P ( operands[1] ))))
    {
	/* if we're doing a nop move, return a null string. note that
	   an insn could look like a nop move isasmuchas rtx_equal_p returns
	   true; however the MEM_IN_STRUCT_P kludge used by alter_subreg ( )
	   (final.c) may indicate a move from the LSW of a long to an int
	   in the same accumulator. */

	return "";
    }
    
    switch ( which_alternative )
    {
    case 0:
	if ( MEM_IN_STRUCT_P ( operands[0] ) || 
	    MEM_IN_STRUCT_P ( operands[1] ))
	{
	    return "move	%1,%0";
	}
	else if ( DST_REGS == REGNO_REG_CLASS ( REGNO ( operands[0] )) &&
		 ( DST_REGS == REGNO_REG_CLASS ( REGNO ( operands[1] )) ||
		  IS_SRC_OR_MPY_P ( REGNO ( operands[1] ))))
	{
	    return "tfr	%1,%0";
	}
	return "move	%1,%0";
	
    case 1:
    case 2:
	return "move	%1,%0";
	
    case 3:
	if ( 0 == INTVAL ( operands[1] ))
	{
	    if ( DST_REGS == REGNO_REG_CLASS ( REGNO ( operands[0] )))
	    {
		added_flags = (( added_flags & ~ CCS_NOT_AFFECTED ) |
			       CCS_SET_CORRECTLY );

		return "clr	%0";
	    }
	    else
	    {
		return "move	#%1,%0";
	    }
	}
	else
	{
	    return "move	#>%1,%0";
	}
    }
}

/* the dsp56600 uses the IEEE single precision format. this routine assumes
   that the host has 32 bit integers and that float is ieee sp. */
unsigned int
get_float_format ( number )
    double number;
{
    float ieee_sp = (float) number;
    unsigned int *peek = (unsigned int*) & ieee_sp;
    
#if defined( _MSDOS ) || defined( MIPSEL )
    return ( 0x0000ffff & ((*peek) >> 16 )) | ( 0xffff0000 & ((*peek) << 16 ));
#else
    return *peek;
#endif
}


char*
move_double_integer ( is_float_p, operands )
    int is_float_p;
    rtx *operands;
{
    extern char mem_space;
    extern union real_extract adjusted_dval;

    if ( late_rtx_equal_p ( operands[0], operands[1] ))
    {
	return "";
    }
    
    if ( REG_P ( operands[0] ) && REG_P ( operands[1] ) &&
	DSP_A_REGNUM <= REGNO ( operands[0] ) &&
	DSP_B_REGNUM >= REGNO ( operands[0] ))
    {
	/* S <- S or D */

	if ( IS_SRC_OR_MPY_P ( REGNO ( operands[1] )))
	{
	    if ( MEM_IN_STRUCT_P ( operands[0] )  ||
		MEM_IN_STRUCT_P ( operands[1] ))
	    {
		return "move	%g1,%0" SC
		       "move	%1,%h0";
	    }
	    else
	    {
		return "tfr	%g1,%0" SC
		       "move	%1,%h0";
	    }
	}
	else
	{
	    if ( MEM_IN_STRUCT_P ( operands[0] )  ||
		MEM_IN_STRUCT_P ( operands[1] ))
	    {
		return "move	%1,%0";
	    }
	    else
	    {
		return "tfr	%1,%0";
	    }
	}
    }
    
    else if ( REG_P ( operands[0] ) && REG_P ( operands[1] ) &&
	     DSP_X0_REGNUM <= REGNO ( operands[0] ) &&
	     DSP_Y1_REGNUM >= REGNO ( operands[0] ))
    {
	/* D <- S or D */

	if ( IS_SRC_OR_MPY_P ( REGNO ( operands[1] )))
	{
	    return "move	%g1,%g0" SC
		   "move	%1,%0";
	}
	else
	{
	    return "move	%e1,%g0" SC
		   "move	%h1,%0";
	}
    }

    else if ( MEM == GET_CODE ( operands[0] ) && REG_P ( operands[1] ))
    {
	/* m <- S or D */
	if ( 'l' == memory_model )
	{
	    if ( PLUS == GET_CODE ( XEXP ( operands[0], 0 )))
	    {
		if ( REG == GET_CODE ( XEXP ( XEXP ( operands[0], 0 ), 0 )))
		{
		    operands[2] = XEXP ( XEXP ( operands[0], 0 ), 0 );
		    operands[3] = XEXP ( XEXP ( operands[0], 0 ), 1 );
		}
		else
		{
		    operands[2] = XEXP ( XEXP ( operands[0], 0 ), 1 );
		    operands[3] = XEXP ( XEXP ( operands[0], 0 ), 0 );
		}
		if ( IS_SRC_OR_MPY_P ( REGNO ( operands[1] )))
		{
		    return "move	%g1,x:(%2+%3)" SC
			   "move	%1,y:(%2+%3)";
		}
		else
		{
		    return "move	%e1,x:(%2+%3)" SC
			   "move	%h1,y:(%2+%3)";
		}
	    }
	    return "move	%m1,%0";
	}
	else /* memory_model is x or y. */
	{
	    if ( PLUS == GET_CODE ( XEXP ( operands[0], 0 )))
	    {
		if ( REG == GET_CODE ( XEXP ( XEXP ( operands[0], 0 ), 0 )))
		{
		    operands[2] = XEXP ( XEXP ( operands[0], 0 ), 0 );
		    operands[3] = XEXP ( XEXP ( operands[0], 0 ), 1 );
		}
		else
		{
		    operands[2] = XEXP ( XEXP ( operands[0], 0 ), 1 );
		    operands[3] = XEXP ( XEXP ( operands[0], 0 ), 0 );
		}
		
		if ( CONST_INT == GET_CODE ( operands[3] ) &&
		    ! INTVAL ( operands[3] ))
		{
		    if ( IS_SRC_OR_MPY_P ( REGNO ( operands[1] )))
		    {
			return fms ( "move	%1,@:(%2)+" SC
				     "move	%g1,@:(%2)-" );
		    }
		    else
		    {
			return fms ( "move	%h1,@:(%2)+" SC
				     "move	%e1,@:(%2)-" );
		    }
		}
		else
		{
		    if ( IS_SRC_OR_MPY_P ( REGNO ( operands[1] )))
		    {
			return fms ( "move	%g1,@:(%2+%3+1)" SC
				     "move	%1,@:(%2+%3)" );
		    }
		    else
		    {
			return fms ( "move	%e1,@:(%2+%3+1)" SC
				     "move	%h1,@:(%2+%3)" );
		    }
		}
	    }
	    else if ( POST_INC == GET_CODE ( XEXP ( operands[0], 0 )))
	    {
		operands[2] = XEXP ( XEXP ( operands[0], 0 ), 0 );
		
		if ( IS_SRC_OR_MPY_P ( REGNO ( operands[1] )))
		{
		    return fms ( "move	%1,@:(%2)+" SC
				 "move	%g1,@:(%2)+" );
		}
		else
		{
		    return fms ( "move	%h1,@:(%2)+" SC
				 "move	%e1,@:(%2)+" );
		}
	    }
	    else if ( POST_DEC == GET_CODE ( XEXP ( operands[0], 0 )))
	    {
		operands[2] = XEXP ( XEXP ( operands[0], 0 ), 0 );
		
		if ( IS_SRC_OR_MPY_P ( REGNO ( operands[1] )))
		{
		    return fms ( "move	%1,@:(%2)+" SC
				 "move	%g1,@:(%2)-" SC
				 "move	(%2)-" SC
				 "move	(%2)-" );
		}
		else
		{
		    return fms ( "move	%h1,@:(%2)+" SC
				 "move	%e1,@:(%2)-" SC
				 "move	(%2)-" SC
				 "move	(%2)-" );
		}
	    }
	    else if ( REG == GET_CODE ( XEXP ( operands[0], 0 )))
	    {
		operands[2] = XEXP ( operands[0], 0 );
		
		if ( IS_SRC_OR_MPY_P ( REGNO ( operands[1] )))
		{
		    return fms ( "move	%1,@:(%2)+" SC
				 "move	%g1,@:(%2)-" );
		}
		else
		{
		    return fms ( "move	%h1,@:(%2)+" SC
				 "move	%e1,@:(%2)-" );
		}
	    }
	    else
	    {
		if ( IS_SRC_OR_MPY_P ( REGNO ( operands[1] )))
		{
		    return "move	%1,%0" SC
			   "move	%g1,%0+1";
		}
		else
		{
		    return "move	%h1,%0" SC
			   "move	%e1,%0+1";
		}
	    }
	}
    }
    
    else if ( REG_P ( operands[0] ) && MEM == GET_CODE ( operands[1] ))
    {
	/* S or D <- m */

	if ( 'l' == memory_model )
	{
	    if ( PLUS == GET_CODE ( XEXP ( operands[1], 0 )))
	    {
		if ( REG == GET_CODE ( XEXP ( XEXP ( operands[1], 0 ), 0 )))
		{
		    operands[2] = XEXP ( XEXP ( operands[1], 0 ), 0 );
		    operands[3] = XEXP ( XEXP ( operands[1], 0 ), 1 );
		}
		else
		{
		    operands[2] = XEXP ( XEXP ( operands[1], 0 ), 1 );
		    operands[3] = XEXP ( XEXP ( operands[1], 0 ), 0 );
		}
		
		if ( IS_SRC_OR_MPY_P ( REGNO ( operands[0] )))
		{
		    return "move	x:(%2+%3),%g0" SC
			   "move	y:(%2+%3),%0";
		}
		else
		{
		    return "move	x:(%2+%3),%0" SC
			   "move	y:(%2+%3),%h0";
		}
	    }
	    
	    else if ( IS_SRC_OR_MPY_P ( REGNO ( operands[0] )))
	    {
		return "move	%1,%m0";
	    }
	    else
	    {
		return "move	%1,%0";
	    }
	}
	else /* memory_model is x or y */
	{
	    if ( PLUS == GET_CODE ( XEXP ( operands[1], 0 )))
	    {
		if ( REG == GET_CODE ( XEXP ( XEXP ( operands[1], 0 ), 0 )))
		{
		    operands[2] = XEXP ( XEXP ( operands[1], 0 ), 0 );
		    operands[3] = XEXP ( XEXP ( operands[1], 0 ), 1 );
		}
		else
		{
		    operands[2] = XEXP ( XEXP ( operands[1], 0 ), 1 );
		    operands[3] = XEXP ( XEXP ( operands[1], 0 ), 0 );
		}
		
		if ( CONST_INT == GET_CODE ( operands[3] ) &&
		    ! INTVAL ( operands[3] ))
		{
		    if ( IS_SRC_OR_MPY_P ( REGNO ( operands[0] )))
		    {
			return fms ( "move	(%2)+" SC
				     "move	@:(%2)-,%g0" SC
				     "move	@:(%2),%0" );
		    }
		    else
		    {
			return fms ( "move	(%2)+" SC
				     "move	@:(%2)-,%0" SC
				     "move	@:(%2),%h0" );
		    }
		}
		else
		{
		    if ( IS_SRC_OR_MPY_P ( REGNO ( operands[0] )))
		    {
			return fms ( "move	@:(%2+%3+1),%g0" SC
				     "move	@:(%2+%3),%0" );
		    }
		    else
		    {
			return fms ( "move	@:(%2+%3+1),%0" SC
				     "move	@:(%2+%3),%h0" );
		    }
		}
	    }
	    else if ( POST_INC == GET_CODE ( XEXP ( operands[1], 0 )))
	    {
		operands[2] = XEXP ( XEXP ( operands[1], 0 ), 0 );
		
		if ( IS_SRC_OR_MPY_P ( REGNO ( operands[0] )))
		{
		    return fms ( "move	(%2)+" SC
				 "move	@:(%2)-,%g0" SC
				 "move	@:(%2)+,%0" SC
				 "move	(%2)+" );
		}
		else
		{
		    return fms ( "move	(%2)+" SC
				 "move	@:(%2)-,%0" SC
				 "move	@:(%2)+,%h0" SC
				 "move	(%2)+" );
		}
	    }
	    else if ( POST_DEC == GET_CODE ( XEXP ( operands[1], 0 )))
	    {
		operands[2] = XEXP ( XEXP ( operands[1], 0 ), 0 );
		
		if ( IS_SRC_OR_MPY_P ( REGNO ( operands[0] )))
		{
		    return fms ( "move	(%2)+" SC
				 "move	@:(%2)-,%g0" SC
				 "move	@:(%2)-,%0" SC
				 "move	(%2)-" );
		}
		else
		{
		    return fms ( "move	(%2)+" SC
				 "move	@:(%2)-,%0" SC
				 "move	@:(%2)-,%h0" SC
				 "move	(%2)-" );
		}
	    }
	    else if ( REG == GET_CODE ( XEXP ( operands[1], 0 )))
	    {
		operands[2] = XEXP ( operands[1], 0 );
		
		if ( IS_SRC_OR_MPY_P ( REGNO ( operands[0] )))
		{
		    return fms ( "move	(%2)+" SC
				 "move	@:(%2)-,%g0" SC
				 "move	@:(%2),%0" );
		}
		else
		{
		    return fms ( "move	(%2)+" SC
				 "move	@:(%2)-,%0" SC
				 "move	@:(%2),%h0" );
		}
	    }
	    else
	    {
		if ( IS_SRC_OR_MPY_P ( REGNO ( operands[0] )))
		{
		    return "move	%1+1,%g0" SC
			   "move	%1,%0";
		}
		else
		{
		    return "move	%1+1,%0" SC
			   "move	%1,%h0";
		}
	    }
	}
    }
    
    else if ( REG_P ( operands[0] ) && LEGITIMATE_CONSTANT_P ( operands[1] ))
    {
	/* S or D <- const */

	if ( is_float_p )
	{
            unsigned int memory_value =
                get_float_format
                    (((union real_extract*) & 
                      CONST_DOUBLE_LOW ( operands[1] ))->d );
        
#if defined( __WATCOMC__ ) || defined(_MSDOS)
            operands[2] =
                gen_rtx ( CONST_INT, VOIDmode, memory_value  & 0x0000ffff );
        
            operands[3] = 
                gen_rtx ( CONST_INT, VOIDmode, 
                         (( memory_value >> 16 ) & 0x0000ffff ));
#else
            operands[2] =
                gen_rtx ( CONST_INT, VOIDmode,
                         (( memory_value >> 16 ) & 0x0000ffff ));
        
            operands[3] = 
                gen_rtx ( CONST_INT, VOIDmode, memory_value & 0x0000ffff );
#endif
            
	    if ( IS_SRC_OR_MPY_P ( REGNO ( operands[0] )))
	    {
		return "move	#>%2,%g0\n\tmove	#>%3,%0";
	    }
	    else
	    {
		if ( 0 == INTVAL ( operands[3] ))
		{
		    if ( 0 == INTVAL ( operands[2] ))
		    {
			added_flags = (( added_flags & ~ CCS_NOT_AFFECTED ) |
				       CCS_SET_CORRECTLY );

			return "clr	%0";
		    }
		    else
		    {
			return "move	#>%2,%0";
		    }
		}
		else
		{
		    return "move	#>%2,%0" SC
			   "move	#>%3,%h0";
		}
	    }
	}
	else /* not a floating constant. */
	{
	    
            if ( CONST_INT == GET_CODE ( operands[1] ))
            {
                operands[2] =
                    gen_rtx ( CONST_INT, VOIDmode,
                             ( INTVAL ( operands[1] ) >> 16 ) & 0x0000ffff );
 
                operands[3] =
                    gen_rtx ( CONST_INT, VOIDmode, 
                             INTVAL ( operands[1] ) & 0x0000ffff );
            }
            else
            {
                operands[2] =
                    gen_rtx ( CONST_INT, VOIDmode, 
                             ( CONST_DOUBLE_LOW ( operands[1] ) >> 16 )
                             & 0x0000ffff );
                operands[3] = 
                    gen_rtx ( CONST_INT, VOIDmode,
                             CONST_DOUBLE_LOW ( operands[1] ) & 0x0000ffff );
            }
            
	    if ( IS_SRC_OR_MPY_P ( REGNO ( operands[0] )))
	    {
		if ( rtx_equal_p ( operands[2], operands[3] ))
		{
		    if ( 0 == INTVAL ( operands[2] ))
		    {
			return "move	#%2,%g0" SC
			       "move	%g0,%0";
		    }
		    return "move	#>%2,%g0" SC
			   "move	%g0,%0";
		}
		else
		{
		    if ( 0 == INTVAL ( operands[2] ))
		    {
			if ( 0 == INTVAL ( operands[3] ))
			{
			    return "move	#0,%g0" SC
				   "move	%g0,%0";
			}
			return "move	#0,%g0" SC
			       "move	#>%3,%0";
		    }
		    else if ( 0 == INTVAL ( operands[3] ))
		    {
			return "move	#>%2,%g0" SC
			       "move	#0,%0";
		    }
		    return "move	#>%2,%g0" SC
			   "move	#>%3,%0";
		}
	    }
	    else
	    {
		if ( 0 == INTVAL ( operands[3] ))
		{
		    if ( 0 == INTVAL ( operands[2] ))
		    {
			added_flags = (( added_flags & ~ CCS_NOT_AFFECTED ) |
				       CCS_SET_CORRECTLY );

			return "clr	%0";
		    }
		    else
		    {
			return "move	#>%2,%0";
		    }
		}
		else if ( 0 == INTVAL ( operands[2] ))
		{
		    return "move	#0,%0" SC
			   "move	#>%3,%h0";
		}
		else
		{
		    if ( rtx_equal_p ( operands[2], operands[3] ))
		    {
			return "move	#>%2,%0" SC
			       "move	%0,%h0";
		    }
		    else
		    {
			return "move	#>%2,%0" SC
			       "move	#>%3,%h0";
		    }
		}
	    }
	}
    }
    else
    {
	abort ( );
    }
}

char*
move_double_fraction ( operands )
    rtx *operands;
{
    extern char mem_space;
    extern union real_extract adjusted_dval;

    if ( late_rtx_equal_p ( operands[0], operands[1] ))
    {
	return "";
    }
    
    switch ( which_alternative )
    {
    case 0:
	if ( IS_SRC_OR_MPY_P ( REGNO ( operands[1] )))
	{
	    return "tfr	%g1,%0" SC
		   "move	%1,%h0";
	}
	else
	{
	    return "tfr	%1,%0";
	}

    case 1:
	if ( IS_SRC_OR_MPY_P ( REGNO ( operands[1] )))
	{
	    return "move	%g1,%g0" SC
		   "move	%1,%0";
	}
	else
	{
	    return "move	%1,%g0" SC
		   "move	%h1,%0";
	}

    case 2:
	if ( 'l' == memory_model )
	{
	    if ( PLUS == GET_CODE ( XEXP ( operands[0], 0 )))
	    {
		if ( REG == GET_CODE ( XEXP ( XEXP ( operands[0], 0 ), 0 )))
		{
		    operands[2] = XEXP ( XEXP ( operands[0], 0 ), 0 );
		    operands[3] = XEXP ( XEXP ( operands[0], 0 ), 1 );
		}
		else
		{
		    operands[2] = XEXP ( XEXP ( operands[0], 0 ), 1 );
		    operands[3] = XEXP ( XEXP ( operands[0], 0 ), 0 );
		}
		if ( IS_SRC_OR_MPY_P ( REGNO ( operands[1] )))
		{
		    return "move	%g1,x:(%2+%3)" SC
			   "move	%1,y:(%2+%3)";
		}
		else
		{
		    return "move	%1,x:(%2+%3)" SC
			   "move	%h1,y:(%2+%3)";
		}
	    }
	    return "move	%m1,%0";
	}
	else /* memory_model is x or y. */
	{
	    if ( PLUS == GET_CODE ( XEXP ( operands[0], 0 )))
	    {
		if ( REG == GET_CODE ( XEXP ( XEXP ( operands[0], 0 ), 0 )))
		{
		    operands[2] = XEXP ( XEXP ( operands[0], 0 ), 0 );
		    operands[3] = XEXP ( XEXP ( operands[0], 0 ), 1 );
		}
		else
		{
		    operands[2] = XEXP ( XEXP ( operands[0], 0 ), 1 );
		    operands[3] = XEXP ( XEXP ( operands[0], 0 ), 0 );
		}
		
		if ( CONST_INT == GET_CODE ( operands[3] ) &&
		    ! INTVAL ( operands[3] ))
		{
		    if ( IS_SRC_OR_MPY_P ( REGNO ( operands[1] )))
		    {
			return fms ( "move	%1,@:(%2)+" SC
				     "move	%g1,@:(%2)-" );
		    }
		    else
		    {
			return fms ( "move	%h1,@:(%2)+" SC
				     "move	%1,@:(%2)-" );
		    }
		}
		else
		{
		    if ( IS_SRC_OR_MPY_P ( REGNO ( operands[1] )))
		    {
			return fms ( "move	%g1,@:(%2+%3+1)" SC
				     "move	%1,@:(%2+%3)" );
		    }
		    else
		    {
			return fms ( "move	%1,@:(%2+%3+1)" SC
				     "move	%h1,@:(%2+%3)" );
		    }
		}
	    }
	    else if ( POST_INC == GET_CODE ( XEXP ( operands[0], 0 )))
	    {
		operands[2] = XEXP ( XEXP ( operands[0], 0 ), 0 );
		
		if ( IS_SRC_OR_MPY_P ( REGNO ( operands[1] )))
		{
		    return fms ( "move	%1,@:(%2)+" SC
				 "move	%g1,@:(%2)+" );
		}
		else
		{
		    return fms ( "move	%h1,@:(%2)+" SC
				 "move	%1,@:(%2)+" );
		}
	    }
	    else if ( POST_DEC == GET_CODE ( XEXP ( operands[0], 0 )))
	    {
		operands[2] = XEXP ( XEXP ( operands[0], 0 ), 0 );
		
		if ( IS_SRC_OR_MPY_P ( REGNO ( operands[1] )))
		{
		    return fms ( "move	%1,@:(%2)+" SC
				 "move	%g1,@:(%2)-" SC
				 "move	(%2)-" SC
				 "move	(%2)-" );
		}
		else
		{
		    return fms ( "move	%h1,@:(%2)+" SC
				 "move	%1,@:(%2)-" SC
				 "move	(%2)-" SC
				 "move	(%2)-" );
		}
	    }
	    else if ( REG == GET_CODE ( XEXP ( operands[0], 0 )))
	    {
		operands[2] = XEXP ( operands[0], 0 );
		
		if ( IS_SRC_OR_MPY_P ( REGNO ( operands[1] )))
		{
		    return fms ( "move	%1,@:(%2)+" SC
				 "move	%g1,@:(%2)-" );
		}
		else
		{
		    return fms ( "move	%h1,@:(%2)+" SC
				 "move	%1,@:(%2)-" );
		}
	    }
	    else
	    {
		if ( IS_SRC_OR_MPY_P ( REGNO ( operands[1] )))
		{
		    return "move	%1,%0" SC
			   "move	%g1,%0+1";
		}
		else
		{
		    return "move	%h1,%0" SC
			   "move	%1,%0+1";
		}
	    }
	}
	
    case 3:
	if ( 'l' == memory_model )
	{
	    if ( PLUS == GET_CODE ( XEXP ( operands[1], 0 )))
	    {
		if ( REG == GET_CODE ( XEXP ( XEXP ( operands[1], 0 ), 0 )))
		{
		    operands[2] = XEXP ( XEXP ( operands[1], 0 ), 0 );
		    operands[3] = XEXP ( XEXP ( operands[1], 0 ), 1 );
		}
		else
		{
		    operands[2] = XEXP ( XEXP ( operands[1], 0 ), 1 );
		    operands[3] = XEXP ( XEXP ( operands[1], 0 ), 0 );
		}
		
		if ( IS_SRC_OR_MPY_P ( REGNO ( operands[0] )))
		{
		    return "move	x:(%2+%3),%g0" SC
			   "move	y:(%2+%3),%0";
		}
		else
		{
		    return "move	x:(%2+%3),%0" SC
			   "move	y:(%2+%3),%h0";
		}
	    }
	    
	    else if ( IS_SRC_OR_MPY_P ( REGNO ( operands[0] )))
	    {
		return "move	%1,%m0";
	    }
	    else
	    {
		return "move	%1,%0";
	    }
	}
	else /* memory_model is x or y */
	{
	    if ( PLUS == GET_CODE ( XEXP ( operands[1], 0 )))
	    {
		if ( REG == GET_CODE ( XEXP ( XEXP ( operands[1], 0 ), 0 )))
		{
		    operands[2] = XEXP ( XEXP ( operands[1], 0 ), 0 );
		    operands[3] = XEXP ( XEXP ( operands[1], 0 ), 1 );
		}
		else
		{
		    operands[2] = XEXP ( XEXP ( operands[1], 0 ), 1 );
		    operands[3] = XEXP ( XEXP ( operands[1], 0 ), 0 );
		}
		
		if ( CONST_INT == GET_CODE ( operands[3] ) &&
		    ! INTVAL ( operands[3] ))
		{
		    if ( IS_SRC_OR_MPY_P ( REGNO ( operands[0] )))
		    {
			return fms ( "move	(%2)+" SC
				     "move	@:(%2)-,%g0" SC
				     "move	@:(%2),%0" );
		    }
		    else
		    {
			return fms ( "move	(%2)+" SC
				     "move	@:(%2)-,%0" SC
				     "move	@:(%2),%h0" );
		    }
		}
		else
		{
		    if ( IS_SRC_OR_MPY_P ( REGNO ( operands[0] )))
		    {
			return fms ( "move	@:(%2+%3+1),%g0" SC
				     "move	@:(%2+%3),%0" );
		    }
		    else
		    {
			return fms ( "move	@:(%2+%3+1),%0" SC
				     "move	@:(%2+%3),%h0" );
		    }
		}
	    }
	    else if ( POST_INC == GET_CODE ( XEXP ( operands[1], 0 )))
	    {
		operands[2] = XEXP ( XEXP ( operands[1], 0 ), 0 );
		
		if ( IS_SRC_OR_MPY_P ( REGNO ( operands[0] )))
		{
		    return fms ( "move	(%2)+" SC
				 "move	@:(%2)-,%g0" SC
				 "move	@:(%2)+,%0" SC
				 "move	(%2)+" );
		}
		else
		{
		    return fms ( "move	(%2)+" SC
				 "move	@:(%2)-,%0" SC
				 "move	@:(%2)+,%h0" SC
				 "move	(%2)+" );
		}
	    }
	    else if ( POST_DEC == GET_CODE ( XEXP ( operands[1], 0 )))
	    {
		operands[2] = XEXP ( XEXP ( operands[1], 0 ), 0 );
		
		if ( IS_SRC_OR_MPY_P ( REGNO ( operands[0] )))
		{
		    return fms ( "move	(%2)+" SC
				 "move	@:(%2)-,%g0" SC
				 "move	@:(%2)-,%0" SC
				 "move	(%2)-" );
		}
		else
		{
		    return fms ( "move	(%2)+" SC
				 "move	@:(%2)-,%0" SC
				 "move	@:(%2)-,%h0" SC
				 "move	(%2)-" );
		}
	    }
	    else if ( REG == GET_CODE ( XEXP ( operands[1], 0 )))
	    {
		operands[2] = XEXP ( operands[1], 0 );
		
		if ( IS_SRC_OR_MPY_P ( REGNO ( operands[0] )))
		{
		    return fms ( "move	(%2)+" SC
				 "move	@:(%2)-,%g0" SC
				 "move	@:(%2),%0" );
		}
		else
		{
		    return fms ( "move	(%2)+" SC
				 "move	@:(%2)-,%0" SC
				 "move	@:(%2),%h0" );
		}
	    }
	    else
	    {
		if ( IS_SRC_OR_MPY_P ( REGNO ( operands[0] )))
		{
		    return "move	%1+1,%g0" SC
			   "move	%1,%0";
		}
		else
		{
		    return "move	%1+1,%0" SC
			   "move	%1,%h0";
		}
	    }
	}
	
    case 4:
	{
	    if ( CONST_INT == GET_CODE ( operands[1] ))
	    {
		if ( IS_SRC_OR_MPY_P ( REGNO ( operands[0] )))
		{
		    if ( 0 == INTVAL ( operands[1] ))
		    {
			return "move	#0,%g0" SC
			       "move	#%1,%0";
		    }
		    else if ( 0 > INTVAL ( operands[1] ))
		    {
			return "move	#-1,%g0" SC
			       "move	#>%1,%0";
		    }
		    else
		    {
			return "move	#0,%g0" SC
			       "move	#>%1,%0";
		    }
		}
		else
		{
		    if ( 0 == INTVAL ( operands[1] ))
		    {
			return "clr	%0";
		    }
		    else if ( 0 > INTVAL ( operands[1] ))
		    {
			return "move	#-1,%0" SC
			       "move	#>%1,%h0";
		    }
		    else
		    {
			return "move	#0,%0" SC
			       "move	#>%1,%h0";
		    }
		}
	    }
	    
	    operands[2] =
		gen_rtx ( CONST_INT, VOIDmode, 
			 (( CONST_DOUBLE_LOW ( operands[1] ) >> 16 ) & 0x00ffff ));
	    operands[3] = 
		gen_rtx ( CONST_INT, VOIDmode,
			 ( CONST_DOUBLE_LOW ( operands[1] ) & 0x00ffff ));
	    
	    if ( IS_SRC_OR_MPY_P ( REGNO ( operands[0] )))
	    {
		if ( rtx_equal_p ( operands[2], operands[3] ))
		{
		    return "move	#>%2,%g0" SC
			   "move	%g0,%0";
		}
		else
		{
		    return "move	#>%2,%g0" SC
			   "move	#>%3,%0";
		}
	    }
	    else
	    {
		if ( 0 == INTVAL ( operands[3] ))
		{
		    if ( 0 == INTVAL ( operands[2] ))
		    {
			added_flags = (( added_flags & ~ CCS_NOT_AFFECTED ) |
				       CCS_SET_CORRECTLY );

			return "clr	%0";
		    }
		    else
		    {
			return "move	#>%2,%0";
		    }
		}
		else if ( 0 == INTVAL ( operands[2] ))
		{
		    return "move	#%2,%0" SC
			   "move	#>%3,%h0";
		}
		else
		{
		    if ( rtx_equal_p ( operands[2], operands[3] ))
		    {
			return "move	#>%2,%0" SC
			       "move	%0,%h0";
		    }
		    else
		    {
			return "move	#>%2,%0" SC
			       "move	#>%3,%h0";
		    }
		}
	    }
	}
    }
}


/* given an insn and a label, return 1 iff:
   1) the label immediately follows the passed insn, and
   2) the label only has a single reference, and
   3) the insn is an alu opcode. */

int alu_insn_code;


int
ifcc_combo_follows_p ( insn, label )
    rtx insn, label;
{
    rtx next = NEXT_INSN ( insn );
    
    /* make sure we're dealing with an alu opcode. */
    alu_insn_code = INSN_CODE ( insn );
    if ( ! ( get_spec_bits ( insn_machine_info[alu_insn_code].spec_bits )
	    & IFCCABLE_OP_CODE ))
    {
	return 0;
    }
    
    /* check for a single label reference. */
    if ( 1 != LABEL_NUSES ( label ))
    {
	return 0;
    }

    /* verify that our CODE_LABEL follows that. */
    while ( (NULL != next) && (NOTE == GET_CODE ( next )))
    {
	next = NEXT_INSN ( next );
    }
    
    if ( label != next )
    {
	return 0;
    }
    return 1;
}

int
max_combo_follows_p ( insn, label )
    rtx insn, label;
{
    rtx next = NEXT_INSN ( insn );
    rtx body = PATTERN ( insn );
    
    /* make sure we're dealing with an acc->acc tfr opcode. */
    if ( GET_MODE ( SET_SRC ( body )) != GET_MODE ( SET_DEST ( body )) ||
	REGNO ( SET_DEST ( body )) > DSP_B_REGNUM ||
	REGNO ( SET_SRC ( body )) > DSP_B_REGNUM )
    {
	return 0;
    }
    
    /* check for a single label reference. */
    if ( 1 != LABEL_NUSES ( label ))
    {
	return 0;
    }

    /* verify that our CODE_LABEL follows that. */
    while ( NOTE == GET_CODE ( next ))
    {
	next = NEXT_INSN ( next );
    }
    
    if ( label != next )
    {
	return 0;
    }
    return 1;
}

char *insn_template[];

static char*
output_ifcc ( insn, operands, cond_index, flip_p )
    rtx insn, operands[];
    int cond_index, flip_p;
{
    static char buffer[BUFSIZ];
    
    /* if we need to, flip the conditional. */
    if ( flip_p )
    {
	PUT_CODE ( operands[cond_index],
		  reverse_condition ( GET_CODE ( operands[cond_index] )));
    }
	
    /* delete the follow-on label. */
    {
        rtx next = NEXT_INSN ( insn );
	
	while ( CODE_LABEL != GET_CODE ( next ))
	{
	    next = NEXT_INSN ( next );
	}
	PUT_CODE ( next, NOTE );
	INSN_DELETED_P ( next ) = 1;

	PUT_CODE ( insn, INSN );
    }
    
    /* pump the insn template into the buffer. */
    {
	extern int alu_insn_code;
	char *template = insn_template[alu_insn_code];

	if ( NULL == template )
	{
	    template = ( *insn_outfun[alu_insn_code] ) ( operands, insn );
	}
	(void) strcpy ( buffer, template );
    }
    
    /* append the ifcc to the template. */
    (void) sprintf ( buffer + strlen ( buffer ), "\tif%%%d.u", cond_index );

    return buffer;
}

static char*
output_max ( insn )
    rtx insn;
{
    /* delete the follow-on label. */
    {
        rtx next = NEXT_INSN ( insn );
	
	while ( CODE_LABEL != GET_CODE ( next ))
	{
	    next = NEXT_INSN ( next );
	}
	PUT_CODE ( next, NOTE );
	INSN_DELETED_P ( next ) = 1;
    }
    
    added_flags = CCS_SET_CORRECTLY;

    return "max	%1,%0";
}

void
gen_int_logical ( alu_op, operands )
    enum rtx_code alu_op;
    rtx *operands;
{
    int one_count ( ), zero_count ( );
    rtx force_reg ( );
    
    int (*bit_counter) ( );
    enum rtx_code bit_op;
    
    switch ( alu_op )
    {
    case AND:
	bit_counter = zero_count;
	bit_op = BITCLR;
	break;
	
    case IOR:
	bit_counter = one_count;
	bit_op = BITSET;
	break;
	
    case XOR:
	bit_counter = one_count;
	bit_op = BITCHG;
    }

    if ( CONST_INT == GET_CODE ( operands[2] ))
    {
	rtx dest = operands[0];
	
	switch (( * bit_counter ) ( INTVAL ( operands[2] ), 16 ))
	{
	case 0:
	    /* this mask has no effect. just emit nothing. */
	    return;

	case 1:
	case 2:
	case 3:
	case 4:
	    /* use single bit ops */
	    
	    if ( MEM == GET_CODE ( operands[0] ) && 
		rtx_equal_p ( operands[0], operands[1] ) &&
		! restricted_memory_operand ( operands[1], SImode ))
	    {
		/* we need to make the memory address acceptable. */
		
		dest = operands[0] = operands[1] = copy_rtx ( operands[0] );
		
		XEXP ( operands[0], 0 ) =
		    force_reg ( Pmode, XEXP ( operands[0], 0 ));
	    }
	    else if ( ! ( restricted_memory_operand ( operands[0], SImode ) &&
			 rtx_equal_p ( operands[0], operands[1] )))
	    {
		/* we need to act on a register. if operand[0] is 
		   already a register, then we'll use it. also, the
		   data source must be in the same register. */
		
		if ( ! REG_P ( operands[0] ))
		{
		    dest = gen_reg_rtx ( SImode );
		}
		
		if ( ! rtx_equal_p ( dest, operands[1] ))
		{
		    emit_move_insn ( dest, operands[1] );
		}
	    }
	    
            {
		int count = 0, mask = INTVAL ( operands[2] );
		
		for ( ; count < 16; ++ count )
		{
		    if (( AND == alu_op && ! ( mask & 1 )) ||
			( AND != alu_op && ( mask & 1 )))
		    {
			emit_insn
			    ( gen_rtx 
			     ( SET, SImode, dest,
			      gen_rtx ( bit_op, SImode, dest, gen_rtx
				       ( CONST_INT, VOIDmode, count ))));
		    }
		    mask >>= 1;
		}
	    }
	    
	    if ( dest != operands[0] )
	    {
		emit_move_insn ( operands[0], dest );
	    }
	    return;
	
	case 16:
	    /* this is a simple set. */
	    switch ( alu_op )
	    {
	    case AND:
		emit_move_insn ( operands[0], const0_rtx );
		break;
		
	    case IOR:
		emit_move_insn
		    ( operands[0], gen_rtx ( CONST_INT, VOIDmode, -1 ));
		break;
		
	    case XOR:
		if ( ! REG_P ( operands[0] ))
		{
		    dest = gen_reg_rtx ( SImode );
		}
		
		if ( ! rtx_equal_p ( dest, operands[1] ))
		{
		    emit_move_insn ( dest, operands[1] );
		}
		
		emit_insn ( gen_rtx ( SET, SImode, dest,
				     gen_rtx ( NOT, SImode, dest )));
		
		if ( dest != operands[0] )
		{
		    emit_move_insn ( operands[0], dest );
		}
	    }
	    return;
	}
	
	/* just perform a typical 'and' using an immediate. */
	
	if ( ! REG_P ( operands[0] ))
	{
	    dest = gen_reg_rtx ( SImode );
	}
	
	if ( ! rtx_equal_p ( dest, operands[1] ))
	{
	    emit_move_insn ( dest, operands[1] );
	}
	
	emit_insn ( gen_rtx ( SET, SImode, dest, gen_rtx
			     ( alu_op, SImode, dest, operands[2] )));
	
	if ( dest != operands[0] )
	{
	    emit_move_insn ( operands[0], dest );
	}
    }
    else
    {
	/* just perform a typical 'and' using a register. */
	
	rtx dest = ( REG_P ( operands[0] ))
	    ? operands[0] : gen_reg_rtx ( SImode );
	
	if ( ! rtx_equal_p ( dest, operands[1] ))
	{
	    emit_move_insn ( dest, operands[1] );
	}
	
	if ( ! REG_P ( operands[2] ))
	{
	    operands[2] = force_reg ( SImode, operands[2] );
	}
	
	emit_insn ( gen_rtx ( SET, SImode, dest, gen_rtx
			     ( alu_op, SImode, dest, operands[2] )));
	
	if ( dest != operands[0] )
	{
	    emit_move_insn ( operands[0], dest );
	}
    }
}

void
gen_long_logical ( alu_op, operands )
    enum rtx_code alu_op;
    rtx *operands;
{
    int one_count ( ), zero_count ( );
    rtx force_reg ( );
    
    int (*bit_counter) ( );
    enum rtx_code bit_op;
    
    switch ( alu_op )
    {
    case AND:
	bit_counter = zero_count;
	bit_op = BITCLR;
	break;
	
    case IOR:
	bit_counter = one_count;
	bit_op = BITSET;
	break;
	
    case XOR:
	bit_counter = one_count;
	bit_op = BITCHG;
    }

    if ( CONST_DOUBLE == GET_CODE ( operands[2] ) &&
	! TARGET_CONSERVE_P_MEM )
    {
	rtx dest = operands[0];
	
	switch (( * bit_counter ) ( upper_16 ( operands[2] ), 16 ) +
		( * bit_counter ) ( lower_16 ( operands[2] ), 16 ))
	{
	case 0:
	    /* this mask has no effect. just emit nothing. */
	    return;

	case 1:
	case 2:
	case 3:
	case 4:
	case 5:
	case 6:
	case 7:
	case 8:
	case 9:
	case 10:
	    /* use single bit ops */
	    
	    if ( MEM == GET_CODE ( operands[0] ) && 
		rtx_equal_p ( operands[0], operands[1] ) &&
		! restricted_memory_operand ( operands[1], DImode ))
	    {
		/* we need to make the memory address acceptable. */
		
		dest = operands[0] = operands[1] = copy_rtx ( operands[0] );
		
		XEXP ( operands[0], 0 ) =
		    force_reg ( Pmode, XEXP ( operands[1], 0 ));
	    }
	    else if ( ! ( restricted_memory_operand ( operands[0], DImode ) &&
			 rtx_equal_p ( operands[0], operands[1] )))
	    {
		/* we need to act on a register. if operand[0] is 
		   already a register, then we'll use it. also, the
		   data source must be in the same register. */
		
		if ( ! REG_P ( operands[0] ))
		{
		    dest = gen_reg_rtx ( DImode );
		}
		
		if ( ! rtx_equal_p ( dest, operands[1] ))
		{
		    emit_move_insn ( dest, operands[1] );
		}
	    }
	    
            {
		int count = 0, mask = lower_16 ( operands[2] );
		
		for ( ; count < 16; ++ count )
		{
		    if (( AND == alu_op && ! ( mask & 1 )) ||
			( AND != alu_op && ( mask & 1 )))
		    {
			emit_insn
			    ( gen_rtx 
			     ( SET, DImode,
			      dest, gen_rtx ( bit_op, DImode, dest, gen_rtx
					     ( CONST_INT, VOIDmode, count ))));
		    }
		    mask >>= 1;
		}
        
		for ( mask = upper_16 ( operands[2] ); count < 32; ++ count )
		{
		    if (( AND == alu_op && ! ( mask & 1 )) ||
			( AND != alu_op && ( mask & 1 )))
		    {
			emit_insn
			    ( gen_rtx
			     ( SET, DImode,
			      dest, gen_rtx ( bit_op, DImode, dest, gen_rtx
					     ( CONST_INT, VOIDmode, count ))));
		    }
		    mask >>= 1;
		}
	    }
	    
	    if ( dest != operands[0] )
	    {
		emit_move_insn ( operands[0], dest );
	    }
	    return;
	
	case 32:
	    /* this is a simple set. */
	    switch ( alu_op )
	    {
	    case AND:
		emit_move_insn ( operands[0], dconst0_rtx );
		break;
		
	    case IOR:
		emit_move_insn
		    ( operands[0], gen_rtx
		     ( CONST_DOUBLE, VOIDmode, NULL, -1, -1 ));
		break;
		
	    case XOR:
		if ( ! REG_P ( operands[0] ))
		{
		    dest = gen_reg_rtx ( DImode );
		}
		
		if ( ! rtx_equal_p ( dest, operands[1] ))
		{
		    emit_move_insn ( dest, operands[1] );
		}
		
		emit_insn
		    ( gen_rtx
		     ( SET, DImode, dest, gen_rtx ( NOT, DImode, dest )));
		
		if ( dest != operands[0] )
		{
		    emit_move_insn ( operands[0], dest );
		}
	    }
	    return;
	}
	
	/* just perform a typical 'and' using an immediate. */
	
	if ( ! REG_P ( operands[0] ))
	{
	    dest = gen_reg_rtx ( DImode );
	}
	
	if ( ! rtx_equal_p ( dest, operands[1] ))
	{
	    emit_move_insn ( dest, operands[1] );
	}
	
	emit_insn
	    ( gen_rtx ( SET, DImode, dest, gen_rtx
		       ( alu_op, DImode, dest, operands[2] )));
	
	if ( dest != operands[0] )
	{
	    emit_move_insn ( operands[0], dest );
	}
    }
    else
    {
	/* just perform a typical 'and' using a register. */
	
	rtx dest = ( REG_P ( operands[0] ))
	    ? operands[0] : gen_reg_rtx ( DImode );
	
	if ( ! rtx_equal_p ( dest, operands[1] ))
	{
	    emit_move_insn ( dest, operands[1] );
	}
	
	if ( ! REG_P ( operands[2] ))
	{
	    operands[2] = force_reg ( DImode, operands[2] );
	}
	
	emit_insn ( gen_rtx ( SET, DImode, dest, gen_rtx
			     ( alu_op, DImode, dest, operands[2] )));
	
	if ( dest != operands[0] )
	{
	    emit_move_insn ( operands[0], dest );
	}
    }
}

#if 0
char*
output_long_mem_bitop ( name, operands )
    char *name;
    rtx *operands;
{
    operands[2] = gen_rtx ( SYMBOL_REF, VOIDmode, name );
    
    if ( TARGET_L_MEMORY )
    {
	/* LSW in x memory, MSW in y memory. */

	operands[0] = XEXP ( operands[0], 0 );

	if ( 15 < INTVAL ( operands[1] ))
	{
	    operands[1] = gen_rtx
		( CONST_INT, VOIDmode, INTVAL ( operands[1] ) - 16 );

	    return "b%2	#%1,x:%0";
	}
	else
	{
	    return "b%2	#%1,y:%0";
	}
    }
    else
    {
	operands[0] = XEXP ( operands[0], 0 );

	/* LSW @ address, MSW @ address + 1. */

	if ( 15 < INTVAL ( operands[1] ))
	{
	    operands[1] = gen_rtx
		( CONST_INT, VOIDmode, INTVAL ( operands[1] ) - 16 );
	    operands[0] = plus_constant ( XEXP ( operands[0], 0 ), 1 );
	    
	    return fms ( "b%2	#%1,@:%0" );
	}
	else
	{
	    return fms ( "b%2	#%1,@:%0" );
	}
    }
}

char*
output_long_reg_bitop ( name, operands )
    char *name;
    rtx *operands;
{ 
    operands[3] = gen_rtx ( SYMBOL_REF, VOIDmode, name );
    
    if ( 15 < INTVAL ( operands[1] ))
    {
	operands[2] = gen_rtx
	    ( CONST_INT, VOIDmode, INTVAL ( operands[2] ) - 16 );
	
	if ( DSP_B_REGNUM >= REGNO ( operands[0] ))
	{
	    return "b%3	#%2,%e0";
	}
	else
	{
	    return "b%3	#%2,%g0";
	}
    }
    else
    {
	return "b%3	#%2,%h0";
    }
}
#endif

char*
output_pic_dep ( template, pic_yes, pic_no, which_operand, operands )
    char *template, *pic_yes, *pic_no;
    int which_operand;
    rtx *operands;
{
    operands[which_operand] = gen_rtx
	( SYMBOL_REF, VOIDmode, ( TARGET_PIC & 0  ) ? pic_yes : pic_no );

    return template;
}
    
char*
output_long_reg_logical ( name, operands )
    char *name;
    rtx *operands;
{
    operands[3] = gen_rtx ( SYMBOL_REF, VOIDmode, name );
    
    if ( which_alternative )
    {
  	return "%3	%g2,%0	%h0,n6" SC
	       "move	%e0,%h0" SC
	       "move	n6,%e0" SC
	       "%3	%2,%0" SC
	       "move	%e0,n6" SC
	       "move	%h0,%0" SC
	       "move	n6,%h0";
    }
    else
    {
  	return "%3	#%e2,%0" SC
	       "move	%h0,n6" SC
	       "move	%e0,%h0" SC
	       "move	n6,%e0" SC
	       "%3	#%h2,%0" SC
	       "move	%e0,n6" SC
	       "move	%h0,%0" SC
	       "move	n6,%h0";
    }
}


void
local_output_double ( file, value )
    FILE* file;
    double value;
{
    unsigned int memory_value = get_float_format ( value );
    unsigned int H_word;
    unsigned int L_word;
 
#if defined( __WATCOMC__ ) || defined(_MSDOS)
    H_word = ( memory_value & 0xffff );
    L_word = (( memory_value >> 16 ) & 0xffff );
#else
    H_word = (( memory_value >> 16 ) & 0xffff );
    L_word = ( memory_value & 0xffff );
#endif

    if (NULL != file)
    {
        if ('l' == memory_model)
        {
            fprintf (file, "\tdc\t$%04x%04x\n", H_word, L_word);
        }
        else
        {
            fprintf (file, "\tdc\t$%04x\n\tdc\t$%04x\n", L_word, H_word);
        }
    }
 
}


#include "config/dsp.c"

