/* subroutines for insn-output.c for motorola dsp56000/1
   copyright ( c ) 1988 free software foundation, inc.

this file is part of gnu cc.

gnu cc is distributed in the hope that it will be useful,
but without any warranty.  no author or distributor
accepts responsibility to anyone for the consequences of using it
or for whether it serves any particular purpose or works at all,
unless he says so in writing.  refer to the gnu cc general public
license for full details.

everyone is granted permission to copy, modify and redistribute
gnu cc, but only under the conditions described in the
gnu cc general public license.	 a copy of this license is
supposed to have been given to you along with gnu cc so you
can know your rights and responsibilities.  it should be in a
file named copying.  among other things, the copyright notice
and this notice must be preserved on all copies.  */

#define SC "\n\t"
static char* fms ( );

#ifndef file
#include <stdio.h>
#endif

#include <string.h>
#if defined ( _MSDOS )
extern void *malloc( );
#endif

#include <ctype.h>

#include "flags.h"
#include "tree.h"
#if ! defined( _MSDOS )
#include "hard-reg-set.h"
#else
#include "hardrset.h"
#endif

char mem_space = 'y';
char memory_model = 'y';

union real_extract adjusted_dval;
rtx clean_subregs ( );

func_attributes current_func_info = FUNC_NO_INFO;

static char local_call_used_regs[] = CALL_USED_REGISTERS;
enum reg_class regno_reg_class ( );

int FirstSave;


/* this extraneous function is needed because the MetaWare C compiler
   can't handle the comma operator with pointer values. */

#define N_REG_COUNT 8
#define FIRST_N_REG 6

static rtx current_n_reg_value[ N_REG_COUNT ];


void
clear_n_reg_values ( )
{
    int i = N_REG_COUNT;
    
    while ( i -- )
    {
	current_n_reg_value[i] = NULL;
    }
}


int
load_n_reg_p ( reg, new_value )
    rtx reg, new_value;
{
    if ( current_n_reg_value[ REGNO ( reg ) - FIRST_N_REG ] &&
	rtx_equal_p ( current_n_reg_value[ REGNO ( reg ) - FIRST_N_REG ], 
		      new_value ) &&
	CONSTANT_P ( new_value ))
    {
	return 0;
    }
    else
    {
	current_n_reg_value[ REGNO ( reg ) - FIRST_N_REG ] =  new_value;

	return 1;
    }
}
	


char*
assemble_move_singleword ( operands )
    rtx *operands;
{
    extern char mem_space;
    
    /* cases:
           op1     to   op0
	  --------------------
       1) register to register
       2) constant to register
       3) memory to register 
       4) register to memory */

    rtx base_op0 = clean_subregs ( operands[0] ),
        base_op1 = clean_subregs ( operands[1] );
    
#if !defined( MSIL_DISABLE )
    if ( late_rtx_equal_p ( base_op0, base_op1 ))
#else
    if ( rtx_equal_p ( base_op0, base_op1 ))
#endif
    {
	return "";
    }
    
    if ( REG_P ( base_op0 ))
    {
	/* cases 1-3 */

	if ( REG_P ( base_op1 ))
	{
	    /* case 1: register transfer */

	    if ( DSP_B_REGNUM >= REGNO ( base_op0 ))
	    {
		/* we're moving into an accumulator. */
		
		if ( MEM_IN_STRUCT_P ( base_op0 ) ||
		    MEM_IN_STRUCT_P ( base_op1 ))
		{
		    return "move	%1,%0";
		}
		
		return "tfr	%1,%0";
	    }

	    return "move	%e1,%0";
	}
	else if ( LEGITIMATE_CONSTANT_P ( base_op1 ))
	{
	    /* case 2: constant load into a register */

	    if ( DSP_B_REGNUM >= REGNO ( base_op0 ) && ! INTVAL ( base_op1 ))
	    {
		return "clr	%0";
	    }

	    return "move	#>%1,%0";
	}
	else if ( MEM == GET_CODE ( base_op1 ))
	{
	    /* case 3: memory load into a register */

	    if ( PLUS == GET_CODE ( XEXP ( base_op1, 0 )))
	    {
		if ( REG_P ( XEXP ( XEXP ( base_op1, 0 ), 0 )))
		{
		    operands[2] = XEXP ( XEXP ( base_op1, 0 ), 0 );
		    operands[3] = XEXP ( XEXP ( base_op1, 0 ), 1 );
		}
		else
		{
		    operands[2] = XEXP ( XEXP ( base_op1, 0 ), 1 );
		    operands[3] = XEXP ( XEXP ( base_op1, 0 ), 0 );
		}
		
		if ( CONST_INT != GET_CODE ( operands[3] ))
		{
		    if ( load_n_reg_p ( operands[2], operands[3] ))
		    {
			return fms ( "move	#%p3,%j2" SC
				    "move	@:(%2+%j2),%0" );
		    }
		    else
		    {
			return fms ( "move	@:(%2+%j2),%0" );
		    }
		}
		
		switch ( INTVAL ( operands[3] ))
		{
		case 0:
		    return fms ( "move	@:(%2),%0" );
		    
		case 1:
		    if ( REGNO ( base_op0 ) != REGNO ( operands[2] ))
		    {
			return fms ( "move	(%2)+" SC
				    "move	@:(%2)-,%0" );
		    }
		    
		case -1:
		    if ( REGNO ( base_op0 ) != REGNO ( operands[2] ))
		    {
			return fms ( "move	(%2)-" SC
				    "move	@:(%2)+,%0" );
		    }
		    
		default:
		    if ( load_n_reg_p ( operands[2], operands[3] ))
		    {
			return fms ( "move	#%p3,%j2" SC
				    "move	@:(%2+%j2),%0" );
		    }
		    else
		    {
			return fms ( "move	@:(%2+%j2),%0" );
		    }
		}
	    }
	    else
	    {
		return "move	%1,%0";
	    }
	}
    }
    else if ( REG_P ( base_op1 ) && MEM == GET_CODE ( base_op0 ))
    {
	/* case 4: register store into memory */

	if ( PLUS == GET_CODE ( XEXP ( base_op0, 0 )))
	{
	    if ( REG_P ( XEXP ( XEXP ( base_op0, 0 ), 0 )))
	    {
		operands[2] = XEXP ( XEXP ( base_op0, 0 ), 0 );
		operands[3] = XEXP ( XEXP ( base_op0, 0 ), 1 );
	    }
	    else
	    {
		operands[2] = XEXP ( XEXP ( base_op0, 0 ), 1 );
		operands[3] = XEXP ( XEXP ( base_op0, 0 ), 0 );
	    }
	    
	    if ( CONST_INT != GET_CODE ( operands[3] ))
	    {
		if ( load_n_reg_p ( operands[2], operands[3] ))
		{
		    return fms ( "move	#%p3,%j2" SC
				 "move	%e1,@:(%2+%j2)" );
		}

		return fms ( "move	%e1,@:(%2+%j2)" );
	    }
	    
	    switch ( INTVAL ( operands[3] ))
	    {
	    case 0:
		return fms ( "move	%e1,@:(%2)" );
		    
	    case 1:
		if ( REGNO ( operands[2] ) != REGNO ( base_op1 ))
		{
		    return fms ( "move	(%2)+" SC
				 "move	%e1,@:(%2)-" );
		}
		    
	    case -1:
		if ( REGNO ( operands[2] ) != REGNO ( base_op1 ))
		{
		    return fms ( "move	(%2)-" SC
				 "move	%e1,@:(%2)+" );
		}
		
	    default:
		if ( load_n_reg_p ( operands[2], operands[3] ))
		{
		    return fms ( "move	#%p3,%j2" SC
				 "move	%e1,@:(%2+%j2)" );
		}

		return fms ( "move	%e1,@:(%2+%j2)" );
	    }
	}

	return "move	%e1,%0";
    }
}


char*
assemble_move_doubleword ( is_float_p, operands )
    int is_float_p;
    rtx *operands;
{
    extern char mem_space;
    
    /* cases:
           op1     to   op0
	  --------------------
       1) register to register
       2) constant to register
       3) memory to register 
       4) register to memory */

    rtx base_op0 = clean_subregs ( operands[0] ),
        base_op1 = clean_subregs ( operands[1] );
    
    if ( rtx_equal_p ( base_op0, base_op1 ))
    {
	return "";
    }
    
    if ( REG_P ( base_op0 ))
    {
	/* cases 1-3 */
	
	if ( REG_P ( base_op1 ))
	{
	    /* case 1: register transfer */

	    if ( DSP_B_REGNUM >= REGNO ( base_op0 ))
	    {
		/* we're storing into an accumulator */

		if ( DSP_R0_REGNUM > REGNO ( base_op1 ) && 
		    DSP_B_REGNUM < REGNO ( base_op1 ))
		{
		    /* we're moving from an x or y register. */

		    if ( MEM_IN_STRUCT_P ( base_op0 )  ||
			MEM_IN_STRUCT_P ( base_op1 ))
		    {
			return "move	%g1,%0" SC
			       "move	%1,%h0";
		    }

		    return "tfr	%g1,%0" SC
			   "move	%1,%h0";
		}

		/* we're moving from an accumulator. */

		if ( MEM_IN_STRUCT_P ( base_op0 ) ||
		    MEM_IN_STRUCT_P ( base_op1 ))
		{
		    return "move	%1,%0";
		}

		return "tfr	%1,%0";
	    }

	    /* we're storing into an x or y register. */

	    if ( DSP_R0_REGNUM > REGNO ( base_op1 ) && 
		DSP_B_REGNUM < REGNO ( base_op1 ))
	    {
		/* we're moving from an x or y register. */

		return "move	%g1,%g0" SC
		       "move	%1,%0";
	    }

	    /* we're moving from an accumulator. */

	    return "move	%e1,%g0" SC
		   "move	%h1,%0";
	}
	else if ( LEGITIMATE_CONSTANT_P ( base_op1 ))
	{
	    /* case 2: constant load into a register */

	    if ( is_float_p )
	    {

		/* we're being called on to load a F.P. constant. */

		union real_extract* watcom_stink =
		    (union real_extract*) &CONST_DOUBLE_LOW ( base_op1 );
		
		dtok ( NULL, watcom_stink->d );
	    	
		operands[2] =
		    gen_rtx ( CONST_INT, VOIDmode, adjusted_dval.i[1] );
		
		operands[3] = 
		    gen_rtx ( CONST_INT, VOIDmode, adjusted_dval.i[0] );
		
		if ( DSP_R0_REGNUM > REGNO ( base_op0 ) && 
		    DSP_B_REGNUM < REGNO ( base_op0 ))
		{
		    /* we're loading an x or y register. */

		    return "move	#>%2,%g0" SC
			   "move	#>%3,%0";
		}

		/* we're loading an accumulator. */

		if ( ! INTVAL ( operands[3] ))
		{
		    if ( ! INTVAL ( operands[2] ))
		    {
			return "clr	%0";
		    }

		    return "move	#>%2,%0";
		}

		return "move	#>%2,%0" SC
		       "move	#>%3,%h0";
	    }

	    /* this isn't a F.P. constant. */

	    if ( CONST_INT == GET_CODE ( base_op1 ))
	    {
		/* it's a single word constant. */

		if ( DSP_R0_REGNUM > REGNO ( base_op0 ) && 
		    DSP_B_REGNUM < REGNO ( base_op0 ))
		{
		    if ( ! INTVAL ( base_op1 ))
		    {
			return "move	#0,%g0" SC
			       "move	#%1,%0";
		    }
		    else if ( 0 > INTVAL ( base_op1 ))
		    {
			return "move	#-1,%g0" SC
			       "move	#>%1,%0";
		    }

		    return "move	#0,%g0" SC
			   "move	#>%1,%0";
		}

		if ( ! INTVAL ( base_op1 ))
		{
		    return "clr	%0";
		}
		else if ( 0 > INTVAL ( base_op1 ))
		{
		    return "move	#-1,%0" SC
			   "move	#>%1,%h0";
		}

		return "move	#0,%0" SC
		       "move	#>%1,%h0";
	    }
	    
	    /* it's a double word constant. */

	    operands[2] =
		gen_rtx
		    ( CONST_INT, VOIDmode, 
		     (( CONST_DOUBLE_LOW ( base_op1 ) >> 24 ) & 0x0000ff ) |
		     (( CONST_DOUBLE_HIGH ( base_op1 ) << 8 ) & 0xffff00 ));
	    operands[3] = 
		gen_rtx ( CONST_INT, VOIDmode,
			 ( CONST_DOUBLE_LOW ( base_op1 ) & 0xffffff ));
	    
	    if ( DSP_R0_REGNUM > REGNO ( base_op0 ) && 
		DSP_B_REGNUM < REGNO ( base_op0 ))
	    {
		/* we're loading a x or y register. */

		if ( rtx_equal_p ( operands[2], operands[3] ))
		{
		    return "move	#>%2,%g0" SC
			   "move	%g0,%0";
		}

		return "move	#>%2,%g0" SC
		       "move	#>%3,%0";
	    }

	    /* we're loading an accumulator. */

	    if ( ! INTVAL ( operands[3] ))
	    {
		if ( ! INTVAL ( operands[2] ))
		{
		    return "clr	%0";
		}

		return "move	#>%2,%0";
	    }
	    if ( rtx_equal_p ( operands[2], operands[3] ))
	    {
		return "move	#>%2,%0" SC
		       "move	%0,%h0";
	    }

	    return "move	#>%2,%0" SC
		   "move	#>%3,%h0";
	}
	else if ( MEM == GET_CODE ( base_op1 ))
	{
	    /* case 3: memory load into a register */

	    if ( TARGET_L_MEMORY )
	    {
		if ( PLUS == GET_CODE ( XEXP ( base_op1, 0 )))
		{
		    if ( REG_P ( XEXP ( XEXP ( base_op1, 0 ), 0 )))
		    {
			operands[2] = XEXP ( XEXP ( base_op1, 0 ), 0 );
			operands[3] = XEXP ( XEXP ( base_op1, 0 ), 1 );
		    }
		    else
		    {
			operands[2] = XEXP ( XEXP ( base_op1, 0 ), 1 );
			operands[3] = XEXP ( XEXP ( base_op1, 0 ), 0 );
		    }
		    
		    if ( CONST_INT != GET_CODE ( operands[3] ))
		    {
			if ( DSP_R0_REGNUM > REGNO ( base_op0 ) && 
			    DSP_B_REGNUM < REGNO ( base_op0 ))
			{
			    /* we're loading a x or y register. */

			    if ( load_n_reg_p ( operands[2], operands[3] ))
			    {
				return "move	#%p3,%j2" SC
				       "move	l:(%2+%j2),%m0";
			    }
			    else
			    {
				return "move	l:(%2+%j2),%m0";
			    }
			}
			/* we're loading an accumulator. */
			
			if ( load_n_reg_p ( operands[2], operands[3] ))
			{
			    return "move	#%p3,%j2" SC
				   "move	l:(%2+%j2),%0";
			}
			
			return "move	l:(%2+%j2),%0";
		    }
		    
		    switch ( INTVAL ( operands[3] ))
		    {
		    case 0:
			if ( IS_SRC_OR_MPY_P ( REGNO ( base_op0 )))
			{
			    return "move	l:(%2),%m0";
			}

			return "move	l:(%2),%0";
			
		    case 1:
			if ( IS_SRC_OR_MPY_P ( REGNO ( base_op0 )))
			{
			    return "move	(%2)+" SC
				   "move	l:(%2)-,%m0";
			}

			return "move	(%2)+" SC
			       "move	l:(%2)-,%0";
			
		    case -1:
			if ( DSP_R0_REGNUM > REGNO ( base_op0 ) && 
			    DSP_B_REGNUM < REGNO ( base_op0 ))
			{
			    return "move	(%2)-" SC
				   "move	l:(%2)+,%m0";
			}

			return "move	(%2)-" SC
			       "move	l:(%2)+,%0";
			
		    default:
			if ( DSP_R0_REGNUM > REGNO ( base_op0 ) && 
			    DSP_B_REGNUM < REGNO ( base_op0 ))
			{
			    if ( load_n_reg_p ( operands[2], operands[3] ))
			    {
				return "move	#%p3,%j2" SC
				       "move	l:(%2+%j2),%m0";
			    }

			    return "move	l:(%2+%j2),%m0";
			}
			
			if ( load_n_reg_p ( operands[2], operands[3] ))
			{
			    return "move	#%p3,%j2" SC
				   "move	l:(%2+%j2),%0";
			}
			
			return "move	l:(%2+%j2),%0";
		    }
		}

		if ( DSP_R0_REGNUM > REGNO ( base_op0 ) && 
		    DSP_B_REGNUM < REGNO ( base_op0 ))
		{
		    return "move	%1,%m0";
		}
		
		return "move	%1,%0";
	    }
	    else /* memory_model is x or y */
	    {
		if ( PLUS == GET_CODE ( XEXP ( base_op1, 0 )))
		{
		    if ( REG == GET_CODE ( XEXP ( XEXP ( base_op1, 0 ), 0 )))
		    {
			operands[2] = XEXP ( XEXP ( base_op1, 0 ), 0 );
			operands[3] = XEXP ( XEXP ( base_op1, 0 ), 1 );
		    }
		    else
		    {
			operands[2] = XEXP ( XEXP ( base_op1, 0 ), 1 );
			operands[3] = XEXP ( XEXP ( base_op1, 0 ), 0 );
		    }
		    
		    if ( CONST_INT != GET_CODE ( operands[3] ))
		    {
			if ( DSP_R0_REGNUM > REGNO ( base_op0 ) && 
			    DSP_B_REGNUM < REGNO ( base_op0 ))
			{
			    if ( load_n_reg_p ( operands[2], operands[3] ))
			    {
				return fms ( "move	#%p3,%j2" SC
					    "move	(%2)+" SC
					    "move	(%2)+%j2" SC
					    "move	@:(%2)-,%g0" SC
					    "move	@:(%2)-%j2,%0" );
			    }

			    return fms ( "move	(%2)+" SC
					"move	(%2)+%j2" SC
					"move	@:(%2)-,%g0" SC
					"move	@:(%2)-%j2,%0" );
			}
			else
			{
			    if ( load_n_reg_p ( operands[2], operands[3] ))
			    {
				return fms ( "move	#%p3,%j2" SC
					    "move	(%2)+" SC
					    "move	(%2)+%j2" SC
					    "move	@:(%2)-,%0" SC
					    "move	@:(%2)-%j2,%h0" );
			    }

			    return fms ( "move	(%2)+" SC
					"move	(%2)+%j2" SC
					"move	@:(%2)-,%0" SC
					"move	@:(%2)-%j2,%h0" );
			}
		    }
		    
		    switch ( INTVAL ( operands[3] ))
		    {
		    case 0:
			if ( DSP_R0_REGNUM > REGNO ( base_op0 ) && 
			    DSP_B_REGNUM < REGNO ( base_op0 ))
			{
			    return fms ( "move	(%2)+" SC
					 "move	@:(%2)-,%g0" SC
					 "move	@:(%2),%0" );
			}

			return fms ( "move	(%2)+" SC
				    "move	@:(%2)-,%0" SC
				    "move	@:(%2),%h0" );
			
		    case 1:
			if ( DSP_R0_REGNUM > REGNO ( base_op0 ) && 
			    DSP_B_REGNUM < REGNO ( base_op0 ))
			{
			    return fms ( "move	(%2)+" SC
					 "move	(%2)+" SC
					 "move	@:(%2)-,%g0" SC
					 "move	@:(%2)-,%0" );
			}

			return fms ( "move	(%2)+" SC
				    "move	(%2)+" SC
				    "move	@:(%2)-,%0" SC
				    "move	@:(%2)-,%h0" );
			
		    case -1:
			if ( IS_SRC_OR_MPY_P ( REGNO ( base_op0 )))
			{
			    return fms ( "move	(%2)-" SC
					 "move	@:(%2)-,%g0" SC
					 "move	@:(%2)+,%0" SC
					 "move	(%2)+" );
			}

			return fms ( "move	(%2)-" SC
				    "move	@:(%2)-,%0" SC
				    "move	@:(%2)+,%h0" SC
				    "move	(%2)+" );
			
		    default:
			if ( DSP_R0_REGNUM > REGNO ( base_op0 ) && 
			    DSP_B_REGNUM < REGNO ( base_op0 ))
			{
			    if ( load_n_reg_p ( operands[2], operands[3] ))
			    {
				return fms ( "move	#%p3,%j2" SC
					     "move	(%2)+" SC
					     "move	(%2)+%j2" SC
					     "move	@:(%2)-,%g0" SC
					     "move	@:(%2)-%j2,%0" );
			    }

			    return fms ( "move	(%2)+" SC
					"move	(%2)+%j2" SC
					"move	@:(%2)-,%g0" SC
					"move	@:(%2)-%j2,%0" );
			}
			else
			{
			    if ( load_n_reg_p ( operands[2], operands[3] ))
			    {
				return fms ( "move	#%p3,%j2" SC
					     "move	(%2)+" SC
					     "move	(%2)+%j2" SC
					     "move	@:(%2)-,%0" SC
					     "move	@:(%2)-%j2,%h0" );
			    }

			    return fms ( "move	(%2)+" SC
					"move	(%2)+%j2" SC
					"move	@:(%2)-,%0" SC
					"move	@:(%2)-%j2,%h0" );
			}
		    }
		}
		else if ( POST_INC == GET_CODE ( XEXP ( base_op1, 0 )))
		{
		    operands[2] = XEXP ( XEXP ( base_op1, 0 ), 0 );
		    
		    if ( DSP_R0_REGNUM > REGNO ( base_op0 ) && 
			DSP_B_REGNUM < REGNO ( base_op0 ))
		    {
			if ( load_n_reg_p ( operands[2], 
					   gen_rtx ( CONST_INT, VOIDmode, 2 )))
			{
			    return fms ( "move	#2,%j2" SC
					 "move	(%2)+" SC
					 "move	@:(%2)-,%g0" SC
					 "move	@:(%2)+%j2,%0" );
			}

			return fms ( "move	(%2)+" SC
				    "move	@:(%2)-,%g0" SC
				    "move	@:(%2)+%j2,%0" );
		    }
		    else
		    {
			if ( load_n_reg_p ( operands[2], 
					   gen_rtx ( CONST_INT, VOIDmode, 2 )))
			{
			    return fms ( "move	#2,%j2" SC
					 "move	(%2)+" SC
					 "move	@:(%2)-,%0" SC
					 "move	@:(%2)+%j2,%h0" );
			}

			return fms ( "move	(%2)+" SC
				    "move	@:(%2)-,%0" SC
				    "move	@:(%2)+%j2,%h0" );
		    }
		}
		else if ( POST_DEC == GET_CODE ( XEXP ( base_op1, 0 )))
		{
		    operands[2] = XEXP ( XEXP ( base_op1, 0 ), 0 );
		    
		    if ( DSP_R0_REGNUM > REGNO ( base_op0 ) && 
			DSP_B_REGNUM < REGNO ( base_op0 ))
		    {
			if ( load_n_reg_p ( operands[2], 
					   gen_rtx ( CONST_INT, VOIDmode, 2 )))
			{
			    return fms ( "move	#2,%j2" SC
					 "move	(%2)+" SC
					 "move	@:(%2)-,%g0" SC
					 "move	@:(%2)-%j2,%0" );
			}

			return fms ( "move	(%2)+" SC
				    "move	@:(%2)-,%g0" SC
				    "move	@:(%2)-%j2,%0" );
		    }
		    else
		    {
			if ( load_n_reg_p ( operands[2], 
					   gen_rtx ( CONST_INT, VOIDmode, 2 )))
			{
			    return fms ( "move	#2,%j2" SC
					 "move	(%2)+" SC
					 "move	@:(%2)-,%0" SC
					 "move	@:(%2)-%j2,%h0" );
			}

			return fms ( "move	(%2)+" SC
				    "move	@:(%2)-,%0" SC
				    "move	@:(%2)-%j2,%h0" );
		    }
		}
		else if ( REG == GET_CODE ( XEXP ( base_op1, 0 )))
		{
		    operands[2] = XEXP ( base_op1, 0 );
		    
		    if ( DSP_R0_REGNUM > REGNO ( base_op0 ) && 
			DSP_B_REGNUM < REGNO ( base_op0 ))
		    {
			return fms ( "move	(%2)+" SC
				     "move	@:(%2)-,%g0" SC
				     "move	@:(%2),%0" );
		    }

		    return fms ( "move	(%2)+" SC
				"move	@:(%2)-,%0" SC
				"move	@:(%2),%h0" );
		}

		if ( IS_SRC_OR_MPY_P ( REGNO ( base_op0 )))
		{
		    return "move	%1+1,%g0" SC
			"move	%1,%0";
		}
		
		return "move	%1+1,%0" SC
		    "move	%1,%h0";
	    }
	}
    }
    else if ( REG_P ( base_op1 ) && MEM == GET_CODE ( base_op0 ))
    {
	/* case 4: register store into memory */

	if ( TARGET_L_MEMORY )
	{
	    if ( PLUS == GET_CODE ( XEXP ( base_op0, 0 )))
	    {
		if ( REG_P ( XEXP ( XEXP ( base_op0, 0 ), 0 )))
		{
		    operands[2] = XEXP ( XEXP ( base_op0, 0 ), 0 );
		    operands[3] = XEXP ( XEXP ( base_op0, 0 ), 1 );
		}
		else
		{
		    operands[2] = XEXP ( XEXP ( base_op0, 0 ), 1 );
		    operands[3] = XEXP ( XEXP ( base_op0, 0 ), 0 );
		}
		
		if ( CONST_INT != GET_CODE ( operands[3] ))
		{
		    if ( DSP_R0_REGNUM > REGNO ( base_op1 ) && 
			DSP_B_REGNUM < REGNO ( base_op1 ))
		    {
			if ( load_n_reg_p ( operands[2], operands[3] ))
			{
			    return "move	#%p3,%j2" SC
				   "move	%m1,l:(%2+%j2)";
			}

			return "move	%m1,l:(%2+%j2)";
		    }
		    else
		    {
			if ( load_n_reg_p ( operands[2], operands[3] ))
			{
			    return "move	#%p3,%j2" SC
				   "move	%o1,l:(%2+%j2)";
			}

			return "move	%o1,l:(%2+%j2)";
		    }
		}
		
		switch ( INTVAL ( operands[3] ))
		{
		case 0:
		    if ( DSP_R0_REGNUM > REGNO ( base_op1 ) && 
			DSP_B_REGNUM < REGNO ( base_op1 ))
		    {
			return "move	%m1,l:(%2)";
		    }

		    return "move	%o1,l:(%2)";
		    
		case 1:
		    if ( DSP_R0_REGNUM > REGNO ( base_op1 ) && 
			DSP_B_REGNUM < REGNO ( base_op1 ))
		    {
			return "move	(%2)+" SC
			       "move	%m1,l:(%2)-";
		    }

		    return "move	(%2)+" SC
			   "move	%o1,l:(%2)-";
		    
		case -1:
		    if ( DSP_R0_REGNUM > REGNO ( base_op1 ) && 
			DSP_B_REGNUM < REGNO ( base_op1 ))
		    {
			return "move	(%2)-" SC
			       "move	%m1,l:(%2)+";
		    }

		    return "move	(%2)-" SC
			   "move	%o1,l:(%2)+";
		    
		default:
		    if ( DSP_R0_REGNUM > REGNO ( base_op1 ) && 
			DSP_B_REGNUM < REGNO ( base_op1 ))
		    {
			if ( load_n_reg_p ( operands[2], operands[3] ))
			{
			    return "move	#%p3,%j2" SC
				   "move	%m1,l:(%2+%j2)";
			}

			return "move	%m1,l:(%2+%j2)";
		    }
		    else
		    {
			if ( load_n_reg_p ( operands[2], operands[3] ))
			{
			    return "move	#%p3,%j2" SC
				   "move	%o1,l:(%2+%j2)";
			}

			return "move	%o1,l:(%2+%j2)";
		    }
		}
	    }
	    else
	    {
		if ( DSP_R0_REGNUM > REGNO ( base_op1 ) && 
		    DSP_B_REGNUM < REGNO ( base_op1 ))
		{
		    return "move	%m1,%0";
		}

		return "move	%o1,%0";
	    }
	}
	else /* memory_model is x or y. */
	{
	    if ( PLUS == GET_CODE ( XEXP ( base_op0, 0 )))
	    {
		if ( REG_P ( XEXP ( XEXP ( base_op0, 0 ), 0 )))
		{
		    operands[2] = XEXP ( XEXP ( base_op0, 0 ), 0 );
		    operands[3] = XEXP ( XEXP ( base_op0, 0 ), 1 );
		}
		else
		{
		    operands[2] = XEXP ( XEXP ( base_op0, 0 ), 1 );
		    operands[3] = XEXP ( XEXP ( base_op0, 0 ), 0 );
		}
		
		if ( CONST_INT != GET_CODE ( operands[3] ))
		{
		    if ( IS_SRC_OR_MPY_P ( REGNO ( base_op1 )))
		    {
			if ( load_n_reg_p ( operands[2], operands[3] ))
			{
			    return fms ( "move	#%p3,%j2" SC
					 "move	(%2)+" SC
					 "move	(%2)+%j2" SC
					 "move	%g1,@:(%2)-" SC
					 "move	%1,@:(%2)-%j2" );
			}

			return fms ( "move	(%2)+" SC
				    "move	(%2)+%j2" SC
				    "move	%g1,@:(%2)-" SC
				    "move	%1,@:(%2)-%j2" );
		    }
		    else
		    {
			if ( load_n_reg_p ( operands[2], operands[3] ))
			{
			    return fms ( "move	#%p3,%j2" SC
					 "move	(%2)+" SC
					 "move	(%2)+%j2" SC
					 "move	%e1,@:(%2)-" SC
					 "move	%h1,@:(%2)-%j2" );
			}

			return fms ( "move	(%2)+" SC
				    "move	(%2)+%j2" SC
				    "move	%e1,@:(%2)-" SC
				    "move	%h1,@:(%2)-%j2" );
		    }
		}
		
		switch ( INTVAL ( operands[3] ))
		{
		case 0:
		    if ( DSP_R0_REGNUM > REGNO ( base_op1 ) && 
			DSP_B_REGNUM < REGNO ( base_op1 ))
		    {
			return fms ( "move	%1,@:(%2)+" SC
				     "move	%g1,@:(%2)-" );
		    }

		    return fms ( "move	%h1,@:(%2)+" SC
				"move	%e1,@:(%2)-" );
		    
		case 1:
		    if ( DSP_R0_REGNUM > REGNO ( base_op1 ) && 
			DSP_B_REGNUM < REGNO ( base_op1 ))
		    {
			return fms ( "move	(%2)+" SC
				     "move	%1,@:(%2)+" SC
				     "move	%g1,@:(%2)-" SC
				     "move	(%2)-" );
		    }

		    return fms ( "move	(%2)+" SC
				"move	%h1,@:(%2)+" SC
				"move	%e1,@:(%2)-" SC
				"move	(%2)-" );
		    
		case -1:
		    if ( DSP_R0_REGNUM > REGNO ( base_op1 ) && 
			DSP_B_REGNUM < REGNO ( base_op1 ))
		    {
			return fms ( "move	(%2)-" SC
				     "move	%g1,@:(%2)-" SC
				     "move	%1,@:(%2)+" SC
				     "move	(%2)+" );
		    }

		    return fms ( "move	(%2)-" SC
				"move	%e1,@:(%2)-" SC
				"move	%h1,@:(%2)+" SC
				"move	(%2)+" );
		    
		default:
		    if ( DSP_R0_REGNUM > REGNO ( base_op1 ) && 
			DSP_B_REGNUM < REGNO ( base_op1 ))
		    {
			if ( load_n_reg_p ( operands[2], operands[3] ))
			{
			    return fms ( "move	#%p3,%j2" SC
					 "move	(%2)+" SC
					 "move	(%2)+%j2" SC
					 "move	%g1,@:(%2)-" SC
					 "move	%1,@:(%2)-%j2" );
			}

			return fms ( "move	(%2)+" SC
				    "move	(%2)+%j2" SC
				    "move	%g1,@:(%2)-" SC
				    "move	%1,@:(%2)-%j2" );
		    }
		    else
		    {
			if ( load_n_reg_p ( operands[2], operands[3] ))
			{
			    return fms ( "move	#%p3,%j2" SC
					 "move	(%2)+" SC
					 "move	(%2)+%j2" SC
					 "move	%e1,@:(%2)-" SC
					 "move	%h1,@:(%2)-%j2" );
			}

			return fms ( "move	(%2)+" SC
				    "move	(%2)+%j2" SC
				    "move	%e1,@:(%2)-" SC
				    "move	%h1,@:(%2)-%j2" );
		    }
		}
	    }
	    else if ( POST_INC == GET_CODE ( XEXP ( base_op0, 0 )))
	    {
		operands[2] = XEXP ( XEXP ( base_op0, 0 ), 0 );
		
		if ( IS_SRC_OR_MPY_P ( REGNO ( base_op1 )))
		{
		    return fms ( "move	%1,@:(%2)+" SC
				 "move	%g1,@:(%2)+" );
		}

		return fms ( "move	%h1,@:(%2)+" SC
			    "move	%e1,@:(%2)+" );
	    }
	    else if ( POST_DEC == GET_CODE ( XEXP ( base_op0, 0 )))
	    {
		operands[2] = XEXP ( XEXP ( base_op0, 0 ), 0 );
		
		if ( DSP_R0_REGNUM > REGNO ( base_op1 ) && 
		    DSP_B_REGNUM < REGNO ( base_op1 ))
		{
		    if ( load_n_reg_p ( operands[2], 
				       gen_rtx ( CONST_INT, VOIDmode, 3 )))
		    {
			return fms ( "move	#3,%j2" SC
				     "move	%1,@:(%2)+" SC
				     "move	%g1,@:(%2)-%j2" );
		    }

		    return fms ( "move	%1,@:(%2)+" SC
				"move	%g1,@:(%2)-%j2" );
		}
		else
		{
		    if ( load_n_reg_p ( operands[2], 
				       gen_rtx ( CONST_INT, VOIDmode, 3 )))
		    {
			return fms ( "move	#3,%j2" SC
				     "move	%h1,@:(%2)+" SC
				     "move	%e1,@:(%2)-%j2" );
		    }

		    return fms ( "move	%h1,@:(%2)+" SC
				"move	%e1,@:(%2)-%j2" );
		}
	    }
	    else if ( REG == GET_CODE ( XEXP ( base_op0, 0 )))
	    {
		operands[2] = XEXP ( base_op0, 0 );
		
		if ( DSP_R0_REGNUM > REGNO ( base_op1 ) && 
		    DSP_B_REGNUM < REGNO ( base_op1 ))
		{
		    return fms ( "move	%1,@:(%2)+" SC
				 "move	%g1,@:(%2)-" );
		}

		return fms ( "move	%h1,@:(%2)+" SC
			    "move	%e1,@:(%2)-" );
	    }

	    if ( DSP_R0_REGNUM > REGNO ( base_op1 ) && 
		DSP_B_REGNUM < REGNO ( base_op1 ))
	    {
		return "move	%1,%0" SC
		       "move	%g1,%0+1";
	    }

	    return "move	%h1,%0" SC
		   "move	%e1,%0+1";
	}
    }
}


char*
assemble_move_pointer ( operands )
    rtx *operands;
{
    extern char mem_space;
    
    /* cases:
           op1     to   op0
	  --------------------
       1) register to register
       2) constant to register
       3) memory to register 
       4) register to memory */

    rtx base_op0 = clean_subregs ( operands[0] ),
        base_op1 = clean_subregs ( operands[1] );
    
    if ( rtx_equal_p ( base_op0, base_op1 ))
    {
	return "";
    }
    
    if ( REG_P ( base_op0 ))
    {
	/* cases 1-3 */
	
	if ( REG_P ( base_op1 ))
	{
	    /* case 1: register transfer */

	    if ( DSP_B_REGNUM >= REGNO ( base_op0 ))
	    {
		if ( MEM_IN_STRUCT_P ( base_op0 ) || 
		    MEM_IN_STRUCT_P ( base_op1 ) ||
		    DSP_R0_REGNUM <= REGNO ( base_op1 ))
		{
		    /* we're moving to/from the LSW of an accumulator, or
		       we're moving from an address register into an 
		       accumulator. */
		    
		    return "move	%1,%0";
		}
		else
		{
		    /* we're moving an alu register into an accumulator. */

		    return "tfr	%1,%0";
		}
	    }

	    /* perform a standard register transfer. */
	    
	    return "move	%e1,%0";
	}
	else if ( LEGITIMATE_CONSTANT_P ( base_op1 ))
	{
	    /* case 2: constant load into a register */

	    if ( DSP_R0_REGNUM <= REGNO ( base_op0 ))
	    {
		/* we're loading an address register. we do not need to
		   use the force operator. */

		return "move	#%1,%0";
	    }
	    else if ( DSP_B_REGNUM >= REGNO ( base_op0 ) &&
		     ! INTVAL ( base_op1 ))
	    {
		/* we're loding 0 into an accumulator. */

		return "clr	%0";
	    }

	    /* we're loading a constant into an accumulator. */

	    return "move	#>%1,%0";
	}
	else if ( MEM == GET_CODE ( base_op1 ))
	{
	    /* case 3: memory load into a register */

	    if ( PLUS == GET_CODE ( XEXP ( base_op1, 0 )))
	    {
		/* we're using a offset address. we need to do more 
		   work when using this phoney addressing mode. */

		if ( REG_P ( XEXP ( XEXP ( base_op1, 0 ), 0 )))
		{
		    operands[2] = XEXP ( XEXP ( base_op1, 0 ), 0 );
		    operands[3] = XEXP ( XEXP ( base_op1, 0 ), 1 );
		}
		else
		{
		    operands[2] = XEXP ( XEXP ( base_op1, 0 ), 1 );
		    operands[3] = XEXP ( XEXP ( base_op1, 0 ), 0 );
		}
		
		if ( CONST_INT != GET_CODE ( operands[3] ))
		{
		    /* the offset is a symbolic constant; we can't 
		       do any tricks because we don't know the symbol's
		       value. */

		    if ( load_n_reg_p ( operands[2], operands[3] ))
		    {
			return fms ( "move	#%p3,%j2" SC
				     "move	@:(%2+%j2),%0" );
		    }
		    else
		    {
			return fms ( "move	@:(%2+%j2),%0" );
		    }
		}
	    
		/* the offset is a constant int. special cases can be
		   made faster, depending on the offset. */

		switch ( INTVAL ( operands[3] ))
		{
		case 0:
		    return fms ( "move	@:(%2),%0" );
		    
		case 1:
		    if ( REGNO ( base_op0 ) != REGNO ( operands[2] ))
		    {
			return fms ( "move	(%2)+" SC
				     "move	@:(%2)-,%0" );
		    }
		    
		case -1:
		    if ( REGNO ( base_op0 ) != REGNO ( operands[2] ))
		    {
			return fms ( "move	(%2)-" SC
				     "move	@:(%2)+,%0" );
		    }
		}

		if ( load_n_reg_p ( operands[2], operands[3] ))
		{
		    return fms ( "move	#%p3,%j2" SC
				 "move	@:(%2+%j2),%0" );
		}
		return fms ( "move	@:(%2+%j2),%0" );
	    }

	    /* we're doing a register load using a non-offset address. */

	    return "move	%1,%0";
	}
    }
    else if ( REG_P ( base_op1 ) && MEM == GET_CODE ( base_op0 ))
    {
	/* case 4: register store into memory */

	if ( PLUS == GET_CODE ( XEXP ( base_op0, 0 )))
	{
	    /* we're using a offset address. we need to do more work
	       when using this phoney addressing mode. */

	    if ( REG == GET_CODE ( XEXP ( XEXP ( base_op0, 0 ), 0 )))
	    {
		operands[2] = XEXP ( XEXP ( base_op0, 0 ), 0 );
		operands[3] = XEXP ( XEXP ( base_op0, 0 ), 1 );
	    }
	    else
	    {
		operands[2] = XEXP ( XEXP ( base_op0, 0 ), 1 );
		operands[3] = XEXP ( XEXP ( base_op0, 0 ), 0 );
	    }
	    
	    /* the offset is a symbolic constant; we can't 
	       do any tricks because we don't know the symbol's value. */

	    if ( CONST_INT != GET_CODE ( operands[3] ))
	    {
		if ( load_n_reg_p ( operands[2], operands[3] ))
		{
		    return fms ( "move	#%p3,%j2" SC
				 "move	%e1,@:(%2+%j2)" );
		}
		else
		{
		    return fms ( "move	%e1,@:(%2+%j2)" );
		}
	    }
	    
	    /* the offset is a constant int. special cases can be
	       made faster, depending on the offset. */

	    switch ( INTVAL ( operands[3] ))
	    {
	    case 0:
		return fms ( "move	%e1,@:(%2)" );
		    
	    case 1:
		if ( REGNO ( base_op1 ) != REGNO ( operands[2] ))
		{
		    return fms ( "move	(%2)+" SC
				 "move	%e1,@:(%2)-" );
		}
		    
	    case -1:
		if ( REGNO ( base_op1 ) != REGNO ( operands[2] ))
		{
		    return fms ( "move	(%2)-" SC
				 "move	%e1,@:(%2)+" );
		}
	    }
	    
	    if ( load_n_reg_p ( operands[2], operands[3] ))
	    {
		return fms ( "move	#%p3,%j2" SC
			     "move	%e1,@:(%2+%j2)" );
	    }
	    else
	    {
		return fms ( "move	%e1,@:(%2+%j2)" );
	    }
	}
	/* we're doing a register store using a non-offset address. */
	
	return "move	%e1,%0";
    }

    abort ( );
}

char*
move_pointer ( operands )
    rtx *operands;
{
    char real_mem_space = mem_space;
    char *retval = assemble_move_pointer ( operands );
    
    mem_space = real_mem_space;
    
    return retval;
}

char*
move_single_integer ( operands )
    rtx *operands;
{
    char real_mem_space = mem_space;
    char *retval = assemble_move_singleword ( operands );
    
    mem_space = real_mem_space;
    
    return retval;
}

char*
move_double_integer ( is_float_p, operands )
    int is_float_p;
    rtx *operands;
{
    char real_mem_space = mem_space;
    char *retval = assemble_move_doubleword ( is_float_p, operands );
    
    mem_space = real_mem_space;
    
    return retval;
}

int
register_or_002_crement_operand ( op, mode )
    rtx op;
    enum machine_mode mode;
{
    return (( TARGET_56002 && crement_operand ( op, mode )) ||
	    register_operand ( op, mode ));
}

int
register_or_002_pow_two_operand ( op, mode )
    rtx op;
    enum machine_mode mode;
{
    return (( TARGET_56002 && pow_two_operand ( op, mode )) ||
	    register_operand ( op, mode ));
}

#include "config/dsp.c"
