/* subroutines for insn-output.c for motorola DSP56300
   copyright ( c ) 1988 free software foundation, inc.

this file is part of gnu cc.

gnu cc is distributed in the hope that it will be useful,
but without any warranty.  no author or distributor
accepts responsibility to anyone for the consequences of using it
or for whether it serves any particular purpose or works at all,
unless he says so in writing.  refer to the gnu cc general public
license for full details.

everyone is granted permission to copy, modify and redistribute
gnu cc, but only under the conditions described in the
gnu cc general public license.	 a copy of this license is
supposed to have been given to you along with gnu cc so you
can know your rights and responsibilities.  it should be in a
file named copying.  among other things, the copyright notice
and this notice must be preserved on all copies.  */

#define SC "\n\t"
static char* fms ( );

#ifndef file
#include <stdio.h>
#endif

#include <string.h>
#if defined ( _MSDOS )
extern void *malloc( );
#endif

#include <ctype.h>

#include "flags.h"
#include "tree.h"
#if ! defined( _MSDOS )
#include "hard-reg-set.h"
#else
#include "hardrset.h"
#endif

char mem_space = 'y';
char memory_model = 'y';

union real_extract adjusted_dval;
func_attributes current_func_info = FUNC_NO_INFO;

enum reg_class regno_reg_class ( );
char * ( *const insn_outfun[] ) ( );
const INSN_MACHINE_INFO insn_machine_info[];

int FirstSave;


int
fixup_btst_cc_consumer ( insn )
    rtx insn;
{
    rtx peek = NEXT_INSN ( insn );
    
    for ( ; NULL != peek; peek = NEXT_INSN ( peek ))
    {
	if ( JUMP_INSN == GET_CODE ( peek ) ||
	    CALL_INSN == GET_CODE ( peek ) ||
	    CODE_LABEL == GET_CODE ( peek ) ||
	    BARRIER == GET_CODE ( peek ))
	{
	    break;
	}

	if ( INSN == GET_CODE ( peek ) &&
	    PARALLEL == GET_CODE ( PATTERN ( peek )) &&
	    SET == GET_CODE ( XVECEXP ( PATTERN ( peek ), 0, 0 )) &&
	    0 == strcmp 
	    ( GET_RTX_FORMAT
	     ( GET_CODE 
	      ( XEXP ( XVECEXP ( PATTERN ( peek ), 0, 0 ), 1 ))), "ee" ) &&
	    ( cc0_rtx == XEXP
	     ( XEXP ( XVECEXP ( PATTERN ( peek ), 0, 0 ), 1 ), 0 ) ||
	     cc0_rtx == XEXP
	     ( XEXP ( XVECEXP ( PATTERN ( peek ), 0, 0 ), 1 ), 1 )))
	{
	    switch ( GET_CODE 
		    ( XEXP ( XVECEXP ( PATTERN ( peek ), 0, 0 ), 1 )))
	    {
	    case EQ:
	    case EQU:
	    case LE:
	    case LEU:
		PUT_CODE
		    ( XEXP ( XVECEXP ( PATTERN ( peek ), 0, 0 ), 1 ), CC );
		break;
		
	    case NE:
	    case NEU:
	    case GT:
	    case GTU:
		PUT_CODE 
		    ( XEXP ( XVECEXP ( PATTERN ( peek ), 0, 0 ), 1 ), CS );
		break;
		
	    case GE:
	    case GEU:
		/* always true; harden the move. */
		XEXP ( XVECEXP ( PATTERN ( peek ), 0, 0 ), 1 ) = const1_rtx;
		PATTERN ( peek ) = XVECEXP ( PATTERN ( peek ), 0, 0 );
		
		return 0;
		
	    case LT:
	    case LTU:
		/* always false; harden the branch. */
		XEXP ( XVECEXP ( PATTERN ( peek ), 0, 0 ), 1 ) = const0_rtx;
		PATTERN ( peek ) = XVECEXP ( PATTERN ( peek ), 0, 0 );

		return 0;
	    }
	    return 1;
	}
    }

    if (( NULL != peek ) &&
	( JUMP_INSN == GET_CODE ( peek )) &&
	( SET == GET_CODE ( PATTERN ( peek ))) &&
	( IF_THEN_ELSE == GET_CODE ( XEXP ( PATTERN ( peek ), 1 ))))
    {
	switch ( GET_CODE ( XEXP ( XEXP ( PATTERN ( peek ), 1 ), 0 )))
	{
	case EQ:
	case EQU:
	case LE:
	case LEU:
	    PUT_CODE ( XEXP ( XEXP ( PATTERN ( peek ), 1 ), 0 ), CC );
	    break;
	    
	case NE:
	case NEU:
	case GT:
	case GTU:
	    PUT_CODE ( XEXP ( XEXP ( PATTERN ( peek ), 1 ), 0 ), CS );
	    break;
	    
	case GE:
	case GEU:
	    /* always true; harden the branch. */
	    if ( pc_rtx == XEXP ( XEXP ( PATTERN ( peek ), 1 ), 1 ))
	    {
		/* eliminate the branch. */
		PUT_CODE ( peek, NOTE );
		INSN_DELETED_P ( peek ) = 1;
	    }
	    else
	    {
		/* make the branch a hard branch. */
		XEXP ( PATTERN ( peek ), 1 ) = 
		    XEXP ( XEXP ( PATTERN ( peek ), 1 ), 1 );

	    }
	    return 0;
	    
	case LT:
	case LTU:
	    /* always false; harden the branch. */
	    if ( pc_rtx == XEXP ( XEXP ( PATTERN ( peek ), 1 ), 1 ))
	    {
		/* make the branch a hard branch. */
		XEXP ( PATTERN ( peek ), 1 ) = 
		    XEXP ( XEXP ( PATTERN ( peek ), 1 ), 2 );
	    }
	    else
	    {
		/* eliminate the branch. */
		PUT_CODE ( peek, NOTE );
		INSN_DELETED_P ( peek ) = 1;
	    }
	    return 0;
	}
    }
    return 1;
}


void
flip_btst_cc_consumer ( insn )
    rtx insn;
{
    rtx peek = NEXT_INSN ( insn );
    
    for ( ; NULL != peek; peek = NEXT_INSN ( peek ))
    {
	if ( JUMP_INSN == GET_CODE ( peek ) ||
	    CALL_INSN == GET_CODE ( peek ) ||
	    CODE_LABEL == GET_CODE ( peek ) ||
	    BARRIER == GET_CODE ( peek ))
	{
	    break;
	}

	if ( INSN == GET_CODE ( peek ) &&
	    PARALLEL == GET_CODE ( PATTERN ( peek )) &&
	    SET == GET_CODE ( XVECEXP ( PATTERN ( peek ), 0, 0 )) &&
	    0 == strcmp 
	    ( GET_RTX_FORMAT
	     ( GET_CODE 
	      ( XEXP ( XVECEXP ( PATTERN ( peek ), 0, 0 ), 1 ))), "ee" ) &&
	    ( cc0_rtx == XEXP
	     ( XEXP ( XVECEXP ( PATTERN ( peek ), 0, 0 ), 1 ), 0 ) ||
	     cc0_rtx == XEXP
	     ( XEXP ( XVECEXP ( PATTERN ( peek ), 0, 0 ), 1 ), 1 )))
	{
	    PUT_CODE ( XEXP ( XVECEXP ( PATTERN ( peek ), 0, 0 ), 1 ),
		      reverse_condition 
		      ( GET_CODE
		       ( XEXP ( XVECEXP ( PATTERN ( peek ), 0, 0 ), 1 ))));
	}
    }

    if (( NULL != peek ) &&
	( JUMP_INSN == GET_CODE ( peek )) &&
	( SET == GET_CODE ( PATTERN ( peek ))) &&
	( IF_THEN_ELSE == GET_CODE ( XEXP ( PATTERN ( peek ), 1 ))))
    {
	PUT_CODE ( XEXP ( XEXP ( PATTERN ( peek ), 1 ), 0 ), 
		  reverse_condition
		  ( GET_CODE ( XEXP ( XEXP ( PATTERN ( peek ), 1 ), 0 ))));
    }
}


void
harden_btst_cc_consumer ( insn )
    rtx insn;
{
    rtx peek = NEXT_INSN ( insn );
    
    for ( ; NULL != peek; peek = NEXT_INSN ( peek ))
    {
	if ( JUMP_INSN == GET_CODE ( peek ) ||
	    CALL_INSN == GET_CODE ( peek ) ||
	    CODE_LABEL == GET_CODE ( peek ) ||
	    BARRIER == GET_CODE ( peek ))
	{
	    break;
	}

	if ( INSN == GET_CODE ( peek ) &&
	    PARALLEL == GET_CODE ( PATTERN ( peek )) &&
	    SET == GET_CODE ( XVECEXP ( PATTERN ( peek ), 0, 0 )) &&
	    0 == strcmp 
	    ( GET_RTX_FORMAT
	     ( GET_CODE 
	      ( XEXP ( XVECEXP ( PATTERN ( peek ), 0, 0 ), 1 ))), "ee" ) &&
	    ( cc0_rtx == XEXP
	     ( XEXP ( XVECEXP ( PATTERN ( peek ), 0, 0 ), 1 ), 0 ) ||
	     cc0_rtx == XEXP
	     ( XEXP ( XVECEXP ( PATTERN ( peek ), 0, 0 ), 1 ), 1 )))
	{
	    XEXP ( XVECEXP ( PATTERN ( peek ), 0, 0 ), 1 ) = const0_rtx;
	    PATTERN ( peek ) = XVECEXP ( PATTERN ( peek ), 0, 0 );
	}
    }

    if (( NULL != peek ) &&
	( JUMP_INSN == GET_CODE ( peek )) &&
	( SET == GET_CODE ( PATTERN ( peek ))) &&
	( IF_THEN_ELSE == GET_CODE ( XEXP ( PATTERN ( peek ), 1 ))))
    {
	if ( pc_rtx == XEXP ( XEXP ( PATTERN ( peek ), 1 ), 1 ))
	{
	    /* make the branch a hard branch. */
	    XEXP ( PATTERN ( peek ), 1 ) = 
		XEXP ( XEXP ( PATTERN ( peek ), 1 ), 2 );
	}
	else
	{
	    /* eliminate the branch. */
	    PUT_CODE ( peek, NOTE );
	    INSN_DELETED_P ( peek ) = 1;
	}
    }
}

/* given an insn and a label, return 1 iff:
   1) the label immediately follows the passed insn, and
   2) the label only has a single reference, and
   3) the insn is an alu opcode. */

int alu_insn_code;

int
ifcc_combo_follows_p ( insn, label )
    rtx insn, label;
{
    rtx next = NEXT_INSN ( insn );
    
    /* make sure we're dealing with an alu opcode. */
    alu_insn_code = INSN_CODE ( insn );
    if ( ! ( get_spec_bits ( insn_machine_info[alu_insn_code].spec_bits )
	    & IFCCABLE_OP_CODE ))
    {
	return 0;
    }
    
    /* check for a single label reference. */
    if ( 1 != LABEL_NUSES ( label ))
    {
	return 0;
    }

    /* verify that our CODE_LABEL follows that. */
    while ( NOTE == GET_CODE ( next ))
    {
	next = NEXT_INSN ( next );
    }
    
    if ( label != next )
    {
	return 0;
    }
    return 1;
}

char *insn_template[];

static char*
output_ifcc ( insn, operands, cond_index, flip_p )
    rtx insn, operands[];
    int cond_index, flip_p;
{
    static char buffer[BUFSIZ];
    
    /* if we need to, flip the conditional. */
    if ( flip_p )
    {
	PUT_CODE ( operands[cond_index],
		  reverse_condition ( GET_CODE ( operands[cond_index] )));
    }
	
    /* delete the follow-on label. */
    {
        rtx next = NEXT_INSN ( insn );
	
	while ( CODE_LABEL != GET_CODE ( next ))
	{
	    next = NEXT_INSN ( next );
	}
	PUT_CODE ( next, NOTE );
	INSN_DELETED_P ( next ) = 1;

	PUT_CODE ( insn, INSN );
    }
    
    /* pump the insn template into the buffer. */
    {
	extern int alu_insn_code;
	char *template = insn_template[alu_insn_code];

	if ( NULL == template )
	{
	    template = ( *insn_outfun[alu_insn_code] ) ( operands, insn );
	}
	(void) strcpy ( buffer, template );
    }
    
    /* append the ifcc to the template. */
    (void) sprintf ( buffer + strlen ( buffer ), "\tif%%%d.u", cond_index );

    return buffer;
}

void
gen_int_logical ( alu_op, operands )
    enum rtx_code alu_op;
    rtx *operands;
{
    int one_count ( ), zero_count ( );
    rtx force_reg ( );
    
    int (*bit_counter) ( );
    enum rtx_code bit_op;
    
    switch ( alu_op )
    {
    case AND:
	bit_counter = zero_count;
	bit_op = BITCLR;
	break;
	
    case IOR:
	bit_counter = one_count;
	bit_op = BITSET;
	break;
	
    case XOR:
	bit_counter = one_count;
	bit_op = BITCHG;
    }

    if ( CONST_INT == GET_CODE ( operands[2] ))
    {
	rtx dest = operands[0];
	
	switch (( * bit_counter ) ( INTVAL ( operands[2] ), 24 ))
	{
	case 0:
	    /* this mask has no effect. just emit nothing. */
	    return;

	case 1:
	case 2:
	case 3:
	case 4:
	    /* use single bit ops */
	    
	    if ( MEM == GET_CODE ( operands[0] ) && 
		rtx_equal_p ( operands[0], operands[1] ) &&
		! restricted_memory_operand ( operands[1], SImode ))
	    {
		/* we need to make the memory address acceptable. */
		
		dest = operands[0] = operands[1] = copy_rtx ( operands[0] );
		
		XEXP ( operands[0], 0 ) =
		    force_reg ( Pmode, XEXP ( operands[0], 0 ));
	    }
	    else if ( ! ( restricted_memory_operand ( operands[0], SImode ) &&
			 rtx_equal_p ( operands[0], operands[1] )))
	    {
		/* we need to act on a register. if operand[0] is 
		   already a register, then we'll use it. also, the
		   data source must be in the same register. */
		
		if ( ! REG_P ( operands[0] ))
		{
		    dest = gen_reg_rtx ( SImode );
		}
		
		if ( ! rtx_equal_p ( dest, operands[1] ))
		{
		    emit_move_insn ( dest, operands[1] );
		}
	    }
	    
            {
		int count = 0, mask = INTVAL ( operands[2] );
		
		for ( ; count < 16; ++ count )
		{
		    if (( AND == alu_op && ! ( mask & 1 )) ||
			( AND != alu_op && ( mask & 1 )))
		    {
			emit_insn
			    ( gen_rtx 
			     ( SET, SImode, dest,
			      gen_rtx ( bit_op, SImode, dest, gen_rtx
				       ( CONST_INT, VOIDmode, count ))));
		    }
		    mask >>= 1;
		}
	    }
	    
	    if ( dest != operands[0] )
	    {
		emit_move_insn ( operands[0], dest );
	    }
	    return;
	
	case 16:
	    /* this is a simple set. */
	    switch ( alu_op )
	    {
	    case AND:
		emit_move_insn ( operands[0], const0_rtx );
		break;
		
	    case IOR:
		emit_move_insn
		    ( operands[0], gen_rtx ( CONST_INT, VOIDmode, -1 ));
		break;
		
	    case XOR:
		if ( ! REG_P ( operands[0] ))
		{
		    dest = gen_reg_rtx ( SImode );
		}
		
		if ( ! rtx_equal_p ( dest, operands[1] ))
		{
		    emit_move_insn ( dest, operands[1] );
		}
		
		emit_insn ( gen_rtx ( SET, SImode, dest,
				     gen_rtx ( NOT, SImode, dest )));
		
		if ( dest != operands[0] )
		{
		    emit_move_insn ( operands[0], dest );
		}
	    }
	    return;
	}
	
	/* just perform a typical 'and' using an immediate. */
	
	if ( ! REG_P ( operands[0] ))
	{
	    dest = gen_reg_rtx ( SImode );
	}
	
	if ( ! rtx_equal_p ( dest, operands[1] ))
	{
	    emit_move_insn ( dest, operands[1] );
	}
	
	emit_insn ( gen_rtx ( SET, SImode, dest, gen_rtx
			     ( alu_op, SImode, dest, operands[2] )));
	
	if ( dest != operands[0] )
	{
	    emit_move_insn ( operands[0], dest );
	}
    }
    else
    {
	/* just perform a typical 'and' using a register. */
	
	rtx dest = ( REG_P ( operands[0] ))
	    ? operands[0] : gen_reg_rtx ( SImode );
	
	if ( ! rtx_equal_p ( dest, operands[1] ))
	{
	    emit_move_insn ( dest, operands[1] );
	}
	
	if ( ! REG_P ( operands[2] ))
	{
	    operands[2] = force_reg ( SImode, operands[2] );
	}
	
	emit_insn ( gen_rtx ( SET, SImode, dest, gen_rtx
			     ( alu_op, SImode, dest, operands[2] )));
	
	if ( dest != operands[0] )
	{
	    emit_move_insn ( operands[0], dest );
	}
    }
}

void
gen_ptr_logical ( alu_op, operands )
    enum rtx_code alu_op;
    rtx *operands;
{
    int one_count ( ), zero_count ( );
    rtx force_reg ( );
    
    int (*bit_counter) ( );
    enum rtx_code bit_op;
    
    switch ( alu_op )
    {
    case AND:
	bit_counter = zero_count;
	bit_op = BITCLR;
	break;
	
    case IOR:
	bit_counter = one_count;
	bit_op = BITSET;
	break;
	
    case XOR:
	bit_counter = one_count;
	bit_op = BITCHG;
    }

    if ( CONST_INT == GET_CODE ( operands[2] ))
    {
	rtx dest = operands[0];
	
	switch (( * bit_counter ) ( INTVAL ( operands[2] ), 24 ))
	{
	case 0:
	    /* this mask has no effect. just emit nothing. */
	    return;

	case 1:
	case 2:
	case 3:
	case 4:
	    /* use single bit ops */
	    
	    if ( MEM == GET_CODE ( operands[0] ) && 
		rtx_equal_p ( operands[0], operands[1] ) &&
		! restricted_memory_operand ( operands[1], SImode ))
	    {
		/* we need to make the memory address acceptable. */
		
		dest = operands[0] = operands[1] = copy_rtx ( operands[0] );
		
		XEXP ( operands[0], 0 ) =
		    force_reg ( Pmode, XEXP ( operands[0], 0 ));
	    }
	    else if ( ! ( restricted_memory_operand ( operands[0], SImode ) &&
			 rtx_equal_p ( operands[0], operands[1] )))
	    {
		/* we need to act on a register. if operand[0] is 
		   already a register, then we'll use it. also, the
		   data source must be in the same register. */
		
		if ( ! REG_P ( operands[0] ))
		{
		    dest = gen_reg_rtx ( SImode );
		}
		
		if ( ! rtx_equal_p ( dest, operands[1] ))
		{
		    emit_move_insn ( dest, operands[1] );
		}
	    }
	    
            {
		int count = 0, mask = INTVAL ( operands[2] );
		
		for ( ; count < 24; ++ count )
		{
		    if (( AND == alu_op && ! ( mask & 1 )) ||
			( AND != alu_op && ( mask & 1 )))
		    {
			emit_insn
			    ( gen_rtx 
			     ( SET, SImode, dest,
			      gen_rtx ( bit_op, SImode, dest, gen_rtx
				       ( CONST_INT, VOIDmode, count ))));
		    }
		    mask >>= 1;
		}
	    }
	    
	    if ( dest != operands[0] )
	    {
		emit_move_insn ( operands[0], dest );
	    }
	    return;
	
	case 24:
	    /* this is a simple set. */
	    switch ( alu_op )
	    {
	    case AND:
		emit_move_insn ( operands[0], const0_rtx );
		break;
		
	    case IOR:
		emit_move_insn
		    ( operands[0], gen_rtx ( CONST_INT, VOIDmode, -1 ));
		break;
		
	    case XOR:
		if ( ! REG_P ( operands[0] ))
		{
		    dest = gen_reg_rtx ( SImode );
		}
		
		if ( ! rtx_equal_p ( dest, operands[1] ))
		{
		    emit_move_insn ( dest, operands[1] );
		}
		
		emit_insn ( gen_rtx ( SET, SImode, dest,
				     gen_rtx ( NOT, SImode, dest )));
		
		if ( dest != operands[0] )
		{
		    emit_move_insn ( operands[0], dest );
		}
	    }
	    return;
	}
	
	/* just perform a typical 'and' using an immediate. */
	
	if ( ! REG_P ( operands[0] ))
	{
	    dest = gen_reg_rtx ( SImode );
	}
	
	if ( ! rtx_equal_p ( dest, operands[1] ))
	{
	    emit_move_insn ( dest, operands[1] );
	}
	
	emit_insn ( gen_rtx ( SET, SImode, dest, gen_rtx
			     ( alu_op, SImode, dest, operands[2] )));
	
	if ( dest != operands[0] )
	{
	    emit_move_insn ( operands[0], dest );
	}
    }
    else
    {
	/* just perform a typical 'and' using a register. */
	
	rtx dest = ( REG_P ( operands[0] ))
	    ? operands[0] : gen_reg_rtx ( SImode );
	
	if ( ! rtx_equal_p ( dest, operands[1] ))
	{
	    emit_move_insn ( dest, operands[1] );
	}
	
	if ( ! REG_P ( operands[2] ))
	{
	    operands[2] = force_reg ( SImode, operands[2] );
	}
	
	emit_insn ( gen_rtx ( SET, SImode, dest, gen_rtx
			     ( alu_op, SImode, dest, operands[2] )));
	
	if ( dest != operands[0] )
	{
	    emit_move_insn ( operands[0], dest );
	}
    }
}

void
gen_long_logical ( alu_op, operands )
    enum rtx_code alu_op;
    rtx *operands;
{
    int one_count ( ), zero_count ( );
    rtx force_reg ( );
    
    int (*bit_counter) ( );
    enum rtx_code bit_op;
    
    switch ( alu_op )
    {
    case AND:
	bit_counter = zero_count;
	bit_op = BITCLR;
	break;
	
    case IOR:
	bit_counter = one_count;
	bit_op = BITSET;
	break;
	
    case XOR:
	bit_counter = one_count;
	bit_op = BITCHG;
    }

    if ( CONST_DOUBLE == GET_CODE ( operands[2] ) &&
	! TARGET_CONSERVE_P_MEM )
    {
	rtx dest = operands[0];
	
	switch (( * bit_counter ) ( upper_16 ( operands[2] ), 16 ) +
		( * bit_counter ) ( lower_16 ( operands[2] ), 16 ))
	{
	case 0:
	    /* this mask has no effect. just emit nothing. */
	    return;

	case 1:
	case 2:
	case 3:
	case 4:
	case 5:
	case 6:
	case 7:
	case 8:
	case 9:
	case 10:
	    /* use single bit ops */
	    
	    if ( MEM == GET_CODE ( operands[0] ) && 
		rtx_equal_p ( operands[0], operands[1] ) &&
		! restricted_memory_operand ( operands[1], DImode ))
	    {
		/* we need to make the memory address acceptable. */
		
		dest = operands[0] = operands[1] = copy_rtx ( operands[0] );
		
		XEXP ( operands[0], 0 ) =
		    force_reg ( Pmode, XEXP ( operands[1], 0 ));
	    }
	    else if ( ! ( restricted_memory_operand ( operands[0], DImode ) &&
			 rtx_equal_p ( operands[0], operands[1] )))
	    {
		/* we need to act on a register. if operand[0] is 
		   already a register, then we'll use it. also, the
		   data source must be in the same register. */
		
		if ( ! REG_P ( operands[0] ))
		{
		    dest = gen_reg_rtx ( DImode );
		}
		
		if ( ! rtx_equal_p ( dest, operands[1] ))
		{
		    emit_move_insn ( dest, operands[1] );
		}
	    }
	    
            {
		int count = 0, mask = lower_16 ( operands[2] );
		
		for ( ; count < 16; ++ count )
		{
		    if (( AND == alu_op && ! ( mask & 1 )) ||
			( AND != alu_op && ( mask & 1 )))
		    {
			emit_insn
			    ( gen_rtx 
			     ( SET, DImode,
			      dest, gen_rtx ( bit_op, DImode, dest, gen_rtx
					     ( CONST_INT, VOIDmode, count ))));
		    }
		    mask >>= 1;
		}

		for ( mask = upper_16 ( operands[2] ); count < 32; ++ count )
		{
		    if (( AND == alu_op && ! ( mask & 1 )) ||
			( AND != alu_op && ( mask & 1 )))
		    {
			emit_insn
			    ( gen_rtx
			     ( SET, DImode,
			      dest, gen_rtx ( bit_op, DImode, dest, gen_rtx
					     ( CONST_INT, VOIDmode, count ))));
		    }
		    mask >>= 1;
		}
	    }
	    
	    if ( dest != operands[0] )
	    {
		emit_move_insn ( operands[0], dest );
	    }
	    return;
	
	case 32:
	    /* this is a simple set. */
	    switch ( alu_op )
	    {
	    case AND:
		emit_move_insn ( operands[0], dconst0_rtx );
		break;
		
	    case IOR:
		emit_move_insn
		    ( operands[0], gen_rtx
		     ( CONST_DOUBLE, VOIDmode, NULL, -1, -1 ));
		break;
		
	    case XOR:
		if ( ! REG_P ( operands[0] ))
		{
		    dest = gen_reg_rtx ( DImode );
		}
		
		if ( ! rtx_equal_p ( dest, operands[1] ))
		{
		    emit_move_insn ( dest, operands[1] );
		}
		
		emit_insn
		    ( gen_rtx
		     ( SET, DImode, dest, gen_rtx ( NOT, DImode, dest )));
		
		if ( dest != operands[0] )
		{
		    emit_move_insn ( operands[0], dest );
		}
	    }
	    return;
	}
	
	/* just perform a typical 'and' using an immediate. */
	
	if ( ! REG_P ( operands[0] ))
	{
	    dest = gen_reg_rtx ( DImode );
	}
	
	if ( ! rtx_equal_p ( dest, operands[1] ))
	{
	    emit_move_insn ( dest, operands[1] );
	}
	
	emit_insn
	    ( gen_rtx ( SET, DImode, dest, gen_rtx
		       ( alu_op, DImode, dest, operands[2] )));
	
	if ( dest != operands[0] )
	{
	    emit_move_insn ( operands[0], dest );
	}
    }
    else
    {
	/* just perform a typical 'and' using a register. */
	
	rtx dest = ( REG_P ( operands[0] ))
	    ? operands[0] : gen_reg_rtx ( DImode );
	
	if ( ! rtx_equal_p ( dest, operands[1] ))
	{
	    emit_move_insn ( dest, operands[1] );
	}
	
	if ( ! REG_P ( operands[2] ))
	{
	    operands[2] = force_reg ( DImode, operands[2] );
	}
	
	emit_insn ( gen_rtx ( SET, DImode, dest, gen_rtx
			     ( alu_op, DImode, dest, operands[2] )));
	
	if ( dest != operands[0] )
	{
	    emit_move_insn ( operands[0], dest );
	}
    }
}

char*
output_pic_dep ( template, pic_yes, pic_no, which_operand, operands )
    char *template, *pic_yes, *pic_no;
    int which_operand;
    rtx *operands;
{
    operands[which_operand] = gen_rtx ( SYMBOL_REF, VOIDmode, pic_yes );

    return template;
}

char*
output_long_mem_bitop ( name, operands )
    char *name;
    rtx *operands;
{
    operands[2] = gen_rtx ( SYMBOL_REF, VOIDmode, name );
    operands[0] = XEXP ( operands[0], 0 );

    /* LSW @ address, MSW @ address + 1. */

    if ( 15 < INTVAL ( operands[1] ))
    {
	operands[1] = gen_rtx
	    ( CONST_INT, VOIDmode, INTVAL ( operands[1] ) - 16 );
	operands[0] = plus_constant ( XEXP ( operands[0], 0 ), 1 );
	    
	return fms ( "b%2	#%1,@:%0" );
    }
    else
    {
	return fms ( "b%2	#%1,@:%0" );
    }
}

char*
output_long_reg_bitop ( name, operands )
    char *name;
    rtx *operands;
{ 
    operands[3] = gen_rtx ( SYMBOL_REF, VOIDmode, name );
    
    if ( 15 < INTVAL ( operands[1] ))
    {
	operands[2] = gen_rtx
	    ( CONST_INT, VOIDmode, INTVAL ( operands[2] ) - 16 );
	
	if ( DSP_B_REGNUM >= REGNO ( operands[0] ))
	{
	    return "b%3	#%2,%e0";
	}
	else
	{
	    return "b%3	#%2,%g0";
	}
    }
    else
    {
	return "b%3	#%2,%h0";
    }
}

char*
output_long_reg_logical ( name, operands )
    char *name;
    rtx *operands;
{
    operands[3] = gen_rtx ( SYMBOL_REF, VOIDmode, name );
    
    if ( which_alternative )
    {
  	return "%3	%g2,%0	%h0,n6" SC
	       "move	%e0,%h0" SC
	       "move	n6,%e0" SC
	       "%3	%2,%0" SC
	       "move	%e0,n6" SC
	       "move	%h0,%0" SC
	       "move	n6,%h0";
    }
    else
    {
  	return "%3	#%e2,%0" SC
	       "move	%h0,n6" SC
	       "move	%e0,%h0" SC
	       "move	n6,%e0" SC
	       "%3	#%h2,%0" SC
	       "move	%e0,n6" SC
	       "move	%h0,%0" SC
	       "move	n6,%h0";
    }
}

char*
output_movsi ( operands )
    rtx *operands;
{
    enum rtx_code addr_code;

    operands[2] = NULL;
    if ( MEM == GET_CODE ( operands[0] ))
    {
	addr_code = GET_CODE ( XEXP ( operands[0], 0 ));

	if ( POST_INC == addr_code || POST_DEC == addr_code )
	{
	    operands[2] = XEXP ( XEXP ( operands[0], 0 ), 0 );
	}
    }
    else if ( MEM == GET_CODE ( operands[1] ))
    {
	addr_code = GET_CODE ( XEXP ( operands[1], 0 ));

	if ( POST_INC == addr_code || POST_DEC == addr_code )
	{
	    operands[2] = XEXP ( XEXP ( operands[1], 0 ), 0 );
	}
    }

    if ( NULL != operands[2] )
    {
	if ( POST_INC == addr_code )
	{
	    return "move	%1,%0" SC "move	(%2)+";
	}
	else if ( POST_DEC == addr_code )
	{
	    return "move	%1,%0" SC "move	(%2)-";
	}
    }
    return "move	%1,%0";
}

char*
output_movdi ( operands )
    rtx *operands;
{
    enum rtx_code addr_code;

    operands[2] = NULL;
    if ( MEM == GET_CODE ( operands[0] ))
    {
	addr_code = GET_CODE ( XEXP ( operands[0], 0 ));

	if ( POST_INC == addr_code || POST_DEC == addr_code )
	{
	    operands[2] = XEXP ( XEXP ( operands[0], 0 ), 0 );
	}
    }
    else if ( MEM == GET_CODE ( operands[1] ))
    {
	addr_code = GET_CODE ( XEXP ( operands[1], 0 ));

	if ( POST_INC == addr_code || POST_DEC == addr_code )
	{
	    operands[2] = XEXP ( XEXP ( operands[1], 0 ), 0 );
	}
    }

    if ( NULL != operands[2] )
    {
	if ( POST_INC == addr_code )
	{
	    return "move	%1,%0" SC "lua	(%2+#3),%2";
	}
	else if ( POST_DEC == addr_code )
	{
	    return "move	%1,%0" SC "lua	(%2-#3),%2";
	}
    }
    return "move	%1,%0";
}

char*
output_move_byte_signed ( operands )
    rtx *operands;
{
    int r_plus_offset_p = FALSE;
    
    if ( REG_P ( operands[0] ) && REG_P ( operands[1] ) &&
	REGNO ( operands[0] ) == REGNO ( operands[1] ))
    {
	return "";
    }
    
    if ( MEM != GET_CODE ( operands[0] ) && MEM != GET_CODE ( operands[1] ))
    {
	return "move	%1,%0";
    }

    return "movebs	%1,%0";
}

char*
output_move_byte_unsigned ( operands )
    rtx *operands;
{
    int r_plus_offset_p = FALSE;
    
    if ( REG_P ( operands[0] ) && REG_P ( operands[1] ) &&
	REGNO ( operands[0] ) == REGNO ( operands[1] ))
    {
	return "";
    }
    
    if ( MEM != GET_CODE ( operands[0] ) && MEM != GET_CODE ( operands[1] ))
    {
	return "move	%1,%0";
    }

    return "moveb	%1,%0";
}

#include "config/dsp.c"
