/* $Id: defs.h,v 1.10 1991/12/16 18:07:21 jay Exp $ */
/* Basic definitions for GDB, the GNU debugger.
   Copyright (C) 1986, 1989 Free Software Foundation, Inc.

This file is part of GDB.

GDB is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 1, or (at your option)
any later version.

GDB is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GDB; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */

#ifdef __WATCOMC__
extern void error( char *__format,...);
extern void fatal ( char * __format, ... );
extern int query (char *__ctlstr, ...);
extern void fprintf_filtered (FILE *__stream,char *__format, ... );
extern void printf_filtered (char *__format, ... );
#else
extern void fprintf_filtered ();
extern void printf_filtered ();
#endif

#define COFF_AOUT_H <a.out.h>
#define DELETE_FIRST_OBJECT_FILE 1
#define DEFAULT_PROMPT "(gdb) "
#define GDB_INIT_FILE ".gdbinit"
#define GDB_INIT_FILE2 "/.gdbinit"
#define GDB_INIT_FILE3 "./.gdbinit"
#define UNDERSCORE_PREFIX_CHAR '_'
#define CORE_ADDR unsigned int
#define VALID_TEXT_ADDRESS(pc) (1)
#define CORE_ADDR_CAST(ca) ca
#define CORE_ADDR_MAP(ca) (0)
#define CORE_ADDR_ADDR(ca) (ca)
#define CORE_ADDR_W0(ca) (ca)
#define CORE_ADDR_W1(ca) (0)
#define RESTART_CROSS_DEBUGGED_CODE(exec_file,from_tty) 
#define CORE_ZERO (0)
#define LONGEST_ZERO (0)
#define FRAME_ZERO (0)
#define COFF_VALUE long

#define LMAP 0
#define CORE_ADDR_INVALID(ca,val) (ca == val)
#define CORE_ADDR_VALID(ca,val) (ca != val)
#define INVALIDATE_CORE_ADDR(ca,val) {ca=val;}
#define TARGET_WORD_NUM_BITS (sizeof(long)*8)
#define ADDRESS_ALIGN 1
#define PADDRESS_ALIGN 1
#define SIZEOF_FLT sizeof(float)
#define SIZEOF_DOUBLE sizeof(double)

#define SIZEOF_CHAR sizeof(char)
#define SIZEOF_SHORT sizeof(short)
#define SIZEOF_INT sizeof(int)
#define SIZEOF_LONG sizeof(long)

#define SIZEOF_UNSIGNED_CHAR sizeof(char)
#define SIZEOF_UNSIGNED_SHORT sizeof(short)
#define SIZEOF_UNSIGNED_INT sizeof(int)
#define SIZEOF_UNSIGNED_LONG sizeof(long)
#define SIZEOF_POINTER sizeof(char *)
#define SIZEOF_REGISTER_TYPE sizeof(REGISTER_TYPE)

#define DSIZEOF_FLT sizeof(float)
#define DSIZEOF_DOUBLE sizeof(double)

#define DSIZEOF_CHAR sizeof(char)
#define DSIZEOF_SHORT sizeof(short)
#define DSIZEOF_INT sizeof(int)
#define DSIZEOF_LONG sizeof(long)

#define DSIZEOF_UNSIGNED_CHAR sizeof(char)
#define DSIZEOF_UNSIGNED_SHORT sizeof(short)
#define DSIZEOF_UNSIGNED_INT sizeof(int)
#define DSIZEOF_UNSIGNED_LONG sizeof(long)
#define DSIZEOF_POINTER sizeof(char *)
#define DSIZEOF_REGISTER_TYPE sizeof(REGISTER_TYPE)

#define PRINT_WORD_X(stream,format,val,len) \
  fprintf_filtered(stream,format,val)
#define PRINT_WORD_D(stream,format,val,len) \
  fprintf_filtered(stream,format,val)
#define PRINT_WORD_U(stream,format,val,len) \
  fprintf_filtered(stream,format,val)
#define PRINT_WORD_O(stream,format,val,len) \
  fprintf_filtered(stream,format,val)
#define PRINT_WORD_0X(stream,format,val,len) \
  fprintf_filtered(stream,format,val)

#define LM_CHAR_TYPE char
#define XY_CHAR_TYPE char
#define DOUBLE_TYPE double
#define FLOAT_TYPE float
#define FLT_PTR float *
#define DOUBLE_PTR double *

#define LM_CHAR_PTR char *
#define LM_SHORT_PTR short *
#define LM_INT_PTR int *
#define LM_LONG_PTR long *
#define LM_UNSIGNED_CHAR_PTR unsigned char *
#define LM_UNSIGNED_SHORT_PTR unsigned short *
#define LM_UNSIGNED_INT_PTR unsigned int *
#define LM_UNSIGNED_LONG_PTR unsigned long *
#define LM_POINTER_PTR char **

#define XY_CHAR_PTR char *
#define XY_SHORT_PTR short *
#define XY_INT_PTR int *
#define XY_LONG_PTR long *
#define XY_FLT_PTR float *
#define XY_UNSIGNED_CHAR_PTR unsigned char *
#define XY_UNSIGNED_SHORT_PTR unsigned short *
#define XY_UNSIGNED_LONG_PTR unsigned long *
#define XY_UNSIGNED_INT_PTR unsigned int *
#define XY_POINTER_PTR char **

#define UNSIGNED_LONGEST_PTR unsigned LONGEST *

#define TARGET_PACKED_FIELDS_BIG_ENDIAN 1
#define DOUBLE_TO_TARGET_DOUBLE(num) (num)
#define DOUBLE_TO_TARGET_FLOAT(num) (num)
#define TARGET_DOUBLE_TO_DOUBLE(num) (num)
#define TARGET_FLOAT_TO_DOUBLE(num) (num)
#define TARGET_DOUBLE_TO_LONG(dv,rv)  *(LM_LONG_PTR)&rv= *(DOUBLE_PTR)dv
#define TARGET_FLOAT_TO_LONG(dv,rv)  *(LM_LONG_PTR)&rv= *(FLT_PTR)dv
#define EXTEND_CHAR(num)  (num)
#define EXTEND_SHORT(num) (num)
#define EXTEND_INT(num) (num)
#define EXTEND_LONG(num) (num)
#define EXTEND_UNSIGNED_CHAR(num)  (num)
#define EXTEND_UNSIGNED_SHORT(num) (num)
#define EXTEND_UNSIGNED_INT(num) (num)
#define EXTEND_UNSIGNED_LONG(num) (num)
#define EXTEND_POINTER(num) (num)

#define LONGEST_TO_HOST_CHAR(num)  ((char)num)
#define LONGEST_TO_HOST_INT(num) ((int)num)
#define LONGEST_TO_HOST_UNSIGNED_CHAR(num)  ((unsigned char)num)

#define XY_LONGEST_TO_TARGET_CHAR(num)  ((char)num)
#define XY_LONGEST_TO_TARGET_SHORT(num) ((short)num)
#define XY_LONGEST_TO_TARGET_INT(num) ((int)num)
#define XY_LONGEST_TO_TARGET_LONG(num) ((long)num)

#define LM_LONGEST_TO_TARGET_CHAR(num)  ((char)num)
#define LM_LONGEST_TO_TARGET_SHORT(num) ((short)num)
#define LM_LONGEST_TO_TARGET_INT(num) ((int)num)
#define LM_LONGEST_TO_TARGET_LONG(num) ((long)num)

#define LONGEST_TO_CORE_ADDR(num) ((CORE_ADDR)num)

#define UNSIGNED_LONGEST_TO_LONGEST(num) ((LONGEST)num)
#define CORE_ADDR_TO_LONG(num) ((long)num)
#define CORE_ADDR_TO_LONGEST(num) ((LONGEST)num)

#define XY_TARGET_CHAR_TO_LONGEST(num) (num)
#define LM_TARGET_CHAR_TO_LONGEST(num) (num)

#define LM_TARGET_CHAR_TO_DOUBLE(num) (num)
#define LM_TARGET_SHORT_TO_DOUBLE(num) (num)
#define LM_TARGET_INT_TO_DOUBLE(num) (num)
#define LM_TARGET_LONG_TO_DOUBLE(num) (num)
#define LM_TARGET_UNSIGNED_LONG_TO_DOUBLE(num) (num)
#define LM_TARGET_UNSIGNED_CHAR_TO_DOUBLE(num) (num)
#define LM_TARGET_UNSIGNED_SHORT_TO_DOUBLE(num) (num)
#define LM_TARGET_UNSIGNED_INT_TO_DOUBLE(num) (num)

#define XY_TARGET_CHAR_TO_DOUBLE(num) (num)
#define XY_TARGET_SHORT_TO_DOUBLE(num) (num)
#define XY_TARGET_INT_TO_DOUBLE(num) (num)
#define XY_TARGET_LONG_TO_DOUBLE(num) (num)
#define XY_TARGET_UNSIGNED_LONG_TO_DOUBLE(num) (num)
#define XY_TARGET_UNSIGNED_CHAR_TO_DOUBLE(num) (num)
#define XY_TARGET_UNSIGNED_SHORT_TO_DOUBLE(num) (num)
#define XY_TARGET_UNSIGNED_INT_TO_DOUBLE(num) (num)

#define HOST_CHAR_TO_LONGEST(num) (LONGEST) num
#define HOST_SHORT_TO_LONGEST(num) (LONGEST) num
#define HOST_INT_TO_LONGEST(num) (LONGEST) num
#define HOST_UNSIGNED_LONG_TO_LONGEST(num) (UNSIGNED_LONGEST) num
#define HOST_UNSIGNED_CHAR_TO_LONGEST(num) (UNSIGNED_LONGEST) num
#define HOST_UNSIGNED_SHORT_TO_LONGEST(num) (UNSIGNED_LONGEST) num
#define HOST_UNSIGNED_INT_TO_LONGEST(num) (UNSIGNED_LONGEST) num

#define UNSIGNED_LONGEST unsigned LONGEST
#define LONGEST_TO_UNSIGNED_LONGEST(num) (unsigned LONGEST) num
#define ADD_DOUBLE(v1,v2) (v1 + v2)
#define SUB_DOUBLE(v1,v2) (v1 - v2)
#define MUL_DOUBLE(v1,v2) (v1 * v2)
#define DIV_DOUBLE(v1,v2) (v1 / v2)
#define EQUAL_DOUBLE(v1,v2) (v1 == v2)

#define ADD_UNSIGNED_LONGEST(v1,v2) (v1 + v2)
#define SUB_UNSIGNED_LONGEST(v1,v2) (v1 - v2)
#define MUL_UNSIGNED_LONGEST(v1,v2) (v1 * v2)
#define DIV_UNSIGNED_LONGEST(v1,v2) (v1 / v2)
#define REM_UNSIGNED_LONGEST(v1,v2) (v1 % v2) 
#define LSH_UNSIGNED_LONGEST(v1,v2) (v1 << v2) 
#define RSH_UNSIGNED_LONGEST(v1,v2) (v1 >> v2)
#define LOGAND_UNSIGNED_LONGEST(v1,v2) (v1 & v2) 
#define LOGIOR_UNSIGNED_LONGEST(v1,v2) (v1 | v2) 
#define LOGXOR_UNSIGNED_LONGEST(v1,v2) (v1 ^ v2) 
#define AND_UNSIGNED_LONGEST(v1,v2) (v1 && v2)
#define OR_UNSIGNED_LONGEST(v1,v2) (v1 || v2) 
#define MIN_UNSIGNED_LONGEST(v1,v2) (v1 < v2 ? v1 : v2)
#define MAX_UNSIGNED_LONGEST(v1,v2) (v1 > v2 ? v1 : v2)

#define ADD_LONGEST(v1,v2) (v1 + v2)
#define SUB_LONGEST(v1,v2) (v1 - v2)
#define MUL_LONGEST(v1,v2) (v1 * v2)
#define DIV_LONGEST(v1,v2) (v1 / v2)
#define REM_LONGEST(v1,v2) (v1 % v2) 
#define LSH_LONGEST(v1,v2) (v1 << v2) 
#define RSH_LONGEST(v1,v2) (v1 >> v2)
#define LOGAND_LONGEST(v1,v2) (v1 & v2) 
#define LOGIOR_LONGEST(v1,v2) (v1 | v2) 
#define LOGXOR_LONGEST(v1,v2) (v1 ^ v2) 
#define AND_LONGEST(v1,v2) (v1 && v2)
#define OR_LONGEST(v1,v2) (v1 || v2) 
#define MIN_LONGEST(v1,v2) (v1 < v2 ? v1 : v2)
#define MAX_LONGEST(v1,v2) (v1 > v2 ? v1 : v2)
#define EQUAL_LONGEST(v1,v2) (v1 == v2)
#define EQUAL_PTR(v1,v2) ((char *)v1 == (char *)v2)
#define LESS_UNSIGNED_LONGEST(v1,v2) (v1 < v2)
#define LESS_LONGEST(v1,v2) (v1 < v2)
#define LESS_PTR(v1,v2) ((char *)v1 < (char *)v2)
#define LESS_DOUBLE(v1,v2) (v1 < v2)
#define NEG_DOUBLE(v1) - v1
#define NEG_LONGEST(v1) - v1
#define LOGNOT_LONGEST(v1) ~ v1
#define ARG_REG_PARAM(addr,i) 0
#define PUT_REG_PARAM(addr,i,arg)

#define min(a, b) (((a) < (b)) ? (a) : (b))
#define max(a, b) (((a) > (b)) ? (a) : (b))

extern char *savestring ();
extern char *concat ();
extern char *xmalloc (), *xrealloc ();
extern int parse_escape ();
extern char *reg_names[];

#ifndef MSDOS
#define MSDOS 0
#endif
/* Various possibilities for alloca.  */
#ifdef __GNUC__
#define alloca __builtin_alloca
#include <stdlib.h>
#else
#ifdef sparc
#include <alloca.h>
#else
#ifndef APLC
#include <stdlib.h>
#endif
#if MSDOS
#include <malloc.h>
#else
extern char *alloca ();
#endif
#endif
#endif

extern int quit_flag;

extern int immediate_quit;

#define QUIT { if (quit_flag) quit (); }

/* Notes on classes: class_alias is for alias commands which are not
   abbreviations of the original command.  */

enum command_class
{
  no_class = -1, class_run = 0, class_vars, class_stack,
  class_files, class_support, class_info, class_breakpoint,
  class_alias, class_obscure, class_user
};

/* the cleanup list records things that have to be undone
   if an error happens (descriptors to be closed, memory to be freed, etc.)
   Each link in the chain records a function to call and an
   argument to give it.

   Use make_cleanup to add an element to the cleanup chain.
   Use do_cleanups to do all cleanup actions back to a given
   point in the chain.  Use discard_cleanups to remove cleanups
   from the chain back to a given point, not doing them.  */

struct cleanup
{
  struct cleanup *next;
  void (*function) ();
  int arg;
};

extern void do_cleanups ();
extern void discard_cleanups ();
extern struct cleanup *make_cleanup ();
extern struct cleanup *save_cleanups ();
extern void restore_cleanups ();
extern void free_current_contents ();
extern void reinitialize_more_filter ();
extern void fputs_filtered ();
extern void print_spaces_filtered ();
extern char *tilde_expand ();

/* Structure for saved commands lines
   (for breakpoints, defined commands, etc).  */

struct command_line
{
  struct command_line *next;
  char *line;
};

struct command_line *read_command_lines ();

/* String containing the current directory (what getwd would return).  */

extern char *current_directory;

