/* Machine-dependent code which would otherwise be in inflow.c and core.c,
	$Id: m561-dep.c,v 1.3 1993/04/08 22:07:24 jay Exp $

   for GDB, the GNU debugger.
   Copyright (C) 1986, 1987, 1989 Free Software Foundation, Inc.
   This code is for the sparc cpu.

This file is part of GDB.

GDB is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 1, or (at your option)
any later version.

GDB is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GDB; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */

#include <stdlib.h>
#include <stdio.h>
#include "defs.h"
#include "param.h"
#include "value.h"
#include "symtab.h"
#include "frame.h"
#include "obstack.h"
#include "inferior.h"

#include "simcom.h"
#include "simdev.h"
#include "simusr.h"
#include "core100.h"
#include "gsig100.h"
#include <signal.h>
#include <fcntl.h>
#if MSDOS
#include "stub.h"
#endif
#ifndef DSP56100
#define DSP56100 1
#endif
#include "../hostio/hostio.h"

#define STACK_MAP memory_map_x

extern struct dev_const dv_const;
extern struct dev_var *dv_var;
static  unsigned long *hspr;

LONGEST longest_zero;
CORE_ADDR core_zero;
FRAME_ADDR frame_zero_init;
static
struct reg_info{
   int startbyte; /* start byte in dsp_regs structure */
   char *regname; /* used to look up periph and regnum from dsp_findreg */
   struct type **virtual_type;
   int regbytes; /* number of bytes used in dsp_regs structure */
   int real_size; /* actual number of bytes used by the dsp */
   int periph;
   int regnum; /* cross to dsp reg number */
   }
reg_info[]=
{
{0,"a0",&builtin_type_long,8,4,0,0},
{0,"a0",&builtin_type_int,4,2,0,0},
{4,"a1",&builtin_type_int,4,2,0,0},
{8,"a2",&builtin_type_int,4,1,0,0},
{12,"b0",&builtin_type_long,8,4,0,0},
{12,"b0",&builtin_type_int,4,2,0,0},
{16,"b1",&builtin_type_int,4,2,0,0},
{20,"b2",&builtin_type_int,4,1,0,0},
{24,"bcr",&builtin_type_unsigned_int,4,2,0,0},
{28,"cocr",&builtin_type_unsigned_int,4,2,0,0},
{32,"cosr",&builtin_type_unsigned_int,4,2,0,0},
{36,"cra0",&builtin_type_unsigned_int,4,2,0,0},
{40,"cra1",&builtin_type_unsigned_int,4,2,0,0},
{44,"crb0",&builtin_type_unsigned_int,4,2,0,0},
{48,"crb1",&builtin_type_unsigned_int,4,2,0,0},
{52,"crx",&builtin_type_unsigned_int,4,2,0,0},
{56,"ctx",&builtin_type_unsigned_int,4,2,0,0},
{60,"cvr",&builtin_type_unsigned_int,4,1,0,0},
{64,"cyc",&builtin_type_long,8,6,0,0},
{72,"hcr",&builtin_type_unsigned_int,4,1,0,0},
{76,"hrx",&builtin_type_unsigned_int,4,2,0,0},
{80,"hsr",&builtin_type_unsigned_int,4,1,0,0},
{84,"htx",&builtin_type_unsigned_int,4,2,0,0},
{88,"icr",&builtin_type_unsigned_int,4,1,0,0},
{92,"ictr",&builtin_type_long,8,6,0,0},
{100,"ipr",&builtin_type_unsigned_int,4,2,0,0},
{104,"isr",&builtin_type_unsigned_int,4,1,0,0},
{108,"ivr",&builtin_type_unsigned_int,4,1,0,0},
{112,"la",&builtin_type_unsigned_int,4,2,0,0},
{116,"lc",&builtin_type_unsigned_int,4,2,0,0},
{120,"m0",&builtin_type_unsigned_int,4,2,0,0},
{124,"m1",&builtin_type_unsigned_int,4,2,0,0},
{128,"m2",&builtin_type_unsigned_int,4,2,0,0},
{132,"m3",&builtin_type_unsigned_int,4,2,0,0},
{136,"n0",&builtin_type_unsigned_int,4,2,0,0},
{140,"n1",&builtin_type_unsigned_int,4,2,0,0},
{144,"n2",&builtin_type_unsigned_int,4,2,0,0},
{148,"n3",&builtin_type_unsigned_int,4,2,0,0},
{152,"omr",&builtin_type_unsigned_int,4,1,0,0},
{156,"pbc",&builtin_type_unsigned_int,4,1,0,0},
{160,"pbd",&builtin_type_unsigned_int,4,2,0,0},
{164,"pbddr",&builtin_type_unsigned_int,4,2,0,0},
{168,(char *)NULL,&builtin_type_unsigned_int,8,2,0,0},
{176,"pcc",&builtin_type_unsigned_int,4,2,0,0},
{180,"pcd",&builtin_type_unsigned_int,4,2,0,0},
{184,"pcddr",&builtin_type_unsigned_int,4,2,0,0},
{188,"plcr",&builtin_type_unsigned_int,4,2,0,0},
{192,"r0",&builtin_type_unsigned_int,4,2,0,0},
{196,"r1",&builtin_type_unsigned_int,4,2,0,0},
{200,"r2",&builtin_type_unsigned_int,8,2,0,0},
{208,"r3" ,&builtin_type_unsigned_int,4,2,0,0},
{212,"rmh0" ,&builtin_type_unsigned_int,4,2,0,0},
{216,"rmh1" ,&builtin_type_unsigned_int,4,2,0,0},
{220,"rml0" ,&builtin_type_unsigned_int,4,2,0,0},
{224,"rml1" ,&builtin_type_unsigned_int,4,2,0,0},
{228,"rx0",&builtin_type_unsigned_int,4,2,0,0},
{232,"rx1",&builtin_type_unsigned_int,4,2,0,0},
{236,"rxh",&builtin_type_unsigned_int,4,1,0,0},
{240,"rxl",&builtin_type_unsigned_int,4,1,0,0},
{244,"sccr",&builtin_type_unsigned_int,4,2,0,0},
{248,"scr",&builtin_type_unsigned_int,4,2,0,0},
{252,"r2",&builtin_type_unsigned_int,8,2,0,0},
{260,"sr",&builtin_type_unsigned_int,4,2,0,0},
{264,"srx",&builtin_type_unsigned_int,4,1,0,0},
{268,"ssh",&builtin_type_unsigned_int,4,2,0,0},
{272,"ssisr",&builtin_type_unsigned_int,4,1,0,0},
{276,"ssl",&builtin_type_unsigned_int,4,2,0,0},
{280,"ssr0",&builtin_type_unsigned_int,4,1,0,0},
{284,"ssr1",&builtin_type_unsigned_int,4,1,0,0},
{288,"stx",&builtin_type_unsigned_int,4,1,0,0},
{292,"stxa",&builtin_type_unsigned_int,4,1,0,0},
{296,"tcr",&builtin_type_unsigned_int,4,2,0,0},
{300,"tcpr",&builtin_type_unsigned_int,4,2,0,0},
{304,"tctr",&builtin_type_unsigned_int,4,2,0,0},
{308,"tmh0",&builtin_type_unsigned_int,4,2,0,0},
{312,"tmh1",&builtin_type_unsigned_int,4,2,0,0},
{316,"tml0",&builtin_type_unsigned_int,4,2,0,0},
{320,"tml1",&builtin_type_unsigned_int,4,2,0,0},
{324,"tpr",&builtin_type_unsigned_int,4,2,0,0},
{328,"tsr0",&builtin_type_unsigned_int,4,1,0,0},
{332,"tsr1",&builtin_type_unsigned_int,4,1,0,0},
{336,"tx0",&builtin_type_unsigned_int,4,2,0,0},
{340,"tx1",&builtin_type_unsigned_int,4,2,0,0},
{344,"txh",&builtin_type_unsigned_int,4,1,0,0},
{348,"txl",&builtin_type_unsigned_int,4,1,0,0},
{352,"x0",&builtin_type_long,8,4,0,0},
{352,"x0",&builtin_type_int,4,2,0,0},
{356,"x1",&builtin_type_int ,4,2,0,0},
{360,"y0",&builtin_type_long,8,4,0,0},
{360,"y0",&builtin_type_int,4,2,0,0},
{364,"y1",&builtin_type_int,4,2,0,0},
{368,"r2",&builtin_type_unsigned_int,8,2,0,0},
{376,"sp",&builtin_type_unsigned_int,4,1,0,0}
};

/* dig through the stack to get the 1st argument to the current function.
   (which hasn't manipulated the stack pointer yet). */

unsigned long
get_1st_arg ( )
{
    unsigned long location, value;
    
    /* find the stack pointer. the first argument will in the memory
       location addressed by the stack pointer - 1. */
    dsp_rreg ( 0, 0, REG_R2, & location );
    location -= 1;
    dsp_rmem ( 0, memory_map_x, location, & value );
    return value;
}

/* dig through the stack to get the 2nd argument to the current function.
   (which hasn't manipulated the stack pointer yet). */

unsigned long
get_2nd_arg ( )
{
    unsigned long location, value;
    
    /* find the stack pointer. the first argument will in the memory
       location addressed by the stack pointer - 1. */
    dsp_rreg ( 0, 0, REG_R2, & location );
    location -= 2;
    dsp_rmem ( 0, memory_map_x, location, & value );
    return value;
}


dsp_561_register_byte(regnumber)
int regnumber;
{/* Index within `registers' of the first byte of the space for
   362     register N.  */
return (reg_info[regnumber].startbyte);
}

dsp_561_register_raw_size(regnumber)
int regnumber;
{
return (reg_info[regnumber].regbytes);
}

struct type *
register_virtual_type(regnumber)
int regnumber;
{
return ( *reg_info[regnumber].virtual_type);
}

/* m561 doesnt have ptrace */

int
call_ptrace (request, pid, arg3, arg4)
     int request, pid, arg3, arg4;
{
 if (request==0) return;
 error ("no ptrace");
}

void
kill_inferior ()
{
}

/* This is used when GDB is exiting.  It gives less chance of error.*/

void
kill_inferior_fast ()
{
}

static
void intrpt1()
{

   (void) signal(SIGINT,intrpt1);
   dv_var->CTRLBR = 1;
}

/* Resume execution of the inferior process.
   If STEP is nonzero, single-step it.
   If SIGNAL is nonzero, give it that signal.  */
extern CORE_ADDR text_end;

static
unsigned long
send_address,receive_address;

CORE_ADDR
program_exit_address;

void
resume (step, signums)
     int step;
     int signums;
{
  extern void request_quit ();
  extern int cross_debugging_trap,trap_expected;
  extern CORE_ADDR step_resume_break_address;
  int printed_something;
  CORE_ADDR pc;
  struct dev_var *dv=dv_const.sv[0];
  if (remote_debugging)
    remote_resume (step, signums);
  else
    {
  dv_var->CTRLBR=0; /* flag cleared for break signal */
  (void) signal(SIGINT,intrpt1);
 cross_debugging_trap=0;
  printed_something=0;

do{


    if ( send_address && send_address == dv_var->reg_exec )
      {
	  /* we, as the host, are now going to *receive* some data.
	     the hio_receive buffer should be large enough to handle
	     the full transmission. */

	  unsigned long input_buffer, input_count;
	  int i;
	  
	  input_buffer = get_1st_arg ( );
	  input_count = get_2nd_arg ( );
	  hio_receive.length = input_count;
	  CHECK_BUFFER_SIZE ( & hio_receive, input_count );
	  
	  for ( i = 0; i < input_count; ++ i )
	  {
	      dsp_rmem ( 0, memory_map_x, input_buffer ++, hio_receive.buffer + i );
	  }
	  hio_receive.valid_p = TRUE;
	  printed_something=1;
      }
      else if ( receive_address && receive_address == dv_var->reg_exec )
      {
	  /* the dsp is ready to receive a message, so we'll go ahead and
	     *send* it. the dsp should have allocated a buffer large 
	     enough to handle the full transmission. */

	  unsigned long output_buffer;
	  int i;
	  
	  output_buffer = get_1st_arg ( );
	  for ( i = 0; i < hio_send.length; ++ i )
	  {
	      dsp_wmem ( 0, memory_map_x, output_buffer ++, hio_send.buffer + i );
	  }
	  hio_send.valid_p = FALSE;
      }
      
	/* Clear end-of-instruction and end-of-repeat flag bits */
	dv->flg_stat&= ~(DSP_GEOI|DSP_GEOR);
	while (!(dv->flg_stat& (DSP_GEOI|DSP_GEOR))) 
   dsp_exec(0);
	CORE_ADDR_ADDR(pc)=dv_var->reg_exec;

    process_pending_host_io();
    if ( printed_something){
	fflush(stdout);
	printed_something=0;
	}

 if (CORE_ADDR_ADDR(pc)==CORE_ADDR_ADDR(program_exit_address)){
   cross_debugging_trap=SIGCHLD;
   break;
   }
	if (step) break;
 if (dv_var->CTRLBR) break; /* break signal occurred */
	}while((!breakpoint_here_p(pc))&&
  /* following line tests for dummy function end address */
  (CORE_ADDR_ADDR(pc)!= (CORE_ADDR_ADDR(text_end) - 2)) &&
  ((!CORE_ADDR_ADDR(step_resume_break_address))||
  (CORE_ADDR_ADDR(pc)!=CORE_ADDR_ADDR(step_resume_break_address))));/*stop if step or breakpoint */
 (void) signal(SIGINT,request_quit);
 if (!cross_debugging_trap)
 cross_debugging_trap=(dv_var->CTRLBR)?SIGINT:SIGTRAP;
		}
}

union dsp_regs{
      char ra[REGISTER_BYTES];
   struct dsp_561_registers rs;
      };
CORE_ADDR stack_zero;

void
fetch_inferior_registers ()
{
  union dsp_regs inferior_registers;
  extern char registers[];
  int i;

  if (remote_debugging)
    remote_fetch_registers (registers);
  else
    { /* get all registers */
      for (i=0;i<NUM_REGS;i++)
        if(reg_info[i].regbytes==4)
         dsp_rreg(0,reg_info[i].periph,reg_info[i].regnum,
            (unsigned long *)&inferior_registers.ra[reg_info[i].startbyte]);
      *(unsigned long *)&inferior_registers.ra[reg_info[CYC_REGNUM].startbyte]=
         dv_var->reg_cycl
         &0xffffl;
      *(unsigned long *)&inferior_registers.ra[reg_info[ICNT_REGNUM].startbyte]=
         dv_var->reg_icnt
         &0xffffl;
      *(unsigned long *)&inferior_registers.ra[reg_info[CYC_REGNUM].startbyte+sizeof(long)]=
        dv_var->reg_cycl
        >>16&0xffffl;
      *(unsigned long *)&inferior_registers.ra[reg_info[ICNT_REGNUM].startbyte+sizeof(long)]=
        dv_var->reg_icnt
        >>16&0xffffl;
      *(unsigned long *)&inferior_registers.ra[reg_info[PC_REGNUM].startbyte]=
        dv_var->reg_exec;
      *(unsigned long *)&inferior_registers.ra[reg_info[SP_REGNUM].startbyte]=
        hspr[REG_R2];
      *(unsigned long *)&inferior_registers.ra[reg_info[FP_REGNUM].startbyte]=
        hspr[REG_R2];
  *(unsigned long *)&inferior_registers.ra[reg_info[SP_REGNUM].startbyte+sizeof(long)]= (long) CORE_ADDR_MAP(stack_zero);
  *(unsigned long *)&inferior_registers.ra[reg_info[PC_REGNUM].startbyte+sizeof(long)]= (long) memory_map_p;
  *(unsigned long *)&inferior_registers.ra[reg_info[FP_REGNUM].startbyte+sizeof(long)]= (long) CORE_ADDR_MAP(stack_zero);
      bcopy (&inferior_registers.ra[0], &registers[0], REGISTER_BYTES);
#if 0
      read_inferior_memory (inferior_registers.r_sp,
             &registers[REGISTER_BYTE (16)],
             16*4);
#endif
    }
}

/* Store our register values back into the inferior.
   If REGNO is -1, do this for all registers.
   Otherwise, REGNO specifies which register (so we can save time).  */
void
store_inferior_registers (regno)
     int regno;
{
  union dsp_regs inferior_registers;
  extern char registers[];
	int i,regoffset,xrsp,xrthis;
 unsigned long newval,oldval;
 void remote_store_registers();

  xrsp=reg_info[SP_REGNUM].regnum;

  if (remote_debugging)
    remote_store_registers (registers);
  else if (regno>=0){ /* single register number */
    i=regno;
    xrthis=reg_info[i].regnum;
    regoffset=reg_info[i].startbyte;
    newval= *(unsigned long *)&registers[regoffset];
    if(reg_info[i].regbytes==4){
      dsp_rreg(0,reg_info[i].periph,reg_info[i].regnum,&oldval);
      if (newval!=oldval){
         dsp_wreg(0,reg_info[i].periph,reg_info[i].regnum,&newval);
         if ((reg_info[i].periph==0)&&xrthis==xrsp) write_register(SP_REGNUM,newval);
         }
      }
    else if (i==ICNT_REGNUM||i==CYC_REGNUM){
       newval+=(*(unsigned long *)&registers[regoffset+sizeof(long)])<<16;
       dsp_wreg(0,reg_info[i].periph,reg_info[i].regnum,&newval);
       }
    else if(i==PC_REGNUM){
      oldval= dv_var->reg_exec;
      if (newval!=oldval)
       dsp_wreg(0,0,REG_PC,&newval);
      }
    else if (i==FP_REGNUM){
      oldval= hspr[REG_R2];
      if (newval!=oldval){
       dsp_wreg(0,0,REG_R2,&newval);
         write_register(R2_REGNUM,newval);
        }
      }
    else if (i==SP_REGNUM){
      oldval= hspr[REG_R2];
      if (newval!=oldval){
       dsp_wreg(0,0,REG_R2,&newval);
         write_register(R2_REGNUM,newval);
        }
      }
    else{ /* long register values X,Y,A10,B10 */
      store_inferior_registers(i+1);
      store_inferior_registers(i+2);
      }
   }
  else /* all registers */
    {
      for (i=0;i<NUM_REGS;i++){
				regoffset=reg_info[i].startbyte;
          newval= *(unsigned long *)&registers[regoffset];
         if (i==ICNT_REGNUM||i==CYC_REGNUM)
            newval+=(*(unsigned long *)&registers[regoffset+sizeof(long)])<<16;
    if(reg_info[i].regbytes==4||(i==FP_REGNUM)||(i==SP_REGNUM)||
       (i==ICNT_REGNUM||i==CYC_REGNUM)){
      if(i==CYC_REGNUM)oldval=dv_var->reg_cycl;
      else if (i==ICNT_REGNUM)oldval= dv_var->reg_icnt;
      else
      dsp_rreg(0,reg_info[i].periph,reg_info[i].regnum, &oldval);
      if (newval!=oldval)
      dsp_wreg(0,reg_info[i].periph,reg_info[i].regnum, &newval);
      }
     }
    regoffset=reg_info[PC_REGNUM].startbyte;
    oldval=dv_var->reg_exec; 
    newval= *(unsigned long *)&registers[regoffset];
    if (newval!=oldval)
       dsp_wreg(0,0,REG_PC,&newval);
#if 0
	  write_inferior_memory (*(int *)&registers[REGISTER_BYTE (SP_REGNUM)],
				 &registers[REGISTER_BYTE (16)],
				 16*4);
#endif
    }
}

/* Copy LEN bytes from inferior's memory starting at MEMADDR
   to debugger memory starting at MYADDR. */

int
read_inferior_memory (memaddr, myaddr, len)
     CORE_ADDR memaddr;
     char *myaddr;
     int len;
{
  register int i;
  int incr;
  long addr;
  int count,buflen;
  register long *buffer;
		enum memory_map memmap; 
 /* notice that l is converted to y mem since longs are in y serially */
 memmap= CORE_ADDR_MAP(memaddr);
		count=len/4;


  /* Read all the longwords */
	addr=CORE_ADDR_ADDR(memaddr);
 incr=1;

/* Allocate buffer of that many longwords.  */
buflen= (incr==1||len>4)?len:8;
buffer = (long *) alloca (buflen);

  for (i = 0; i < count; i+=incr, addr++ )
    dsp_rmem(0,memmap,addr,&buffer[i]);

  bcopy ((char *) buffer , myaddr, len);
  return 0;
}

/* Copy LEN bytes of data from debugger memory at MYADDR
   to inferior's memory at MEMADDR.*/

int
write_inferior_memory (memaddr, myaddr, len)
     CORE_ADDR memaddr;
     char *myaddr;
     int len;
{
  register int i;
  /* Round starting address down to longword boundary.  */
  long addr,*wordp;
  int incr;
  /* Round ending address up; get number of longwords that makes.  */
	enum memory_map memmap;
  register int count;
count=len/4;

  /* Write the entire buffer.  */
 memmap= CORE_ADDR_MAP(memaddr);
 incr= 1;

	addr=CORE_ADDR_ADDR(memaddr);
 wordp= (long *) myaddr;
  for (i = 0; i < count; i+=incr, addr++ )
    dsp_wmem(0,memmap,addr,wordp+i);

  return 0;
}

/* Non-zero if this is an object (.o) file, rather than an executable.
   Distinguishing between the two is rarely necessary (and seems like
   a hack, but there is no other way to get the text and data
   addresses--N_TXTADDR should probably take care of
   this, but it doesn't).  */
/* This definition will not work
   if someone decides to make ld preserve relocation info.  */
#define IS_OBJECT_FILE(hdr) (hdr.a_trsize != 0)

/* Make COFF and non-COFF names for things a little more compatible
   to reduce conditionals later.  */

#ifdef COFF_FORMAT
#define a_magic magic
#endif

#ifndef COFF_FORMAT
#ifndef AOUTHDR
#define AOUTHDR struct exec
#endif
#endif

extern char *sys_siglist[];

/* Hook for `exec_file_command' command to call.  */

extern void (*exec_file_display_hook) ();
   
/* File names of core file and executable file.  */

extern char *execfile;

/* Descriptors on which executable file are open.
   Note that the execchan is closed when an inferior is created
   and reopened if the inferior dies or is killed.  */

extern int execchan;

/* Last modification time of executable file.
   Also used in source.c to compare against mtime of a source file.  */

extern int exec_mtime;

/* Virtual addresses of bounds of the two areas of memory in the core file.  */

extern CORE_ADDR data_start;
extern CORE_ADDR data_end;
extern CORE_ADDR stack_start;
extern CORE_ADDR stack_end;

/* Virtual addresses of bounds of two areas of memory in the exec file.*/

extern CORE_ADDR text_start;

extern CORE_ADDR exec_data_start;
extern CORE_ADDR exec_data_end;

/* Address in executable file of start of text area data.  */

extern int text_offset;

/* Address in executable file of start of data area data.  */

extern int exec_data_offset;

/* Address in core file of start of data area data.  */

extern int data_offset;

/* Address in core file of start of stack area data.  */

extern int stack_offset;
  
#ifdef COFF_FORMAT
/* various coff data structures */

extern FILHDR file_hdr;
extern SCNHDR text_hdr;
extern SCNHDR data_hdr;

#endif /* not COFF_FORMAT */

/* a.out header of exec file.  */

extern AOUTHDR exec_aouthdr;

extern void validate_files ();

/*ARGSUSED*/
void
core_file_command (filename, from_tty)
     char *filename;
     int from_tty;
{/* maybe later load state files  with this?*/
 error ("No core files for m561");
}

static
struct{ /* used for loading section data */
long block_size;
long *mem;
} raw_data;

void exec_file_command();
static
CORE_ADDR text_entry_address;

restart_cross_debugged_code(filename,from_tty) 
     char *filename;
     int from_tty;
{
exec_file_command (filename, from_tty);
/*dsp_wreg(0,0,REG_PC,&CORE_ADDR_ADDR(text_entry_address));*/
}

static
read_section_contents(chan)
     register int chan;
{
FILHDR fl_hdr;
AOUTHDR ao_hdr;
SCNHDR section_hdr;
register int i;

if (read_file_hdr(chan,&fl_hdr) < 0) return (-1);
if (read_aout_hdr(chan,&ao_hdr,(int)fl_hdr.f_opthdr) < 0) return (-1);
for (i=0;i<fl_hdr.f_nscns;i++){
if (lseek (chan, FILHSZ + fl_hdr.f_opthdr + (i * SCNHSZ) , 0) < 0)
  return -1;
if (myread (chan, (char *) &section_hdr, SCNHSZ) < 0)
  return -1;
#ifdef COFF_BYTE_SWAP
   swapem(&section_hdr,(unsigned long)SCNHSZ);
   swapem(section_hdr.s_name,8l);
#endif

if ((strncmp (section_hdr.s_name, ".txt", 8) == 0)||
   (strncmp (section_hdr.s_name, ".dat", 8) == 0)){
  /* load memory block */
  if (section_hdr.s_size > raw_data.block_size){
    /* expand raw data block size  to twice size of current block */
    if (raw_data.mem) raw_data.mem= 
            (long *) xrealloc((char *)raw_data.mem,
         (long) (section_hdr.s_size*2l)*sizeof(long));
    else raw_data.mem=
          (long *)xmalloc((long) (section_hdr.s_size*2l)*sizeof(long));
    raw_data.block_size=section_hdr.s_size*2l; 
		}
  if (lseek (chan,section_hdr.s_scnptr,0) < 0)
    return (-1);
  if (myread(chan,(char *)raw_data.mem,(int)(section_hdr.s_size*sizeof(long)))<0)
  return (-1);
#ifdef COFF_BYTE_SWAP
   swapem(raw_data.mem,(unsigned long)(section_hdr.s_size*sizeof(long)));
#endif
  if (section_hdr.s_flags&STYP_BLOCK){
    /* block data section specified by length:val */
    CORE_ADDR ct;
    unsigned long section_length;
    unsigned long val = *(unsigned long *)raw_data.mem;
    ct= section_hdr.s_paddr;
    section_length = CORE_ADDR_ADDR(section_hdr.s_vaddr); 
    for (;section_length!=0; section_length--){
      if(write_inferior_memory( ct,(char *)raw_data.mem,
         (int)(section_hdr.s_size*sizeof(long))) != 0)
         return (-1);
      CORE_ADDR_ADDR(ct)+=1;
      }
    }
   else
  if (write_inferior_memory(section_hdr.s_paddr,(char *)raw_data.mem,
     (int)(section_hdr.s_size*sizeof(long))) != 0)
 return (-1);
  }
}
 dsp_wreg(0,0,REG_PC,&CORE_ADDR_ADDR(ao_hdr.entry));
 text_entry_address=ao_hdr.entry;
if (raw_data.mem){
  free(raw_data.mem);
  raw_data.block_size=0;
  raw_data.mem= NULL;
  }
 return 0;
}


set_stack_type(module_stack_type)
unsigned long module_stack_type; /* 1=y,2=x,3=l */
{
module_stack_type&=3;
if (module_stack_type){
  enum memory_map stack_map=
    memory_map_x;
    CORE_ADDR_MAP(frame_zero_init)= stack_map;
    CORE_ADDR_MAP(stack_end_addr)= stack_map;
    CORE_ADDR_MAP(stack_zero)= stack_map;
  /* these sizes need reinitialization based on stack space */
  TYPE_LENGTH(builtin_type_char)=SIZEOF_CHAR;
  TYPE_LENGTH(builtin_type_short)=SIZEOF_SHORT;
  TYPE_LENGTH(builtin_type_addr)=SIZEOF_POINTER;
  TYPE_LENGTH(builtin_type_long)=SIZEOF_LONG;
  TYPE_LENGTH(builtin_type_int)=SIZEOF_INT;
  TYPE_LENGTH(builtin_type_unsigned_char)=SIZEOF_UNSIGNED_CHAR;
  TYPE_LENGTH(builtin_type_unsigned_short)=SIZEOF_UNSIGNED_SHORT;
  TYPE_LENGTH(builtin_type_unsigned_int)=SIZEOF_UNSIGNED_INT;
  TYPE_LENGTH(builtin_type_unsigned_long)=SIZEOF_UNSIGNED_LONG;
  TYPE_LENGTH(builtin_type_float)=SIZEOF_FLT;
  TYPE_LENGTH(builtin_type_double)=SIZEOF_DOUBLE;
  }
}

extern CORE_ADDR startup_file_end;	/* From blockframe.c */

get_printf_stuff(module_stack_type)
unsigned long module_stack_type; /* 1=x,2=y,3=l */
{
    int func_index=lookup_misc_func("__send");

    send_address=(func_index== -1)?0
	:CORE_ADDR_ADDR(misc_function_vector[func_index].address);

    func_index=lookup_misc_func("__receive");
    receive_address=(func_index== -1)?0
	:CORE_ADDR_ADDR(misc_function_vector[func_index].address);

 func_index=lookup_misc_func("__crt0_end");
 program_exit_address= CORE_ZERO;
if (func_index== -1){
 CORE_ADDR_ADDR( program_exit_address)=ADDR_BITS;
 }
else{
 CORE_ADDR_ADDR( startup_file_end)=
 CORE_ADDR_ADDR( program_exit_address)=
   CORE_ADDR_ADDR(misc_function_vector[func_index].address);
 }

}
#ifndef O_BINARY
#define O_BINARY 0
#endif

void
exec_file_command (filename, from_tty)
     char *filename;
     int from_tty;
{

  /* Eliminate all traces of old exec file.
     Mark text segment as empty.  */

dsp_init(0);
  data_start = CORE_ZERO;
  text_start = CORE_ZERO;
  text_end = CORE_ZERO;
  exec_data_start = CORE_ZERO;
  data_end = CORE_ZERO;
  exec_data_end = CORE_ZERO;
  if (execchan >= 0)
    close (execchan);
  execchan = -1;
  cross_debugging=0;

  /* Now open and digest the file the user requested, if any.  */

  if (filename)
    {
      filename = tilde_expand (filename);
      make_cleanup (free, filename);
      
      if (execfile)
        free (execfile);
      execfile = 0;
      execchan = openp (getenv ("PATH"), 1, filename, O_RDONLY|O_BINARY, 0,
			&execfile);
      if (execchan < 0)
	perror_with_name (filename);
#ifdef COFF_FORMAT
      {
	int aout_hdrsize;
	int num_sections;

	if (read_file_hdr (execchan, &file_hdr) < 0)
	  error ("\"%s\": not in executable format.", execfile);

	aout_hdrsize = file_hdr.f_opthdr;
	num_sections = file_hdr.f_nscns;

	if (read_aout_hdr (execchan, &exec_aouthdr, aout_hdrsize) < 0)
	  error ("\"%s\": can't read optional aouthdr", execfile);

	if (read_section_hdr (execchan, _TEXT, &text_hdr, num_sections,
			      aout_hdrsize) < 0)/* just finds first ".text" section */
	  error ("\"%s\": can't read text section header", execfile);

	if (read_section_hdr (execchan, _DATA, &data_hdr, num_sections,
			      aout_hdrsize) < 0)
	  error ("\"%s\": can't read data section header", execfile);

 if (read_section_contents (execchan) < 0)
   error ("\"%s\": can't read section contents", execfile);

	text_start = exec_aouthdr.text_start;
	text_end = exec_aouthdr.text_end;
 CORE_ADDR_ADDR(text_end)+=CALL_DUMMY_LENGTH;
 {  /* clears out debug area */
    CORE_ADDR ct;
    unsigned long section_length;
    unsigned long val = 0; /* nop instruction */
    ct=exec_aouthdr.text_end;
    section_length = CALL_DUMMY_LENGTH;
    for (;section_length!=0; section_length--){
      write_inferior_memory( ct,(char *)&val, sizeof(long));
      CORE_ADDR_ADDR(ct)+=1;
      }
 }
	text_offset = text_hdr.s_scnptr; /* doesn't appear to be used */
	exec_data_start = exec_aouthdr.data_start;
	exec_data_end = exec_aouthdr.data_end;
	exec_data_offset = data_hdr.s_scnptr;/* doesn't appear to be used */
	data_start = exec_data_start;
	data_end = exec_data_start;
	exec_mtime = file_hdr.f_timdat;
      }
#endif /* COFF_FORMAT */

      validate_files ();
    }
  else{
      if (execfile)
           free (execfile);
      execfile = 0;
    if (from_tty)
      printf ("No exec file now.\n");
    }

  /* Tell display code (if any) about the changed file name.  */
  if (exec_file_display_hook)
    (*exec_file_display_hook) (filename);
  cross_debugging=1;
}


/*
 * Find the pc saved in frame FRAME.  
 * In this case it is the last thing on the stack after the frame temps.
 * The value is stored previously by init_extra_frame_info
 */
CORE_ADDR
frame_saved_pc (frame)
     FRAME frame;
{
  CORE_ADDR retv;
  CORE_ADDR_MAP(retv)=memory_map_p;
  CORE_ADDR_ADDR(retv)=frame->saved_pc;
  return (retv);
}

CORE_ADDR
frame_locals_address (fi)
  struct frame_info *fi;
{
  /* fix up frame pointer to adjust for arg offsets */
  /* this currently works assuming the frame pointer value */
  /* has been predecremented to point to  the old fp position */
  /* it assumes that the symbol offsets will be supplied based 
     on the true fp which is two beyond that.
  */
  CORE_ADDR retv;
  retv=fi->frame;
  return (retv);
}
CORE_ADDR
frame_struct_args_address (fi)
  struct frame_info *fi;
{
  /* fix up frame pointer to adjust for arg offsets */
  /* this currently works assuming the frame pointer value */
  /* has been predecremented to point to  the old fp position */
  /* it assumes that the symbol offsets will be supplied based 
     on the true fp which is two beyond that.
  */
  CORE_ADDR retv;
  retv=fi->frame;
  return (retv);
}
frame_args_skip()
{
return (0);
}

/* initializes frame_size and arg_size and saved_pc*/

void
init_extra_frame_info(fi)
FRAME fi;
{
    CORE_ADDR pc_temp;
    FRAME_ADDR frame_addr;
    unsigned long pc;
    int offset,pc_offset,argsize;
    unsigned long rv;
    unsigned long nextinsn;
    
    CORE_ADDR get_pc_function_start ();

    if (fi->extra_inited)
	return; /* already initialized */
    fi->extra_inited=1;
    pc=CORE_ADDR_ADDR(fi->pc);
    if (pc==0l) 
	return;
    dsp_rmem(0,memory_map_p,pc,&nextinsn);

    if (nextinsn==0x130){ /* jsr long - ok try to fix up stack based on following */
	pc+=2;
	dsp_rmem(0,memory_map_p,pc,&nextinsn);
	}
    else if (nextinsn==0x121||((nextinsn&0xff00)==0x0a)){ /*jsr r1 or jsr short */
	pc+=1;
	dsp_rmem(0,memory_map_p,pc,&nextinsn);
	}

    if (nextinsn==0x3fdcl){ /*move #d,n2*/
	pc+=1; /* addr of move #d,n2 offset */
	dsp_rmem(0,memory_map_p,pc,&nextinsn);
	if (nextinsn&SIGN_TEST_BIT){
	    nextinsn|= ~WORD_BITS;
	    nextinsn= -nextinsn;
	    argsize=nextinsn;
	    pc+=2; /* past nop to move (r2)+n2 */
	    dsp_rmem(0,memory_map_p,pc,&nextinsn);
	    if (nextinsn!=0x3611) /* must have been something else */
		argsize=0;
	    }
	else argsize=0;
	}
    else{ /* series of up to 3 "move (r2)-" instructions */
	argsize=0;
	while (nextinsn==0x3211){ /* move (r2)- */
	    argsize++;
	    pc+=1; /* addr of move #d,n2 offset */
	    dsp_rmem(0,memory_map_p,pc,&nextinsn);
	    }
	if (argsize){ /* check for possibly last one being bogus (part of preamble) */
	    if ((nextinsn&0xfc17)==0x3c02){ /* move x:(r2)-,rn or x:(r2),rn */
		argsize--;
		}
	    }
	}
    CORE_ADDR_ADDR(fi->frame)-=argsize; /* adjust frame pointer on return from function calls */
    }

/* this takes the frame info
   in thisframe, and the value of their frame pointer, in chain, and
   should modify the chain so that it has the correct value for the
   calling functions frame pointer. In this case chain is the 
   r2 value.  Since it is also used as a stack pointer, it may be
   necessary to decrement it here to get the value to be used for
   the frame pointer in the previous function.
*/

CORE_ADDR
frame_chain_combine(chain,fi)
CORE_ADDR chain;
FRAME fi;
{
    return  ( chain);
    }

CORE_ADDR
frame_args_address (fi)
  struct frame_info *fi;
{
  /* fix up frame pointer to adjust for arg offsets */
  /* this currently works assuming the frame pointer value */
  /* has been predecremented to point to  the old fp position */
  /* it assumes that the symbol offsets will be supplied based 
     on the true fp which is two beyond that.
  */
  CORE_ADDR retv;
  retv=fi->frame;
  return (retv);
}

struct command_line *get_breakpoint_commands ();


/*
 * This routine should be more specific in it's actions; making sure
 * that it uses the same register in the initial prologue section.
 */
CORE_ADDR 
skip_prologue (pc)
     CORE_ADDR pc;
{
    struct block *bl, *block_for_pc();
    int ui,offset;
    CORE_ADDR pc_temp;
    unsigned long nextinsn,ofp;
    pc_temp=pc;
    CORE_ADDR_MAP(pc_temp)=memory_map_p;

	{ /* no debug info, so find the hard coded way */
	dsp_rmem(0,memory_map_p,CORE_ADDR_ADDR(pc_temp),&nextinsn);
	if (nextinsn==0x3fdcl){ /*move #d,n2*/
	    CORE_ADDR_ADDR(pc_temp)+=4;/* skip long second word,nop and move (r2)+n2 */
	    dsp_rmem(0,memory_map_p,CORE_ADDR_ADDR(pc_temp),&nextinsn);
	    }
	else if (nextinsn==0x1e6l){ /*lea (r2)+,r2 */
	    CORE_ADDR_ADDR(pc_temp)+=2; /* skip inserted nop */
	    dsp_rmem(0,memory_map_p,CORE_ADDR_ADDR(pc_temp),&nextinsn);
	    }
	if (nextinsn==0x3b06l){ /* move ssh,x:(r2)+ */
	    CORE_ADDR_ADDR(pc_temp)+=1;
	    }

	}
    return(pc_temp);
}

static
init_frame_info(fi)
FRAME fi;
{
    CORE_ADDR pc_temp;
    FRAME_ADDR frame_addr;
    unsigned long pc,saved_pc;
    int offset,pc_offset,argsize;
    unsigned long rv;
    unsigned long nextinsn;
    
    CORE_ADDR get_pc_function_start ();

    if (CORE_ADDR_ADDR(fi->frame)==0l) 
	return;

    pc_temp = get_pc_function_start (fi->pc); 
    pc=CORE_ADDR_ADDR(pc_temp);
    dsp_rmem(0,memory_map_p,pc,&nextinsn);

    if (pc==0) 
	return;

    if (nextinsn==0x3fdcl){ /*move #d,n2*/
	pc+=1; /* addr of move #d,n2 offset */
	dsp_rmem(0,memory_map_p,pc,&nextinsn);
	offset=nextinsn;
	pc+=3;/* nop,long second word and move (r2)+n2 */
	dsp_rmem(0,memory_map_p,pc,&nextinsn);
	}
    else if (nextinsn==0x1e6l){ /*lea (r2)+,r2 */
	offset=1;
	pc+=2;
	dsp_rmem(0,memory_map_p,pc,&nextinsn);
	}
    else offset=0;
    
    if (nextinsn==0x3b06l){
	pc_offset=offset;
	offset++; /* move ssh,x:(r2)+ */
	pc+=1;
	dsp_rmem(0,memory_map_p,pc,&nextinsn);
	
	if (nextinsn==0x130) /* jsr long or short stack checks */
	    pc+=2;
	else if ((nextinsn&0xff00)==0xa00) /* short jump */
	    pc+=1;
	}
    else pc_offset= -1;
    
    for(;;){ /* this should get the size of the saved registers on the stack */
	/* move reg,x:(r2)+  */
	dsp_rmem(0,memory_map_p,pc,&nextinsn);
	if ((nextinsn&0xfc1fl)==0x3806l)
	    offset++; /* saved regsiter in form of move reg,x:(r2)+ */
	else if (nextinsn==0l); /*nop */
	else break; /* no valid register being pushed */
	pc+=1;
	}
    
    fi->frame_size=offset;
    if (pc_offset>=0){
	fi->pc_offset=offset-pc_offset; /* offset to saved pc on stack */
	frame_addr=fi->frame; /* current frame offset */
	CORE_ADDR_ADDR(frame_addr)-= fi->pc_offset;
	saved_pc=read_memory_integer(frame_addr,4);
	fi->saved_pc=saved_pc;
	}
    else {
	fi->saved_pc=saved_pc_after_call();
	}
    
    /* determine the size of stack used for args. Read number of  */
    pc=fi->saved_pc;
    dsp_rmem(0,memory_map_p,pc,&nextinsn);
    
    if (nextinsn==0x3fdcl){ /*move #d,n2*/
	pc+=1; /* addr of move #d,n2 offset */
	dsp_rmem(0,memory_map_p,pc,&nextinsn);
	if (nextinsn&SIGN_TEST_BIT){
	    nextinsn|= ~WORD_BITS;
	    nextinsn= -nextinsn;
	    argsize=nextinsn;
	    pc+=2; /* past nop to move (r2)+n2 */
	    dsp_rmem(0,memory_map_p,pc,&nextinsn);
	    if (nextinsn!=0x3611) /* must have been something else */
		argsize=0;
	    }
	else argsize=0;
	}
    else{ /* series of up to 3 "move (r2)-" instructions */
	argsize=0;
	while (nextinsn==0x3211){ /* move (r2)- */
	    argsize++;
	    pc+=1; /* addr of move #d,n2 offset */
	    dsp_rmem(0,memory_map_p,pc,&nextinsn);
	    }
	if (argsize){ /* check for possibly last one being bogus (part of preamble) */
	    if ((nextinsn&0xfc17)==0x3c02){ /* move x:(r2)-,rn */
		argsize--;
		}
	    }
	}
    fi->arg_size=argsize;
    }

frameless_function_invocation(fi,leaf)
FRAME fi;
int *leaf;
{
    *leaf=0;
    init_frame_info(fi);
    return;
}

unsigned long
saved_pc_after_call()
{
unsigned long ssh,pc;
unsigned long nextinsn;
unsigned long oldsp,tsp;
dsp_rreg(0,0,REG_SP,&oldsp);
tsp=oldsp;
while (tsp>1){ /* check for do instruction in the code */
    dsp_rreg(0,0,REG_SSH,&pc); /* get last pushed address */
    pc-=2;
    dsp_rmem(0,memory_map_p,pc,&nextinsn);

    if (((nextinsn&0xff00)==0x0e00)||
	((nextinsn&0xffe0)==0x0400)||
	((nextinsn&0xffe0)==0x00c0)||
	(nextinsn==0x0002)){ /* four forms of do instruction */
	tsp-=2; /* two locations on stack for each do loop nest */
	}
    else break;
    }

if (tsp!=oldsp)
    dsp_wreg(0,0,REG_SP,&tsp);

dsp_rreg(0,0,REG_SSH,&ssh);

if (tsp!=oldsp)
    dsp_wreg(0,0,REG_SP,&oldsp);

return ssh;
}


/*Store the address of the place in which to copy the structure the
subroutine will return.  This is called from call_function. */

store_struct_return(addr,sp)
CORE_ADDR addr;
CORE_ADDR sp;
{
 write_register (A1_REGNUM, CORE_ADDR_ADDR(addr));
}

store_return_value(data_type,valbuf)
struct type *data_type;
char *valbuf;
{ 
  LONGEST lbuf;
  int regno;

    if (TYPE_CODE (data_type) == TYPE_CODE_FLT){
      /* Floating-point values are returned in the register pair */
      /* formed by a1:a0 */
      write_register_bytes (REGISTER_BYTE (A10_REGNUM), valbuf,
             TYPE_LENGTH (data_type),A10_REGNUM); 
      }
    else {
      /* Other values are returned in register a1 for int or a10 for 
         longs.  */ 
      regno=(TYPE_DATA_LENGTH (data_type)==DSIZEOF_LONG)?A10_REGNUM:A1_REGNUM;
      write_register_bytes (
         REGISTER_BYTE (regno), valbuf, TYPE_DATA_LENGTH (data_type),regno);  
       }
}


/* only gets called when not a leaf,so it is known that the return pc from ssh is saved 
   on the stack */

unsigned long
frame_chain(thisframe)
FRAME thisframe;
{
    CORE_ADDR core_temp;
    int offset;
    unsigned long rv;
    
    CORE_ADDR get_pc_function_start ();
    if (thisframe&& thisframe->next&&!thisframe->saved_pc){
	init_frame_info(thisframe);
	}

    core_temp=(thisframe)->frame;
    
    if (CORE_ADDR_ADDR(core_temp)==0l) return (0l);

    offset=thisframe->frame_size+thisframe->arg_size;
    rv=((CORE_ADDR_ADDR(thisframe->frame))-offset);
    
    return  ( rv);
}

int
frame_chain_valid(chain,thisframe)
CORE_ADDR chain;
FRAME thisframe;
{
 int rv;
 unsigned long saved_pc,end_pc;
 saved_pc=CORE_ADDR_ADDR(FRAME_SAVED_PC (thisframe));
 end_pc=CORE_ADDR_ADDR(program_exit_address);
 rv= (CORE_ADDR_ADDR(chain) != 0&&
          (saved_pc)&&
	  (saved_pc!=(end_pc-2))&&
	  (saved_pc!=(end_pc-1)))?1:0;
 return (rv);

}

/* Extract from an array REGBUF containing the (raw) register state
   the address in which a function should return its structure value,
   as a CORE_ADDR (or an expression that can be used as one).  
   The address is held in register a1 and should point to xmem */

CORE_ADDR
extract_struct_value_address(regbuf)
char regbuf[REGISTER_BYTES];
{
  CORE_ADDR core_temp; 
  core_temp=FRAME_ZERO; /* initialize for stack memory */
  CORE_ADDR_ADDR(core_temp)= 
   *(long *)&regbuf[REGISTER_BYTE (A1_REGNUM)]; /* A1 position */
  return (core_temp);
}

struct reg_var_xref reg_var_xref[]={
{A1_REGNUM,A10_REGNUM},
{B1_REGNUM,B10_REGNUM},
{X0_REGNUM,X10_REGNUM},
{X1_REGNUM,X10_REGNUM},
{Y0_REGNUM,Y10_REGNUM},
{Y1_REGNUM,Y10_REGNUM},
{R0_REGNUM,R0_REGNUM},
{R1_REGNUM,R1_REGNUM},
{R2_REGNUM,R2_REGNUM},
{R3_REGNUM,R3_REGNUM}
};


static unsigned long dummy_frame_addr; 
int
frame_find_saved_registers(fip,fsrp)
 struct frame_info *fip;
 struct frame_saved_regs *fsrp;
{
  register CORE_ADDR next_addr;
  CORE_ADDR pc;
  unsigned long nextinsn;
  int opc;

  bzero (fsrp, sizeof *fsrp);
  next_addr = fip->frame;             
  if (CORE_ADDR_ADDR(fip->pc) >= (CORE_ADDR_ADDR(text_end) - 
      CALL_DUMMY_LENGTH))  /* dummy frame */
    { 
      CORE_ADDR_ADDR(next_addr)=dummy_frame_addr;
      opc=1;
      pc = fip->pc;
      CORE_ADDR_ADDR(next_addr)-=20; /* decr sp to find start of pushed registers */
      fsrp->regs[FP_REGNUM] = next_addr;
      CORE_ADDR_ADDR(next_addr)+=1;
      fsrp->regs[PC_REGNUM] = next_addr;
      CORE_ADDR_ADDR(next_addr)+=1;
      fsrp->regs[A0_REGNUM]= next_addr;
      CORE_ADDR_ADDR(next_addr)+=1;
      fsrp->regs[A1_REGNUM]= next_addr;
      CORE_ADDR_ADDR(next_addr)+=1;
      fsrp->regs[A2_REGNUM]= next_addr;
      CORE_ADDR_ADDR(next_addr)+=1;
      fsrp->regs[B0_REGNUM]= next_addr;
      CORE_ADDR_ADDR(next_addr)+=1;
      fsrp->regs[B1_REGNUM]= next_addr;
      CORE_ADDR_ADDR(next_addr)+=1;
      fsrp->regs[B2_REGNUM]= next_addr;
      CORE_ADDR_ADDR(next_addr)+=1;
      fsrp->regs[X0_REGNUM]= next_addr;
      CORE_ADDR_ADDR(next_addr)+=1;
      fsrp->regs[X1_REGNUM]= next_addr;
      CORE_ADDR_ADDR(next_addr)+=1;
      fsrp->regs[Y0_REGNUM]= next_addr;
      CORE_ADDR_ADDR(next_addr)+=1;
      fsrp->regs[Y1_REGNUM]= next_addr;
      CORE_ADDR_ADDR(next_addr)+=1;
      fsrp->regs[R0_REGNUM]= next_addr;
      CORE_ADDR_ADDR(next_addr)+=1;
      fsrp->regs[R1_REGNUM]= next_addr;
      CORE_ADDR_ADDR(next_addr)+=1;
      fsrp->regs[R3_REGNUM]= next_addr;
      CORE_ADDR_ADDR(next_addr)+=1;
      fsrp->regs[N0_REGNUM]= next_addr;
      CORE_ADDR_ADDR(next_addr)+=1;
      fsrp->regs[N1_REGNUM]= next_addr;
      CORE_ADDR_ADDR(next_addr)+=1;
      fsrp->regs[N2_REGNUM]= next_addr;
      CORE_ADDR_ADDR(next_addr)+=1;
      fsrp->regs[N3_REGNUM]= next_addr;
      CORE_ADDR_ADDR(next_addr)+=1;
      fsrp->regs[PS_REGNUM]= next_addr;
    }
  else                           
    { 
      CORE_ADDR get_pc_function_start ();
   /* for real function calls, the code at the start of the function is:
      move #d,n2    or lea (r2)+,r2 (as a replacement of this and the following inst
      nop
      move (r2)+n2  
      move ssh,x:(r2)+ doesn't always exist
      jsr  stack_check only for stack checks

      move b0,x:(r2)+
      move b1,x:(r2)+ ; stack pointer points past last reg
      etc.
      */

      init_extra_frame_info(fip);
      init_frame_info(fip);
      pc = get_pc_function_start (fip->pc); 
      dsp_rmem(0,memory_map_p,CORE_ADDR_ADDR(pc),&nextinsn);
      if (nextinsn==0x3fdcl){ /*move #d,n2*/
	  CORE_ADDR_ADDR(pc)+=4;/* long second word,nop and move (r2)+n2 */
	  dsp_rmem(0,memory_map_p,CORE_ADDR_ADDR(pc),&nextinsn);
	  }
      else if (nextinsn==0x1e6l){ /*lea (r2)+,r2 */
	  CORE_ADDR_ADDR(pc)+=2;
	  dsp_rmem(0,memory_map_p,CORE_ADDR_ADDR(pc),&nextinsn);
	  }
      if (nextinsn==0x3b06l){ /* move ssh,x:(r2)+ */
	  CORE_ADDR_ADDR(pc)+=1;
	  dsp_rmem(0,memory_map_p,CORE_ADDR_ADDR(pc),&nextinsn);
	  if (nextinsn==0x130) /* jsr long or short stack checks */
	      CORE_ADDR_ADDR(pc)+=2;
	  else if ((nextinsn&0xff00)==0xa00) /* short jump */
	      CORE_ADDR_ADDR(pc)+=1;
	  }

      /* start of register spill space */
      CORE_ADDR_ADDR(next_addr)-= fip->frame_size;
      
      /* decode following instructions for move regname,x:(r2)+ 
	 which saves registers in spill space on stack */
      for(;;){
	  /* move reg,x/y:(r6)+ ; mask out the x/y select bit */
	  dsp_rmem(0,memory_map_p,CORE_ADDR_ADDR(pc),&nextinsn);
	  if (nextinsn==0x38e6l)
	      fsrp->regs[B0_REGNUM]= next_addr;
	  else if (nextinsn==0x39a6l)
	      fsrp->regs[B1_REGNUM]= next_addr;
	  else if (nextinsn==0x3806l)
	      fsrp->regs[X0_REGNUM]= next_addr;
	  else if (nextinsn==0x3846l)
	      fsrp->regs[X1_REGNUM]= next_addr;
	  else if (nextinsn==0x3826l)
	      fsrp->regs[Y0_REGNUM]= next_addr;
	  else if (nextinsn==0x3866l)
	      fsrp->regs[Y1_REGNUM]= next_addr;
	  else if (nextinsn==0x3a06l)
	      fsrp->regs[R0_REGNUM]= next_addr;
	  else if (nextinsn==0x3a26l)
	      fsrp->regs[R1_REGNUM]= next_addr;
	  else if (nextinsn==0x3a66l)
	      fsrp->regs[R3_REGNUM]= next_addr;
	  else if (nextinsn==0l); /*nop */
	  else break; /* no valid register being pushed */
	  CORE_ADDR_ADDR(next_addr)+=1;
	  CORE_ADDR_ADDR(pc)+=1;
	  }
      if (fip->pc_offset>=0){
	  fsrp->regs[PC_REGNUM]= fip->frame;
	  CORE_ADDR_ADDR(fsrp->regs[PC_REGNUM])-=fip->pc_offset;
	  }
      }
#if 0
  fsrp->regs[SP_REGNUM] = fip->frame; 
  fsrp->regs[FP_REGNUM] = fip->frame; 
#endif
  }


/* Things needed for making the inferior call functions.  */
 /*
 *   PUSH_DUMMY_FRAME saves the registers above sp' and pushes the
 * register file stack down one.
 *
 *   call_function then writes CALL_DUMMY, pushes the args onto the
 * stack, and adjusts the stack pointer.
 *
 *   run_stack_dummy then starts execution (in the middle of
 * CALL_DUMMY, as directed by call_function).
 */

/* Push an empty stack frame, to record the current PC, etc.  */
CORE_ADDR push_word (),read_register();

push_dummy_frame()
{
  CORE_ADDR sp;
  unsigned long old_sp;
  sp = read_register (SP_REGNUM);
  old_sp = CORE_ADDR_ADDR(sp);
  sp = push_word (sp, old_sp); /* FP_REGNUM */
  sp = push_word (sp, CORE_ADDR_ADDR(read_register (PC_REGNUM))); 
  sp = push_word (sp, CORE_ADDR_ADDR(read_register (A0_REGNUM))); 
  sp = push_word (sp, CORE_ADDR_ADDR(read_register (A1_REGNUM))); 
  sp = push_word (sp, CORE_ADDR_ADDR(read_register (A2_REGNUM))); 
  sp = push_word (sp, CORE_ADDR_ADDR(read_register (B0_REGNUM))); 
  sp = push_word (sp, CORE_ADDR_ADDR(read_register (B1_REGNUM))); 
  sp = push_word (sp, CORE_ADDR_ADDR(read_register (B2_REGNUM))); 
  sp = push_word (sp, CORE_ADDR_ADDR(read_register (X0_REGNUM))); 
  sp = push_word (sp, CORE_ADDR_ADDR(read_register (X1_REGNUM))); 
  sp = push_word (sp, CORE_ADDR_ADDR(read_register (Y0_REGNUM))); 
  sp = push_word (sp, CORE_ADDR_ADDR(read_register (Y1_REGNUM))); 
  sp = push_word (sp, CORE_ADDR_ADDR(read_register (R0_REGNUM))); 
  sp = push_word (sp, CORE_ADDR_ADDR(read_register (R1_REGNUM))); 
  sp = push_word (sp, CORE_ADDR_ADDR(read_register (R3_REGNUM))); 
  sp = push_word (sp, CORE_ADDR_ADDR(read_register (N0_REGNUM))); 
  sp = push_word (sp, CORE_ADDR_ADDR(read_register (N1_REGNUM))); 
  sp = push_word (sp, CORE_ADDR_ADDR(read_register (N2_REGNUM))); 
  sp = push_word (sp, CORE_ADDR_ADDR(read_register (N3_REGNUM))); 
  sp = push_word (sp, CORE_ADDR_ADDR(read_register (PS_REGNUM))); 
  write_register (FP_REGNUM, CORE_ADDR_ADDR(sp)); /* needed? */
  write_register (SP_REGNUM, CORE_ADDR_ADDR(sp)); 
  dummy_frame_addr=CORE_ADDR_ADDR(sp);
}

/* Discard from the stack the innermost frame,
   restoring all saved registers.  */

pop_frame()
{
 FRAME frame = get_current_frame (); 
   CORE_ADDR fp; 
   int regnum;
 unsigned long old_frame;
struct frame_saved_regs fsr; 
  struct frame_info *fi;
  fi = get_frame_info (frame); 
  fp = fi->frame; 
  get_frame_saved_regs (fi, &fsr); 
  for (regnum = 0; regnum< NUM_REGS ;regnum++){
      if (CORE_ADDR_ADDR(fsr.regs[regnum])) 
	  write_register (regnum, read_memory_integer (fsr.regs[regnum], 4));
    }

 if(!CORE_ADDR_ADDR(fsr.regs[FP_REGNUM])){ /* wasn't a PUSH_DUMMY call */
     init_extra_frame_info(fi);
     init_frame_info(fi);
     write_register(PC_REGNUM,fi->saved_pc,4);
     old_frame=CORE_ADDR_ADDR(fi->frame)-fi->frame_size;
     write_register(SP_REGNUM,old_frame,4);
     write_register(FP_REGNUM,old_frame,4);
     }

  flush_cached_frames ();
  set_current_frame (create_new_frame (read_register (FP_REGNUM),
               read_pc ()));
}

value
value_xmem (arg1)
     register value arg1;
{
  COERCE_ENUM (arg1);
  CORE_ADDR_ADDR(VALUE_ADDRESS(arg1))= *(unsigned long *)VALUE_CONTENTS(arg1);
  CORE_ADDR_MAP(VALUE_ADDRESS(arg1))=memory_map_x;
  return (arg1);
}

value
value_lmem (arg1)
     register value arg1;
{
  COERCE_ENUM (arg1);
  CORE_ADDR_ADDR(VALUE_ADDRESS(arg1))= *(unsigned long *)VALUE_CONTENTS(arg1);
  CORE_ADDR_MAP(VALUE_ADDRESS(arg1))=memory_map_x;
  return (arg1);
}

value
value_ymem (arg1)
     register value arg1;
{
  COERCE_ENUM (arg1);
  CORE_ADDR_ADDR(VALUE_ADDRESS(arg1))= *(unsigned long *)VALUE_CONTENTS(arg1);
  CORE_ADDR_MAP(VALUE_ADDRESS(arg1))=memory_map_x;
  return (arg1);
}

value
value_pmem (arg1)
     register value arg1;
{
  COERCE_ENUM (arg1);
  CORE_ADDR_ADDR(VALUE_ADDRESS(arg1))= *(unsigned long *)VALUE_CONTENTS(arg1);
  CORE_ADDR_MAP(VALUE_ADDRESS(arg1))=memory_map_p;
  return (arg1);
}

/* for right now these don't do whole thing */
LONGEST
add_longest(v1,v2)
  LONGEST v1,v2;
{
 v1.w0.l &= WORD_BITS;
 v2.w0.l &= WORD_BITS;
 v1.w0.l += v2.w0.l;
 v1.w1.l += v2.w1.l;
 if (v1.w0.l & ~WORD_BITS){
    v1.w1.l += 1;
    }
 v1.w0.l &= WORD_BITS;
 v1.w1.l &= WORD_BITS;
 return v1;
}

LONGEST
sub_longest(v1,v2)
  LONGEST v1,v2;
{
 v1=ADD_LONGEST(v1,NEG_LONGEST(v2));
 return v1;
}

LONGEST
mul_longest(v1,v2)
  LONGEST v1,v2;
{
 long s1,s2,sresult;
 double d1,d2,dresult;
 s1 = v1.w1.l&SIGN_TEST_BIT;
 s2 = v2.w1.l&SIGN_TEST_BIT;
 sresult = s1^s2;
 if (s1) v1 = NEG_LONGEST(v1);
 if (s2) v2 = NEG_LONGEST(v2);
 d1 = (((double)(v1.w1.u&WORD_BITS))*((double)(WORD_BITS+1)))+
      ((double)(v1.w0.u&WORD_BITS));
 d2 = (((double)(v2.w1.u&WORD_BITS))*((double)(WORD_BITS+1)))+
      ((double)(v2.w0.u&WORD_BITS));
 dresult = d1*d2; /* unsigned multiply */
 v1.w1.u = dresult/((double)(WORD_BITS+1));
 v1.w0.u = dresult - (((double)v1.w1.u)*((double)(WORD_BITS+1)));
 v1.w1.u &= WORD_BITS;
 v1.w0.u &= WORD_BITS;
 if (sresult) v1 = NEG_LONGEST(v1); 
 return v1;
}

LONGEST
div_longest(v1,v2)
  LONGEST v1,v2;
{
 long s1,s2,sresult;
 double d1,d2,dresult;
 s1 = v1.w1.l&SIGN_TEST_BIT;
 s2 = v2.w1.l&SIGN_TEST_BIT;
 sresult = s1^s2;
 if (s1) v1 = NEG_LONGEST(v1);
 if (s2) v2 = NEG_LONGEST(v2);
 d1 = (((double)(v1.w1.u&WORD_BITS))*((double)(WORD_BITS+1)))+
      ((double)(v1.w0.u&WORD_BITS));
 d2 = (((double)(v2.w1.u&WORD_BITS))*((double)(WORD_BITS+1)))+
      ((double)(v2.w0.u&WORD_BITS));
 dresult = d1/d2; /* unsigned multiply */
 v1.w1.u = dresult/((double)(WORD_BITS+1));
 v1.w0.u = dresult - (((double)v1.w1.u)*((double)(WORD_BITS+1)));
 v1.w1.u &= WORD_BITS;
 v1.w0.u &= WORD_BITS;
 if (sresult) v1 = NEG_LONGEST(v1); 
 return v1;
}

LONGEST
rem_longest(v1,v2)
  LONGEST v1,v2;
{
 LONGEST vr;
 long s1,s2,sresult;
 double d1,d2,dresult;
 s1 = v1.w1.l&SIGN_TEST_BIT;
 s2 = v2.w1.l&SIGN_TEST_BIT;
 sresult = s1^s2;
 if (s1) v1 = NEG_LONGEST(v1);
 if (s2) v2 = NEG_LONGEST(v2);
 d1 = (((double)(v1.w1.u&WORD_BITS))*((double)(WORD_BITS+1)))+
      ((double)(v1.w0.u&WORD_BITS));
 d2 = (((double)(v2.w1.u&WORD_BITS))*((double)(WORD_BITS+1)))+
      ((double)(v2.w0.u&WORD_BITS));
 dresult = d1/d2; /* unsigned multiply */
 vr.w1.u = dresult/((double)(WORD_BITS+1));
 vr.w0.u = dresult - (((double)vr.w1.u)*((double)(WORD_BITS+1)));
 vr.w1.u &= WORD_BITS;
 vr.w0.u &= WORD_BITS;
 vr = MUL_UNSIGNED_LONGEST(vr,v2);
 vr = SUB_UNSIGNED_LONGEST(v1,vr);
 if (sresult) vr = NEG_LONGEST(vr); 
 return vr;   
}
 
static LONGEST
longest_minus_1;
#define MAX_WORD_BITS ((sizeof(long)+sizeof(long))*8)

LONGEST
lsh_longest(v1,v2)
  LONGEST v1,v2;
{
 int shiftcount=0;
 v2.w0.l &= WORD_BITS;
 while ((v2.w0.l||v2.w1.l)&&(shiftcount++ <MAX_WORD_BITS)){
   v2=ADD_LONGEST(v2,longest_minus_1);
   v1.w1.l <<=1;
   if (v1.w0.l & SIGN_TEST_BIT) 
      v1.w1.l |= 1;
   v1.w0.l <<=1;
   }
 v1.w0.l &= WORD_BITS;
 v1.w1.l &= WORD_BITS;
 return v1;
}

LONGEST
rsh_longest(v1,v2)
  LONGEST v1,v2;
{
 int shiftcount=0;
 v2.w0.l &= WORD_BITS;
 v2.w1.l &= WORD_BITS;
 v1.w0.l &= WORD_BITS;
 v1.w1.l &= WORD_BITS;
 if (v1.w1.l&SIGN_TEST_BIT)
   v1.w1.l |= ~WORD_BITS;
 else v1.w1.l &= WORD_BITS; /* sign extend v1 */
 while ((v2.w0.l||v2.w1.l)&&(shiftcount++ <MAX_WORD_BITS)){
   v2=ADD_LONGEST(v2,longest_minus_1);
   v1.w0.l >>=1;
   if (v1.w1.l & 1)
      v1.w0.l |= SIGN_TEST_BIT;
   v1.w1.l >>=1;
   }
 v1.w1.l &= WORD_BITS; 
 return v1;
}

LONGEST
logand_longest(v1,v2)
  LONGEST v1,v2;
{
 v1.w0.l &= v2.w0.l;
 v1.w1.l &= v2.w1.l;
 return v1;
}
  
LONGEST
logior_longest(v1,v2) 
  LONGEST v1,v2; 
{ 
 v1.w0.l |= v2.w0.l; 
 v1.w1.l |= v2.w1.l;
 return v1; 
}
 
LONGEST
logxor_longest(v1,v2) 
  LONGEST v1,v2; 
{ 
 v1.w0.l ^= v2.w0.l; 
 v1.w1.l ^= v2.w1.l; 
 return v1; 
}

LONGEST
and_longest(v1,v2) 
  LONGEST v1,v2; 
{ 
 v1.w0.l = ((v1.w0.l||v1.w1.l) && (v2.w0.l||v2.w1.l))?1:0; 
 v1.w1.l =  0;
 return v1; 
}

LONGEST
or_longest(v1,v2) 
  LONGEST v1,v2; 
{ 
 v1.w0.l = (v1.w0.l || v2.w0.l || v1.w1.l || v2.w1.l )?1:0; 
 v1.w1.l = 0;
 return v1; 
}

LONGEST 
min_longest(v1,v2)  
  LONGEST v1,v2; 
{  
 /* returns (v1<v2)? v1:v2 */
  LONGEST vt;
 long s1,s2,sresult;
 s1 = v1.w1.l&SIGN_TEST_BIT;
 s2 = v2.w1.l&SIGN_TEST_BIT;
 if(s1^s2){ /* different signs */
   if (s2) /* and v2 is negative */
      v1 = v2; /* so v2 is smaller */
   }
 else{ /* same sign operands */
   vt = SUB_LONGEST(v1,v2);
   sresult = vt.w1.l & SIGN_TEST_BIT;
   if (!sresult)
         v1 = v2; /* v2 <= v1 */
   }
 
 return v1;  
}

LONGEST  
max_longest(v1,v2)   
  LONGEST v1,v2;  
{   
 LONGEST vt;
 long s1,s2,sresult;
 s1 = v1.w1.l&SIGN_TEST_BIT;
 s2 = v2.w1.l&SIGN_TEST_BIT;
 if(s1^s2){ /* different signs */
   if (s1) /* and v1 is negative */
      v1 = v2; /* so v2 is larger */
   }
 else{ /* same sign operands */
   vt = SUB_LONGEST(v1,v2);
   sresult = vt.w1.l & SIGN_TEST_BIT;
   if (sresult)
         v1 = v2; /* v2 >= v1 */
   }
 
 return v1;   
}

static 
LONGEST
longest_one;

LONGEST
neg_longest(v1)
  LONGEST v1;
{
 v1 = LOGNOT_LONGEST(v1);
 v1 = ADD_LONGEST(v1,longest_one);
 return v1;
}

LONGEST 
lognot_longest(v1) 
  LONGEST v1; 
{ 
 v1.w0.l = (~ v1.w0.l)&WORD_BITS;
 v1.w1.l = (~ v1.w1.l)&WORD_BITS;
 return v1;
}


LONGEST
int_to_longest(i1)
  int i1;
{
  LONGEST rv;
  long v1 = i1;
  rv.w0.l = v1 & WORD_BITS;
  rv.w1.l = (v1 >> TARGET_WORD_NUM_BITS) & WORD_BITS;
  return rv;
}

LONGEST
long_to_longest(i1)
  long i1;
{
  LONGEST rv;
  long v1 = i1;
  rv.w0.l = v1 & WORD_BITS;
  rv.w1.l = (v1 >> TARGET_WORD_NUM_BITS) & WORD_BITS;
  return rv;
}

LONGEST
char_to_longest(c1)
  char c1;
{
  LONGEST rv;
  long v1 = c1;
  rv.w0.l = v1 & WORD_BITS;
  rv.w1.l = (v1 >> TARGET_WORD_NUM_BITS) & WORD_BITS;
  return rv;
}

LONGEST
short_to_longest(s1)
  short s1;
{
  LONGEST rv;
  long v1 = s1;
  rv.w0.l = v1 & WORD_BITS;
  rv.w1.l = (v1 >> TARGET_WORD_NUM_BITS) & WORD_BITS;
  return rv;
}
  
LONGEST
unsigned_long_to_longest(u1)
  unsigned long u1;
{
  LONGEST rv;
  unsigned long v1 = u1;
  rv.w0.u = v1 & WORD_BITS;
  rv.w1.u = (v1 >> TARGET_WORD_NUM_BITS) & WORD_BITS ;
  return rv;
}

LONGEST
unsigned_char_to_longest(c1)
  unsigned char c1;
{
  LONGEST rv;
  unsigned long v1 = c1;
  rv.w0.u = v1 & WORD_BITS;
  rv.w1.u = (v1 >> TARGET_WORD_NUM_BITS) & WORD_BITS;
  return rv;
}

LONGEST
unsigned_short_to_longest(s1)
  unsigned short s1;
{
  LONGEST rv;
  unsigned long v1 = s1;
  rv.w0.u = v1 & WORD_BITS;
  rv.w1.u = (v1 >> TARGET_WORD_NUM_BITS) & WORD_BITS;
  return rv;
}

LONGEST
unsigned_int_to_longest(i1)
  unsigned int i1;
{
  LONGEST rv;
  unsigned long v1 = i1;
  rv.w0.u = v1 & WORD_BITS;
  rv.w1.u = (v1 >> TARGET_WORD_NUM_BITS) & WORD_BITS;
  return rv;
}

LONGEST
core_addr_to_long(i1)
  CORE_ADDR i1;
{
  LONGEST rv;
  rv.w0.u = i1.w0.u & ADDR_BITS;
  rv.w1.u = 0;
  return rv;
}

int
equal_longest(v1,v2)
  LONGEST v1,v2;
{
 
 return (((v1.w0.l&WORD_BITS) == (v2.w0.l&WORD_BITS))&&
         ((v1.w1.l&WORD_BITS) == (v2.w1.l&WORD_BITS)))?1:0;
}

int
less_unsigned_longest(v1,v2)
  LONGEST v1,v2;
{
 int rv;
   v1.w1.u &= WORD_BITS;
   v2.w1.u &= WORD_BITS;
   if (v1.w1.u == v2.w1.u){
     v1.w0.u &= WORD_BITS;
     v2.w0.u  &= WORD_BITS;
     rv= (v1.w0.u < v2.w0.u)?1:0;
     }
   else rv= (v1.w1.u < v2.w1.u)?1:0;
return (rv);
}

int
less_longest(v1,v2)
  LONGEST v1,v2;
{
 LONGEST vt;
 long s1,s2,sresult;
 int rv;
 s1 = v1.w1.l&SIGN_TEST_BIT;
 s2 = v2.w1.l&SIGN_TEST_BIT;
 if(s1^s2){ /* different signs */
   rv = (s2)? 0:1;
   }
 else{ /* same sign operands */
   vt = SUB_LONGEST(v1,v2);
   sresult = vt.w1.l & SIGN_TEST_BIT;
   rv = (sresult)? 1:0;
   }
 return (rv);
}

int
equal_double(v1,v2)
  double v1,v2; 
{ 
 return (v1 == v2)? 1:0; 
}

int
equal_ptr(v1,v2)
  LONGEST v1,v2; 
{ 
 return ((v1.w0.u&ADDR_BITS) == (v2.w0.u&ADDR_BITS) &&
         (v1.w1.mape == v2.w1.mape))? 1:0; 
}

int
less_ptr(v1,v2)
  LONGEST v1,v2; 
{ 
 return ((v1.w0.u&ADDR_BITS) < (v2.w0.u&ADDR_BITS))? 1:0; 
}

double
add_double(v1,v2) 
  double v1,v2;  
{  
 return (v1+ v2); 
}

double
sub_double(v1,v2) 
  double v1,v2;  
{  
 return (v1 - v2); 
}

double
mul_double(v1,v2)
  double v1,v2;
{
 return (v1 * v2);
}

double
div_double(v1,v2) 
  double v1,v2; 
{ 
 return (v1 / v2); 
} 

double
neg_double(v1) 
  double v1; 
{ 
 return ( - v1); 
}

int 
less_double(v1,v2)
  double v1,v2;
{
  return (v1 < v2)? 1 : 0 ;
} 


LONGEST
mul_unsigned_longest(v1,v2)
  LONGEST v1,v2;
{
 double d1,d2,dresult;
 d1 = (((double)(v1.w1.u&WORD_BITS))*((double)(WORD_BITS+1)))+
      ((double)(v1.w0.u&WORD_BITS));
 d2 = (((double)(v2.w1.u&WORD_BITS))*((double)(WORD_BITS+1)))+
      ((double)(v2.w0.u&WORD_BITS));
 dresult = d1*d2; /* unsigned multiply */
 v1.w1.u = dresult/((double)(WORD_BITS+1));
 v1.w0.u = dresult - (((double)v1.w1.u)*((double)(WORD_BITS+1)));
 v1.w1.u &= WORD_BITS;
 v1.w0.u &= WORD_BITS;
 return v1;
}

LONGEST
div_unsigned_longest(v1,v2)
  LONGEST v1,v2;
{
 double d1,d2,dresult;
 d1 = (((double)(v1.w1.u&WORD_BITS))*((double)(WORD_BITS+1)))+
      ((double)(v1.w0.u&WORD_BITS));
 d2 = (((double)(v2.w1.u&WORD_BITS))*((double)(WORD_BITS+1)))+
      ((double)(v2.w0.u&WORD_BITS));
 dresult = d1/d2; /* unsigned divide */
 v1.w1.u = dresult/((double)(WORD_BITS+1));
 v1.w0.u = dresult - (((double)v1.w1.u)*((double)(WORD_BITS+1)));
 v1.w1.u &= WORD_BITS;
 v1.w0.u &= WORD_BITS;
 return v1;
}

LONGEST
rem_unsigned_longest(v1,v2)
  LONGEST v1,v2;
{
 LONGEST vr;
 double d1,d2,dresult;
 d1 = (((double)(v1.w1.u&WORD_BITS))*((double)(WORD_BITS+1)))+
      ((double)(v1.w0.u&WORD_BITS));
 d2 = (((double)(v2.w1.u&WORD_BITS))*((double)(WORD_BITS+1)))+
      ((double)(v2.w0.u&WORD_BITS));
 dresult = d1/d2; /* unsigned divide */
 vr.w1.u = dresult/((double)(WORD_BITS+1));
 vr.w0.u = dresult - (((double)vr.w1.u)*((double)(WORD_BITS+1)));
 vr.w1.u &= WORD_BITS;
 vr.w0.u &= WORD_BITS;
 vr = MUL_UNSIGNED_LONGEST(vr,v2);
 vr = SUB_UNSIGNED_LONGEST(v1,vr);
 return vr;
}
 
LONGEST
rsh_unsigned_longest(v1,v2)
  LONGEST v1,v2;
{
 int shiftcount=0;
 v2.w0.u &= WORD_BITS;
 v2.w1.u &= WORD_BITS;
 v1.w0.u &= WORD_BITS;
 v1.w1.u &= WORD_BITS;
 while ((v2.w0.u||v2.w1.u)&&(shiftcount++ <MAX_WORD_BITS)){
   v2=ADD_LONGEST(v2,longest_minus_1);
   v1.w0.u >>=1;
   if (v1.w1.u & 1)
      v1.w0.u |= SIGN_TEST_BIT;
   v1.w1.u >>=1;
   }
 return v1;
}



LONGEST
unpack_field_as_longest(valaddr,bitpos,bitsize) 
  char *valaddr;
  int bitpos,bitsize;
{
 unsigned long vu[3]; 
 LONGEST v1,vmask;
 int wordoffset_start= bitpos/ (sizeof(long)*8);
 int bitoffset = bitpos% (SIZEOF_INT*8);
 int wordoffset_end= wordoffset_start+
     (((bitoffset+bitsize-1)/TARGET_WORD_NUM_BITS)*(SIZEOF_INT/sizeof(long)));
 int wordoffset_mid= ((wordoffset_end-wordoffset_start)>(SIZEOF_INT/sizeof(long)))?wordoffset_start+(SIZEOF_INT/sizeof(long)):wordoffset_end;
 vmask=longest_zero;
 vu[0] = *((( unsigned long *) valaddr)+wordoffset_start); 
 vu[1] = (wordoffset_mid>wordoffset_start)?
 *((( unsigned long *) valaddr)+wordoffset_mid):0;
 vu[2] = (wordoffset_end>wordoffset_mid)?
 *((( unsigned long *) valaddr)+wordoffset_end):0;

 while (bitoffset-- >0){
   vu[0] >>=1;
   if (vu[1] & 1)
      vu[0] |= SIGN_TEST_BIT;
   vu[1] >>=1;
   if (vu[2] & 1)
      vu[1] |= SIGN_TEST_BIT;
   vu[2] >>=1;
   }

 while (bitsize-- >0){
   vmask.w1.u<<=1;
   if (vmask.w0.u&SIGN_TEST_BIT) vmask.w1.u|=1;
   vmask.w0.u<<=1;
   vmask.w0.u|=1;
   }
 v1.w0.u = vu[0] & vmask.w0.u &  WORD_BITS;
 v1.w1.u = vu[1] & vmask.w1.u & WORD_BITS;
 return v1;
}

  
modify_field_longest(addr,fieldval,bitpos,bitsize) 
  char *addr;
  LONGEST fieldval;
  int bitpos,bitsize;
{
 unsigned long vf[3];
 unsigned long vm[3];
 int wordoffset_start= bitpos/ (sizeof(long)*8);
 int bitoffset = bitpos% (SIZEOF_INT*8);
 int wordoffset_end= wordoffset_start+
     (((bitoffset+bitsize-1)/TARGET_WORD_NUM_BITS)*(SIZEOF_INT/sizeof(long)));
 int wordoffset_mid= ((wordoffset_end-wordoffset_start)>(SIZEOF_INT/sizeof(long)))?wordoffset_start+(SIZEOF_INT/sizeof(long)):wordoffset_end;

 vm[2]=0;
 if (bitsize>TARGET_WORD_NUM_BITS){
   int upperbits= bitsize - TARGET_WORD_NUM_BITS;
   vm[0]=WORD_BITS;
   vm[1]=(1l << upperbits) - 1l;
   }
 else{
   vm[1]=0;
   vm[0]=(1l << bitsize) -1l;
   }

 vf[2]=0;
 vf[1]=fieldval.w1.u&vm[1];
 vf[0]=fieldval.w0.u&vm[0];

 while (bitoffset-- >0){
   vf[2]<<=1;
   if (vf[1]&SIGN_TEST_BIT) vf[2]|=1;
   vf[1]<<=1;
   if (vf[0]&SIGN_TEST_BIT) vf[1]|=1;
   vf[0]<<=1;
   vm[2]<<=1;
   if (vm[1]&SIGN_TEST_BIT) vm[2]|=1;
   vm[1]<<=1;
   if (vm[0]&SIGN_TEST_BIT) vm[1]|=1;
   vm[0]<<=1;
   }

  *((( unsigned long *) addr)+wordoffset_start)&= ~(vm[0]&WORD_BITS);
  *((( unsigned long *) addr)+wordoffset_start)|= vf[0]&WORD_BITS;
  if (wordoffset_mid>wordoffset_start){
   *((( unsigned long *) addr)+wordoffset_mid)&= ~(vm[1]&WORD_BITS);
   *((( unsigned long *) addr)+wordoffset_mid)|= vf[1]&WORD_BITS;
   if (wordoffset_end>wordoffset_mid){
    *((( unsigned long *) addr)+wordoffset_end)&= ~(vm[2]&WORD_BITS);
    *((( unsigned long *) addr)+wordoffset_end)|= vf[2]&WORD_BITS;
    }
   }
}  
 
  
LONGEST
min_unsigned_longest(v1,v2)
  LONGEST v1,v2;
{  
   v1.w1.u &= WORD_BITS;
   v2.w1.u &= WORD_BITS;
   if (v1.w1.u == v2.w1.u){
     v1.w0.u &= WORD_BITS;
     v2.w0.u  &= WORD_BITS;
     if (v1.w0.u > v2.w0.u)
        v1 = v2; /* return value */
     }
   else if (v1.w1.u > v2.w1.u)
     v1 = v2;
 return v1;
}
 
LONGEST
max_unsigned_longest(v1,v2)
  LONGEST v1,v2;
{ /* returns (v1>v2)?v1:v2 */
   v1.w1.u &= WORD_BITS;
   v2.w1.u  &= WORD_BITS;
   if (v1.w1.u == v2.w1.u){
     v1.w0.u &= WORD_BITS;
     v2.w0.u  &= WORD_BITS;
     if (v1.w0.u < v2.w0.u)
       v1 = v2; /* return value */
     }
   else if (v1.w1.u < v2.w1.u)
      v1 = v2; /* return value */
 return v1;
}
 
LONGEST
longest_to_target_int(v1)
  LONGEST v1;
{
 v1.w0.l = (v1.w0.l)&WORD_BITS;
 v1.w1.l = ((v1.w0.l)&SIGN_TEST_BIT)?WORD_BITS:0;
 return v1;
}

LONGEST
longest_to_target_unsigned_int(v1)
  LONGEST v1;
{
 v1.w0.l = (v1.w0.l)&WORD_BITS;
 v1.w1.l = 0;
 return v1;
}
 
LONGEST longest_to_target_long(v1)
LONGEST v1;
{
 v1.w0.u &=WORD_BITS;
 v1.w1.u&= WORD_BITS;
 return (v1);
}

LONGEST longest_to_target_pointer(v1)
LONGEST v1;
{
 v1.w0.u&= ADDR_BITS;
 return (v1);
}

do_registers_info(regnum)
  int regnum;
{
  register int i;
  int regsize;

  if (regnum == -1)
    printf_filtered (
      "Register       Contents (relative to selected stack frame)\n\n");

  for (i = 0; i < NUM_REGS; i++) 
    {
      unsigned char raw_buffer[MAX_REGISTER_RAW_SIZE];
      unsigned char virtual_buffer[MAX_REGISTER_VIRTUAL_SIZE];

      if (regnum != -1 && i != regnum)
   continue;

      /* Get the data in raw format, then convert also to virtual format.  */
      read_relative_register_raw_bytes (i, raw_buffer);
      REGISTER_CONVERT_TO_VIRTUAL (i, raw_buffer, virtual_buffer);

      fputs_filtered (reg_names[i], stdout);
      print_spaces_filtered (15 - strlen (reg_names[i]), stdout);
 
      /* If virtual format is floating, print it that way.  */
      if (TYPE_CODE (REGISTER_VIRTUAL_TYPE (i)) == TYPE_CODE_FLT
     && ! INVALID_FLOAT (virtual_buffer, REGISTER_VIRTUAL_SIZE (i)))
   val_print (REGISTER_VIRTUAL_TYPE (i), virtual_buffer, core_zero,
         stdout, 0, 1, 0, Val_pretty_default);
      /* Else if virtual format is too long for printf,
    print in hex a byte at a time.  */
      else if ((regsize=reg_info[i].real_size) == 4)
   { /* only for long registers */
     LONGEST tl;
     bcopy (virtual_buffer, &tl, SIZEOF_LONG);
     printf_filtered ("0x%04x%04x",tl.w1.u,tl.w0.u);
   }
      /* Else print as integer in hex and in decimal.  */
      else
   {
     long lval;
 
     bcopy (virtual_buffer, &lval, sizeof (long));
     if (lval == 0)

    printf_filtered ("0");
     else if (regsize==1) 
       printf_filtered ("0x%02x  %d", lval, lval);
     else if (regsize==2) 
       printf_filtered ("0x%04x  %d", lval, lval);
   }

      /* If register has different raw and virtual formats,
    print the raw format in hex now.  */

      if (REGISTER_CONVERTIBLE (i))
   {
     register int j;

     printf_filtered ("  (raw 0x");
     for (j = 0; j < REGISTER_RAW_SIZE (i); j++)
       printf_filtered ("%02x", raw_buffer[j]);
     printf_filtered (")");
   }
      printf_filtered ("\n");
    }
}

static char retstringbuf[80];

char *
int_to_xstring(v1)
LONGEST v1;
{
 sprintf(retstringbuf,"0x%x",v1.w0.u&WORD_BITS); 
 return (retstringbuf);
}

char *
int_to_0xstring(v1)
LONGEST v1;
{
 sprintf(retstringbuf,"0x%04x",v1.w0.u&WORD_BITS); 
 return (retstringbuf);
}

char *
int_to_ostring(v1)
LONGEST v1;
{
 sprintf(retstringbuf,"0%o",v1.w0.u&WORD_BITS); 
 return (retstringbuf);
}

char *
long_to_ostring(v1)
LONGEST v1;
{
    long vl;
 v1.w1.u &= WORD_BITS;
 v1.w0.u &= WORD_BITS;
    vl=(v1.w1.u<<TARGET_WORD_NUM_BITS)|v1.w0.u;
   sprintf(retstringbuf,"0%o",vl); 
 return (retstringbuf);
}

char *
long_to_xstring(v1)
LONGEST v1;
{
    long vl;
 v1.w1.u &= WORD_BITS;
 v1.w0.u &= WORD_BITS;
    vl=(v1.w1.u<<TARGET_WORD_NUM_BITS)|v1.w0.u;
   sprintf(retstringbuf,"0x%x",vl); 
 return (retstringbuf);
}

char *
long_to_0xstring(v1)
LONGEST v1;
{
    long vl;
 v1.w1.u &= WORD_BITS;
 v1.w0.u &= WORD_BITS;
    vl=(v1.w1.u<<TARGET_WORD_NUM_BITS)|v1.w0.u;
 sprintf(retstringbuf,"0x%08x",vl);
 return (retstringbuf);
}

char *
int_to_ustring(v1)
LONGEST v1;
{
 sprintf(retstringbuf,"%u",v1.w0.u&WORD_BITS); 
 return (retstringbuf);
}

char *
int_to_dstring(v1)
LONGEST v1;
{
 long s1;

 s1 = v1.w0.l&SIGN_TEST_BIT;
 if (s1) v1 = NEG_LONGEST(v1);
 sprintf(retstringbuf,(s1)?"-%d":"%d",v1.w0.u&WORD_BITS); 
 return (retstringbuf);
}

char *
long_to_dstring(v1)
LONGEST v1;
{
    long vl;
 v1.w1.u &= WORD_BITS;
 v1.w0.u &= WORD_BITS;
    vl=(v1.w1.u<<TARGET_WORD_NUM_BITS)|v1.w0.u;

 sprintf(retstringbuf,"%ld",vl);
 return (retstringbuf);
}

char *
long_to_ustring(v1)
LONGEST v1;
{
    long vl;
 v1.w1.u &= WORD_BITS;
 v1.w0.u &= WORD_BITS;
    vl=(v1.w1.u<<TARGET_WORD_NUM_BITS)|v1.w0.u;

   sprintf(retstringbuf,"%ul",vl);
 return (retstringbuf);
}

double
target_long_to_double(v1)
LONGEST v1;
{
 double rv;
    long vl;
 v1.w1.u &= WORD_BITS;
 v1.w0.u &= WORD_BITS;
    vl=(v1.w1.u<<TARGET_WORD_NUM_BITS)|v1.w0.u;
 rv=vl;
 return (rv);
}

double
target_unsigned_long_to_double(v1)
LONGEST v1;
{
 double rv;
 unsigned long vl;
 v1.w1.u &= WORD_BITS;
 v1.w0.u &= WORD_BITS;
    vl=(v1.w1.u<<TARGET_WORD_NUM_BITS)|v1.w0.u;
 rv=vl;

 return (rv);
}

double
target_double_to_double(v1)
LONGEST v1;
{
double result;
float tval;
 unsigned long vl;
 v1.w1.u &= WORD_BITS;
 v1.w0.u &= WORD_BITS;
    vl=(v1.w1.u<<TARGET_WORD_NUM_BITS)|v1.w0.u;
 tval= *(float *)&vl;
 result=tval;
return (result);
}

  
LONGEST
double_to_target_double(dval)
double dval;
{
float tval;
LONGEST rv;
unsigned long lval;
tval=dval;
lval= *(unsigned long *)&tval;
  rv.w1.u = (lval>>TARGET_WORD_NUM_BITS)& WORD_BITS; /* mantissa */
  rv.w0.u = lval & WORD_BITS;
  return (rv);
}

CORE_ADDR stack_end_addr;

static
char default_dsp_device_number[]="56156";
extern
char *dsp_device_number;
_initialize_m561()
{
int i;
CORE_ADDR_MAP(core_zero)= memory_map_p;
CORE_ADDR_MAP(frame_zero_init)= STACK_MAP;
CORE_ADDR_MAP(stack_end_addr)= STACK_MAP;
CORE_ADDR_MAP(stack_zero)= STACK_MAP;
CORE_ADDR_W0(longest_minus_1)=WORD_BITS;
CORE_ADDR_W1(longest_minus_1)=WORD_BITS;
CORE_ADDR_W0(longest_one)=1;

init_host_io_structures ( );

dsp_startup();
if (!dsp_device_number)
    dsp_device_number= default_dsp_device_number;

if (!dsp_new(0,dsp_device_number))
    fatal ("unable to create device number:%s",dsp_device_number);

hspr=dv_var->periph[0].regval;
for (i=0;i<NUM_REGS;i++)
 if(reg_info[i].regname)
  dsp_findreg(0,reg_info[i].regname,&reg_info[i].periph,&reg_info[i].regnum);
}



