/* Machine-dependent code which would otherwise be in inflow.c and core.c,
	$Id: m56k-dep.c,v 1.20 1993/07/23 14:52:50 jay Exp $

   for GDB, the GNU debugger.
   Copyright (C) 1986, 1987, 1989 Free Software Foundation, Inc.
   This code is for the sparc cpu.

This file is part of GDB.

GDB is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 1, or (at your option)
any later version.

GDB is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GDB; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */

#include <stdlib.h>
#include <stdio.h>
#include "defs.h"
#include "param.h"
#include "value.h"
#include "symtab.h"
#include "frame.h"
#include "obstack.h"
#include "inferior.h"

#include "simcom.h"
#include "simdev.h"
#include "simusr.h"
#include "core56k.h"
#include "gsig56k.h"
#include <signal.h>
#include <fcntl.h>
#if MSDOS
#include "stub.h"
#endif
#ifndef DSP56000
#define DSP56000 1
#endif
#include "../hostio/hostio.h"

#define STACK_MAP memory_map_y

extern struct dev_const dv_const;
extern struct dev_var *dv_var;
static  unsigned long *hspr;

LONGEST longest_zero;
CORE_ADDR core_zero;
FRAME_ADDR frame_zero_init;
CORE_ADDR stack_zero;
static enum memory_map stmap;
static
struct reg_info{
   int startbyte; /* start byte in dsp_regs structure */
   char *regname; /* used to look up periph and regnum from dsp_findreg */
   struct type **virtual_type;
   int regbytes; /* number of bytes used in dsp_regs structure */
   int real_size; /* actual number of bytes used by the dsp */
   int periph;
   int regnum; /* cross to dsp reg number */
   }
reg_info[]=
{
{0,"a0",&builtin_type_long,8,6,0,0},
{0,"a0",&builtin_type_int,4,3,0,0},
{4,"a1",&builtin_type_int,4,3,0,0},
{8,"a2",&builtin_type_int,4,1,0,0},
{12,"b0",&builtin_type_long,8,6,0,0},
{12,"b0",&builtin_type_int,4,3,0,0},
{16,"b1",&builtin_type_int,4,3,0,0},
{20,"b2",&builtin_type_int,4,1,0,0},
{24,"bcr",&builtin_type_unsigned_int,4,2,0,0},
{28,"cra",&builtin_type_unsigned_int,4,2,0,0},
{32,"crb",&builtin_type_unsigned_int,4,2,0,0},
{36,"cvr",&builtin_type_unsigned_int,4,1,0,0},
{40,"cyc",&builtin_type_long,8,6,0,0},
{48,"hcr",&builtin_type_unsigned_int,4,1,0,0},
{52,"hrx",&builtin_type_unsigned_int,4,3,0,0},
{56,"hsr",&builtin_type_unsigned_int,4,1,0,0},
{60,"htx",&builtin_type_unsigned_int,4,3,0,0},
{64,"icr",&builtin_type_unsigned_int,4,1,0,0},
{68,"ictr",&builtin_type_long,8,6,0,0},
{76,"ipr",&builtin_type_unsigned_int,4,2,0,0},
{80,"isr",&builtin_type_unsigned_int,4,1,0,0},
{84,"ivr",&builtin_type_unsigned_int,4,1,0,0},
{88,"la",&builtin_type_unsigned_int,4,2,0,0},
{92,"lc",&builtin_type_unsigned_int,4,2,0,0},
{96,"m0",&builtin_type_unsigned_int,4,2,0,0},
{100,"m1",&builtin_type_unsigned_int,4,2,0,0},
{104,"m2",&builtin_type_unsigned_int,4,2,0,0},
{108,"m3",&builtin_type_unsigned_int,4,2,0,0},
{112,"m4",&builtin_type_unsigned_int,4,2,0,0},
{116,"m5",&builtin_type_unsigned_int,4,2,0,0},
{120,"m6",&builtin_type_unsigned_int,4,2,0,0},
{124,"m7",&builtin_type_unsigned_int,4,2,0,0},
{128,"n0",&builtin_type_unsigned_int,4,2,0,0},
{132,"n1",&builtin_type_unsigned_int,4,2,0,0},
{136,"n2",&builtin_type_unsigned_int,4,2,0,0},
{140,"n3",&builtin_type_unsigned_int,4,2,0,0},
{144,"n4",&builtin_type_unsigned_int,4,2,0,0},
{148,"n5",&builtin_type_unsigned_int,4,2,0,0},
{152,"n6",&builtin_type_unsigned_int,4,2,0,0},
{156,"n7",&builtin_type_unsigned_int,4,2,0,0},
{160,"omr",&builtin_type_unsigned_int,4,1,0,0},
{164,"pbc",&builtin_type_unsigned_int,4,1,0,0},
{168,"pbd",&builtin_type_unsigned_int,4,2,0,0},
{172,"pbddr",&builtin_type_unsigned_int,4,2,0,0},
{176,(char *)NULL,&builtin_type_unsigned_int,8,2,0,0},
{184,"pcc",&builtin_type_unsigned_int,4,2,0,0},
{188,"pcd",&builtin_type_unsigned_int,4,2,0,0},
{192,"pcddr",&builtin_type_unsigned_int,4,2,0,0},
{196,"r0",&builtin_type_unsigned_int,4,2,0,0},
{200,"r1",&builtin_type_unsigned_int,4,2,0,0},
{204,"r2",&builtin_type_unsigned_int,4,2,0,0},
{208,"r3" ,&builtin_type_unsigned_int,4,2,0,0},
{212,"r4",&builtin_type_unsigned_int,4,2,0,0},
{216,"r5",&builtin_type_unsigned_int,4,2,0,0},
{220,"r6",&builtin_type_unsigned_int,4,2,0,0},
{224,"r7",&builtin_type_unsigned_int,4,2,0,0},
{228,"rx",&builtin_type_unsigned_int,4,3,0,0},
{232,"rxh",&builtin_type_unsigned_int,4,1,0,0},
{236,"rxl",&builtin_type_unsigned_int,4,1,0,0},
{240,"rxm",&builtin_type_unsigned_int,4,1,0,0},
{244,"sccr",&builtin_type_unsigned_int,4,2,0,0},
{248,"scr",&builtin_type_unsigned_int,4,2,0,0},
{252,"r6",&builtin_type_unsigned_int,8,2,0,0},
{260,"sr",&builtin_type_unsigned_int,4,2,0,0},
{264,"srx",&builtin_type_unsigned_int,4,1,0,0},
{268,"ssh",&builtin_type_unsigned_int,4,2,0,0},
{272,"ssisr",&builtin_type_unsigned_int,4,1,0,0},
{276,"ssl",&builtin_type_unsigned_int,4,2,0,0},
{280,"ssr",&builtin_type_unsigned_int,4,1,0,0},
{284,"stx",&builtin_type_unsigned_int,4,1,0,0},
{288,"stxa",&builtin_type_unsigned_int,4,1,0,0},
{292,"tsr",&builtin_type_unsigned_int,4,1,0,0},
{296,"tx",&builtin_type_unsigned_int,4,3,0,0},
{300,"txh",&builtin_type_unsigned_int,4,1,0,0},
{304,"txl",&builtin_type_unsigned_int,4,1,0,0},
{308,"txm",&builtin_type_unsigned_int,4,1,0,0},
{312,"x0",&builtin_type_long,8,6,0,0},
{312,"x0",&builtin_type_int,4,3,0,0},
{316,"x1",&builtin_type_int ,4,3,0,0},
{320,"y0",&builtin_type_long,8,6,0,0},
{320,"y0",&builtin_type_int,4,3,0,0},
{324,"y1",&builtin_type_int,4,3,0,0},
{328,"r0",&builtin_type_unsigned_int,8,2,0,0},
{336,"sp",&builtin_type_unsigned_int,4,1,0,0}
};

/* dig through the stack to get the 1st argument to the current function.
   (which hasn't manipulated the stack pointer yet). */

unsigned long
get_1st_arg ( )
{
    unsigned long location, value;
    
    /* find the stack pointer. the first argument will in the memory
       location addressed by the stack pointer - 1. */

    location= hspr[REG_R6]-1;
    dsp_rmem ( 0, stmap, location, & value );
    return value;
}

/* dig through the stack to get the 2nd argument to the current function.
   (which hasn't manipulated the stack pointer yet). */

unsigned long
get_2nd_arg ( )
{
    unsigned long location, value;
    
    /* find the stack pointer. the first argument will in the memory
       location addressed by the stack pointer - 1. */
    location=hspr[REG_R6]- 2;
    dsp_rmem ( 0, stmap, location, & value );
    return value;
}

dsp_56k_register_byte(regnumber)
int regnumber;
{/* Index within `registers' of the first byte of the space for
   362     register N.  */
return (reg_info[regnumber].startbyte);
}

dsp_56k_register_raw_size(regnumber)
int regnumber;
{
return (reg_info[regnumber].regbytes);
}

struct type *
register_virtual_type(regnumber)
int regnumber;
{
return ( *reg_info[regnumber].virtual_type);
}

/* m56k doesnt have ptrace */

int
call_ptrace (request, pid, arg3, arg4)
     int request, pid, arg3, arg4;
{
 if (request==0) return;
 error ("no ptrace");
}

void
kill_inferior ()
{
}

/* This is used when GDB is exiting.  It gives less chance of error.*/

void
kill_inferior_fast ()
{
}

static
void intrpt1()
{

   (void) signal(SIGINT,intrpt1);
   dv_var->CTRLBR = 1;
}

/* Resume execution of the inferior process.
   If STEP is nonzero, single-step it.
   If SIGNAL is nonzero, give it that signal.  */
extern CORE_ADDR text_end;

CORE_ADDR
printf_end_address;

static
unsigned long
send_address,receive_address;

CORE_ADDR
program_exit_address;

void
resume (step, signums)
     int step;
     int signums;
{
  extern void request_quit ();
  extern int cross_debugging_trap,trap_expected;
  extern CORE_ADDR step_resume_break_address;
  CORE_ADDR pc;
  int printed_something;
  struct dev_var *dv=dv_const.sv[0];
  if (remote_debugging)
    remote_resume (step, signums);
  else
    {
  dv_var->CTRLBR=0; /* flag cleared for break signal */
  (void) signal(SIGINT,intrpt1);
 cross_debugging_trap=0;
  printed_something=0;
do{
    if ( send_address && (send_address == dv_var->reg_exec ))
      {
	  /* we, as the host, are now going to *receive* some data.
	     the hio_receive buffer should be large enough to handle
	     the full transmission. */

	  unsigned long input_buffer, input_count;
	  int i;
	  
	  input_buffer = get_1st_arg ( );
	  input_count = get_2nd_arg ( );
	  hio_receive.length = input_count;
	  CHECK_BUFFER_SIZE ( & hio_receive, input_count );
	  
	  for ( i = 0; i < input_count; ++ i )
	  {
	      dsp_rmem ( 0, stmap, input_buffer ++, hio_receive.buffer + i );
	  }
	  hio_receive.valid_p = TRUE;
	  printed_something=1;
      }
      else if ( receive_address && (receive_address == dv_var->reg_exec ))
	  {
	  /* the dsp is ready to receive a message, so we'll go ahead and
	     *send* it. the dsp should have allocated a buffer large 
	     enough to handle the full transmission. */

	  unsigned long output_buffer;
	  int i;

	  output_buffer = get_1st_arg ( );
	  for ( i = 0; i < hio_send.length; ++ i )
	  {
	      dsp_wmem ( 0, stmap, output_buffer ++, hio_send.buffer + i );
	  }
	  hio_send.valid_p = FALSE;
      }
      
	/* Clear end-of-instruction and end-of-repeat flag bits */
	dv->flg_stat&= ~(DSP_GEOI|DSP_GEOR);
	while (!(dv->flg_stat& (DSP_GEOI|DSP_GEOR))) 
   dsp_exec(0);
	CORE_ADDR_ADDR(pc)=dv_var->reg_exec;

    process_pending_host_io();
    if ( printed_something){
	fflush(stdout);
	printed_something=0;
	}

 if (CORE_ADDR_ADDR(pc)==CORE_ADDR_ADDR(printf_end_address)&&
      CORE_ADDR_ADDR(pc)){
     /* read character string from memory address in x0 */
      char ch;
      CORE_ADDR printf_string_address;
      printf_string_address = FRAME_ZERO;
      CORE_ADDR_ADDR(printf_string_address)=
        hspr[REG_X0];
      while (ch=read_memory_integer(printf_string_address,4)){
       putc(ch,stdout);
       if (dv_var->CTRLBR) break; /* break signal occurred */
       CORE_ADDR_ADDR(printf_string_address)+=1;
       }
      fflush(stdout);
      }	

 if (CORE_ADDR_ADDR(pc)==CORE_ADDR_ADDR(program_exit_address)){
   cross_debugging_trap=SIGCHLD;
   break;
   }
	if (step) break;
 if (dv_var->CTRLBR) break; /* break signal occurred */
	}while((!breakpoint_here_p(pc))&&
  /* following line tests for dummy function end address */
  (CORE_ADDR_ADDR(pc)!= (CORE_ADDR_ADDR(text_end) - 2)) &&
  ((!CORE_ADDR_ADDR(step_resume_break_address))||
  (CORE_ADDR_ADDR(pc)!=CORE_ADDR_ADDR(step_resume_break_address))));/*stop if step or breakpoint */
 (void) signal(SIGINT,request_quit);
 if (!cross_debugging_trap)
 cross_debugging_trap=(dv_var->CTRLBR)?SIGINT:SIGTRAP;
		}
}

union dsp_regs{
      char ra[REGISTER_BYTES];
   struct dsp_56k_registers rs;
      };

void
fetch_inferior_registers ()
{
  union dsp_regs inferior_registers;
  extern char registers[];
  int i;

  if (remote_debugging)
    remote_fetch_registers (registers);
  else
    { /* get all registers */
      for (i=0;i<NUM_REGS;i++)
        if(reg_info[i].regbytes==4)
         dsp_rreg(0,reg_info[i].periph,reg_info[i].regnum,
            (unsigned long *)&inferior_registers.ra[reg_info[i].startbyte]);
      *(unsigned long *)&inferior_registers.ra[reg_info[CYC_REGNUM].startbyte]=
         dv_var->reg_cycl
         &0xffffffl;
      *(unsigned long *)&inferior_registers.ra[reg_info[ICNT_REGNUM].startbyte]=
         dv_var->reg_icnt
         &0xffffffl;
      *(unsigned long *)&inferior_registers.ra[reg_info[CYC_REGNUM].startbyte+sizeof(long)]=
        dv_var->reg_cycl
        >>24&0xffl;
      *(unsigned long *)&inferior_registers.ra[reg_info[ICNT_REGNUM].startbyte+sizeof(long)]=
        dv_var->reg_icnt
        >>24&0xffl;
      *(unsigned long *)&inferior_registers.ra[reg_info[PC_REGNUM].startbyte]=
        dv_var->reg_exec;
      *(unsigned long *)&inferior_registers.ra[reg_info[SP_REGNUM].startbyte]=
        hspr[REG_R6];
      *(unsigned long *)&inferior_registers.ra[reg_info[FP_REGNUM].startbyte]=
        hspr[REG_R0];
  *(unsigned long *)&inferior_registers.ra[reg_info[SP_REGNUM].startbyte+sizeof(long)]= (long) CORE_ADDR_MAP(stack_zero);
  *(unsigned long *)&inferior_registers.ra[reg_info[PC_REGNUM].startbyte+sizeof(long)]= (long) memory_map_p;
  *(unsigned long *)&inferior_registers.ra[reg_info[FP_REGNUM].startbyte+sizeof(long)]= (long) CORE_ADDR_MAP(stack_zero);
      bcopy (&inferior_registers.ra[0], &registers[0], REGISTER_BYTES);
#if 0
      read_inferior_memory (inferior_registers.r_sp,
             &registers[REGISTER_BYTE (16)],
             16*4);
#endif
    }
}

/* Store our register values back into the inferior.
   If REGNO is -1, do this for all registers.
   Otherwise, REGNO specifies which register (so we can save time).  */
void
store_inferior_registers (regno)
     int regno;
{
  union dsp_regs inferior_registers;
  extern char registers[];
	int i,regoffset,xrsp,xrfp,xrthis;
 unsigned long newval,oldval;
 void remote_store_registers();

  xrsp=reg_info[SP_REGNUM].regnum;
  xrfp=reg_info[FP_REGNUM].regnum;
  if (remote_debugging)
    remote_store_registers (registers);
  else if (regno>=0){ /* single register number */
    i=regno;
    xrthis=reg_info[i].regnum;
    regoffset=reg_info[i].startbyte;
    newval= *(unsigned long *)&registers[regoffset];
    if(reg_info[i].regbytes==4){
      dsp_rreg(0,reg_info[i].periph,reg_info[i].regnum,&oldval);
      if (newval!=oldval){
         dsp_wreg(0,reg_info[i].periph,reg_info[i].regnum,&newval);
         if ((reg_info[i].periph==0)&&xrthis==xrsp) write_register(SP_REGNUM,newval);
         else if ((reg_info[i].periph==0)&&xrthis==xrfp) write_register(FP_REGNUM,newval);
         }
      }
    else if (i==ICNT_REGNUM||i==CYC_REGNUM){
       newval+=(*(unsigned long *)&registers[regoffset+sizeof(long)])<<24;
       dsp_wreg(0,reg_info[i].periph,reg_info[i].regnum,&newval);
       }
    else if(i==PC_REGNUM){
      oldval= dv_var->reg_exec;
      if (newval!=oldval)
       dsp_wreg(0,0,REG_PC,&newval);
      }
    else if (i==FP_REGNUM){
      oldval= hspr[REG_R0];
      if (newval!=oldval){
       dsp_wreg(0,0,REG_R0,&newval);
         write_register(R0_REGNUM,newval);
        }
      }
    else if (i==SP_REGNUM){
      oldval= hspr[REG_R6];
      if (newval!=oldval){
       dsp_wreg(0,0,REG_R6,&newval);
         write_register(R6_REGNUM,newval);
        }
      }
    else{ /* long register values X,Y,A10,B10 */
      store_inferior_registers(i+1);
      store_inferior_registers(i+2);
      }
   }
  else /* all registers */
    {
      for (i=0;i<NUM_REGS;i++){
				regoffset=reg_info[i].startbyte;
          newval= *(unsigned long *)&registers[regoffset];
         if (i==ICNT_REGNUM||i==CYC_REGNUM)
            newval+=(*(unsigned long *)&registers[regoffset+sizeof(long)])<<24;
    if(reg_info[i].regbytes==4||(i==FP_REGNUM)||(i==SP_REGNUM)||
       (i==ICNT_REGNUM||i==CYC_REGNUM)){
      if(i==CYC_REGNUM)oldval=dv_var->reg_cycl;
      else if (i==ICNT_REGNUM)oldval= dv_var->reg_icnt;
      else
      dsp_rreg(0,reg_info[i].periph,reg_info[i].regnum, &oldval);
      if (newval!=oldval)
      dsp_wreg(0,reg_info[i].periph,reg_info[i].regnum, &newval);
      }
     }
    regoffset=reg_info[PC_REGNUM].startbyte;
    oldval=dv_var->reg_exec; 
    newval= *(unsigned long *)&registers[regoffset];
    if (newval!=oldval)
       dsp_wreg(0,0,REG_PC,&newval);
#if 0
	  write_inferior_memory (*(int *)&registers[REGISTER_BYTE (SP_REGNUM)],
				 &registers[REGISTER_BYTE (16)],
				 16*4);
#endif
    }
}

/* Copy LEN bytes from inferior's memory starting at MEMADDR
   to debugger memory starting at MYADDR. */

int
read_inferior_memory (memaddr, myaddr, len)
     CORE_ADDR memaddr;
     char *myaddr;
     int len;
{
  register int i;
  int incr;
  long addr;
  int count,buflen;
  register long *buffer;
		enum memory_map memmap; 
 /* notice that l is converted to y mem since longs are in y serially */
 memmap= CORE_ADDR_MAP(memaddr);
		count=len/4;


  /* Read all the longwords */
	addr=CORE_ADDR_ADDR(memaddr);
 incr= (memmap==memory_map_l||
     memmap==memory_map_le||
     memmap==memory_map_li)?2:1;

/* Allocate buffer of that many longwords.  */
buflen= (incr==1||len>4)?len:8;
buffer = (long *) alloca (buflen);

  for (i = 0; i < count; i+=incr, addr++ )
    dsp_rmem(0,memmap,addr,&buffer[i]);

  bcopy ((char *) buffer , myaddr, len);
  return 0;
}

/* Copy LEN bytes of data from debugger memory at MYADDR
   to inferior's memory at MEMADDR.*/

int
write_inferior_memory (memaddr, myaddr, len)
     CORE_ADDR memaddr;
     char *myaddr;
     int len;
{
  register int i;
  /* Round starting address down to longword boundary.  */
  long addr,*wordp;
  int incr;
  /* Round ending address up; get number of longwords that makes.  */
	enum memory_map memmap;
  register int count;
count=len/4;

  /* Write the entire buffer.  */
 memmap= CORE_ADDR_MAP(memaddr);
 incr= (memmap==memory_map_l||
     memmap==memory_map_le||
     memmap==memory_map_li)?2:1;

	addr=CORE_ADDR_ADDR(memaddr);
 wordp= (long *) myaddr;
  for (i = 0; i < count; i+=incr, addr++ )
    dsp_wmem(0,memmap,addr,wordp+i);

  return 0;
}

/* Non-zero if this is an object (.o) file, rather than an executable.
   Distinguishing between the two is rarely necessary (and seems like
   a hack, but there is no other way to get the text and data
   addresses--N_TXTADDR should probably take care of
   this, but it doesn't).  */
/* This definition will not work
   if someone decides to make ld preserve relocation info.  */
#define IS_OBJECT_FILE(hdr) (hdr.a_trsize != 0)

/* Make COFF and non-COFF names for things a little more compatible
   to reduce conditionals later.  */

#ifdef COFF_FORMAT
#define a_magic magic
#endif

#ifndef COFF_FORMAT
#ifndef AOUTHDR
#define AOUTHDR struct exec
#endif
#endif

extern char *sys_siglist[];

/* Hook for `exec_file_command' command to call.  */

extern void (*exec_file_display_hook) ();
   
/* File names of core file and executable file.  */

extern char *execfile;

/* Descriptors on which executable file are open.
   Note that the execchan is closed when an inferior is created
   and reopened if the inferior dies or is killed.  */

extern int execchan;

/* Last modification time of executable file.
   Also used in source.c to compare against mtime of a source file.  */

extern int exec_mtime;

/* Virtual addresses of bounds of the two areas of memory in the core file.  */

extern CORE_ADDR data_start;
extern CORE_ADDR data_end;
extern CORE_ADDR stack_start;
extern CORE_ADDR stack_end;

/* Virtual addresses of bounds of two areas of memory in the exec file.*/

extern CORE_ADDR text_start;

extern CORE_ADDR exec_data_start;
extern CORE_ADDR exec_data_end;

/* Address in executable file of start of text area data.  */

extern int text_offset;

/* Address in executable file of start of data area data.  */

extern int exec_data_offset;

/* Address in core file of start of data area data.  */

extern int data_offset;

/* Address in core file of start of stack area data.  */

extern int stack_offset;
  
#ifdef COFF_FORMAT
/* various coff data structures */

extern FILHDR file_hdr;
extern SCNHDR text_hdr;
extern SCNHDR data_hdr;

#endif /* not COFF_FORMAT */

/* a.out header of exec file.  */

extern AOUTHDR exec_aouthdr;

extern void validate_files ();

/*ARGSUSED*/
void
core_file_command (filename, from_tty)
     char *filename;
     int from_tty;
{/* maybe later load state files  with this?*/
 error ("No core files for m56k");
}

static
struct{ /* used for loading section data */
long block_size;
long *mem;
} raw_data;

void exec_file_command();
static
CORE_ADDR text_entry_address;

restart_cross_debugged_code(filename,from_tty) 
     char *filename;
     int from_tty;
{
exec_file_command (filename, from_tty);
/*dsp_wreg(0,0,REG_PC,&CORE_ADDR_ADDR(text_entry_address));*/
}

static
read_section_contents(chan)
     register int chan;
{
FILHDR fl_hdr;
AOUTHDR ao_hdr;
SCNHDR section_hdr;
register int i;

if (read_file_hdr(chan,&fl_hdr) < 0) return (-1);
if (read_aout_hdr(chan,&ao_hdr,(int)fl_hdr.f_opthdr) < 0) return (-1);
for (i=0;i<fl_hdr.f_nscns;i++){
if (lseek (chan, FILHSZ + fl_hdr.f_opthdr + (i * SCNHSZ) , 0) < 0)
  return -1;
if (myread (chan, (char *) &section_hdr, SCNHSZ) < 0)
  return -1;
#ifdef COFF_BYTE_SWAP
   swapem(&section_hdr,(unsigned long)SCNHSZ);
   swapem(section_hdr.s_name,8l);
#endif

if ((strncmp (section_hdr.s_name, ".txt", 8) == 0)||
   (strncmp (section_hdr.s_name, ".dat", 8) == 0)){
  /* load memory block */
  if (section_hdr.s_size > raw_data.block_size){
    /* expand raw data block size  to twice size of current block */
    if (raw_data.mem) raw_data.mem= 
            (long *) xrealloc((char *)raw_data.mem,
         (long) (section_hdr.s_size*2l)*sizeof(long));
    else raw_data.mem=
          (long *)xmalloc((long) (section_hdr.s_size*2l)*sizeof(long));
    raw_data.block_size=section_hdr.s_size*2l; 
		}
  if (lseek (chan,section_hdr.s_scnptr,0) < 0)
    return (-1);
  if (myread(chan,(char *)raw_data.mem,(int)(section_hdr.s_size*sizeof(long)))<0)
  return (-1);
#ifdef COFF_BYTE_SWAP
   swapem(raw_data.mem,(unsigned long)(section_hdr.s_size*sizeof(long)));
#endif
  if (section_hdr.s_flags&STYP_BLOCK){
    /* block data section specified by length:val */
    CORE_ADDR ct;
    unsigned long section_length;
    unsigned long val = *(unsigned long *)raw_data.mem;
    ct= section_hdr.s_paddr;
    section_length = CORE_ADDR_ADDR(section_hdr.s_vaddr); 
    for (;section_length!=0; section_length--){
      if(write_inferior_memory( ct,(char *)raw_data.mem,
         (int)(section_hdr.s_size*sizeof(long))) != 0)
         return (-1);
      CORE_ADDR_ADDR(ct)+=1;
      }
    }
   else
  if (write_inferior_memory(section_hdr.s_paddr,(char *)raw_data.mem,
     (int)(section_hdr.s_size*sizeof(long))) != 0)
 return (-1);
  }
}
 dsp_wreg(0,0,REG_PC,&CORE_ADDR_ADDR(ao_hdr.entry));
 text_entry_address=ao_hdr.entry;
if (raw_data.mem){
  free(raw_data.mem);
  raw_data.block_size=0;
  raw_data.mem= NULL;
  }
 return 0;
}


set_stack_type(module_stack_type)
unsigned long module_stack_type; /* 1=y,2=x,3=l */
{
module_stack_type&=3;
if (module_stack_type){
  enum memory_map stack_map=
   (module_stack_type==1)?memory_map_y:
   (module_stack_type==2)?memory_map_x: memory_map_l;
    CORE_ADDR_MAP(frame_zero_init)= stack_map;
    CORE_ADDR_MAP(stack_end_addr)= stack_map;
    CORE_ADDR_MAP(stack_zero)= stack_map;
  stmap=(stack_map==memory_map_x)?memory_map_x:memory_map_y;
  /* these sizes need reinitialization based on stack space */
  TYPE_LENGTH(builtin_type_char)=SIZEOF_CHAR;
  TYPE_LENGTH(builtin_type_short)=SIZEOF_SHORT;
  TYPE_LENGTH(builtin_type_addr)=SIZEOF_POINTER;
  TYPE_LENGTH(builtin_type_long)=SIZEOF_LONG;
  TYPE_LENGTH(builtin_type_int)=SIZEOF_INT;
  TYPE_LENGTH(builtin_type_unsigned_char)=SIZEOF_UNSIGNED_CHAR;
  TYPE_LENGTH(builtin_type_unsigned_short)=SIZEOF_UNSIGNED_SHORT;
  TYPE_LENGTH(builtin_type_unsigned_int)=SIZEOF_UNSIGNED_INT;
  TYPE_LENGTH(builtin_type_unsigned_long)=SIZEOF_UNSIGNED_LONG;
  TYPE_LENGTH(builtin_type_float)=SIZEOF_FLT;
  TYPE_LENGTH(builtin_type_double)=SIZEOF_DOUBLE;
  }
}

extern CORE_ADDR startup_file_end;	/* From blockframe.c */

get_printf_stuff(module_stack_type)
unsigned long module_stack_type; /* 1=x,2=y,3=l */
{
    int func_index;
    func_index=lookup_misc_func("__send");

    send_address=(func_index== -1)?0
	:CORE_ADDR_ADDR(misc_function_vector[func_index].address);

    func_index=lookup_misc_func("__receive");
    receive_address=(func_index== -1)?0
	:CORE_ADDR_ADDR(misc_function_vector[func_index].address);

func_index=lookup_misc_func("__printf_end");
 printf_end_address= CORE_ZERO;
if (func_index== -1){
 CORE_ADDR_ADDR( printf_end_address)=0;
 }
else{
 /* stop at this address for printf functions  - x0 will then
    have the address of the string in it for debugging printf.
 */

 CORE_ADDR_ADDR( printf_end_address)=
   CORE_ADDR_ADDR(misc_function_vector[func_index].address);
 }

 func_index=lookup_misc_func("__crt0_end");
 program_exit_address= CORE_ZERO;
if (func_index== -1){
 CORE_ADDR_ADDR( program_exit_address)=ADDR_BITS;
 }
else{
 CORE_ADDR_ADDR( startup_file_end)=
 CORE_ADDR_ADDR( program_exit_address)=
   CORE_ADDR_ADDR(misc_function_vector[func_index].address);
 }

}
#ifndef O_BINARY
#define O_BINARY 0
#endif

void
exec_file_command (filename, from_tty)
     char *filename;
     int from_tty;
{

  /* Eliminate all traces of old exec file.
     Mark text segment as empty.  */

dsp_init(0);
  data_start = CORE_ZERO;
  text_start = CORE_ZERO;
  text_end = CORE_ZERO;
  exec_data_start = CORE_ZERO;
  data_end = CORE_ZERO;
  exec_data_end = CORE_ZERO;
  if (execchan >= 0)
    close (execchan);
  execchan = -1;
  cross_debugging=0;

  /* Now open and digest the file the user requested, if any.  */

  if (filename)
    {
      filename = tilde_expand (filename);
      make_cleanup (free, filename);
      
      if (execfile)
        free (execfile);
      execfile = 0;
      execchan = openp (getenv ("PATH"), 1, filename, O_RDONLY|O_BINARY, 0,
			&execfile);
      if (execchan < 0)
	perror_with_name (filename);
#ifdef COFF_FORMAT
      {
	int aout_hdrsize;
	int num_sections;

	if (read_file_hdr (execchan, &file_hdr) < 0)
	  error ("\"%s\": not in executable format.", execfile);

	aout_hdrsize = file_hdr.f_opthdr;
	num_sections = file_hdr.f_nscns;

	if (read_aout_hdr (execchan, &exec_aouthdr, aout_hdrsize) < 0)
	  error ("\"%s\": can't read optional aouthdr", execfile);

	if (read_section_hdr (execchan, _TEXT, &text_hdr, num_sections,
			      aout_hdrsize) < 0)/* just finds first ".text" section */
	  error ("\"%s\": can't read text section header", execfile);

	if (read_section_hdr (execchan, _DATA, &data_hdr, num_sections,
			      aout_hdrsize) < 0)
	  error ("\"%s\": can't read data section header", execfile);

 if (read_section_contents (execchan) < 0)
   error ("\"%s\": can't read section contents", execfile);

	text_start = exec_aouthdr.text_start;
	text_end = exec_aouthdr.text_end;
 CORE_ADDR_ADDR(text_end)+=CALL_DUMMY_LENGTH;
 {  /* clears out debug area */
    CORE_ADDR ct;
    unsigned long section_length;
    unsigned long val = 0; /* nop instruction */
    ct=exec_aouthdr.text_end;
    section_length = CALL_DUMMY_LENGTH;
    for (;section_length!=0; section_length--){
      write_inferior_memory( ct,(char *)&val, sizeof(long));
      CORE_ADDR_ADDR(ct)+=1;
      }
 }
	text_offset = text_hdr.s_scnptr; /* doesn't appear to be used */
	exec_data_start = exec_aouthdr.data_start;
	exec_data_end = exec_aouthdr.data_end;
	exec_data_offset = data_hdr.s_scnptr;/* doesn't appear to be used */
	data_start = exec_data_start;
	data_end = exec_data_start;
	exec_mtime = file_hdr.f_timdat;
      }
#endif /* COFF_FORMAT */

      validate_files ();
    }
  else{
      if (execfile)
           free (execfile);
      execfile = 0;
    if (from_tty)
      printf ("No exec file now.\n");
    }

  /* Tell display code (if any) about the changed file name.  */
  if (exec_file_display_hook)
    (*exec_file_display_hook) (filename);
  cross_debugging=1;
}

CORE_ADDR get_pc_function_start ();

/* for functions which do not update r0 (the fp), the old frame pointer
   location will need to be figured off the r6 value passed in thisframe->frame,
   otherwise the r0 value is passed in thisframe->fp, and this function will
   need to just back up one or two locations from the r0 value.
   */

static
CORE_ADDR
old_fp_location(thisframe)
FRAME thisframe; /* current fp value (stored in r0) */
{
    CORE_ADDR core_temp,pc_temp;
    int offset,nofp;
    unsigned long nextinsn,fp,pc,oldsp;
    
    if (CORE_ADDR_ADDR(thisframe->ofp))
	return (thisframe->ofp);
    core_temp=(thisframe)->frame;
    
    pc_temp = get_pc_function_start (thisframe->pc); 
    pc=CORE_ADDR_ADDR(pc_temp);
    dsp_rmem(0,memory_map_p,pc,&nextinsn);
    if ((nextinsn&0xffffbf)==0x55e3cl){ /* move ssh,x/y:(r6)+ */
	offset=1; /* well, this is where it should have been */
	nofp=1;
	pc++;
	dsp_rmem(0,memory_map_p,pc,&nextinsn);
	}
    else if ((nextinsn&0xf7ffffl)==0x605e00l){ /* move r0,y/x:(r6)+ */
	offset=1;
	pc++;
	dsp_rmem(0,memory_map_p,pc,&nextinsn);
	if ((nextinsn&0xffffbf)==0x55e3cl){ /* move ssh,x/y:(r6)+ */
	    pc++;
	    dsp_rmem(0,memory_map_p,pc,&nextinsn);
	    offset++;
	    }
	if ((nextinsn==0x0045e10l)||  /* lua (r6)+,r0 */
	    (nextinsn==0x205e00l)){ /* move (r6)+ */
	    offset++;
	    nofp=0;
	    }
	else if ((nextinsn==0x22d000l)|| /* move r6,r0 */
		 (nextinsn==0x76f400l)|| /* move #>xxxx,n6 */
		 ((nextinsn&0xff00ff)==0x3e0000l)){ /* move #<XXXX,n6 */
	    nofp=0;
	    }
	else nofp=1;
	}
    else{
	offset=0;
	nofp=1;
	}

    if (nofp){ /* well, we'll have to figure out what the fp should have been */
	while ( /* stack pointer was incremented for register stores */
	  (nextinsn&0xc0ff00l)==0x405e00l){ /* move 0DDDDDD,x/y:(r6)+ or move LLL,L:(r6)+ */
	    offset++;
	    pc++;
	    dsp_rmem(0,memory_map_p,pc,&nextinsn);
	    }

	/* If it just returned from a jsr, the stack will be larger from args */
	pc=CORE_ADDR_ADDR(thisframe->pc);
	dsp_rmem(0,memory_map_p,pc,&nextinsn);
	while (nextinsn==0x205600l){ /* move (r6)- cleaning up args */
	    offset++; 
	    pc++;
	    dsp_rmem(0,memory_map_p,pc,&nextinsn);
	    /* check for epilog move x/y:(r6)-,0DDDDDD, or move L:(r6)-,LLL */
	    /* or move x/y:(r6),0DDDDDD, or move L:(r6),LLL */
	    if ((nextinsn&0xc0cf00l)==0x40c600l) 
		offset--;

	    }
	/* now get the current sp value and adjust it by subtracting offset */
	if (thisframe->next)
	    core_temp=thisframe->next->ofp;
	else 
	    CORE_ADDR_ADDR(core_temp)=hspr[REG_R6];
	}

    if (CORE_ADDR_MAP(core_temp)==memory_map_l)
	CORE_ADDR_MAP(core_temp)= memory_map_y;
    CORE_ADDR_ADDR(core_temp)-=offset; /* address of old fp */

    thisframe->ofp=core_temp;
    return(core_temp);
    }

/*
 * Find the pc saved in frame FRAME if it is indeed saved by move ssh,x:(r6)+ 
 * as part of the preamble - it may be a leaf function,though - in which case
 * it is still in the hardware stack.
 */


CORE_ADDR
frame_saved_pc (frame)
     FRAME frame;
{
  CORE_ADDR retv;
  CORE_ADDR core_temp;
  CORE_ADDR pc_temp;
  unsigned long nextinsn,pc;
  int leaf,offset;
  pc_temp=get_pc_function_start (frame->pc);
  pc= CORE_ADDR_ADDR(pc_temp);

  dsp_rmem(0,memory_map_p,pc,&nextinsn);
  if ((nextinsn&0xf7ffffl)==0x605e00l){ /* move r0,y/x:(r6)+ */
      pc++;
      offset=1;
      dsp_rmem(0,memory_map_p,pc,&nextinsn);
      }
  else offset=0; /* fp not saved on stack, so pc will be at 0 offset from pseudo fp */
  leaf=((nextinsn&0xffffbf)==0x55e3cl)?0:1;/* move ssh,x/y:(r6)+ */
  CORE_ADDR_MAP(retv)=memory_map_p;
  if (leaf){ /* leaf function */
      CORE_ADDR_ADDR(retv)=saved_pc_after_call();
      }
  else{ /* pc saved on stack */
      core_temp=old_fp_location(frame);
      CORE_ADDR_ADDR(core_temp)+=offset;
      CORE_ADDR_ADDR(retv)=read_memory_integer(core_temp,4);
      }
  return (retv);
}

CORE_ADDR
frame_locals_address (fi)
  struct frame_info *fi;
{
  /* fix up frame pointer to adjust for arg offsets */
  /* this currently works assuming the frame pointer value */
  /* has been predecremented to point to  the old fp position */
  /* it assumes that the symbol offsets will be supplied based 
     on the true fp which is two beyond that.
  */
  CORE_ADDR retv;
  retv=fi->frame;
  return (retv);
}
CORE_ADDR
frame_struct_args_address (fi)
  struct frame_info *fi;
{
  /* fix up frame pointer to adjust for arg offsets */
  /* this currently works assuming the frame pointer value */
  /* has been predecremented to point to  the old fp position */
  /* it assumes that the symbol offsets will be supplied based 
     on the true fp which is two beyond that.
  */
  CORE_ADDR retv;
  retv=fi->frame;
  return (retv);
}
frame_args_skip()
{
return (0);
}

CORE_ADDR
frame_args_address (fi)
  struct frame_info *fi;
{
  /* fix up frame pointer to adjust for arg offsets */
  /* this currently works assuming the frame pointer value */
  /* has been predecremented to point to  the old fp position */
  /* it assumes that the symbol offsets will be supplied based 
     on the true fp which is two beyond that.
  */
  CORE_ADDR retv;
  retv=fi->frame;
  return (retv);
}

struct command_line *get_breakpoint_commands ();

/*
 * This routine should be more specific in it's actions; making sure
 * that it uses the same register in the initial prologue section.
 */
CORE_ADDR 
skip_prologue (pc)
     CORE_ADDR pc;
{
    int offset;
    unsigned long pc_temp;
    unsigned long nextinsn;
    pc_temp=CORE_ADDR_ADDR(pc);
    dsp_rmem(0,memory_map_p,pc_temp,&nextinsn);
    if ((nextinsn&0xffffbf)==0x55e3cl) /* move ssh,x/y:(r6)+ */
	offset=1;
    else if ((nextinsn&0xf7ffffl)==0x605e00l){ /* move r0,y/x:(r6)+ */
	pc_temp++;
	offset=1;
	dsp_rmem(0,memory_map_p,pc_temp,&nextinsn);
	
	if (nextinsn==0x0045e10l)  /* lua (r6)+,r0 */
	    offset++;
	else{
	    if ((nextinsn==0x205e00l)|| /* move (r6)+ */
		((nextinsn&0xffffbf)==0x55e3cl)){ /* move ssh,x/y:(r6)+ */
		offset++;
		pc_temp++;
		dsp_rmem(0,memory_map_p,pc_temp,&nextinsn);
		}
	    if (nextinsn==0x76f400l){ /* move #>xxxx,n6 */
		offset+=4; /* skip move to n,move r6,r0,move (r6)+n6 */
		}
	    else if ((nextinsn&0xff00ff)==0x3e0000l){ /* move #<XXXX,n6 */
		offset+=3; /* skip move to n, move r6,r0, move (r6)+n6 */
		}
	    else{
		if (nextinsn==0x22d000l){ /* move r6,r0 */
		    offset++;
		    pc_temp++;
		    dsp_rmem(0,memory_map_p,pc_temp,&nextinsn);
		    }
		if (nextinsn==0x205e00l){ /* move (r6)+ */
		    offset++;
		    }
		}
	    }
	}
    else offset=0;

    CORE_ADDR_ADDR(pc)+=offset;

    return (pc);
}


unsigned long
saved_pc_after_call()
{
    unsigned long ssh,pc,ni,oldsp,tsp;
    dsp_rreg(0,0,REG_SP,&oldsp);
    tsp=oldsp;
    
    /* get the last address on the stack that was from a jsr */
    while (tsp>1){ /* check for do instruction in the code */
	dsp_rreg(0,0,REG_SSH,&pc); /* get last pushed address */
	pc-=2;
	dsp_rmem(0,memory_map_p,pc,&ni);
	
	if ((ni&0xff0020l)==0x60000l){ /* DO instruction */
	    tsp-=2; /* two locations on stack for each do loop nest */
	    }
	else break;
	}
    
    if (tsp!=oldsp)
	dsp_wreg(0,0,REG_SP,&tsp);
    
    dsp_rreg(0,0,REG_SSH,&ssh);
    
    if (tsp!=oldsp)
	dsp_wreg(0,0,REG_SP,&oldsp);
    
    return ssh;
}


/*Store the address of the place in which to copy the structure the
subroutine will return.  This is called from call_function. */

store_struct_return(addr,sp)
CORE_ADDR addr;
CORE_ADDR sp;
{
 write_register (A1_REGNUM, CORE_ADDR_ADDR(addr));
}

store_return_value(data_type,valbuf)
struct type *data_type;
char *valbuf;
{ 
  LONGEST lbuf;
  int regno;

    if (TYPE_CODE (data_type) == TYPE_CODE_FLT){
      /* Floating-point values are returned in the register pair */
      /* formed by a1:a0 */
      lbuf= double_to_kp( *(double *) valbuf);
      write_register_bytes (REGISTER_BYTE (A10_REGNUM), (char *)&lbuf,
             TYPE_LENGTH (data_type),A10_REGNUM); 
      }
    else {
      /* Other values are returned in register a1 for int or a10 for 
         longs.  */ 
      regno=(TYPE_DATA_LENGTH (data_type)==DSIZEOF_LONG)?A10_REGNUM:A1_REGNUM;
      write_register_bytes (
         REGISTER_BYTE (regno), valbuf, TYPE_DATA_LENGTH (data_type),regno);  
       }
}

/*
  Given a value for the current fp, return the previous fp value.
  Sometimes it will not be there (frameless functions), but the
  other functions take care of this by keeping the old frame
  pointer location in thisframe->ofp - where it should have been
  even if it wasn't pushed.  The other functions use that value
  rather than the fp to backtrace.
*/


unsigned long
frame_chain(thisframe)
FRAME thisframe;
{
    unsigned long nextinsn;
    CORE_ADDR core_temp,pc_temp;
    unsigned long pc;

    pc_temp = get_pc_function_start (thisframe->pc); 
    pc=CORE_ADDR_ADDR(pc_temp);
    dsp_rmem(0,memory_map_p,pc,&nextinsn);
    core_temp=old_fp_location(thisframe);

    if ((nextinsn&0xf7ffffl)==0x605e00l){ /* move r0,y/x:(r6)+ */
	/* lucky for us, the old frame ptr was actually pushed on the stack */
	dsp_rmem(0,CORE_ADDR_MAP(core_temp),CORE_ADDR_ADDR(core_temp),&nextinsn);
	}
    else nextinsn=hspr[REG_R0]; /* alas, r0 (the fp) wasn't pushed */

    return  ( nextinsn);

}

int
frame_chain_valid(chain,thisframe)
CORE_ADDR chain;
FRAME thisframe;
{
    int rv;
    unsigned long spc,epc;
    spc=CORE_ADDR_ADDR((FRAME_SAVED_PC (thisframe)));
    epc=CORE_ADDR_ADDR(program_exit_address);
    
    rv=(spc&&(spc!=epc)&&(spc!=epc-1)&&(spc!=epc-2))?1:0;
    return (rv);
}

/* Extract from an array REGBUF containing the (raw) register state
   the address in which a function should return its structure value,
   as a CORE_ADDR (or an expression that can be used as one).  
   The address is held in register a1 and should point to ymem */

CORE_ADDR
extract_struct_value_address(regbuf)
char regbuf[REGISTER_BYTES];
{
  CORE_ADDR core_temp; 
  core_temp=FRAME_ZERO; /* initialize for stack memory */
  CORE_ADDR_ADDR(core_temp)= 
   *(long *)&regbuf[REGISTER_BYTE (A1_REGNUM)]; /* A1 position */
  return (core_temp);
}

struct reg_var_xref reg_var_xref[]={
{A1_REGNUM,A10_REGNUM},
{B1_REGNUM,B10_REGNUM},
{X0_REGNUM,X10_REGNUM},
{X1_REGNUM,X10_REGNUM},
{Y0_REGNUM,Y10_REGNUM},
{Y1_REGNUM,Y10_REGNUM},
{R0_REGNUM,R0_REGNUM},
{R1_REGNUM,R1_REGNUM},
{R2_REGNUM,R2_REGNUM},
{R3_REGNUM,R3_REGNUM},
{R4_REGNUM,R4_REGNUM},
{R5_REGNUM,R5_REGNUM},
{R6_REGNUM,R6_REGNUM},
{R7_REGNUM,R7_REGNUM}
};

static int lllx_reg[]={
A1_REGNUM,B1_REGNUM,X1_REGNUM,Y1_REGNUM,A1_REGNUM,B1_REGNUM,A1_REGNUM,B1_REGNUM};
static int llly_reg[]={
A0_REGNUM,B0_REGNUM,X0_REGNUM,Y0_REGNUM,A0_REGNUM,B0_REGNUM,B1_REGNUM,A1_REGNUM};

int
frame_find_saved_registers(fip,fsrp)
 struct frame_info *fip;
 struct frame_saved_regs *fsrp;
{
  register CORE_ADDR next_addr;
  unsigned long spill_offset;
   CORE_ADDR pc;
  unsigned long nextinsn,tni;
  int fpyes,pcyes;
  unsigned long pc_temp;
  int reg_index,reg_field;

  bzero (fsrp, sizeof *fsrp);
  spill_offset=0;
  if (CORE_ADDR_ADDR(fip->pc) >= (CORE_ADDR_ADDR(text_end) - 
      CALL_DUMMY_LENGTH))  /* dummy frame */
    { 
      next_addr = fip->frame;             
      pc = fip->pc;
      fsrp->regs[A0_REGNUM]= next_addr;
      CORE_ADDR_ADDR(next_addr)+=1;
      fsrp->regs[A1_REGNUM]= next_addr;
      CORE_ADDR_ADDR(next_addr)+=1;
      fsrp->regs[A2_REGNUM]= next_addr;
      CORE_ADDR_ADDR(next_addr)+=1;
      fsrp->regs[B0_REGNUM]= next_addr;
      CORE_ADDR_ADDR(next_addr)+=1;
      fsrp->regs[B1_REGNUM]= next_addr;
      CORE_ADDR_ADDR(next_addr)+=1;
      fsrp->regs[B2_REGNUM]= next_addr;
      CORE_ADDR_ADDR(next_addr)+=1;
      fsrp->regs[X0_REGNUM]= next_addr;
      CORE_ADDR_ADDR(next_addr)+=1;
      fsrp->regs[X1_REGNUM]= next_addr;
      CORE_ADDR_ADDR(next_addr)+=1;
      fsrp->regs[Y0_REGNUM]= next_addr;
      CORE_ADDR_ADDR(next_addr)+=1;
      fsrp->regs[Y1_REGNUM]= next_addr;
      CORE_ADDR_ADDR(next_addr)+=1;
      fsrp->regs[R1_REGNUM]= next_addr;
      CORE_ADDR_ADDR(next_addr)+=1;
      fsrp->regs[R2_REGNUM]= next_addr;
      CORE_ADDR_ADDR(next_addr)+=1;
      fsrp->regs[R3_REGNUM]= next_addr;
      CORE_ADDR_ADDR(next_addr)+=1;
      fsrp->regs[R4_REGNUM]= next_addr;
      CORE_ADDR_ADDR(next_addr)+=1;
      fsrp->regs[R5_REGNUM]= next_addr;
      CORE_ADDR_ADDR(next_addr)+=1;
      fsrp->regs[R7_REGNUM]= next_addr;
      CORE_ADDR_ADDR(next_addr)+=1;
      fsrp->regs[N0_REGNUM]= next_addr;
      CORE_ADDR_ADDR(next_addr)+=1;
      fsrp->regs[N1_REGNUM]= next_addr;
      CORE_ADDR_ADDR(next_addr)+=1;
      fsrp->regs[N2_REGNUM]= next_addr;
      CORE_ADDR_ADDR(next_addr)+=1;
      fsrp->regs[N3_REGNUM]= next_addr;
      CORE_ADDR_ADDR(next_addr)+=1;
      fsrp->regs[N4_REGNUM]= next_addr;
      CORE_ADDR_ADDR(next_addr)+=1;
      fsrp->regs[N5_REGNUM]= next_addr;
      CORE_ADDR_ADDR(next_addr)+=1;
      fsrp->regs[N6_REGNUM]= next_addr;
      CORE_ADDR_ADDR(next_addr)+=1;
      fsrp->regs[N7_REGNUM]= next_addr;
      CORE_ADDR_ADDR(next_addr)+=1;
      fsrp->regs[PS_REGNUM]= next_addr;

      fsrp->regs[FP_REGNUM] = fip->frame; 
      CORE_ADDR_ADDR(fsrp->regs[FP_REGNUM])-=2;
      fsrp->regs[PC_REGNUM] = fip->frame;  
      CORE_ADDR_ADDR(fsrp->regs[PC_REGNUM])-=1;
    }
  else                           
    { 
   /* for real function calls, the code at the start of the function is one of
      several prologs defined in prolog.doc.
      */
      fpyes=pcyes=0;
      pc = get_pc_function_start (fip->pc); 
      pc_temp=CORE_ADDR_ADDR(pc);
      dsp_rmem(0,memory_map_p,pc_temp,&nextinsn);
      if ((nextinsn&0xf7ffffl)==0x605e00l){ /* move r0,y/x:(r6)+ */
	  pc_temp++;
	  dsp_rmem(0,memory_map_p,pc_temp,&nextinsn);

	  if (nextinsn==0x0045e10l){  /* lua (r6)+,r0 */
	      fpyes=1; /* old frame pointer is at r0-1 */
	      pc_temp++;
	      dsp_rmem(0,memory_map_p,pc_temp,&nextinsn);
	    }
	  else{
	      if (nextinsn==0x205e00l){ /* move (r6)+ */
		  fpyes=2; /* old fp will be at r0-2 */
		  pc_temp++;
		  dsp_rmem(0,memory_map_p,pc_temp,&nextinsn);
		  }
	      else if ((nextinsn&0xffffbf)==0x55e3cl){ /* move ssh,x/y:(r6)+ */
		  fpyes=2; /* old fp will be at r0-2 */
		  pcyes=1; /* old pc will be at r0-1 */
		  pc_temp++;
		  dsp_rmem(0,memory_map_p,pc_temp,&nextinsn);
		  }
	      else fpyes=1; /* old fp will be at r0-1 */

	      if (nextinsn==0x76f400l){ /* move #>xxxx,n6;move r6,r0;move(r6)+n6 */
		  pc_temp++;
		  dsp_rmem(0,memory_map_p,pc_temp,&spill_offset);
		  pc_temp+=3;
		  dsp_rmem(0,memory_map_p,pc_temp,&nextinsn);
		  }
	      else if ((nextinsn&0xff00ff)==0x3e0000l){ /* move #<XXXX,n6;move r6,r0;move (r6)+n6 */
		  spill_offset= ((nextinsn &0xff00l)>>8);
		  pc_temp+=3;
		  dsp_rmem(0,memory_map_p,pc_temp,&nextinsn);
		}
	      else if (nextinsn==0x22d000l){ /* move r6,r0 */
		    pc_temp++;
		    dsp_rmem(0,memory_map_p,pc_temp,&nextinsn);
		    if (nextinsn==0x205e00l){ /* move (r6)+ */
			spill_offset=1;
			pc_temp++;
			dsp_rmem(0,memory_map_p,pc_temp,&nextinsn);
			}
		    }
	      }
	  }
      else if ((nextinsn&0xffffbf)==0x55e3cl){ /* move ssh,x/y:(r6)+ */
	  pcyes=1; /* old pc will be at r0-1 */
	  pc_temp++;
	  dsp_rmem(0,memory_map_p,pc_temp,&nextinsn);
	  }


      next_addr = fip->frame ;
      /* start of register spill space */
      CORE_ADDR_ADDR(next_addr)+= spill_offset; 

      /* decode following instructions for move regname,y:(r6)+ 
	 which saves registers in spill space on stack */
      for(;;){
	  CORE_ADDR_MAP(next_addr)=(nextinsn&0x80000l)?memory_map_y:memory_map_x;
	  tni=nextinsn;
	  nextinsn&=0xf7ff00l;
	  if (nextinsn==0x515e00l)
	      fsrp->regs[B0_REGNUM]= next_addr;
	  else if (nextinsn==0x555e00l)
	      fsrp->regs[B1_REGNUM]= next_addr;
	  else if (nextinsn==0x445e00l)
	      fsrp->regs[X0_REGNUM]= next_addr;
	  else if (nextinsn==0x455e00l)
	      fsrp->regs[X1_REGNUM]= next_addr;
	  else if (nextinsn==0x465e00l)
	      fsrp->regs[Y0_REGNUM]= next_addr;
	  else if (nextinsn==0x475e00l)
	      fsrp->regs[Y1_REGNUM]= next_addr;
	  else if (nextinsn==0x615e00l)
	      fsrp->regs[R1_REGNUM]= next_addr;
	  else if (nextinsn==0x625e00l)
	      fsrp->regs[R2_REGNUM]= next_addr;
	  else if (nextinsn==0x635e00l)
	      fsrp->regs[R3_REGNUM]= next_addr;
	  else if (nextinsn==0x645e00l)
	      fsrp->regs[R4_REGNUM]= next_addr;
	  else if (nextinsn==0x655e00l)
	      fsrp->regs[R5_REGNUM]= next_addr;
	  else if (nextinsn==0x675e00l)
	      fsrp->regs[R7_REGNUM]= next_addr;
	  else if ((tni&0xf4ff00l)==0x405e00l){ /*move LLL,L:(r6)+ */
	      reg_field=(tni>>16)&0x3;
	      if (tni&0x80000l)
		  reg_field+=4;
	      CORE_ADDR_MAP(next_addr)=memory_map_x;
	      reg_index=lllx_reg[reg_field];
	      fsrp->regs[reg_index]= next_addr;
	      CORE_ADDR_MAP(next_addr)=memory_map_y;
	      reg_index=llly_reg[reg_field];
	      fsrp->regs[reg_index]= next_addr;
	      }
	  else break; /* end of the instructions which save registers */
	  
	  CORE_ADDR_ADDR(next_addr)+=1;
	  pc_temp++;
	  dsp_rmem(0,memory_map_p,pc_temp,&nextinsn);
	  }
      if (fpyes){
	  fsrp->regs[FP_REGNUM] = fip->frame; 
	  CORE_ADDR_ADDR(fsrp->regs[FP_REGNUM])-=fpyes;
	  }
      if (pcyes){
	  fsrp->regs[PC_REGNUM] = fip->frame;  
	  CORE_ADDR_ADDR(fsrp->regs[PC_REGNUM])-=1;
	  }
    }
}

/* Things needed for making the inferior call functions.  */
 /*
 *   PUSH_DUMMY_FRAME saves the registers above sp' and pushes the
 * register file stack down one.
 *
 *   call_function then writes CALL_DUMMY, pushes the args onto the
 * stack, and adjusts the stack pointer.
 *
 *   run_stack_dummy then starts execution (in the middle of
 * CALL_DUMMY, as directed by call_function).
 */

/* Push an empty stack frame, to record the current PC, etc.  */
CORE_ADDR push_word (),read_register();
 
push_dummy_frame()
{
  CORE_ADDR sp;
 sp = read_register (SP_REGNUM);
  sp = push_word (sp, CORE_ADDR_ADDR(read_register (FP_REGNUM)));
  sp = push_word (sp, CORE_ADDR_ADDR(read_register (PC_REGNUM))); 
  write_register (FP_REGNUM, CORE_ADDR_ADDR(sp));
  sp = push_word (sp, CORE_ADDR_ADDR(read_register (A0_REGNUM))); 
  sp = push_word (sp, CORE_ADDR_ADDR(read_register (A1_REGNUM))); 
  sp = push_word (sp, CORE_ADDR_ADDR(read_register (A2_REGNUM))); 
  sp = push_word (sp, CORE_ADDR_ADDR(read_register (B0_REGNUM))); 
  sp = push_word (sp, CORE_ADDR_ADDR(read_register (B1_REGNUM))); 
  sp = push_word (sp, CORE_ADDR_ADDR(read_register (B2_REGNUM))); 
  sp = push_word (sp, CORE_ADDR_ADDR(read_register (X0_REGNUM))); 
  sp = push_word (sp, CORE_ADDR_ADDR(read_register (X1_REGNUM))); 
  sp = push_word (sp, CORE_ADDR_ADDR(read_register (Y0_REGNUM))); 
  sp = push_word (sp, CORE_ADDR_ADDR(read_register (Y1_REGNUM))); 
  sp = push_word (sp, CORE_ADDR_ADDR(read_register (R1_REGNUM))); 
  sp = push_word (sp, CORE_ADDR_ADDR(read_register (R2_REGNUM))); 
  sp = push_word (sp, CORE_ADDR_ADDR(read_register (R3_REGNUM))); 
  sp = push_word (sp, CORE_ADDR_ADDR(read_register (R4_REGNUM))); 
  sp = push_word (sp, CORE_ADDR_ADDR(read_register (R5_REGNUM))); 
  sp = push_word (sp, CORE_ADDR_ADDR(read_register (R7_REGNUM))); 
  sp = push_word (sp, CORE_ADDR_ADDR(read_register (N0_REGNUM))); 
  sp = push_word (sp, CORE_ADDR_ADDR(read_register (N1_REGNUM))); 
  sp = push_word (sp, CORE_ADDR_ADDR(read_register (N2_REGNUM))); 
  sp = push_word (sp, CORE_ADDR_ADDR(read_register (N3_REGNUM))); 
  sp = push_word (sp, CORE_ADDR_ADDR(read_register (N4_REGNUM))); 
  sp = push_word (sp, CORE_ADDR_ADDR(read_register (N5_REGNUM))); 
  sp = push_word (sp, CORE_ADDR_ADDR(read_register (N6_REGNUM))); 
  sp = push_word (sp, CORE_ADDR_ADDR(read_register (N7_REGNUM))); 
  sp = push_word (sp, CORE_ADDR_ADDR(read_register (PS_REGNUM))); 
  write_register (SP_REGNUM, CORE_ADDR_ADDR(sp)); 
}

/* Discard from the stack the innermost frame,
   restoring all saved registers.  */

pop_frame()
{
 FRAME frame = get_current_frame (); 
   CORE_ADDR fp; 
   int regnum;
  struct frame_saved_regs fsr; 
  struct frame_info *fi;
  fi = get_frame_info (frame); 
  fp = fi->frame; 
  get_frame_saved_regs (fi, &fsr); 
  for (regnum = 0; regnum< NUM_REGS ;regnum++){
    if (regnum!=FP_REGNUM&&regnum!=PC_REGNUM&&regnum!=SP_REGNUM){
    if (CORE_ADDR_ADDR(fsr.regs[regnum])) 
      write_register (regnum, read_memory_integer (fsr.regs[regnum], 4));
    }
   }
  CORE_ADDR_ADDR(fp)--;
  write_register (PC_REGNUM, read_memory_integer (fp, 4));
  CORE_ADDR_ADDR(fp)--;
  write_register (FP_REGNUM, read_memory_integer (fp, 4));
  /*  CORE_ADDR_ADDR(fp)--;*/
  write_register (SP_REGNUM, CORE_ADDR_ADDR(fp) );
  flush_cached_frames ();
  set_current_frame (create_new_frame (read_register (FP_REGNUM),
               read_pc ()));
}

value
value_xmem (arg1)
     register value arg1;
{
  COERCE_ENUM (arg1);
  CORE_ADDR_ADDR(VALUE_ADDRESS(arg1))= *(unsigned long *)VALUE_CONTENTS(arg1);
  CORE_ADDR_MAP(VALUE_ADDRESS(arg1))=memory_map_x;
  return (arg1);
}
value
value_ymem (arg1)
     register value arg1;
{
  COERCE_ENUM (arg1);
  CORE_ADDR_ADDR(VALUE_ADDRESS(arg1))= *(unsigned long *)VALUE_CONTENTS(arg1);
  CORE_ADDR_MAP(VALUE_ADDRESS(arg1))=memory_map_y;
  return (arg1);
}
value
value_pmem (arg1)
     register value arg1;
{
  COERCE_ENUM (arg1);
  CORE_ADDR_ADDR(VALUE_ADDRESS(arg1))= *(unsigned long *)VALUE_CONTENTS(arg1);
  CORE_ADDR_MAP(VALUE_ADDRESS(arg1))=memory_map_p;
  return (arg1);
}
value
value_lmem (arg1)
     register value arg1;
{
  COERCE_ENUM (arg1);
  CORE_ADDR_ADDR(VALUE_ADDRESS(arg1))= *(unsigned long *)VALUE_CONTENTS(arg1);
  CORE_ADDR_MAP(VALUE_ADDRESS(arg1))=memory_map_l;
  return (arg1);
}
/* for right now these don't do whole thing */
LONGEST
add_longest(v1,v2)
  LONGEST v1,v2;
{
 v1.w0.l &= WORD_BITS;
 v2.w0.l &= WORD_BITS;
 v1.w0.l += v2.w0.l;
 v1.w1.l += v2.w1.l;
 if (v1.w0.l & ~WORD_BITS){
    v1.w1.l += 1;
    }
 v1.w0.l &= WORD_BITS;
 v1.w1.l &= WORD_BITS;
 return v1;
}

LONGEST
sub_longest(v1,v2)
  LONGEST v1,v2;
{
 v1=ADD_LONGEST(v1,NEG_LONGEST(v2));
 return v1;
}

LONGEST
mul_longest(v1,v2)
  LONGEST v1,v2;
{
 long s1,s2,sresult;
 double d1,d2,dresult;
 s1 = v1.w1.l&SIGN_TEST_BIT;
 s2 = v2.w1.l&SIGN_TEST_BIT;
 sresult = s1^s2;
 if (s1) v1 = NEG_LONGEST(v1);
 if (s2) v2 = NEG_LONGEST(v2);
 d1 = (((double)(v1.w1.u&WORD_BITS))*((double)(WORD_BITS+1)))+
      ((double)(v1.w0.u&WORD_BITS));
 d2 = (((double)(v2.w1.u&WORD_BITS))*((double)(WORD_BITS+1)))+
      ((double)(v2.w0.u&WORD_BITS));
 dresult = d1*d2; /* unsigned multiply */
 v1.w1.u = dresult/((double)(WORD_BITS+1));
 v1.w0.u = dresult - (((double)v1.w1.u)*((double)(WORD_BITS+1)));
 v1.w1.u &= WORD_BITS;
 v1.w0.u &= WORD_BITS;
 if (sresult) v1 = NEG_LONGEST(v1); 
 return v1;
}

LONGEST
div_longest(v1,v2)
  LONGEST v1,v2;
{
 long s1,s2,sresult;
 double d1,d2,dresult;
 s1 = v1.w1.l&SIGN_TEST_BIT;
 s2 = v2.w1.l&SIGN_TEST_BIT;
 sresult = s1^s2;
 if (s1) v1 = NEG_LONGEST(v1);
 if (s2) v2 = NEG_LONGEST(v2);
 d1 = (((double)(v1.w1.u&WORD_BITS))*((double)(WORD_BITS+1)))+
      ((double)(v1.w0.u&WORD_BITS));
 d2 = (((double)(v2.w1.u&WORD_BITS))*((double)(WORD_BITS+1)))+
      ((double)(v2.w0.u&WORD_BITS));
 dresult = d1/d2; /* unsigned multiply */
 v1.w1.u = dresult/((double)(WORD_BITS+1));
 v1.w0.u = dresult - (((double)v1.w1.u)*((double)(WORD_BITS+1)));
 v1.w1.u &= WORD_BITS;
 v1.w0.u &= WORD_BITS;
 if (sresult) v1 = NEG_LONGEST(v1); 
 return v1;
}

LONGEST
rem_longest(v1,v2)
  LONGEST v1,v2;
{
 LONGEST vr;
 long s1,s2,sresult;
 double d1,d2,dresult;
 s1 = v1.w1.l&SIGN_TEST_BIT;
 s2 = v2.w1.l&SIGN_TEST_BIT;
 sresult = s1^s2;
 if (s1) v1 = NEG_LONGEST(v1);
 if (s2) v2 = NEG_LONGEST(v2);
 d1 = (((double)(v1.w1.u&WORD_BITS))*((double)(WORD_BITS+1)))+
      ((double)(v1.w0.u&WORD_BITS));
 d2 = (((double)(v2.w1.u&WORD_BITS))*((double)(WORD_BITS+1)))+
      ((double)(v2.w0.u&WORD_BITS));
 dresult = d1/d2; /* unsigned multiply */
 vr.w1.u = dresult/((double)(WORD_BITS+1));
 vr.w0.u = dresult - (((double)vr.w1.u)*((double)(WORD_BITS+1)));
 vr.w1.u &= WORD_BITS;
 vr.w0.u &= WORD_BITS;
 vr = MUL_UNSIGNED_LONGEST(vr,v2);
 vr = SUB_UNSIGNED_LONGEST(v1,vr);
 if (sresult) vr = NEG_LONGEST(vr); 
 return vr;   
}
 
static LONGEST
longest_minus_1;
#define MAX_WORD_BITS ((sizeof(long)+sizeof(long))*8)

LONGEST
lsh_longest(v1,v2)
  LONGEST v1,v2;
{
 int shiftcount=0;
 v2.w0.l &= WORD_BITS;
 while ((v2.w0.l||v2.w1.l)&&(shiftcount++ <MAX_WORD_BITS)){
   v2=ADD_LONGEST(v2,longest_minus_1);
   v1.w1.l <<=1;
   if (v1.w0.l & SIGN_TEST_BIT) 
      v1.w1.l |= 1;
   v1.w0.l <<=1;
   }
 v1.w0.l &= WORD_BITS;
 v1.w1.l &= WORD_BITS;
 return v1;
}

LONGEST
rsh_longest(v1,v2)
  LONGEST v1,v2;
{
 int shiftcount=0;
 v2.w0.l &= WORD_BITS;
 v2.w1.l &= WORD_BITS;
 v1.w0.l &= WORD_BITS;
 v1.w1.l &= WORD_BITS;
 if (v1.w1.l&SIGN_TEST_BIT)
   v1.w1.l |= ~WORD_BITS;
 else v1.w1.l &= WORD_BITS; /* sign extend v1 */
 while ((v2.w0.l||v2.w1.l)&&(shiftcount++ <MAX_WORD_BITS)){
   v2=ADD_LONGEST(v2,longest_minus_1);
   v1.w0.l >>=1;
   if (v1.w1.l & 1)
      v1.w0.l |= SIGN_TEST_BIT;
   v1.w1.l >>=1;
   }
 v1.w1.l &= WORD_BITS; 
 return v1;
}

LONGEST
logand_longest(v1,v2)
  LONGEST v1,v2;
{
 v1.w0.l &= v2.w0.l;
 v1.w1.l &= v2.w1.l;
 return v1;
}
  
LONGEST
logior_longest(v1,v2) 
  LONGEST v1,v2; 
{ 
 v1.w0.l |= v2.w0.l; 
 v1.w1.l |= v2.w1.l;
 return v1; 
}
 
LONGEST
logxor_longest(v1,v2) 
  LONGEST v1,v2; 
{ 
 v1.w0.l ^= v2.w0.l; 
 v1.w1.l ^= v2.w1.l; 
 return v1; 
}

LONGEST
and_longest(v1,v2) 
  LONGEST v1,v2; 
{ 
 v1.w0.l = ((v1.w0.l||v1.w1.l) && (v2.w0.l||v2.w1.l))?1:0; 
 v1.w1.l =  0;
 return v1; 
}

LONGEST
or_longest(v1,v2) 
  LONGEST v1,v2; 
{ 
 v1.w0.l = (v1.w0.l || v2.w0.l || v1.w1.l || v2.w1.l )?1:0; 
 v1.w1.l = 0;
 return v1; 
}

LONGEST 
min_longest(v1,v2)  
  LONGEST v1,v2; 
{  
 /* returns (v1<v2)? v1:v2 */
  LONGEST vt;
 long s1,s2,sresult;
 s1 = v1.w1.l&SIGN_TEST_BIT;
 s2 = v2.w1.l&SIGN_TEST_BIT;
 if(s1^s2){ /* different signs */
   if (s2) /* and v2 is negative */
      v1 = v2; /* so v2 is smaller */
   }
 else{ /* same sign operands */
   vt = SUB_LONGEST(v1,v2);
   sresult = vt.w1.l & SIGN_TEST_BIT;
   if (!sresult)
         v1 = v2; /* v2 <= v1 */
   }
 
 return v1;  
}

LONGEST  
max_longest(v1,v2)   
  LONGEST v1,v2;  
{   
 LONGEST vt;
 long s1,s2,sresult;
 s1 = v1.w1.l&SIGN_TEST_BIT;
 s2 = v2.w1.l&SIGN_TEST_BIT;
 if(s1^s2){ /* different signs */
   if (s1) /* and v1 is negative */
      v1 = v2; /* so v2 is larger */
   }
 else{ /* same sign operands */
   vt = SUB_LONGEST(v1,v2);
   sresult = vt.w1.l & SIGN_TEST_BIT;
   if (sresult)
         v1 = v2; /* v2 >= v1 */
   }
 
 return v1;   
}

static 
LONGEST
longest_one;

LONGEST
neg_longest(v1)
  LONGEST v1;
{
 v1 = LOGNOT_LONGEST(v1);
 v1 = ADD_LONGEST(v1,longest_one);
 return v1;
}

LONGEST 
lognot_longest(v1) 
  LONGEST v1; 
{ 
 v1.w0.l = (~ v1.w0.l)&WORD_BITS;
 v1.w1.l = (~ v1.w1.l)&WORD_BITS;
 return v1;
}


LONGEST
int_to_longest(i1)
  int i1;
{
  LONGEST rv;
  long v1 = i1;
  rv.w0.l = v1 & WORD_BITS;
  rv.w1.l = (v1 >> TARGET_WORD_NUM_BITS) & WORD_BITS;
  return rv;
}

LONGEST
long_to_longest(i1)
  long i1;
{
  LONGEST rv;
  long v1 = i1;
  rv.w0.l = v1 & WORD_BITS;
  rv.w1.l = (v1 >> TARGET_WORD_NUM_BITS) & WORD_BITS;
  return rv;
}

LONGEST
char_to_longest(c1)
  char c1;
{
  LONGEST rv;
  long v1 = c1;
  rv.w0.l = v1 & WORD_BITS;
  rv.w1.l = (v1 >> TARGET_WORD_NUM_BITS) & WORD_BITS;
  return rv;
}

LONGEST
short_to_longest(s1)
  short s1;
{
  LONGEST rv;
  long v1 = s1;
  rv.w0.l = v1 & WORD_BITS;
  rv.w1.l = (v1 >> TARGET_WORD_NUM_BITS) & WORD_BITS;
  return rv;
}
  
LONGEST
unsigned_long_to_longest(u1)
  unsigned long u1;
{
  LONGEST rv;
  unsigned long v1 = u1;
  rv.w0.u = v1 & WORD_BITS;
  rv.w1.u = (v1 >> TARGET_WORD_NUM_BITS) & WORD_BITS ;
  return rv;
}

LONGEST
unsigned_char_to_longest(c1)
  unsigned char c1;
{
  LONGEST rv;
  unsigned long v1 = c1;
  rv.w0.u = v1 & WORD_BITS;
  rv.w1.u = (v1 >> TARGET_WORD_NUM_BITS) & WORD_BITS;
  return rv;
}

LONGEST
unsigned_short_to_longest(s1)
  unsigned short s1;
{
  LONGEST rv;
  unsigned long v1 = s1;
  rv.w0.u = v1 & WORD_BITS;
  rv.w1.u = (v1 >> TARGET_WORD_NUM_BITS) & WORD_BITS;
  return rv;
}

LONGEST
unsigned_int_to_longest(i1)
  unsigned int i1;
{
  LONGEST rv;
  unsigned long v1 = i1;
  rv.w0.u = v1 & WORD_BITS;
  rv.w1.u = (v1 >> TARGET_WORD_NUM_BITS) & WORD_BITS;
  return rv;
}

LONGEST
core_addr_to_long(i1)
  CORE_ADDR i1;
{
  LONGEST rv;
  rv.w0.u = i1.w0.u & ADDR_BITS;
  rv.w1.u = 0;
  return rv;
}

int
equal_longest(v1,v2)
  LONGEST v1,v2;
{
 
 return (((v1.w0.l&WORD_BITS) == (v2.w0.l&WORD_BITS))&&
         ((v1.w1.l&WORD_BITS) == (v2.w1.l&WORD_BITS)))?1:0;
}

int
less_unsigned_longest(v1,v2)
  LONGEST v1,v2;
{
 int rv;
   v1.w1.u &= WORD_BITS;
   v2.w1.u &= WORD_BITS;
   if (v1.w1.u == v2.w1.u){
     v1.w0.u &= WORD_BITS;
     v2.w0.u  &= WORD_BITS;
     rv= (v1.w0.u < v2.w0.u)?1:0;
     }
   else rv= (v1.w1.u < v2.w1.u)?1:0;
return (rv);
}

int
less_longest(v1,v2)
  LONGEST v1,v2;
{
 LONGEST vt;
 long s1,s2,sresult;
 int rv;
 s1 = v1.w1.l&SIGN_TEST_BIT;
 s2 = v2.w1.l&SIGN_TEST_BIT;
 if(s1^s2){ /* different signs */
   rv = (s2)? 0:1;
   }
 else{ /* same sign operands */
   vt = SUB_LONGEST(v1,v2);
   sresult = vt.w1.l & SIGN_TEST_BIT;
   rv = (sresult)? 1:0;
   }
 return (rv);
}

int
equal_double(v1,v2)
  double v1,v2; 
{ 
 return (v1 == v2)? 1:0; 
}

int
equal_ptr(v1,v2)
  LONGEST v1,v2; 
{ 
 return ((v1.w0.u&ADDR_BITS) == (v2.w0.u&ADDR_BITS) &&
         (v1.w1.mape == v2.w1.mape))? 1:0; 
}

int
less_ptr(v1,v2)
  LONGEST v1,v2; 
{ 
 return ((v1.w0.u&ADDR_BITS) < (v2.w0.u&ADDR_BITS))? 1:0; 
}

double
add_double(v1,v2) 
  double v1,v2;  
{  
 return (v1+ v2); 
}

double
sub_double(v1,v2) 
  double v1,v2;  
{  
 return (v1 - v2); 
}

double
mul_double(v1,v2)
  double v1,v2;
{
 return (v1 * v2);
}

double
div_double(v1,v2) 
  double v1,v2; 
{ 
 return (v1 / v2); 
} 

double
neg_double(v1) 
  double v1; 
{ 
 return ( - v1); 
}

int 
less_double(v1,v2)
  double v1,v2;
{
  return (v1 < v2)? 1 : 0 ;
} 


LONGEST
mul_unsigned_longest(v1,v2)
  LONGEST v1,v2;
{
 double d1,d2,dresult;
 d1 = (((double)(v1.w1.u&WORD_BITS))*((double)(WORD_BITS+1)))+
      ((double)(v1.w0.u&WORD_BITS));
 d2 = (((double)(v2.w1.u&WORD_BITS))*((double)(WORD_BITS+1)))+
      ((double)(v2.w0.u&WORD_BITS));
 dresult = d1*d2; /* unsigned multiply */
 v1.w1.u = dresult/((double)(WORD_BITS+1));
 v1.w0.u = dresult - (((double)v1.w1.u)*((double)(WORD_BITS+1)));
 v1.w1.u &= WORD_BITS;
 v1.w0.u &= WORD_BITS;
 return v1;
}

LONGEST
div_unsigned_longest(v1,v2)
  LONGEST v1,v2;
{
 double d1,d2,dresult;
 d1 = (((double)(v1.w1.u&WORD_BITS))*((double)(WORD_BITS+1)))+
      ((double)(v1.w0.u&WORD_BITS));
 d2 = (((double)(v2.w1.u&WORD_BITS))*((double)(WORD_BITS+1)))+
      ((double)(v2.w0.u&WORD_BITS));
 dresult = d1/d2; /* unsigned divide */
 v1.w1.u = dresult/((double)(WORD_BITS+1));
 v1.w0.u = dresult - (((double)v1.w1.u)*((double)(WORD_BITS+1)));
 v1.w1.u &= WORD_BITS;
 v1.w0.u &= WORD_BITS;
 return v1;
}

LONGEST
rem_unsigned_longest(v1,v2)
  LONGEST v1,v2;
{
 LONGEST vr;
 double d1,d2,dresult;
 d1 = (((double)(v1.w1.u&WORD_BITS))*((double)(WORD_BITS+1)))+
      ((double)(v1.w0.u&WORD_BITS));
 d2 = (((double)(v2.w1.u&WORD_BITS))*((double)(WORD_BITS+1)))+
      ((double)(v2.w0.u&WORD_BITS));
 dresult = d1/d2; /* unsigned divide */
 vr.w1.u = dresult/((double)(WORD_BITS+1));
 vr.w0.u = dresult - (((double)vr.w1.u)*((double)(WORD_BITS+1)));
 vr.w1.u &= WORD_BITS;
 vr.w0.u &= WORD_BITS;
 vr = MUL_UNSIGNED_LONGEST(vr,v2);
 vr = SUB_UNSIGNED_LONGEST(v1,vr);
 return vr;
}
 
LONGEST
rsh_unsigned_longest(v1,v2)
  LONGEST v1,v2;
{
 int shiftcount=0;
 v2.w0.u &= WORD_BITS;
 v2.w1.u &= WORD_BITS;
 v1.w0.u &= WORD_BITS;
 v1.w1.u &= WORD_BITS;
 while ((v2.w0.u||v2.w1.u)&&(shiftcount++ <MAX_WORD_BITS)){
   v2=ADD_LONGEST(v2,longest_minus_1);
   v1.w0.u >>=1;
   if (v1.w1.u & 1)
      v1.w0.u |= SIGN_TEST_BIT;
   v1.w1.u >>=1;
   }
 return v1;
}



LONGEST
unpack_field_as_longest(valaddr,bitpos,bitsize) 
  char *valaddr;
  int bitpos,bitsize;
{
 unsigned long vu[3]; 
 LONGEST v1,vmask;
 int wordoffset_start= bitpos/ (sizeof(long)*8);
 int bitoffset = bitpos% (SIZEOF_INT*8);
 int wordoffset_end= wordoffset_start+
     (((bitoffset+bitsize-1)/TARGET_WORD_NUM_BITS)*(SIZEOF_INT/sizeof(long)));
 int wordoffset_mid= ((wordoffset_end-wordoffset_start)>(SIZEOF_INT/sizeof(long)))?wordoffset_start+(SIZEOF_INT/sizeof(long)):wordoffset_end;
 vmask=longest_zero;
 vu[0] = *((( unsigned long *) valaddr)+wordoffset_start); 
 vu[1] = (wordoffset_mid>wordoffset_start)?
 *((( unsigned long *) valaddr)+wordoffset_mid):0;
 vu[2] = (wordoffset_end>wordoffset_mid)?
 *((( unsigned long *) valaddr)+wordoffset_end):0;

 while (bitoffset-- >0){
   vu[0] >>=1;
   if (vu[1] & 1)
      vu[0] |= SIGN_TEST_BIT;
   vu[1] >>=1;
   if (vu[2] & 1)
      vu[1] |= SIGN_TEST_BIT;
   vu[2] >>=1;
   }

 while (bitsize-- >0){
   vmask.w1.u<<=1;
   if (vmask.w0.u&SIGN_TEST_BIT) vmask.w1.u|=1;
   vmask.w0.u<<=1;
   vmask.w0.u|=1;
   }
 v1.w0.u = vu[0] & vmask.w0.u &  WORD_BITS;
 v1.w1.u = vu[1] & vmask.w1.u & WORD_BITS;
 return v1;
}

  
modify_field_longest(addr,fieldval,bitpos,bitsize) 
  char *addr;
  LONGEST fieldval;
  int bitpos,bitsize;
{
 unsigned long vf[3];
 unsigned long vm[3];
 int wordoffset_start= bitpos/ (sizeof(long)*8);
 int bitoffset = bitpos% (SIZEOF_INT*8);
 int wordoffset_end= wordoffset_start+
     (((bitoffset+bitsize-1)/TARGET_WORD_NUM_BITS)*(SIZEOF_INT/sizeof(long)));
 int wordoffset_mid= ((wordoffset_end-wordoffset_start)>(SIZEOF_INT/sizeof(long)))?wordoffset_start+(SIZEOF_INT/sizeof(long)):wordoffset_end;

 vm[2]=0;
 if (bitsize>TARGET_WORD_NUM_BITS){
   int upperbits= bitsize - TARGET_WORD_NUM_BITS;
   vm[0]=WORD_BITS;
   vm[1]=(1l << upperbits) - 1l;
   }
 else{
   vm[1]=0;
   vm[0]=(1l << bitsize) -1l;
   }

 vf[2]=0;
 vf[1]=fieldval.w1.u&vm[1];
 vf[0]=fieldval.w0.u&vm[0];

 while (bitoffset-- >0){
   vf[2]<<=1;
   if (vf[1]&SIGN_TEST_BIT) vf[2]|=1;
   vf[1]<<=1;
   if (vf[0]&SIGN_TEST_BIT) vf[1]|=1;
   vf[0]<<=1;
   vm[2]<<=1;
   if (vm[1]&SIGN_TEST_BIT) vm[2]|=1;
   vm[1]<<=1;
   if (vm[0]&SIGN_TEST_BIT) vm[1]|=1;
   vm[0]<<=1;
   }

  *((( unsigned long *) addr)+wordoffset_start)&= ~(vm[0]&WORD_BITS);
  *((( unsigned long *) addr)+wordoffset_start)|= vf[0]&WORD_BITS;
  if (wordoffset_mid>wordoffset_start){
   *((( unsigned long *) addr)+wordoffset_mid)&= ~(vm[1]&WORD_BITS);
   *((( unsigned long *) addr)+wordoffset_mid)|= vf[1]&WORD_BITS;
   if (wordoffset_end>wordoffset_mid){
    *((( unsigned long *) addr)+wordoffset_end)&= ~(vm[2]&WORD_BITS);
    *((( unsigned long *) addr)+wordoffset_end)|= vf[2]&WORD_BITS;
    }
   }
}  
 
  
LONGEST
min_unsigned_longest(v1,v2)
  LONGEST v1,v2;
{  
   v1.w1.u &= WORD_BITS;
   v2.w1.u &= WORD_BITS;
   if (v1.w1.u == v2.w1.u){
     v1.w0.u &= WORD_BITS;
     v2.w0.u  &= WORD_BITS;
     if (v1.w0.u > v2.w0.u)
        v1 = v2; /* return value */
     }
   else if (v1.w1.u > v2.w1.u)
     v1 = v2;
 return v1;
}
 
LONGEST
max_unsigned_longest(v1,v2)
  LONGEST v1,v2;
{ /* returns (v1>v2)?v1:v2 */
   v1.w1.u &= WORD_BITS;
   v2.w1.u  &= WORD_BITS;
   if (v1.w1.u == v2.w1.u){
     v1.w0.u &= WORD_BITS;
     v2.w0.u  &= WORD_BITS;
     if (v1.w0.u < v2.w0.u)
       v1 = v2; /* return value */
     }
   else if (v1.w1.u < v2.w1.u)
      v1 = v2; /* return value */
 return v1;
}
 
LONGEST
longest_to_target_int(v1)
  LONGEST v1;
{
 v1.w0.l = (v1.w0.l)&WORD_BITS;
 v1.w1.l = ((v1.w0.l)&SIGN_TEST_BIT)?WORD_BITS:0;
 return v1;
}

LONGEST
longest_to_target_unsigned_int(v1)
  LONGEST v1;
{
 v1.w0.l = (v1.w0.l)&WORD_BITS;
 v1.w1.l = 0;
 return v1;
}
 
LONGEST longest_to_target_long(v1)
LONGEST v1;
{
 v1.w0.u &=WORD_BITS;
 v1.w1.u&= WORD_BITS;
 return (v1);
}

LONGEST longest_to_target_pointer(v1)
LONGEST v1;
{
 v1.w0.u&= ADDR_BITS;
 return (v1);
}

do_registers_info(regnum)
  int regnum;
{
  register int i;
  int regsize;

  if (regnum == -1)
    printf_filtered (
      "Register       Contents (relative to selected stack frame)\n\n");

  for (i = 0; i < NUM_REGS; i++) 
    {
      unsigned char raw_buffer[MAX_REGISTER_RAW_SIZE];
      unsigned char virtual_buffer[MAX_REGISTER_VIRTUAL_SIZE];

      if (regnum != -1 && i != regnum)
   continue;

      /* Get the data in raw format, then convert also to virtual format.  */
      read_relative_register_raw_bytes (i, raw_buffer);
      REGISTER_CONVERT_TO_VIRTUAL (i, raw_buffer, virtual_buffer);

      fputs_filtered (reg_names[i], stdout);
      print_spaces_filtered (15 - strlen (reg_names[i]), stdout);
 
      /* If virtual format is floating, print it that way.  */
      if (TYPE_CODE (REGISTER_VIRTUAL_TYPE (i)) == TYPE_CODE_FLT
     && ! INVALID_FLOAT (virtual_buffer, REGISTER_VIRTUAL_SIZE (i)))
   val_print (REGISTER_VIRTUAL_TYPE (i), virtual_buffer, core_zero,
         stdout, 0, 1, 0, Val_pretty_default);
      /* Else if virtual format is too long for printf,
    print in hex a byte at a time.  */
      else if ((regsize=reg_info[i].real_size) == 6)
   { /* only for long registers */
     LONGEST tl;
     bcopy (virtual_buffer, &tl, SIZEOF_LONG);
     printf_filtered ("0x%06x%06x",tl.w1.u,tl.w0.u);
   }
      /* Else print as integer in hex and in decimal.  */
      else
   {
     long lval;
 
     bcopy (virtual_buffer, &lval, sizeof (long));
     if (lval == 0)

    printf_filtered ("0");
     else if (regsize==1) 
       printf_filtered ("0x%02x  %d", lval, lval);
     else if (regsize==2) 
       printf_filtered ("0x%04x  %d", lval, lval);
     else if (regsize==3) 
       printf_filtered ("0x%06x  %d", lval, lval);
   }

      /* If register has different raw and virtual formats,
    print the raw format in hex now.  */

      if (REGISTER_CONVERTIBLE (i))
   {
     register int j;

     printf_filtered ("  (raw 0x");
     for (j = 0; j < REGISTER_RAW_SIZE (i); j++)
       printf_filtered ("%02x", raw_buffer[j]);
     printf_filtered (")");
   }
      printf_filtered ("\n");
    }
}

static char retstringbuf[80];
static
LONGEST
longdivider ;

char *
int_to_xstring(v1)
LONGEST v1;
{
 sprintf(retstringbuf,"0x%x",v1.w0.u&WORD_BITS); 
 return (retstringbuf);
}

char *
int_to_0xstring(v1)
LONGEST v1;
{
 sprintf(retstringbuf,"0x%06x",v1.w0.u&WORD_BITS); 
 return (retstringbuf);
}

char *
int_to_ostring(v1)
LONGEST v1;
{
 sprintf(retstringbuf,"0%o",v1.w0.u&WORD_BITS); 
 return (retstringbuf);
}

char *
long_to_ostring(v1)
LONGEST v1;
{
 v1.w1.u &= WORD_BITS;
 v1.w0.u &= WORD_BITS;
 if(v1.w1.u)
   sprintf(retstringbuf,"0%o%08o",v1.w1.u,v1.w0.u);
 else
   sprintf(retstringbuf,"0%o",v1.w0.u); 
 return (retstringbuf);
}

char *
long_to_xstring(v1)
LONGEST v1;
{
 v1.w1.u &= WORD_BITS;
 v1.w0.u &= WORD_BITS;
 if(v1.w1.u)
   sprintf(retstringbuf,"0x%x%06x",v1.w1.u,v1.w0.u);
 else
   sprintf(retstringbuf,"0x%x",v1.w0.u); 
 return (retstringbuf);
}

char *
long_to_0xstring(v1)
LONGEST v1;
{
 v1.w1.u &= WORD_BITS;
 v1.w0.u &= WORD_BITS;
 sprintf(retstringbuf,"0x%06x%06x",v1.w1.u,v1.w0.u);
 return (retstringbuf);
}

char *
int_to_ustring(v1)
LONGEST v1;
{
 sprintf(retstringbuf,"%u",v1.w0.u&WORD_BITS); 
 return (retstringbuf);
}

char *
int_to_dstring(v1)
LONGEST v1;
{
 long s1;

 s1 = v1.w0.l&SIGN_TEST_BIT;
 if (s1) v1 = NEG_LONGEST(v1);
 sprintf(retstringbuf,(s1)?"-%d":"%d",v1.w0.u&WORD_BITS); 
 return (retstringbuf);
}

char *
long_to_dstring(v1)
LONGEST v1;
{
 LONGEST vt,vr;
 long s1;
 unsigned long ut;

 s1 = v1.w1.l&SIGN_TEST_BIT;
 if (s1) v1 = NEG_LONGEST(v1);
 vt = DIV_UNSIGNED_LONGEST(v1,longdivider);
 vr = REM_UNSIGNED_LONGEST(v1,longdivider);
 ut = vt.w0.u| (vt.w1.u<<TARGET_WORD_NUM_BITS);
 if (ut==0)
   sprintf(retstringbuf,(s1)?"-%d":"%d",vr.w0.u); 
 else
   sprintf(retstringbuf,(s1)?"-%d%07d":"%d%07d",ut,vr.w0.u);
 return (retstringbuf);
}

char *
long_to_ustring(v1)
LONGEST v1;
{
 LONGEST vt,vr;
 unsigned long ut;

 vt = DIV_UNSIGNED_LONGEST(v1,longdivider);
 vr = REM_UNSIGNED_LONGEST(v1,longdivider);
 ut = vt.w0.u| (vt.w1.u<<TARGET_WORD_NUM_BITS);
 if (ut==0)
   sprintf(retstringbuf,"%u",vr.w0.u); 
 else
   sprintf(retstringbuf,"%u%07u",ut,vr.w0.u);
 return (retstringbuf);
}

double
target_long_to_double(v1)
LONGEST v1;
{
 long s1;
 double rv;

 s1 = v1.w1.l&SIGN_TEST_BIT;
 if (s1) v1 = NEG_LONGEST(v1);
 rv = v1.w0.l;
 rv+= (double)v1.w1.l * (double)(0x1000000l);
 if (s1) rv = -rv;
 return (rv);
}

double
target_unsigned_long_to_double(v1)
LONGEST v1;
{
 double rv;
 rv = v1.w0.u;
 rv+= (double)v1.w1.u * (double)(0x1000000l);
 return (rv);
}

double
kp_to_double(v1)
LONGEST v1;
{
double result;
   long   dexp, dsgn, dmant;
   long   *uprptr, *lwrptr;                    /* used to make result */
   long    L_word, H_word;
   unsigned long mantissa_low;
   L_word = v1.w0.l;
   H_word = v1.w1.l;
  /* gets sign */
   dsgn = (H_word & 0x00800000) ? 0x80000000 : 0;
   dmant = ( H_word & 0x0ffffff );


   if ( dmant == 0x800000 ){ /* twos complement signed exponent */
      dmant = 0x0400000;
      L_word++; /* bump up exponent */
      }  

   else {
      dmant = (dsgn) ? -dmant : dmant;          /* force positive */
      }  

   dmant &= 0x003fffff;                      /* remove sgn and leading "1" */

   dexp = L_word;        /* dexp = kgetexp() */
   /* 16 bit exponent, two upper bits indicate overflow and underflow */
   if (dexp &0x8000l)
      return (0.0); /* underflow in kp will be zero in ieee */
   else dexp&=0x7fffl;

   dexp -= 8191;             /* IEEE double precision bias  */
   dexp += 1023;             /* kFP little precision bias */
   dexp --;                  /* kFP to IEEE (s.xxx..xx to 01.xxx..xx) */
   mantissa_low=0;
   if (dexp<=0){/* denormalized number or maybe underflow zero in ieee */
      dmant|=0x400000l; /* make the implicit 1 explicit */
      if (dmant&1) mantissa_low|=0x20000000l;
      dmant>>=1;
      while (dexp<0 && (dmant||mantissa_low)){
        /* shift entire mantissa right */
        mantissa_low>>=1;
        if (dmant&1) mantissa_low|=0x20000000l;
        dmant>>=1;
        dexp++;
        }
      if ((!dmant) && (!mantissa_low))
         return (0.0); /* underflow or 0 */

      }  

   /* dont want to create an ieee nan or wrap overflowed exponents,
      so the following code truncates at ieee infinity */
   if (dexp>=0x7ffl){
      dexp = 0x7ffl; /* overflow to infinity */
      dmant = 0;
      mantissa_low=0;
      }  
   else
     dexp &= 0x07ff;

   /* Make a "double" from the sign, exp, and mant */
   uprptr = (long *) &result;      /* word ordering is MACHINE DEPENDENT */
   lwrptr = uprptr + 1;

#ifndef WORDS_BIG_ENDIAN
   /* need to swap for INTEL/microsoft ordering */
   *lwrptr = dsgn | (dexp<<20) | (dmant>>2);   /* all but last 2 mant bits */
   *uprptr = ((dmant<<30)|(mantissa_low));     /* last 2 bits of mant */
#else
   *uprptr = dsgn | (dexp<<20) | (dmant>>2);   /* all but last 2 mant bits */
   *lwrptr = ((dmant<<30)|(mantissa_low));     /* last 2 bits of mant */
#endif
return (result);
}

/* ---------------------------------------------------------------- *\
  
   name         dgetmant
 
   synopsis     dgetmant(dfptval, wordnum)
                double dfptval;
      int wordnum;
 
   description   
      Inputs:
         dfptval = double precision value from which mantissa is extracted
         wordnum:  0 = upper 20 bits (leading 1 suppressed)
         1 = lower 32 bits
 
   return value  
 
\* ---------------------------------------------------------------- */
 
static
long 
dgetmant(dfptval, wordnum)
double dfptval; 
int    wordnum;
{
   long *ivalptr;
 
   ivalptr = (long *) &dfptval;
 
#ifndef WORDS_BIG_ENDIAN
   if (wordnum == 0)
      return( ((*(ivalptr+1))) & 0x000fffffL);
   else   /* lower word */
      return( *(ivalptr) );
#else
   if (wordnum == 0)
      return( ((*ivalptr)) & 0x000fffff);
   else   /* lower word */
      return( *(ivalptr+1) );
#endif
}

/* ---------------------------------------------------------------- *\
   
   name         dgetexp
 
   synopsis     dgetexp(dfptval)
                double dfptval;

   description
 
   return value 
 
\* ---------------------------------------------------------------- */
static 
long dgetexp(dfptval)
double dfptval;
{
   long *ivalptr;
 
   ivalptr = (long *) &dfptval;
#ifndef WORDS_BIG_ENDIAN
   ivalptr++;
#endif
   return( ((*ivalptr)>>20) & 0x07ff );       /* masks sign bit too */
}
  
LONGEST
double_to_kp(dval)
double dval;
{
LONGEST rv;
unsigned long   *lp,L_word, H_word,tmp,tmp2,dsgn;
long   increase_exponent;
   /* if constant is 0 */
   if ( dval == 0.0 ){
       H_word=L_word=0;
       } 
   else {
   L_word = dgetexp(dval); /* ieee exponent */
   H_word = dgetmant(dval,0); /* grab upper 20 bits of double */
   tmp2=dgetmant(dval,1); /* lower 32 bits of ieee mantissa */
   if (L_word==0){ /* ieee denormalized number */
      L_word++;/* try it*/
      while (! (H_word & 0x100000)){ /* normalize it */
          L_word--; /* exponent decreases */
          H_word<<=1; /* shift entire 52 bit ieee mantissa left */
          if (tmp2 & 0x80000000l)
            H_word|=1;
          tmp2<<=1;
          }
      }    
   else /* normalized ieee number with implied leading 1 */
     H_word |= 0x00100000;      /* add leading 1 */
   H_word <<= 10;
   tmp = ((tmp2 & 0xc0000000) >> 1);   /* grab lower 2 bits */
   tmp >>= 21;                          /* ------------------- */
   H_word |= tmp;                       /* combine upper and lower */
   increase_exponent=0;
   if (tmp2 & 0x20000000l){ /* round up for 1/2 lsb of kp mantissa */
     if(H_word>=0x7fffff00){
        increase_exponent=1;
        H_word+=0x100;
        H_word>>=1;
        }
     else H_word+=0x100;
     }
 
   lp = (unsigned long *) &dval;
#ifndef WORDS_BIG_ENDIAN
   lp++;
#endif
   dsgn= (* lp)&0x80000000l;
   if ( dsgn ){ /* check for negative value in ieee format */
      H_word = -H_word;
      }
 
   H_word >>= 8;
   L_word -= 1023;             /* IEEE double precision bias  */
   L_word += 8191;             /* kevFP little precision bias */
   L_word ++;                  /* lameFP s.xxx..xx */

   L_word += increase_exponent; /* in case rounding modified exponent */

   /* negative weird case ( -0.5 == 800000  not c00000 ) */
   if ( (H_word & 0x800000) && (H_word & 0x400000) ){
      H_word <<= 1;
      L_word--;
      }  
   }   
  rv.w1.u = H_word & WORD_BITS; /* mantissa */
  rv.w0.u = L_word & WORD_BITS; /* exponent */
  return (rv);
}

CORE_ADDR stack_end_addr;

static
char default_dsp_device_number[]="56001";
extern
char *dsp_device_number;
_initialize_m56k()
{
int i;
CORE_ADDR_MAP(core_zero)= memory_map_p;
CORE_ADDR_MAP(frame_zero_init)= STACK_MAP;
CORE_ADDR_MAP(stack_end_addr)= STACK_MAP;
CORE_ADDR_MAP(stack_zero)= STACK_MAP;
CORE_ADDR_W0(longest_minus_1)=WORD_BITS;
CORE_ADDR_W1(longest_minus_1)=WORD_BITS;
CORE_ADDR_W0(longest_one)=1;
CORE_ADDR_W0(longdivider)=10000000l;

stmap=(CORE_ADDR_MAP(stack_zero)==memory_map_x)?memory_map_x:memory_map_y;
init_host_io_structures ( );

dsp_startup();

if (!dsp_device_number)
    dsp_device_number= default_dsp_device_number;

if (!dsp_new(0,dsp_device_number))
    fatal ("unable to create device number:%s",dsp_device_number);

hspr=dv_var->periph[0].regval;
for (i=0;i<NUM_REGS;i++)
 if(reg_info[i].regname)
  dsp_findreg(0,reg_info[i].regname,&reg_info[i].periph,&reg_info[i].regnum);
}



