/* $Id: m96k-dep.c,v 1.19 1993/08/17 19:12:15 jay Exp $ */
/* Machine-dependent code which would otherwise be in inflow.c and core.c,
   for GDB, the GNU debugger.
   Copyright (C) 1986, 1987, 1989 Free Software Foundation, Inc.
   This code is for the sparc cpu.

This file is part of GDB.

GDB is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 1, or (at your option)
any later version.

GDB is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GDB; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */

#include <stdio.h>
#include "defs.h"
#include "param.h"
#include "symtab.h"
#include "value.h"
#include "frame.h"
#include "inferior.h"
#include "obstack.h"

#include "simcom.h"
#include "simdev.h"
#include "simusr.h"
#include "core96k.h"
#include "gsig96k.h"
#include <signal.h>
#include <fcntl.h>
#if MSDOS
#include "stub.h"
#endif
#ifndef DSP96000
#define DSP96000 1
#endif
#include "../hostio/hostio.h"

#define STACK_MAP memory_map_l
extern struct dev_const dv_const;
extern struct dev_var *dv_var;
static  unsigned long *hspr;

LONGEST longest_zero;
CORE_ADDR core_zero;
FRAME_ADDR frame_zero_init;
CORE_ADDR stack_zero;
static enum memory_map stmap;


enum fptype{not_fp,not_fp2,sp,sep,dp,dp2} fptype;

static 
struct{ 
int regbytes; 
char *regname;
int startbyte; 
struct type **virtual_type;
int real_size;
/*int regxref;*/
int periph;
int regnum;
enum regnums fpxref;
enum fptype fptype;
enum pop{popit,nopop}popflag;
enum regnums fpupdate;
}
dsp_96k_reg_info[]=
{
{4,"cvra",0,&builtin_type_unsigned_int,4,/*HST_ACVR*/0,0,0,not_fp,nopop,0},/*acvr*/
{4,"hcra",0,&builtin_type_unsigned_int,4,/*MR_AHCR*/0,0,0,not_fp,nopop,0},/*ahcr*/
{4,"hrxa",0,&builtin_type_unsigned_int,4,/*MR_AHRX*/0,0,0,not_fp,nopop,0},/*ahrx*/
{4,"hsra",0,&builtin_type_unsigned_int,4,/*MR_AHSR*/0,0,0,not_fp,nopop,0},/*ahsr*/
{4,"htxa",0,&builtin_type_unsigned_int,4,/*MR_AHTX*/0,0,0,not_fp,nopop,0},/*ahtx*/
{4,"icsa",0,&builtin_type_unsigned_int,4,/*HST_AICS*/0,0,0,not_fp,nopop,0},/*aics*/
{4,"ivra",0,&builtin_type_unsigned_int,4,/*HST_AIVR*/0,0,0,not_fp,nopop,0},/*aivr*/
{4,"rxa",0,&builtin_type_unsigned_int,4,/*HST_ARX*/0,0,0,not_fp,nopop,0},/*arx*/
{4,"sema",0,&builtin_type_unsigned_int,4,/*HST_ASEM*/0,0,0,not_fp,nopop,0},/*asem*/
{4,"txa",0,&builtin_type_unsigned_int,4,/*HST_ATX*/0,0,0,not_fp,nopop,0},/*atx*/
{4,"bcra",0,&builtin_type_unsigned_int,4,/*MR_ABCR*/0,0,0,not_fp,nopop,0},/*bcra*/
{4,"bcrb",0,&builtin_type_unsigned_int,4,/*MR_BBCR*/0,0,0,not_fp,nopop,0},/*bcrb*/
{4,"bcvr",0,&builtin_type_unsigned_int,4,/*HST_BCVR*/0,0,0,not_fp,nopop,0},/*bcvr*/
{4,"bhcr",0,&builtin_type_unsigned_int,4,/*MR_BHCR*/0,0,0,not_fp,nopop,0},/*bhcr*/
{4,"bhrx",0,&builtin_type_unsigned_int,4,/*MR_BHRX*/0,0,0,not_fp,nopop,0},/*bhrx*/
{4,"bhsr",0,&builtin_type_unsigned_int,4,/*MR_BHSR*/0,0,0,not_fp,nopop,0},/*bhsr*/
{4,"bhtx",0,&builtin_type_unsigned_int,4,/*MR_BHTX*/0,0,0,not_fp,nopop,0},/*bhtx*/
{4,"bics",0,&builtin_type_unsigned_int,4,/*HST_BICS*/0,0,0,not_fp,nopop,0},/*bics*/
{4,"bivr",0,&builtin_type_unsigned_int,4,/*HST_BIVR*/0,0,0,not_fp,nopop,0},/*bivr*/
{4,"brx",0,&builtin_type_unsigned_int,4,/*HST_BRX*/0,0,0,not_fp,nopop,0},/*brx*/
{4,"bsem",0,&builtin_type_unsigned_int,4,/*HST_BSEM*/0,0,0,not_fp,nopop,0},/*bsem*/
{4,"btx",0,&builtin_type_unsigned_int,4,/*HST_BTX*/0,0,0,not_fp,nopop,0},/*btx*/
{4,"cyc",0,&builtin_type_unsigned_int,4,/*REG_CYCL*/0,0,0,not_fp,nopop,0},/*cyc*/
{8,"d0",0,&builtin_type_double,8,/*REG_D0D*/0,0,D0L_REGNUM,sep,nopop,0},/*d0*/
{8,"d0.d",0,&builtin_type_double,/*8*/0,0,REG_D0D,D0L_REGNUM,dp,nopop,0},/*d0.d*/
{4,"d0.l",0,&builtin_type_int,4,/*REG_D0L*/0,0,0,not_fp,popit,D0_REGNUM},/*d0.l*/
{4,"d0.m",0,&builtin_type_int,4,/*REG_D0M*/0,0,0,not_fp,popit,D0_REGNUM},/*d0.m*/
{4,"d0.h",0,&builtin_type_int,4,/*REG_D0H*/0,0,0,not_fp,popit,D0_REGNUM},/*d0.h*/
{8,"d0.ml",0,&builtin_type_double,8,/*REG_D0ML*/0,0,D0L_REGNUM,dp2,nopop,0},/*d0.ml*/
{4,"d0.s",0,&builtin_type_float,4,/*REG_D0S*/0,0,D0L_REGNUM,sp,nopop,0},/*d0.s*/
{8,"d0.x",0,&builtin_type_double,8,/*REG_D0D*/0,0,D0L_REGNUM,sep,nopop,0},/*d0.x*/
{8,"d1",0,&builtin_type_double,8,/*REG_D1D*/0,0,D1L_REGNUM,sep,nopop,0},/*d1*/
{8,"d1.d",0,&builtin_type_double,8,/*REG_D1D*/0,0,D1L_REGNUM,dp,nopop,0},/*d1.d*/
{4,"d1.l",0,&builtin_type_int,4,/*REG_D1L*/0,0,0,not_fp,popit,D1_REGNUM},/*d1.l*/
{4,"d1.m",0,&builtin_type_int,4,/*REG_D1M*/0,0,0,not_fp,popit,D1_REGNUM},/*d1.m*/
{4,"d1.h",0,&builtin_type_int,4,/*REG_D1H*/0,0,0,not_fp,popit,D1_REGNUM},/*d1.h*/
{8,"d1.ml",0,&builtin_type_double,8,/*REG_D1ML*/0,0,D1L_REGNUM,dp2,nopop,0},/*d1.ml*/
{4,"d1.s",0,&builtin_type_float,4,/*REG_D1S*/0,0,D1L_REGNUM,sp,nopop,0},/*d1.s*/
{8,"d1.x",0,&builtin_type_double,8,/*REG_D1D*/0,0,D1L_REGNUM,sep,nopop,0},/*d1.x*/
{8,"d2",0,&builtin_type_double,8,/*REG_D2D*/0,0,D2L_REGNUM,sep,nopop,0},/*d2*/
{8,"d2.d",0,&builtin_type_double,8,/*REG_D2D*/0,0,D2L_REGNUM,dp,nopop,0},/*d2.d*/
{4,"d2.l",0,&builtin_type_int,4,/*REG_D2L*/0,0,0,not_fp,popit,D2_REGNUM},/*d2.l*/
{4,"d2.m",0,&builtin_type_int,4,/*REG_D2M*/0,0,0,not_fp,popit,D2_REGNUM},/*d2.m*/
{4,"d2.h",0,&builtin_type_int,4,/*REG_D2H*/0,0,0,not_fp,popit,D2_REGNUM},/*d2.h*/
{8,"d2.ml",0,&builtin_type_double,8,/*REG_D2ML*/0,0,D2L_REGNUM,dp2,nopop,0},/*d2.ml*/
{4,"d2.s",0,&builtin_type_float,4,/*REG_D2S*/0,0,D2L_REGNUM,sp,nopop,0},/*d2.s*/
{8,"d2.x",0,&builtin_type_double,8,/*REG_D2D*/0,0,D2L_REGNUM,sep,nopop,0},/*d2.x*/
{8,"d3",0,&builtin_type_double,8,/*REG_D3D*/0,0,D3L_REGNUM,sep,nopop,0},/*d3*/
{8,"d3.d",0,&builtin_type_double,8,/*REG_D3D*/0,0,D3L_REGNUM,dp,nopop,0},/*d3.d*/
{4,"d3.l",0,&builtin_type_int,4,/*REG_D3L*/0,0,0,not_fp,popit,D3_REGNUM},/*d3.l*/
{4,"d3.m",0,&builtin_type_int,4,/*REG_D3M*/0,0,0,not_fp,popit,D3_REGNUM},/*d3.m*/
{4,"d3.h",0,&builtin_type_int,4,/*REG_D3H*/0,0,0,not_fp,popit,D3_REGNUM},/*d3.h*/
{8,"d3.ml",0,&builtin_type_double,8,/*REG_D3ML*/0,0,D3L_REGNUM,dp2,nopop,0},/*d3.ml*/
{4,"d3.s",0,&builtin_type_float,4,/*REG_D3S*/0,0,D3L_REGNUM,sp,nopop,0},/*d3.s*/
{8,"d3.x",0,&builtin_type_double,8,/*REG_D3D*/0,0,D3L_REGNUM,sep,nopop,0},/*d3.x*/
{8,"d4",0,&builtin_type_double,8,/*REG_D4D*/0,0,D4L_REGNUM,sep,nopop,0},/*d4*/
{8,"d4.d",0,&builtin_type_double,8,/*REG_D4D*/0,0,D4L_REGNUM,dp,nopop,0},/*d4.d*/
{4,"d4.l",0,&builtin_type_int,4,/*REG_D4L*/0,0,0,not_fp,popit,D4_REGNUM},/*d4.l*/
{4,"d4.m",0,&builtin_type_int,4,/*REG_D4M*/0,0,0,not_fp,popit,D4_REGNUM},/*d4.m*/
{4,"d4.h",0,&builtin_type_int,4,/*REG_D4H*/0,0,0,not_fp,popit,D4_REGNUM},/*d4.h*/
{8,"d4.ml",0,&builtin_type_double,8,/*REG_D4ML*/0,0,D4L_REGNUM,dp2,nopop,0},/*d4.ml*/
{4,"d4.s",0,&builtin_type_float,4,/*REG_D4S*/0,0,D4L_REGNUM,sp,nopop,0},/*d4.s*/
{8,"d4.x",0,&builtin_type_double,8,/*REG_D4D*/0,0,D4L_REGNUM,sep,nopop,0},/*d4.x*/
{8,"d5",0,&builtin_type_double,8,/*REG_D5D*/0,0,D5L_REGNUM,sep,nopop,0},/*d5*/
{8,"d5.d",0,&builtin_type_double,8,/*REG_D5D*/0,0,D5L_REGNUM,dp,nopop,0},/*d5.d*/
{4,"d5.l",0,&builtin_type_int,4,/*REG_D5L*/0,0,0,not_fp,popit,D5_REGNUM},/*d5.l*/
{4,"d5.m",0,&builtin_type_int,4,/*REG_D5M*/0,0,0,not_fp,popit,D5_REGNUM},/*d5.m*/
{4,"d5.h",0,&builtin_type_int,4,/*REG_D5H*/0,0,0,not_fp,popit,D5_REGNUM},/*d5.h*/
{8,"d5.ml",0,&builtin_type_double,8,/*REG_D5ML*/0,0,D5L_REGNUM,dp2,nopop,0},/*d5.ml*/
{4,"d5.s",0,&builtin_type_float,4,/*REG_D5S*/0,0,D5L_REGNUM,sp,nopop,0},/*d5.s*/
{8,"d5.x",0,&builtin_type_double,8,/*REG_D5D*/0,0,D5L_REGNUM,sep,nopop,0},/*d5.x*/
{8,"d6",0,&builtin_type_double,8,/*REG_D6D*/0,0,D6L_REGNUM,sep,nopop,0},/*d6*/
{8,"d6.d",0,&builtin_type_double,8,/*REG_D6D*/0,0,D6L_REGNUM,dp,nopop,0},/*d6.d*/
{4,"d6.l",0,&builtin_type_int,4,/*REG_D6L*/0,0,0,not_fp,popit,D6_REGNUM},/*d6.l*/
{4,"d6.m",0,&builtin_type_int,4,/*REG_D6M*/0,0,0,not_fp,popit,D6_REGNUM},/*d6.m*/
{4,"d6.h",0,&builtin_type_int,4,/*REG_D6H*/0,0,0,not_fp,popit,D6_REGNUM},/*d6.h*/
{8,"d6.ml",0,&builtin_type_double,8,/*REG_D6ML*/0,0,D6L_REGNUM,dp2,nopop,0},/*d6.ml*/
{4,"d6.s",0,&builtin_type_float,4,/*REG_D6S*/0,0,D6L_REGNUM,sp,nopop,0},/*d6.s*/
{8,"d6.x",0,&builtin_type_double,8,/*REG_D6D*/0,0,D6L_REGNUM,sep,nopop,0},/*d6.x*/
{8,"d7",0,&builtin_type_double,8,/*REG_D7D*/0,0,D7L_REGNUM,sep,nopop,0},/*d7*/
{8,"d7.d",0,&builtin_type_double,8,/*REG_D7D*/0,0,D7L_REGNUM,dp,nopop,0},/*d7.d*/
{4,"d7.l",0,&builtin_type_int,4,/*REG_D7L*/0,0,0,not_fp,popit,D7_REGNUM},/*d7.l*/
{4,"d7.m",0,&builtin_type_int,4,/*REG_D7M*/0,0,0,not_fp,popit,D7_REGNUM},/*d7.m*/
{4,"d7.h",0,&builtin_type_int,4,/*REG_D7H*/0,0,0,not_fp,popit,D7_REGNUM},/*d7.h*/
{8,"d7.ml",0,&builtin_type_double,8,/*REG_D7ML*/0,0,D7L_REGNUM,dp2,nopop,0},/*d7.ml*/
{4,"d7.s",0,&builtin_type_float,4,/*REG_D7S*/0,0,D7L_REGNUM,sp,nopop,0},/*d7.s*/
{8,"d7.x",0,&builtin_type_double,8,/*REG_D7D*/0,0,D7L_REGNUM,sep,nopop,0},/*d7.x*/
{8,"d8",0,&builtin_type_double,8,/*REG_D8D*/0,0,D8L_REGNUM,sep,nopop,0},/*d8*/
{8,"d8.d",0,&builtin_type_double,8,/*REG_D8D*/0,0,D8L_REGNUM,dp,nopop,0},/*d8.d*/
{4,"d8.l",0,&builtin_type_int,4,/*REG_D8L*/0,0,0,not_fp,nopop,D8_REGNUM},/*d8.l*/
{4,"d8.m",0,&builtin_type_int,4,/*REG_D8M*/0,0,0,not_fp,nopop,D8_REGNUM},/*d8.m*/
{4,"d8.h",0,&builtin_type_int,4,/*REG_D8H*/0,0,0,not_fp,nopop,D8_REGNUM},/*d8.h*/
{8,"d8.ml",0,&builtin_type_double,8,/*REG_D8ML*/0,0,D8L_REGNUM,dp2,nopop,0},/*d8.ml*/
{4,"d8.s",0,&builtin_type_float,4,/*REG_D8S*/0,0,D8L_REGNUM,sp,nopop,0},/*d8.s*/
{8,"d8.x",0,&builtin_type_double,8,/*REG_D8D*/0,0,D8L_REGNUM,sep,nopop,0},/*d8.x*/
{8,"d9",0,&builtin_type_double,8,/*REG_D9D*/0,0,D9L_REGNUM,sep,nopop,0},/*d9*/
{8,"d9.d",0,&builtin_type_double,8,/*REG_D9D*/0,0,D9L_REGNUM,dp,nopop,0},/*d9.d*/
{4,"d9.l",0,&builtin_type_int,4,/*REG_D9L*/0,0,0,not_fp,nopop,D9_REGNUM},/*d9.l*/
{4,"d9.m",0,&builtin_type_int,4,/*REG_D9M*/0,0,0,not_fp,nopop,D9_REGNUM},/*d9.m*/
{4,"d9.h",0,&builtin_type_int,4,/*REG_D9H*/0,0,0,not_fp,nopop,D9_REGNUM},/*d9.h*/
{8,"d9.ml",0,&builtin_type_double,8,/*REG_D9ML*/0,0,D9L_REGNUM,dp2,nopop,0},/*d9.ml*/
{4,"d9.s",0,&builtin_type_float,4,/*REG_D9S*/0,0,D9L_REGNUM,sp,nopop,0},/*d9.s*/
{8,"d9.x",0,&builtin_type_double,8,/*REG_D9D*/0,0,D9L_REGNUM,sep,nopop,0},/*d9.x*/
{4,"dco0",0,&builtin_type_unsigned_int,4,/*MR_DCO0*/0,0,0,not_fp,nopop,0},/*dco0*/
{4,"dco1",0,&builtin_type_unsigned_int,4,/*MR_DCO1*/0,0,0,not_fp,nopop,0},/*dco1*/
{4,"dcs0",0,&builtin_type_unsigned_int,4,/*MR_DCS0*/0,0,0,not_fp,nopop,0},/*dcs0*/
{4,"dcs1",0,&builtin_type_unsigned_int,4,/*MR_DCS1*/0,0,0,not_fp,nopop,0},/*dcs1*/
{4,"ddm0",0,&builtin_type_unsigned_int,4,/*MR_DDM0*/0,0,0,not_fp,nopop,0},/*ddm0*/
{4,"ddm1",0,&builtin_type_unsigned_int,4,/*MR_DDM1*/0,0,0,not_fp,nopop,0},/*ddm1*/
{4,"ddn0",0,&builtin_type_unsigned_int,4,/*MR_DDN0*/0,0,0,not_fp,nopop,0},/*ddn0*/
{4,"ddn1",0,&builtin_type_unsigned_int,4,/*MR_DDN1*/0,0,0,not_fp,nopop,0},/*ddn1*/
{4,"ddr0",0,&builtin_type_unsigned_int,4,/*MR_DDR0*/0,0,0,not_fp,nopop,0},/*ddr0*/
{4,"ddr1",0,&builtin_type_unsigned_int,4,/*MR_DDR1*/0,0,0,not_fp,nopop,0},/*ddr1*/
{4,"dsm0",0,&builtin_type_unsigned_int,4,/*MR_DSM0*/0,0,0,not_fp,nopop,0},/*dsm0*/
{4,"dsm1",0,&builtin_type_unsigned_int,4,/*MR_DSM1*/0,0,0,not_fp,nopop,0},/*dsm1*/
{4,"dsn0",0,&builtin_type_unsigned_int,4,/*MR_DSN0*/0,0,0,not_fp,nopop,0},/*dsn0*/
{4,"dsn1",0,&builtin_type_unsigned_int,4,/*MR_DSN1*/0,0,0,not_fp,nopop,0},/*dsn1*/
{4,"dsr0",0,&builtin_type_unsigned_int,4,/*MR_DSR0*/0,0,0,not_fp,nopop,0},/*dsr0*/
{4,"dsr1",0,&builtin_type_unsigned_int,4,/*MR_DSR1*/0,0,0,not_fp,nopop,0},/*dsr1*/
{4,"ictr",0,&builtin_type_unsigned_int,4,/*REG_ICNT*/0,0,0,not_fp,nopop,0},/*ictr*/
{4,"ipr",0,&builtin_type_unsigned_int,4,/*MR_IPR*/0,0,0,not_fp,nopop,0},/*ipr*/
{4,"la",0,&builtin_type_unsigned_int,4,/*REG_LA*/0,0,0,not_fp,nopop,0},/*la*/
{4,"lc",0,&builtin_type_unsigned_int,4,/*REG_LC*/0,0,0,not_fp,nopop,0},/*lc*/
{4,"m0",0,&builtin_type_unsigned_int,4,/*REG_M0*/0,0,0,not_fp,nopop,0},/*m0*/
{4,"m1",0,&builtin_type_unsigned_int,4,/*REG_M1*/0,0,0,not_fp,nopop,0},/*m1*/
{4,"m2",0,&builtin_type_unsigned_int,4,/*REG_M2*/0,0,0,not_fp,nopop,0},/*m2*/
{4,"m3",0,&builtin_type_unsigned_int,4,/*REG_M3*/0,0,0,not_fp,nopop,0},/*m3*/
{4,"m4",0,&builtin_type_unsigned_int,4,/*REG_M4*/0,0,0,not_fp,nopop,0},/*m4*/
{4,"m5",0,&builtin_type_unsigned_int,4,/*REG_M5*/0,0,0,not_fp,nopop,0},/*m5*/
{4,"m6",0,&builtin_type_unsigned_int,4,/*REG_M6*/0,0,0,not_fp,nopop,0},/*m6*/
{4,"m7",0,&builtin_type_unsigned_int,4,/*REG_M7*/0,0,0,not_fp,nopop,0},/*m7*/
{4,"n0",0,&builtin_type_unsigned_int,4,/*REG_N0*/0,0,0,not_fp,nopop,0},/*n0*/
{4,"n1",0,&builtin_type_unsigned_int,4,/*REG_N1*/0,0,0,not_fp,popit,0},/*n1*/
{4,"n2",0,&builtin_type_unsigned_int,4,/*REG_N2*/0,0,0,not_fp,popit,0},/*n2*/
{4,"n3",0,&builtin_type_unsigned_int,4,/*REG_N3*/0,0,0,not_fp,popit,0},/*n3*/
{4,"n4",0,&builtin_type_unsigned_int,4,/*REG_N4*/0,0,0,not_fp,popit,0},/*n4*/
{4,"n5",0,&builtin_type_unsigned_int,4,/*REG_N5*/0,0,0,not_fp,popit,0},/*n5*/
{4,"n6",0,&builtin_type_unsigned_int,4,/*REG_N6*/0,0,0,not_fp,popit,0},/*n6*/
{4,"n7",0,&builtin_type_unsigned_int,4,/*REG_N7*/0,0,0,not_fp,popit,0},/*n7*/
{4,"omr",0,&builtin_type_unsigned_int,4,/*REG_OMR*/0,0,0,not_fp,nopop,0},/*omr*/
{8,"pc",0,&builtin_type_unsigned_int,4,/*REG_PC*/0,0,0,not_fp2,nopop,0},/*pc*/
{4,"r0",0,&builtin_type_unsigned_int,4,/*REG_R0*/0,0,0,not_fp,nopop,0},/*r0*/
{4,"r1",0,&builtin_type_unsigned_int,4,/*REG_R1*/0,0,0,not_fp,popit,0},/*r1*/
{4,"r2",0,&builtin_type_unsigned_int,4,/*REG_R2*/0,0,0,not_fp,popit,0},/*r2*/
{4,"r3",0,&builtin_type_unsigned_int,4,/*REG_R3*/0,0,0,not_fp,popit,0},/*r3*/
{4,"r4",0,&builtin_type_unsigned_int,4,/*REG_R4*/0,0,0,not_fp,popit,0},/*r4*/
{4,"r5",0,&builtin_type_unsigned_int,4,/*REG_R5*/0,0,0,not_fp,popit,0},/*r5*/
{4,"r6",0,&builtin_type_unsigned_int,4,/*REG_R6*/0,0,0,not_fp,nopop,0},/*r6*/
{4,"r7",0,&builtin_type_unsigned_int,4,/*REG_R7*/0,0,0,not_fp,popit,0},/*r7*/
{8,"r6",0,&builtin_type_unsigned_int,4,/*REG_R6*/0,0,0,not_fp2,nopop,0},/*??sp*/
{4,"sr",0,&builtin_type_unsigned_int,4,/*REG_SR*/0,0,0,not_fp,popit,0},/*sr*/
{4,"ssh",0,&builtin_type_unsigned_int,4,/*REG_SSTH*/0,0,0,not_fp,nopop,0},/*ssh*/
{4,"ssl",0,&builtin_type_unsigned_int,4,/*REG_SSTL*/0,0,0,not_fp,nopop,0},/*ssl*/
{8,"r0",0,&builtin_type_unsigned_int,4,/*REG_R0*/0,0,0,not_fp2,nopop,0},/*??fp*/
{4,"ssp",0,&builtin_type_unsigned_int,4,/*REG_SP*/0,0,0,not_fp,nopop,0}/*ssp*/
};

static 
init_reg_info()
{
int i,j;
for (i=1,j=0;i<NUM_REGS;i++,j++){
 dsp_96k_reg_info[i].startbyte=
 dsp_96k_reg_info[j].startbyte+dsp_96k_reg_info[j].regbytes;
 };
}
dsp_96k_register_byte(regnumber)
int regnumber;
{
return (dsp_96k_reg_info[regnumber].startbyte);
}

dsp_96k_register_virtual_size(regnumber)
int regnumber;
{
return (TYPE_LENGTH( *dsp_96k_reg_info[regnumber].virtual_type));
}

dsp_96k_register_raw_size(regnumber)
int regnumber;
{
return (dsp_96k_reg_info[regnumber].regbytes);
}

struct type *
register_virtual_type(regnumber)
int regnumber;
{
return ( *dsp_96k_reg_info[regnumber].virtual_type);
}


/* m96k doesnt have ptrace */

int
call_ptrace (request, pid, arg3, arg4)
     int request, pid, arg3, arg4;
{
 if (request==0) return;
 error ("no ptrace");
}

void
kill_inferior ()
{
}

/* This is used when GDB is exiting.  It gives less chance of error.*/

void
kill_inferior_fast ()
{
}

static
void intrpt1()
{

   (void) signal(SIGINT,intrpt1);
   dv_var->CTRLBR = 1;
}

/* Resume execution of the inferior process.
   If STEP is nonzero, single-step it.
   If SIGNAL is nonzero, give it that signal.  */
extern CORE_ADDR text_end;

CORE_ADDR
printf_end_address;

static
unsigned long
send_address,receive_address;

CORE_ADDR
program_exit_address;

static
unsigned long
get_1st_arg ( )
{
    unsigned long value;
    value=hspr[REG_D0L];
    return value;
}

/* dig through the stack to get the 2nd argument to the current function.
   (which hasn't manipulated the stack pointer yet). */

static
unsigned long
get_2nd_arg ( )
{
    unsigned long value;
    value=hspr[REG_D1L];
    return value;
}

void
resume (step, signums)
     int step;
     int signums;
{
  extern void request_quit ();
  extern int cross_debugging_trap,trap_expected;
  extern CORE_ADDR step_resume_break_address;
  int printed_something;
  CORE_ADDR pc;
  struct dev_var *dv=dv_const.sv[0];
  if (remote_debugging)
    remote_resume (step, signums);
  else
    {
  dv_var->CTRLBR=0; /* flag cleared for break signal */
  (void) signal(SIGINT,intrpt1);
 cross_debugging_trap=0;
  printed_something=0;
do{
    if ( send_address && send_address == dv_var->reg_exec )
      {
	  /* we, as the host, are now going to *receive* some data.
	     the hio_receive buffer should be large enough to handle
	     the full transmission. */

	  unsigned long input_buffer, input_count;
	  int i;
	  
	  input_buffer = get_1st_arg ( );
	  input_count = get_2nd_arg ( );
	  hio_receive.length = input_count;
	  CHECK_BUFFER_SIZE ( & hio_receive, input_count );
	  
	  for ( i = 0; i < input_count; ++ i )
	  {
	      dsp_rmem ( 0, stmap, input_buffer ++, hio_receive.buffer + i );
	  }
	  hio_receive.valid_p = TRUE;
	  printed_something=1;
      }
      else if ( receive_address && receive_address == dv_var->reg_exec )
      {
	  /* the dsp is ready to receive a message, so we'll go ahead and
	     *send* it. the dsp should have allocated a buffer large 
	     enough to handle the full transmission. */

	  unsigned long output_buffer;
	  int i;
	  
	  output_buffer = get_1st_arg ( );
	  for ( i = 0; i < hio_send.length; ++ i )
	  {
	      dsp_wmem ( 0, stmap, output_buffer ++, hio_send.buffer + i );
	  }
	  hio_send.valid_p = FALSE;
      }
	/* Clear end-of-instruction and end-of-repeat flag bits */
	dv->flg_stat&= ~(DSP_GEOI|DSP_GEOR);
	while (!(dv->flg_stat& (DSP_GEOI|DSP_GEOR))) 
   dsp_exec(0);
	CORE_ADDR_ADDR(pc)=dv_var->reg_exec;

    process_pending_host_io();
    if ( printed_something){
	fflush(stdout);
	printed_something=0;
	}

 if (CORE_ADDR_ADDR(pc)==CORE_ADDR_ADDR(printf_end_address)&&
      CORE_ADDR_ADDR(pc)){
     /* read character string from memory address in x0 */
      char ch;
      CORE_ADDR printf_string_address;
      printf_string_address = FRAME_ZERO;
      CORE_ADDR_ADDR(printf_string_address)=
	  hspr[REG_D0L];
      if (CORE_ADDR_MAP(printf_string_address)==memory_map_l)
	  CORE_ADDR_MAP(printf_string_address)=memory_map_y;
      while (ch=read_memory_integer(printf_string_address,4)){
       putc(ch,stdout);
       if (dv_var->CTRLBR) break; /* break signal occurred */
       CORE_ADDR_ADDR(printf_string_address)+=1;
       }
      fflush(stdout);
      }	
 if (CORE_ADDR_ADDR(pc)==CORE_ADDR_ADDR(program_exit_address)){
   cross_debugging_trap=SIGCHLD;
   break;
   }
	if (step) break;
 if (dv_var->CTRLBR) break; /* break signal occurred */
	}while((!breakpoint_here_p(pc))&&
  /* following line tests for dummy function end address */
  (CORE_ADDR_ADDR(pc)!= (CORE_ADDR_ADDR(text_end) - 2)) &&
  ((!CORE_ADDR_ADDR(step_resume_break_address))||
  (CORE_ADDR_ADDR(pc)!=CORE_ADDR_ADDR(step_resume_break_address))));/*stop if step or breakpoint */
 (void) signal(SIGINT,request_quit);
 if (!cross_debugging_trap)
 cross_debugging_trap=(dv_var->CTRLBR)?SIGINT:SIGTRAP;
		}
}

union dsp_regs{
      char ra[REGISTER_BYTES];
   struct dsp_96k_registers rs;
      };


static
m96k_dep_to_reg_dp(src,dst)
unsigned long *src,*dst;
{
   unsigned long exponent,sign,mid,low;
   low=src[0]>>11;
   low|= src[1]<<21;
   mid= (src[1]>>11)&0xfffffl; /* upper part of significand */
   sign=src[2]&MSBIT;
   exponent= src[2]&0x7ffl;
   mid|=(exponent<<20)|sign;
   dst[0] =low;
   dst[1] =mid;
}

void
fetch_inferior_registers ()
{
  union dsp_regs inferior_registers;
  extern char registers[];
  int i;
  enum fptype regfptype;
  unsigned long sepbuf[3];
  long dpbuf[2];

  if (remote_debugging)
    remote_fetch_registers (registers);
  else
    { /* get all registers */
      for (i=0;i<NUM_REGS;i++){
	  regfptype=dsp_96k_reg_info[i].fptype;
	  if (regfptype==sep){
	      dsp_rreg(0,dsp_96k_reg_info[i].periph,dsp_96k_reg_info[i].regnum,sepbuf);
	      m96k_dep_to_reg_dp(sepbuf,
		                   (unsigned long *)&inferior_registers.ra[dsp_96k_reg_info[i].startbyte]);
	      }
	  else if(regfptype!=not_fp2)
	      dsp_rreg(0,dsp_96k_reg_info[i].periph,dsp_96k_reg_info[i].regnum,
		       (unsigned long *)&inferior_registers.ra[dsp_96k_reg_info[i].startbyte]);
	  }

      /* now take care of all the not_fp2 registers */

      *(unsigned long *)&inferior_registers.ra[dsp_96k_reg_info[PC_REGNUM].startbyte]=dv_var->reg_exec;
      *(unsigned long *)&inferior_registers.ra[dsp_96k_reg_info[SP_REGNUM].startbyte]=hspr[REG_R6];
      *(unsigned long *)&inferior_registers.ra[dsp_96k_reg_info[FP_REGNUM].startbyte]=hspr[REG_R0];
  *(unsigned long *)&inferior_registers.ra[dsp_96k_reg_info[SP_REGNUM].startbyte+sizeof(long)]= (long) CORE_ADDR_MAP(stack_zero);
  *(unsigned long *)&inferior_registers.ra[dsp_96k_reg_info[PC_REGNUM].startbyte+sizeof(long)]= (long) memory_map_p;
  *(unsigned long *)&inferior_registers.ra[dsp_96k_reg_info[FP_REGNUM].startbyte+sizeof(long)]= (long) CORE_ADDR_MAP(stack_zero);
      bcopy (&inferior_registers.ra[0], &registers[0], REGISTER_BYTES);
#if 0
      read_inferior_memory (inferior_registers.r_sp,
             &registers[REGISTER_BYTE (16)],
             16*4);
#endif
    }
}

static
m96k_dep_to_dp(src,dst)
long *src,*dst;
{
   unsigned long exponent,sign,mid,low;
   low=src[0]>>11;
   low|= src[1]<<21;
   mid= (src[1]>>11)&0xfffffl; /* upper part of significand */
   sign=src[2]&MSBIT;
   exponent= src[2]&0x7ffl;
   mid|=(exponent<<20)|sign;
   if (LMAP){
       dst[0] =low;
       dst[1] =mid;
       }
   else{
       dst[1] =low;
       dst[0] =mid;
       }

}


static 
m96k_dep_to_sp(src,dst)
long *src,*dst;
{
   unsigned long mantissa,exponent,sign;
   mantissa=(src[1]>>8)&0x7fffffl;
   sign=src[2]&MSBIT;
   exponent=src[2]&0x7fl;
   if (src[2]&0x400l) exponent|=0x80l;
   dst[0]= sign|(exponent<<23)|mantissa;
}

static
m96k_dp_to_sep(src,dst)
long *src,*dst;
{
   unsigned long lsb,msb;
   unsigned long exponent,sign,mid,high,low;
   if (LMAP){
       lsb=src[0]; msb=src[1];
       }
   else{
       lsb=src[1]; msb=src[0];
       }
   low=0l;
   mid=(lsb>>21)|((msb&0xfffffl)<<11);
   sign=msb&MSBIT;
   exponent=(msb>>20)&0x7ffl;
   high=exponent|sign;
   if (!exponent){ /* check for denormalized or zero */
      if (mid) high|=UTAG; /* denormalized sep number */
      }  
   else mid|=MSBIT; /* integer implied 1 bit is set */
   dst[0]=low;
   dst[1]=mid;
   dst[2]=high;
}

static
m96k_dp_to_dep(src,dst)
long *src,*dst;
{
   unsigned long lsb,msb;
   unsigned long exponent,sign,mid,high,low;
   if (LMAP){
       lsb=src[0]; msb=src[1];
       }
   else{
       lsb=src[1]; msb=src[0];
       }
   low=lsb<<11;
   mid=(lsb>>21)|((msb&0xfffffl)<<11);
   sign=msb&MSBIT;
   exponent=(msb>>20)&0x7ffl;
   high=exponent|sign;
   if (!exponent){ /* check for denormalized or zero */
      if (mid) high|=VTAG; /* denormalized sep number */
      }  
   else mid|=MSBIT; /* integer implied 1 bit is set */
   dst[0]=low;
   dst[1]=mid;
   dst[2]=high;
}

static
m96k_sp_to_dep(src,dst)
long *src,*dst;
{
   unsigned long from,mantissa,exponent,sign,high;
   from=src[0];
   mantissa=(from&0x7fffffl)<<8;
   sign=from&MSBIT;
   exponent=(from>>23)&0xffl;
   high=(exponent&0x7f)|sign;
   if (exponent==0xffl) high|=0x7ffl; /* inf or nan */
   else high|= (exponent&0x80l)?0x400l:0x380l; /* invert exponent msb */
   if (!exponent){ /* check for denormalized or zero */
      if (mantissa) high|=UTAG; /* denormalized single precision number */
      else high=sign; /* true zero */
      }  
   else mantissa|=MSBIT; /* integer implied 1 bit is set */
   dst[0]=0l; /* clear bits 0..31 in low word */
   dst[1]=mantissa;
   dst[2]=high;
}

static 
update_fp_views(regno)
int regno; /* must be Dn_REGNUM from enum regnums */
{
    unsigned long *sepbuf,*dnbuf,*dndbuf,*dnmlbuf,*dnxbuf;
    long *dnsbuf;
    extern char registers[];
    sepbuf= (unsigned long *)&registers[dsp_96k_reg_info[regno+2].startbyte];
    /* Dn_REGNUM */
    dnbuf=(unsigned long *)&registers[dsp_96k_reg_info[regno].startbyte];
    m96k_dep_to_reg_dp(sepbuf,dnbuf);
    /* DnD_REGNUM */
    dndbuf=(unsigned long *)&registers[dsp_96k_reg_info[regno+1].startbyte];
    dndbuf[0]=dnbuf[0];  dndbuf[1]=dnbuf[1];
    /* DnML_REGNUM */
    dnmlbuf=(unsigned long *)&registers[dsp_96k_reg_info[regno+5].startbyte];
    dnmlbuf[0]=sepbuf[0]; dnmlbuf[1]=sepbuf[1];
    /* DnS_REGNUM */
    dnsbuf=(long *)&registers[dsp_96k_reg_info[regno+6].startbyte];
    m96k_dep_to_sp((long *)sepbuf,dnsbuf);
    /* DnX_REGNUM */
    dnxbuf=(unsigned long *)&registers[dsp_96k_reg_info[regno+7].startbyte];
    dnxbuf[0]=dnbuf[0];  dnxbuf[1]=dnbuf[1];
    }


/* Store our register values back into the inferior.
   If REGNO is -1, do this for all registers.
   Otherwise, REGNO specifies which register (so we can save time).  */
void
store_inferior_registers (regno)
     int regno;
{
  union dsp_regs inferior_registers;
  extern char registers[];
  int i,j,regoffset,xrsp,xrfp,xrthis;
  static int no_fp_reg_update;
 unsigned long newval,oldval;
 void remote_store_registers();

  xrsp=dsp_96k_reg_info[SP_REGNUM].regnum;
  xrfp=dsp_96k_reg_info[FP_REGNUM].regnum;
  if (remote_debugging)
    remote_store_registers (registers);
  else if (regno>=0){ /* single register number */
    i=regno;
    xrthis=dsp_96k_reg_info[i].regnum;
    regoffset=dsp_96k_reg_info[i].startbyte;
    newval= *(unsigned long *)&registers[regoffset];
    if(dsp_96k_reg_info[i].fptype==not_fp){
      dsp_rreg(0,dsp_96k_reg_info[i].periph,xrthis,&oldval);
      if (newval!=oldval){
	  dsp_wreg(0,dsp_96k_reg_info[i].periph,xrthis,&newval);
         if (dsp_96k_reg_info[i].periph==0){
	     if(xrthis==xrsp) write_register(SP_REGNUM,newval);
	     else if (xrthis==xrfp) write_register(FP_REGNUM,newval);
	     }
         }
      if ((no_fp_reg_update==0)&&((j= (int)dsp_96k_reg_info[i].fpupdate)))
	  update_fp_views(j); /* updates different views of L:M:H */
      }
    else if(i==PC_REGNUM){
      oldval= dv_var->reg_exec;
      if (newval!=oldval)
        dsp_wreg(0,0,xrthis,&newval);
      }
    else if (i==FP_REGNUM){
      oldval= hspr[REG_R0];
      if (newval!=oldval){
         dsp_wreg(0,0,REG_R0,&newval);
         write_register(R0_REGNUM,newval);
        }
      }
    else if (i==SP_REGNUM){
      oldval= hspr[REG_R6];
      if (newval!=oldval){
         dsp_wreg(0,0,REG_R6,&newval);
         write_register(R6_REGNUM,newval);
        }
      }
    else{ /* fp register values */
      int sz;
      int fpxref=dsp_96k_reg_info[i].fpxref;
      unsigned long  *newvalar ,*lp;
      newvalar= (unsigned long *)&registers[regoffset];
      regoffset=dsp_96k_reg_info[fpxref].startbyte;
      lp = (unsigned long *)&registers[regoffset]; /* L:M:H pointer */
      if (dsp_96k_reg_info[i].fptype==sep)/* sep registers */
          m96k_dp_to_sep(newvalar,lp);
      else if (dsp_96k_reg_info[i].fptype==dp)/* dnd registers */
          m96k_dp_to_dep(newvalar,lp);
      else if (dsp_96k_reg_info[i].fptype==sp) /* sp assignment via dns */
          m96k_sp_to_dep(newvalar,lp);
      else if (dsp_96k_reg_info[i].fptype==dp2){/* ml registers */
          lp[0]=newvalar[0];
          lp[1]=newvalar[1];
          }

      no_fp_reg_update=1;
      if(dsp_96k_reg_info[i].fptype!=dp2)/* ml registers */
          store_inferior_registers(fpxref+2); /* H register */
      store_inferior_registers(fpxref+1); /* M register */
      no_fp_reg_update=0;
      store_inferior_registers(fpxref); /* L register */
      }
   }
  else /* all registers */
    {
    int thisperiph;
      for (i=0;i<NUM_REGS;i++){
	  thisperiph=dsp_96k_reg_info[i].periph;
          xrthis=dsp_96k_reg_info[i].regnum;
				regoffset=dsp_96k_reg_info[i].startbyte;
          newval= *(unsigned long *)&registers[regoffset];
    if(dsp_96k_reg_info[i].fptype==not_fp
       ||(i==FP_REGNUM)||(i==SP_REGNUM)){
      dsp_rreg(0,thisperiph,xrthis, &oldval);
      if (newval!=oldval)
        dsp_wreg(0,thisperiph,xrthis,&newval);
      }
     }
    regoffset=dsp_96k_reg_info[PC_REGNUM].startbyte;
    oldval=dv_var->reg_exec; 
    newval= *(unsigned long *)&registers[regoffset];
    if (newval!=oldval)
	dsp_wreg(0,0,REG_PC,&newval);
#if 0
	  write_inferior_memory (*(int *)&registers[REGISTER_BYTE (SP_REGNUM)],
				 &registers[REGISTER_BYTE (16)],
				 16*4);
#endif
    }
}

/* Copy LEN bytes from inferior's memory starting at MEMADDR
   to debugger memory starting at MYADDR. */


int
read_inferior_memory (memaddr, myaddr, len)
     CORE_ADDR memaddr;
     char *myaddr;
     int len;
{
  register int i;
  long addr;
  register int count;
  register long *buffer;
  enum memory_map memmap; 
  int incr,buflen;
  memmap=CORE_ADDR_MAP(memaddr);
		count=len/4;
   incr= (memmap==memory_map_l||
	  memmap==memory_map_le||
	  memmap==memory_map_li||
	  memmap==memory_map_laa||
	  memmap==memory_map_lbb||
	  memmap==memory_map_lab||
	  memmap==memory_map_lba
	  )?2:1;

/* Allocate buffer of that many longwords.  */
buflen= (incr==1||len>4)?len:8;
buffer = (long *) alloca (buflen);

  /* Read all the longwords */
	addr=CORE_ADDR_ADDR(memaddr);
  for (i = 0; i < count; i+=incr, addr++ )
    dsp_rmem(0,memmap,addr,&buffer[i]);

  bcopy ((char *) buffer , myaddr, len);
  return 0;
}
#if 0
int
read_inferior_memory (memaddr, myaddr, len)
     CORE_ADDR memaddr;
     char *myaddr;
     int len;
{
  register int i;
  long addr;
  register int count;
  register long *buffer;
  enum memory_map memmap; 
 /* notice that l is converted to y mem since longs are in y serially */
  memmap= CORE_ADDR_MAP(memaddr);

		count=len/4;

/* Allocate buffer of that many longwords.  */
buffer = (long *) alloca (len);

  /* Read all the longwords */
	addr=CORE_ADDR_ADDR(memaddr);
  for (i = 0; i < count; i++, addr++ )
    dsp_rmem(0,memmap,addr,&buffer[i]);

  bcopy ((char *) buffer , myaddr, len);
  return 0;
}
#endif

/* Copy LEN bytes of data from debugger memory at MYADDR
   to inferior's memory at MEMADDR.*/


int
write_inferior_memory (memaddr, myaddr, len)
     CORE_ADDR memaddr;
     char *myaddr;
     int len;
{
  register int i;
  /* Round starting address down to longword boundary.  */
  long addr,*wordp, tval;
  /* Round ending address up; get number of longwords that makes.  */
  enum memory_map memmap;
 int incr;
  register int count;

  /* Write the entire buffer.  */
 memmap= CORE_ADDR_MAP(memaddr);

  count=len/4;
   incr= (memmap==memory_map_l||
	  memmap==memory_map_le||
	  memmap==memory_map_li||
	  memmap==memory_map_laa||
	  memmap==memory_map_lbb||
	  memmap==memory_map_lab||
	  memmap==memory_map_lba
	  )?2:1;

	addr=CORE_ADDR_ADDR(memaddr);
 wordp= (long *) myaddr;
  for (i = 0; i < count; i+=incr, addr++ )
    dsp_wmem(0,memmap,addr,wordp+i);

  return 0;
}
#if 0
int
write_inferior_memory (memaddr, myaddr, len)
     CORE_ADDR memaddr;
     char *myaddr;
     int len;
{
  register int i;
  /* Round starting address down to longword boundary.  */
  long addr,*wordp;
  /* Round ending address up; get number of longwords that makes.  */
  enum memory_map memmap;
  register int count;
count=len/4;

  /* Write the entire buffer.  */
  memmap= CORE_ADDR_MAP(memaddr);



	addr=CORE_ADDR_ADDR(memaddr);
 wordp= (long *) myaddr;
 wordp= (long *) myaddr;
  for (i = 0; i < count; i++, addr++,wordp++ )
    dsp_wmem(0,memmap,addr,wordp);

  return 0;
}
#endif
/* Non-zero if this is an object (.o) file, rather than an executable.
   Distinguishing between the two is rarely necessary (and seems like
   a hack, but there is no other way to get the text and data
   addresses--N_TXTADDR should probably take care of
   this, but it doesn't).  */
/* This definition will not work
   if someone decides to make ld preserve relocation info.  */
#define IS_OBJECT_FILE(hdr) (hdr.a_trsize != 0)

/* Make COFF and non-COFF names for things a little more compatible
   to reduce conditionals later.  */

#ifdef COFF_FORMAT
#define a_magic magic
#endif

#ifndef COFF_FORMAT
#ifndef AOUTHDR
#define AOUTHDR struct exec
#endif
#endif

extern char *sys_siglist[];

/* Hook for `exec_file_command' command to call.  */

extern void (*exec_file_display_hook) ();
   
/* File names of core file and executable file.  */

extern char *execfile;

/* Descriptors on which executable file are open.
   Note that the execchan is closed when an inferior is created
   and reopened if the inferior dies or is killed.  */

extern int execchan;

/* Last modification time of executable file.
   Also used in source.c to compare against mtime of a source file.  */

extern int exec_mtime;

/* Virtual addresses of bounds of the two areas of memory in the core file.  */

extern CORE_ADDR data_start;
extern CORE_ADDR data_end;
extern CORE_ADDR stack_start;
extern CORE_ADDR stack_end;

/* Virtual addresses of bounds of two areas of memory in the exec file.*/

extern CORE_ADDR text_start;

extern CORE_ADDR exec_data_start;
extern CORE_ADDR exec_data_end;

/* Address in executable file of start of text area data.  */

extern int text_offset;

/* Address in executable file of start of data area data.  */

extern int exec_data_offset;

/* Address in core file of start of data area data.  */

extern int data_offset;

/* Address in core file of start of stack area data.  */

extern int stack_offset;
  
#ifdef COFF_FORMAT
/* various coff data structures */

extern FILHDR file_hdr;
extern SCNHDR text_hdr;
extern SCNHDR data_hdr;

#endif /* not COFF_FORMAT */

/* a.out header of exec file.  */

extern AOUTHDR exec_aouthdr;

extern void validate_files ();

/*ARGSUSED*/
void
core_file_command (filename, from_tty)
     char *filename;
     int from_tty;
{/* maybe later load state files  with this?*/
 error ("No core files for m96k");
}

static
struct{ /* used for loading section data */
long block_size;
long *mem;
} raw_data;

void exec_file_command();
static
CORE_ADDR text_entry_address;

restart_cross_debugged_code(filename,from_tty) 
     char *filename;
     int from_tty;
{
exec_file_command (filename, from_tty);
/*dsp_wreg(0,0,REG_PC,&CORE_ADDR_ADDR(text_entry_address));*/
}


static
read_section_contents(chan)
     register int chan;
{
FILHDR fl_hdr;
AOUTHDR ao_hdr;
SCNHDR section_hdr;
register int i;

if (read_file_hdr(chan,&fl_hdr) < 0) return (-1);
if (read_aout_hdr(chan,&ao_hdr,(int)fl_hdr.f_opthdr) < 0) return (-1);
for (i=0;i<fl_hdr.f_nscns;i++){
if (lseek (chan, FILHSZ + fl_hdr.f_opthdr + (i * SCNHSZ) , 0) < 0)
  return -1;
if (myread (chan, (char *) &section_hdr, SCNHSZ) < 0)
  return -1;
#ifdef COFF_BYTE_SWAP
   swapem(&section_hdr,(unsigned long)SCNHSZ);
   swapem(section_hdr.s_name,8l);
#endif


if ((strncmp (section_hdr.s_name, ".txt", 8) == 0)||
   (strncmp (section_hdr.s_name, ".dat", 8) == 0)){
  /* load memory block */
  if (section_hdr.s_size > raw_data.block_size){
    /* expand raw data block size  to twice size of current block */
    if (raw_data.mem) raw_data.mem= 
            (long *) xrealloc((char *)raw_data.mem,
         (long) (section_hdr.s_size*2l)*sizeof(long));
    else raw_data.mem=
          (long *)xmalloc((long) (section_hdr.s_size*2l)*sizeof(long));
    raw_data.block_size=section_hdr.s_size*2l; 
		}
  if (lseek (chan,section_hdr.s_scnptr,0) < 0)
    return (-1);
  if (myread(chan,(char *)raw_data.mem,(int)(section_hdr.s_size*sizeof(long)))<0)
  return (-1);
#ifdef COFF_BYTE_SWAP
   swapem(raw_data.mem,(unsigned long)(section_hdr.s_size*sizeof(long)));
#endif

  if (section_hdr.s_flags&STYP_BLOCK){
    /* block data section specified by length:val */
    CORE_ADDR ct;
    unsigned long section_length;
    unsigned long val;
    ct= section_hdr.s_paddr;
    section_length = CORE_ADDR_ADDR(section_hdr.s_vaddr); 
    val = *(unsigned long *)raw_data.mem;
    for (;section_length!=0; section_length--){
      if(write_inferior_memory( ct,(char *)(char *)raw_data.mem,
          (int)(section_hdr.s_size*sizeof(long)))!=0)
         return (-1);
      CORE_ADDR_ADDR(ct)+=1;
      }
    }
   else
  if (write_inferior_memory(section_hdr.s_paddr,(char *)raw_data.mem,
     (int)(section_hdr.s_size*sizeof(long))) != 0)
 return (-1);
  }
}
 dsp_wreg(0,0,REG_PC,&CORE_ADDR_ADDR(ao_hdr.entry));
 text_entry_address=ao_hdr.entry;
if (raw_data.mem){
  free(raw_data.mem);
  raw_data.block_size=0;
  raw_data.mem= NULL;
  }
 return 0;
}


set_stack_type(module_stack_type)
unsigned long module_stack_type; /* 1=y,2=x,3=l */ 
{ 
module_stack_type&=3;
if (module_stack_type){
  enum memory_map stack_map=
   (module_stack_type==1)?memory_map_y:
   (module_stack_type==2)?memory_map_x: memory_map_l;
    CORE_ADDR_MAP(frame_zero_init)= stack_map;
    CORE_ADDR_MAP(stack_end_addr)= stack_map;
    CORE_ADDR_MAP(stack_zero)= stack_map;
  stmap= (stack_map==memory_map_x)?memory_map_x:memory_map_y;
/* these sizes need reinitialization based on stack space */
  TYPE_LENGTH(builtin_type_char)=SIZEOF_CHAR;
  TYPE_LENGTH(builtin_type_short)=SIZEOF_SHORT;
  TYPE_LENGTH(builtin_type_addr)=SIZEOF_POINTER;
  TYPE_LENGTH(builtin_type_long)=SIZEOF_LONG;
  TYPE_LENGTH(builtin_type_int)=SIZEOF_INT;
  TYPE_LENGTH(builtin_type_unsigned_char)=SIZEOF_UNSIGNED_CHAR;
  TYPE_LENGTH(builtin_type_unsigned_short)=SIZEOF_UNSIGNED_SHORT;
  TYPE_LENGTH(builtin_type_unsigned_int)=SIZEOF_UNSIGNED_INT;
  TYPE_LENGTH(builtin_type_unsigned_long)=SIZEOF_UNSIGNED_LONG;
  TYPE_LENGTH(builtin_type_float)=SIZEOF_FLT;
  TYPE_LENGTH(builtin_type_double)=SIZEOF_DOUBLE;
  }
} 

get_printf_stuff()
{
    int func_index;
    func_index=lookup_misc_func("__send");

    send_address=(func_index== -1)?0
	:CORE_ADDR_ADDR(misc_function_vector[func_index].address);

    func_index=lookup_misc_func("__receive");
    receive_address=(func_index== -1)?0
	:CORE_ADDR_ADDR(misc_function_vector[func_index].address);

func_index=lookup_misc_func("__printf_end");
 printf_end_address= CORE_ZERO;
if (func_index== -1){
 CORE_ADDR_ADDR( printf_end_address)=0;
 }
else{
 /* stop at this address for printf functions  - x0 will then
    have the address of the string in it for debugging printf.
 */

 CORE_ADDR_ADDR( printf_end_address)=
   CORE_ADDR_ADDR(misc_function_vector[func_index].address);
 }

 func_index=lookup_misc_func("__crt0_end");
 program_exit_address= CORE_ZERO;
if (func_index== -1){
 CORE_ADDR_ADDR( program_exit_address)=ADDR_BITS;
 }
else{

 CORE_ADDR_ADDR( program_exit_address)=
   CORE_ADDR_ADDR(misc_function_vector[func_index].address);
 }

}

#ifndef O_BINARY
#define O_BINARY 0
#endif

void
exec_file_command (filename, from_tty)
     char *filename;
     int from_tty;
{

  /* Eliminate all traces of old exec file.
     Mark text segment as empty.  */

dsp_init(0);
  data_start = CORE_ZERO;
  text_start = CORE_ZERO;
  text_end = CORE_ZERO;
  exec_data_start = CORE_ZERO;
  data_end = CORE_ZERO;
  exec_data_end = CORE_ZERO;
  if (execchan >= 0)
    close (execchan);
  execchan = -1;
  cross_debugging=0;

  /* Now open and digest the file the user requested, if any.  */

  if (filename)
    {
      filename = tilde_expand (filename);
      make_cleanup (free, filename);
      if (execfile)
	  free (execfile);
      execfile = 0;
      
      execchan = openp (getenv ("PATH"), 1, filename, O_RDONLY|O_BINARY, 0,
			&execfile);
      if (execchan < 0)
	perror_with_name (filename);
#ifdef COFF_FORMAT
      {
	int aout_hdrsize;
	int num_sections;

	if (read_file_hdr (execchan, &file_hdr) < 0)
	  error ("\"%s\": not in executable format.", execfile);

	aout_hdrsize = file_hdr.f_opthdr;
	num_sections = file_hdr.f_nscns;

	if (read_aout_hdr (execchan, &exec_aouthdr, aout_hdrsize) < 0)
	  error ("\"%s\": can't read optional aouthdr", execfile);

	if (read_section_hdr (execchan, _TEXT, &text_hdr, num_sections,
			      aout_hdrsize) < 0)/* just finds first ".text" section */
	  error ("\"%s\": can't read text section header", execfile);

	if (read_section_hdr (execchan, _DATA, &data_hdr, num_sections,
			      aout_hdrsize) < 0)
	  error ("\"%s\": can't read data section header", execfile);

 if (read_section_contents (execchan) < 0)
   error ("\"%s\": can't read section contents", execfile);

	text_start = exec_aouthdr.text_start;
 text_end = exec_aouthdr.text_end;
 CORE_ADDR_ADDR(text_end)+=CALL_DUMMY_LENGTH;
 {  /* clears out debug area */
    CORE_ADDR ct;
    unsigned long section_length;
    unsigned long val = 0; /* nop instruction */
    ct=exec_aouthdr.text_end;
    section_length = CALL_DUMMY_LENGTH;
    for (;section_length!=0; section_length--){
      write_inferior_memory( ct,(char *)&val, sizeof(long));
      CORE_ADDR_ADDR(ct)+=1;
      }
 }
	text_offset = text_hdr.s_scnptr; /* doesn't appear to be used */
	exec_data_start = exec_aouthdr.data_start;
	exec_data_end = exec_aouthdr.data_end;
	exec_data_offset = data_hdr.s_scnptr;/* doesn't appear to be used */
	data_start = exec_data_start;
	data_end = exec_data_start;
	exec_mtime = file_hdr.f_timdat;
      }
#endif /* COFF_FORMAT */

      validate_files ();
    }
  else{
      if (execfile)
           free (execfile);
      execfile = 0;
    if (from_tty)
      printf ("No exec file now.\n");
    }

  /* Tell display code (if any) about the changed file name.  */
  if (exec_file_display_hook)
    (*exec_file_display_hook) (filename);
  cross_debugging=1;
}


CORE_ADDR get_pc_function_start ();

/* for functions which do not update r0 (the fp), the old frame pointer
   location will need to be figured off the r6 value passed in thisframe->frame,
   otherwise the r0 value is passed in thisframe->fp, and this function will
   need to just back up one or two locations from the r0 value.
   */

static
CORE_ADDR
old_fp_location(thisframe)
FRAME thisframe; /* current fp value (stored in r0) */
{
    CORE_ADDR core_temp,pc_temp;
    int offset,nofp;
    unsigned long nextinsn,fp,pc,oldsp;
    
    if (CORE_ADDR_ADDR(thisframe->ofp))
	return (thisframe->ofp);
    core_temp=(thisframe)->frame;
    
    pc_temp = get_pc_function_start (thisframe->pc); 
    pc=CORE_ADDR_ADDR(pc_temp);
    dsp_rmem(0,memory_map_p,pc,&nextinsn);
    if ((nextinsn&0xfffff7ffl)==0x137a17cl){/* move ssh,x/y:(r6)+ first inst-> frameless*/
	offset=1; /* well, this is where it should have been */
	nofp=1;
	pc++;
	dsp_rmem(0,memory_map_p,pc,&nextinsn);
	}
    else if ((nextinsn&0xfbffffffl)==0x3287a000l){ /* move r0,y/x:(r6)+ */
	offset=1;
	pc++;
	dsp_rmem(0,memory_map_p,pc,&nextinsn);
	if ((nextinsn&0xfffff7ffl)==0x137a17cl){/* move ssh,x/y:(r6)+ */
	    pc++;
	    dsp_rmem(0,memory_map_p,pc,&nextinsn);
	    offset++;
	    }
	if ((nextinsn==0x0047a0a8l)|| /* lea (r6)+,r0 */
	    (nextinsn==0x015b7a000l)){ /* move (r6)+ */
	    offset++;
	    nofp=0;
	    }
	else if ((nextinsn==0xaea2000l)|| /* move r6,r0 */
	    (nextinsn==0x3b6d2000l)|| /* move #>xxxx,n6 */
	    ((nextinsn&0xff80007f)==0x800036)){ 
	    nofp=0;
	    }
	else nofp=1;
	}
    else{
	offset=0;
	nofp=1;
	}

    if (nofp){ /* well, we'll have to figure out what the fp should have been */
	while ( /* stack pointer was incremented for register stores */
	  ((nextinsn&0xf80fc000)==0x30078000l)|| /* move 0DDDDDD,x/y:(r6)+ */
	  ((nextinsn&0xfe0fc000l)==0x24078000l)|| /*move dn.ml,l:(r6)+ */
	  ((nextinsn&0xfc0fc000l)==0x28078000l)){ /*dn.l,x:(r6)+  dm.l,y: */
	    offset++;
	    pc++;
	    dsp_rmem(0,memory_map_p,pc,&nextinsn);
	    }

	/* If it just returned from a jsr, the stack will be larger from args */
	pc=CORE_ADDR_ADDR(thisframe->pc);
	dsp_rmem(0,memory_map_p,pc,&nextinsn);
	while (nextinsn==0x15b5a000l){ /* move (r6)- cleaning up args */
	    offset++; 
	    pc++;
	    dsp_rmem(0,memory_map_p,pc,&nextinsn);
	    /* check for epilog move x/y:(r6)-,0DDDDDD, or move L:(r6)-,LLL */
	    if(((nextinsn&0xf801c000)==0x38018000l)|| /* move x/y:(r6)-,0DDDDDD */
	       ((nextinsn&0xfe01c000l)==0x26018000l)|| /*move l:(r6)+,dn.ml */
	       ((nextinsn&0xfc01c000l)==0x2c018000l)) /*x:(r6)+,dn.l  y:,dm.l */
		offset--;
	    }
	/* now get the current sp value and adjust it by subtracting offset */
	if (thisframe->next)
	    core_temp=thisframe->next->ofp;
	else 
	    CORE_ADDR_ADDR(core_temp)=hspr[REG_R6];
	}

    if (CORE_ADDR_MAP(core_temp)==memory_map_l)
	CORE_ADDR_MAP(core_temp)= memory_map_y;
    CORE_ADDR_ADDR(core_temp)-=offset; /* address of old fp */

    thisframe->ofp=core_temp;
    return(core_temp);
    }

/*
 * Find the pc saved in frame FRAME if it is indeed saved by move ssh,x:(r6)+ 
 * as part of the preamble - it may be a leaf function,though - in which case
 * it is still in the hardware stack.
 */
CORE_ADDR
frame_saved_pc (frame)
     FRAME frame;
{
  CORE_ADDR retv;
  CORE_ADDR core_temp;
  CORE_ADDR pc_temp;
  unsigned long nextinsn,pc;
  int leaf,offset;
  pc_temp=get_pc_function_start (frame->pc);
  pc= CORE_ADDR_ADDR(pc_temp);

  dsp_rmem(0,memory_map_p,pc,&nextinsn);
  if ((nextinsn&0xfbffffffl)==0x3287a000l){ /* move r0,y/x:(r6)+ */
      pc++;
      offset=1;
      dsp_rmem(0,memory_map_p,pc,&nextinsn);
      }
  else offset=0; /* fp not saved on stack, so pc will be at 0 offset from pseudo fp */
  leaf=((nextinsn&0xfffff7ffl)==0x137a17cl)?0:1;/* move ssh,x/y:(r6)+ */
  CORE_ADDR_MAP(retv)=memory_map_p;
  if (leaf){ /* leaf function */
      CORE_ADDR_ADDR(retv)=saved_pc_after_call();
      }
  else{ /* pc saved on stack */
      core_temp=old_fp_location(frame);
      CORE_ADDR_ADDR(core_temp)+=offset;
      CORE_ADDR_ADDR(retv)=read_memory_integer(core_temp,4);
      }
  return (retv);
}

CORE_ADDR
frame_locals_address (fi)
  struct frame_info *fi;
{
  /* fix up frame pointer to adjust for arg offsets */
  /* it assumes that the symbol offsets will be supplied based 
     on the true fp, so just return the fp.
  */
  CORE_ADDR retv;
  retv=fi->frame;
  return (retv);
}
CORE_ADDR
frame_struct_args_address (fi)
  struct frame_info *fi;
{
  /* fix up frame pointer to adjust for arg offsets */
  /* it assumes that the symbol offsets will be supplied based 
     on the true fp.
  */
  CORE_ADDR retv;
  retv=fi->frame;
  return (retv);
}
frame_args_skip()
{
return (0);
}

CORE_ADDR
frame_args_address (fi)
  struct frame_info *fi;
{
  /* fix up frame pointer to adjust for arg offsets */
  /* it assumes that the symbol offsets will be supplied based 
     on the true fp.
  */
  CORE_ADDR retv;
  retv=fi->frame;
  return (retv);
}

struct command_line *get_breakpoint_commands ();

CORE_ADDR 
skip_prologue (pc)
     CORE_ADDR pc;
{
    int offset;
    unsigned long pc_temp;
    unsigned long nextinsn;
    pc_temp=CORE_ADDR_ADDR(pc);
    dsp_rmem(0,memory_map_p,pc_temp,&nextinsn);
    if ((nextinsn&0xfffff7ffl)==0x137a17cl)/* move ssh,x/y:(r6)+ */
	offset=1;
    else if ((nextinsn&0xfbffffffl)==0x3287a000l){ /* move r0,y/x:(r6)+ */
	pc_temp++;
	offset=1;
	dsp_rmem(0,memory_map_p,pc_temp,&nextinsn);
	
	if (nextinsn==0x0047a0a8l)  /* lea (r6)+,r0 */
	    offset++;
	else{
	    if ((nextinsn==0x015b7a000l)|| /* move (r6)+ */
		((nextinsn&0xfffff7ffl)==0x137a17cl)){ /* move ssh,x/y:(r6)+ */
		offset++;
		pc_temp++;
		dsp_rmem(0,memory_map_p,pc_temp,&nextinsn);
		}
	    if (nextinsn==0x3b6d2000l){ /* move #>xxxx,n6 */
		offset+=4; /* skip move to n,move r6,r0,move (r6)+n6 */
		}
	    else if ((nextinsn&0xff80007f)==0x800036){ /* move #<XXXX,n6 */
		offset+=3; /* skip move to n, move r6,r0, move (r6)+n6 */
		}
	    else{
		if (nextinsn==0xaea2000l){ /* move r6,r0 */
		    offset++;
		    pc_temp++;
		    dsp_rmem(0,memory_map_p,pc_temp,&nextinsn);
		    }
		if (nextinsn==0x15b7a000l){ /* move (r6)+ */
		    offset++;
		    }
		}
	    }
	}
    else offset=0;

    CORE_ADDR_ADDR(pc)+=offset;

    return (pc);
}

unsigned long
saved_pc_after_call()
{
    unsigned long ssh,pc,ni,oldsp,tsp;
    dsp_rreg(0,0,REG_SP,&oldsp);
    tsp=oldsp;
    
    /* get the last address on the stack that was from a jsr */
    while (tsp>1){ /* check for do instruction in the code */
	dsp_rreg(0,0,REG_SSH,&pc); /* get last pushed address */
	pc-=2;
	dsp_rmem(0,memory_map_p,pc,&ni);
	
	if ((ni&0xffc00000l)==0x01800000l){ /* DO instruction */
	    tsp-=2; /* two locations on stack for each do loop nest */
	    }
	else break;
	}
    
    if (tsp!=oldsp)
	dsp_wreg(0,0,REG_SP,&tsp);
    
    dsp_rreg(0,0,REG_SSH,&ssh);
    
    if (tsp!=oldsp)
	dsp_wreg(0,0,REG_SP,&oldsp);
    
    return ssh;
}

CORE_ADDR stack_end_addr;

/*Store the address of the place in which to copy the structure the
subroutine will return.  This is called from call_function. */

store_struct_return(addr,sp)
CORE_ADDR addr;
CORE_ADDR sp;
{
 write_register (D0L_REGNUM, CORE_ADDR_ADDR(addr));
}

store_return_value(data_type,valbuf)
struct type *data_type;
char *valbuf;
{ 
  LONGEST lbuf;

    if (TYPE_CODE (data_type) == TYPE_CODE_FLT){
      /* Floating-point values are returned in the register */
      /* formed by d0.d */
      write_register_bytes (REGISTER_BYTE (D0D_REGNUM), valbuf,
             TYPE_LENGTH (data_type),D0D_REGNUM); 
      }
    else 
      /* Other values are returned in register a1 for int or a10 for 
         longs.  */ 
      write_register_bytes (
         REGISTER_BYTE (D0L_REGNUM), 
          valbuf, TYPE_LENGTH (data_type),D0L_REGNUM);  
}

/*
  Given a value for the current fp, return the previous fp value.
  Sometimes it will not be there (frameless functions), but the
  other functions take care of this by keeping the old frame
  pointer location in thisframe->ofp - where it should have been
  even if it wasn't pushed.  The other functions use that value
  rather than the fp to backtrace.
*/


unsigned long
frame_chain(thisframe)
FRAME thisframe;
{
    unsigned long nextinsn;
    CORE_ADDR core_temp,pc_temp;
    unsigned long pc;

    pc_temp = get_pc_function_start (thisframe->pc); 
    pc=CORE_ADDR_ADDR(pc_temp);
    dsp_rmem(0,memory_map_p,pc,&nextinsn);
    core_temp=old_fp_location(thisframe);

    if ((nextinsn&0xfbffffffl)==0x3287a000l){ /* move r0,y/x:(r6)+ */
	/* lucky for us, the old frame ptr was actually pushed on the stack */
	dsp_rmem(0,CORE_ADDR_MAP(core_temp),CORE_ADDR_ADDR(core_temp),&nextinsn);
	}
    else nextinsn=hspr[REG_R0]; /* alas, r0 (the fp) wasn't pushed */

    return  ( nextinsn);
}

/* this only gets called if not a leaf.  In other words, we know that the old pc
   is saved on the stack */
int
frame_chain_valid(chain,thisframe)
CORE_ADDR chain;
FRAME thisframe;
{
    int rv;
    unsigned long spc,epc;
    spc=CORE_ADDR_ADDR((FRAME_SAVED_PC (thisframe)));
    epc=CORE_ADDR_ADDR(program_exit_address);
    
    rv=(spc&&(spc!=epc)&&(spc!=epc-1)&&(spc!=epc-2))?1:0;
    return (rv);
}

/* Extract from an array REGBUF containing the (raw) register state
   the return value of the function 
*/

extract_return_value(data_type,regbuf,valbuf)
char regbuf[REGISTER_BYTES];
struct type *data_type;
char *valbuf;
{
long lpa[3], *dst;

lpa[0]= *(long *) &regbuf[REGISTER_BYTE (D0L_REGNUM)];
lpa[1]= *(long *) &regbuf[REGISTER_BYTE (D0M_REGNUM)];
lpa[2]= *(long *) &regbuf[REGISTER_BYTE (D0H_REGNUM)];
dst= (long *) valbuf;
if (data_type==builtin_type_float){
/* single precision fp value */
m96k_dep_to_sp(lpa,dst);
}
else if (data_type==builtin_type_double){
/* double precision fp value */
m96k_dep_to_dp(lpa,dst);
}
else{
*dst= lpa[0]; /* d0.l value */
}

}

static int dn_reg[]={
D0S_REGNUM,D1S_REGNUM,D2S_REGNUM,D3S_REGNUM,D4S_REGNUM,D5S_REGNUM,D6S_REGNUM,D7S_REGNUM,
D0L_REGNUM,D1L_REGNUM,D2L_REGNUM,D3L_REGNUM,D4L_REGNUM,D5L_REGNUM,D6L_REGNUM,D7L_REGNUM,D0M_REGNUM,D1M_REGNUM,D2M_REGNUM,D3M_REGNUM,D4M_REGNUM,D5M_REGNUM,D6M_REGNUM,D7M_REGNUM,D0H_REGNUM,D1H_REGNUM,D2H_REGNUM,D3H_REGNUM,D4H_REGNUM,D5H_REGNUM,D6H_REGNUM,D7H_REGNUM,
D8L_REGNUM,D8L_REGNUM,D8M_REGNUM,D9M_REGNUM,D8H_REGNUM,D9H_REGNUM,D8S_REGNUM,D9S_REGNUM,R0_REGNUM,R1_REGNUM,R2_REGNUM,R3_REGNUM,R4_REGNUM,R5_REGNUM,R6_REGNUM,R7_REGNUM,
N0_REGNUM,N1_REGNUM,N2_REGNUM,N3_REGNUM,N4_REGNUM,N5_REGNUM,N6_REGNUM,N7_REGNUM,M0_REGNUM,M1_REGNUM,M2_REGNUM,M3_REGNUM,M4_REGNUM,M5_REGNUM,M6_REGNUM,M7_REGNUM};
static int dm_reg[]={D0M_REGNUM,D1M_REGNUM,D2M_REGNUM,D3M_REGNUM,D4M_REGNUM,D5M_REGNUM,
D6M_REGNUM,D7M_REGNUM,D0M_REGNUM,D1M_REGNUM,D2M_REGNUM,D3M_REGNUM,D4M_REGNUM,D5M_REGNUM,
D6M_REGNUM,D7M_REGNUM};
static int dl_reg[]={D0L_REGNUM,D1L_REGNUM,D2L_REGNUM,D3L_REGNUM,D4L_REGNUM,D5L_REGNUM,
D6L_REGNUM,D7L_REGNUM,D0L_REGNUM,D1L_REGNUM,D2L_REGNUM,D3L_REGNUM,D4L_REGNUM,D5L_REGNUM,
D6L_REGNUM,D7L_REGNUM};

/* Extract from an array REGBUF containing the (raw) register state
   the address in which a function should return its structure value,
   as a CORE_ADDR (or an expression that can be used as one).  
   The address is held in register a1 and should point to ymem */


CORE_ADDR
extract_struct_value_address(regbuf)
char regbuf[REGISTER_BYTES];
{
  CORE_ADDR core_temp;
  core_temp=FRAME_ZERO; /* initialize for y memory */
  CORE_ADDR_ADDR(core_temp)= 
   *(long *)&regbuf[REGISTER_BYTE (D0L_REGNUM)]; /* D0L position */
  return (core_temp);
}


frame_find_saved_registers(fip,fsrp)
 struct frame_info *fip;
 struct frame_saved_regs *fsrp;
{
    int reg_field;
    int reg_index;
    int fpyes,pcyes;
   CORE_ADDR next_addr;
  unsigned long spill_offset;
   CORE_ADDR pc;
  unsigned long pc_temp,nextinsn;
  int regnum;

  bzero (fsrp, sizeof *fsrp);
    spill_offset=0;

  if (CORE_ADDR_ADDR(fip->pc) >= (CORE_ADDR_ADDR(text_end) - 
      CALL_DUMMY_LENGTH))  /* dummy frame */
    { 
      next_addr = fip->frame;             
      pc = fip->pc;
      for (regnum = 0; regnum< NUM_REGS ;regnum++){
	  if(dsp_96k_reg_info[regnum].popflag==popit){
	      fsrp->regs[regnum]= next_addr;
	      CORE_ADDR_ADDR(next_addr)+=1;
	      }
	  }

#if 0
      fsrp->regs[SP_REGNUM] = fip->frame;  /* ??? is this implied?? */
      CORE_ADDR_ADDR(fsrp->regs[SP_REGNUM])-=3;
#endif

      fsrp->regs[FP_REGNUM] = fip->frame; 
      CORE_ADDR_ADDR(fsrp->regs[FP_REGNUM])-=2;
      fsrp->regs[PC_REGNUM] = fip->frame;  
      CORE_ADDR_ADDR(fsrp->regs[PC_REGNUM])-=1;
    }
  else { 
   /* for real function calls, the code at the start of the function is one of
      several prologs defined in prolog.doc.
      */
      fpyes=pcyes=0;
      pc = get_pc_function_start (fip->pc); 
      pc_temp=CORE_ADDR_ADDR(pc);
      dsp_rmem(0,memory_map_p,pc_temp,&nextinsn);
      if ((nextinsn&0xfbffffffl)==0x3287a000l){ /* move r0,y/x:(r6)+ */
	  pc_temp++;
	  dsp_rmem(0,memory_map_p,pc_temp,&nextinsn);

	  if(nextinsn==0x0047a0a8l){ /* lea (r6)+,r0 */
	      fpyes=1; /* old frame pointer is at r0-1 */
	      pc_temp++;
	      dsp_rmem(0,memory_map_p,pc_temp,&nextinsn);
	    }
	  else{
	      if (nextinsn==0x015b7a000l){ /* move (r6)+ */
		  fpyes=2; /* old fp will be at r0-2 */
		  pc_temp++;
		  dsp_rmem(0,memory_map_p,pc_temp,&nextinsn);
		  }
	      else if ((nextinsn&0xfffff7ffl)==0x137a17cl){ /* move ssh,x/y:(r6)+ */
		  fpyes=2; /* old fp will be at r0-2 */
		  pcyes=1; /* old pc will be at r0-1 */
		  pc_temp++;
		  dsp_rmem(0,memory_map_p,pc_temp,&nextinsn);
		  }
	      else fpyes=1; /* old fp will be at r0-1 */

	      if (nextinsn==0x3b6d2000l){ /* move #>xxxx,n6;move r6,r0;move(r6)+n6 */
		  pc_temp++;
		  dsp_rmem(0,memory_map_p,pc_temp,&spill_offset);
		  pc_temp+=3;
		  dsp_rmem(0,memory_map_p,pc_temp,&nextinsn);
		  }
	      else if ((nextinsn&0xff80007f)==0x800036l){ /* move #<XXXX,n6;move r6,r0;move (r6)+n6 */
		  spill_offset= ((nextinsn &0x7f80l)>>7);
		  pc_temp+=3;
		  dsp_rmem(0,memory_map_p,pc_temp,&nextinsn);
		}
	      else if (nextinsn==0xaea2000l){ /* move r6,r0 */
		    pc_temp++;
		    dsp_rmem(0,memory_map_p,pc_temp,&nextinsn);
		    if (nextinsn==0x15b7a000l){ /* move (r6)+ */
			spill_offset=1;
			pc_temp++;
			dsp_rmem(0,memory_map_p,pc_temp,&nextinsn);
			}
		    }
	      }
	  }
      else if ((nextinsn&0xfffff7ffl)==0x137a17cl){ /* move ssh,x/y:(r6)+ */
	  pcyes=1; /* old pc will be at r0-1 */
	  pc_temp++;
	  dsp_rmem(0,memory_map_p,pc_temp,&nextinsn);
	  }


      next_addr = fip->frame ;
      /* start of register spill space */
      CORE_ADDR_ADDR(next_addr)+= spill_offset; 

      /* decode following instructions for move regname,y:(r6)+ 
	 which saves registers in spill space on stack */
      for(;;){
	  if ((nextinsn&0xf80fffff)==0x3007a000l){ /* move 0DDDDDD,x/y:(r6)+ */
	      CORE_ADDR_MAP(next_addr)=(nextinsn&0x4000000l)?memory_map_y:memory_map_x;
	      reg_field=(nextinsn>>20)&0x3f;
	      reg_index=dn_reg[reg_field];
	      fsrp->regs[reg_index]= next_addr;
	      }
	  else if ((nextinsn&0xfe0fffffl)==0x2407a000l){ /*move dn.ml,l:(r6)+ */
	      CORE_ADDR_MAP(next_addr)=memory_map_x;
	      reg_field=(nextinsn>>20)&0x1f;
	      reg_index=dm_reg[reg_field];
	      fsrp->regs[reg_index]= next_addr;
	      CORE_ADDR_MAP(next_addr)=memory_map_y;
	      reg_index=dl_reg[reg_field];
	      fsrp->regs[reg_index]= next_addr;
	      }
	  else if ((nextinsn&0xfc0fffffl)==0x2807a000l){ /*dn.l,x:(r6)+  dm.l,y: */
	      CORE_ADDR_MAP(next_addr)=memory_map_x;
	      reg_field=(nextinsn>>20)&7;
	      reg_index=dl_reg[reg_field];
	      fsrp->regs[reg_index]= next_addr;
	      CORE_ADDR_MAP(next_addr)=memory_map_y;
	      reg_field=(nextinsn>>23)&7;
	      reg_index=dl_reg[reg_field];
	      fsrp->regs[reg_index]= next_addr;
	      }
	  else break; /* end of the instructions which save registers */
	  
	  CORE_ADDR_ADDR(next_addr)+=1;
	  pc_temp++;
	  dsp_rmem(0,memory_map_p,pc_temp,&nextinsn);
	  }
      if (fpyes){
	  fsrp->regs[FP_REGNUM] = fip->frame; 
	  CORE_ADDR_ADDR(fsrp->regs[FP_REGNUM])-=fpyes;
	  }
      if (pcyes){
	  fsrp->regs[PC_REGNUM] = fip->frame;  
	  CORE_ADDR_ADDR(fsrp->regs[PC_REGNUM])-=1;
	  }
      }

}

/* cross reference from the compiler reginster number to the
 index of the register used by the debugger. 
*/

enum regnums
regvar_xref[]={
D0L_REGNUM,
D0M_REGNUM,
D0H_REGNUM,
D1L_REGNUM,
D1M_REGNUM,
D1H_REGNUM,
D2L_REGNUM,
D2M_REGNUM,
D2H_REGNUM,
D3L_REGNUM,
D3M_REGNUM,
D3H_REGNUM,
D4L_REGNUM,
D4M_REGNUM,
D4H_REGNUM,
D5L_REGNUM,
D5M_REGNUM,
D5H_REGNUM,
D6L_REGNUM,
D6M_REGNUM,
D6H_REGNUM,
D7L_REGNUM,
D7M_REGNUM,
D7H_REGNUM,
R0_REGNUM,
R1_REGNUM,
R2_REGNUM,
R3_REGNUM,
R4_REGNUM,
R5_REGNUM,
R6_REGNUM,
R7_REGNUM,
N0_REGNUM,
N1_REGNUM,
N2_REGNUM,
N3_REGNUM,
N4_REGNUM,
N5_REGNUM,
N6_REGNUM,
N7_REGNUM
};

enum regnums
regvar_fxref[]={
D0D_REGNUM,
D0M_REGNUM,
D0H_REGNUM,
D1D_REGNUM,
D1M_REGNUM,
D1H_REGNUM,
D2D_REGNUM,
D2M_REGNUM,
D2H_REGNUM,
D3D_REGNUM,
D3M_REGNUM,
D3H_REGNUM,
D4D_REGNUM,
D4M_REGNUM,
D4H_REGNUM,
D5D_REGNUM,
D5M_REGNUM,
D5H_REGNUM,
D6D_REGNUM,
D6M_REGNUM,
D6H_REGNUM,
D7D_REGNUM,
D7M_REGNUM,
D7H_REGNUM,
R0_REGNUM,
R1_REGNUM,
R2_REGNUM,
R3_REGNUM,
R4_REGNUM,
R5_REGNUM,
R6_REGNUM,
R7_REGNUM,
N0_REGNUM,
N1_REGNUM,
N2_REGNUM,
N3_REGNUM,
N4_REGNUM,
N5_REGNUM,
N6_REGNUM,
N7_REGNUM
};

/* Things needed for making the inferior call functions.  */
 /*
 *   PUSH_DUMMY_FRAME saves the registers above sp' and pushes the
 * register file stack down one.
 *
 *   call_function then writes CALL_DUMMY, pushes the args onto the
 * stack, and adjusts the stack pointer.
 *
 *   run_stack_dummy then starts execution (in the middle of
 * CALL_DUMMY, as directed by call_function).
 */

/* Push an empty stack frame, to record the current PC, etc.  */
CORE_ADDR push_word (),read_register();
 
push_dummy_frame()
{
 int regnum;
  CORE_ADDR sp;
  sp = read_register (SP_REGNUM);
  sp = push_word (sp, CORE_ADDR_ADDR(read_register (FP_REGNUM)));
  sp = push_word (sp, CORE_ADDR_ADDR(read_register (PC_REGNUM))); 
  write_register (FP_REGNUM, CORE_ADDR_ADDR(sp));
  for (regnum = 0; regnum< NUM_REGS ;regnum++)
    if(dsp_96k_reg_info[regnum].popflag==popit)
      sp = push_word (sp, CORE_ADDR_ADDR(read_register (regnum))); 
  
  write_register (SP_REGNUM, CORE_ADDR_ADDR(sp)); 
}

/* return 1 if parameter i is register, 0 otherwise */
int arg_reg_param(addr,argn)
CORE_ADDR addr;
int argn;
{
 struct block *bl, *block_for_pc();
 struct symbol *sym;
 int nsyms,i,j;

 if ((bl=block_for_pc(addr))&& (sym=block_function(bl))){
     bl=SYMBOL_BLOCK_VALUE(sym);
     nsyms = BLOCK_NSYMS (bl);
     for (i = 0,j=0; i < nsyms; i++){
	 sym = BLOCK_SYM (bl, i);
	 if (SYMBOL_CLASS (sym) != LOC_REGPARM
	     && SYMBOL_CLASS (sym) != LOC_ARG
	     && SYMBOL_CLASS (sym) != LOC_REF_ARG)
	     continue;
	 if (j++ ==argn){
	     return ((SYMBOL_CLASS (sym) == LOC_REGPARM)?1:0);
	     }
	 }
     }
 return (0);
}     

fix_call_dummy(dummycode, dummyaddr, funaddr, nargs, value_type)
REGISTER_TYPE *dummycode;
CORE_ADDR funaddr,dummyaddr;
int nargs;
struct type *value_type;
{
    int i,j;
    for (i=0,j=0;i<nargs;i++)
	if (arg_reg_param(funaddr,i)) j++;
    nargs-=j; /* number of args on stack */
    *(dummycode+1) = CORE_ADDR_ADDR(funaddr); 
    *(dummycode+3)=nargs;
    }

extern value value_assign(),value_from_register();

put_reg_param(addr,argn,argv)
CORE_ADDR addr;
int argn;
value argv;
{
    value val;
 struct block *bl, *block_for_pc();
 struct symbol *sym;
 int nsyms,i,j;

 if ((bl=block_for_pc(addr))&& (sym=block_function(bl))){
     bl=SYMBOL_BLOCK_VALUE(sym);
     nsyms = BLOCK_NSYMS (bl);
     for (i = 0,j=0; i < nsyms; i++){
	 sym = BLOCK_SYM (bl, i);
	 if (SYMBOL_CLASS (sym) != LOC_REGPARM
	     && SYMBOL_CLASS (sym) != LOC_ARG
	     && SYMBOL_CLASS (sym) != LOC_REF_ARG)
	     continue;
	 if (j++ ==argn){
	     val = value_from_register (SYMBOL_TYPE (sym),
					CORE_ADDR_ADDR(SYMBOL_VALUE (sym)),
					0);
	     val = value_assign(val,argv);
	     return ;
	     }
	 }
     }

    }

/* Discard from the stack the innermost frame,
   restoring all saved registers.  */

pop_frame()
{
FRAME frame = get_current_frame (); 
   CORE_ADDR fp; 
  int regnum;
  struct frame_saved_regs fsr; 
  struct frame_info *fi;
  fi = get_frame_info (frame); 
  fp = fi->frame; 
  get_frame_saved_regs (fi, &fsr); 
  for (regnum = 0; regnum< NUM_REGS ;regnum++){
    if(dsp_96k_reg_info[regnum].popflag==popit){
      if (CORE_ADDR_ADDR(fsr.regs[regnum])) 
      write_register (regnum, read_memory_integer (fsr.regs[regnum], 4));
    }
   }
  CORE_ADDR_ADDR(fp)--;
  write_register (PC_REGNUM, read_memory_integer (fp, 4));
  CORE_ADDR_ADDR(fp)--;
  write_register (FP_REGNUM, read_memory_integer (fp, 4));
  /*CORE_ADDR_ADDR(fp)--;*/
  write_register (SP_REGNUM, CORE_ADDR_ADDR(fp) );
  flush_cached_frames ();
  set_current_frame (create_new_frame (read_register (FP_REGNUM),
               read_pc ()));
}

value
value_xmem (arg1)
     register value arg1;
{
  COERCE_ENUM (arg1);
  CORE_ADDR_ADDR(VALUE_ADDRESS(arg1))= *(unsigned long *)VALUE_CONTENTS(arg1);
  CORE_ADDR_MAP(VALUE_ADDRESS(arg1))=memory_map_x;
  return (arg1);
}
value
value_ymem (arg1)
     register value arg1;
{
  COERCE_ENUM (arg1);
  CORE_ADDR_ADDR(VALUE_ADDRESS(arg1))= *(unsigned long *)VALUE_CONTENTS(arg1);
  CORE_ADDR_MAP(VALUE_ADDRESS(arg1))=memory_map_y;
  return (arg1);
}
value
value_pmem (arg1)
     register value arg1;
{
  COERCE_ENUM (arg1);
  CORE_ADDR_ADDR(VALUE_ADDRESS(arg1))= *(unsigned long *)VALUE_CONTENTS(arg1);
  CORE_ADDR_MAP(VALUE_ADDRESS(arg1))=memory_map_p;
  return (arg1);
}
value
value_lmem (arg1)
     register value arg1;
{
  COERCE_ENUM (arg1);
  CORE_ADDR_ADDR(VALUE_ADDRESS(arg1))= *(unsigned long *)VALUE_CONTENTS(arg1);
  CORE_ADDR_MAP(VALUE_ADDRESS(arg1))=memory_map_l;
  return (arg1);
}
/* for right now these don't do whole thing */
LONGEST
add_longest(v1,v2)
  LONGEST v1,v2;
{
 v1.w0.l += v2.w0.l;
 return v1;
}

LONGEST
sub_longest(v1,v2)
  LONGEST v1,v2;
{
 v1.w0.l -= v2.w0.l;
 return v1;
}

LONGEST
mul_longest(v1,v2)
  LONGEST v1,v2;
{
 v1.w0.l *= v2.w0.l;
 return v1;
}

LONGEST
div_longest(v1,v2)
  LONGEST v1,v2;
{
 v1.w0.l /= v2.w0.l;
 return v1;
}

LONGEST
rem_longest(v1,v2)
  LONGEST v1,v2;
{
 v1.w0.l = v1.w0.l%v2.w0.l;
 return v1;   
}
 
static LONGEST
longest_minus_1;

LONGEST
lsh_longest(v1,v2)
  LONGEST v1,v2;
{
 v1.w0.l <<= v2.w0.l;
 return v1;
}

LONGEST
rsh_longest(v1,v2)
  LONGEST v1,v2;
{
 v1.w0.l >>= v2.w0.l;
 return v1;
}

LONGEST
logand_longest(v1,v2)
  LONGEST v1,v2;
{
 v1.w0.l &= v2.w0.l;
 return v1;
}
  
LONGEST
logior_longest(v1,v2) 
  LONGEST v1,v2; 
{ 
 v1.w0.l |= v2.w0.l; 
 return v1; 
}
 
LONGEST
logxor_longest(v1,v2) 
  LONGEST v1,v2; 
{ 
 v1.w0.l ^= v2.w0.l; 
 return v1; 
}

LONGEST
and_longest(v1,v2) 
  LONGEST v1,v2; 
{ 
 v1.w0.l = (v1.w0.l&&v2.w0.l)?1:0; 
 return v1; 
}

LONGEST
or_longest(v1,v2) 
  LONGEST v1,v2; 
{ 
 v1.w0.l = (v1.w0.l || v2.w0.l )?1:0; 
 return v1; 
}

LONGEST 
min_longest(v1,v2)  
  LONGEST v1,v2; 
{  
 /* returns (v1<v2)? v1:v2 */
 v1= (v1.w0.l<v2.w0.l)?v1:v2;
 return v1;  
}

LONGEST  
max_longest(v1,v2)   
  LONGEST v1,v2;  
{   
 v1= (v1.w0.l>=v2.w0.l)?v1:v2;
 return v1;   
}

static 
LONGEST
longest_one;

LONGEST
neg_longest(v1)
  LONGEST v1;
{
 v1.w0.l = -v1.w0.l;
 return v1;
}

LONGEST 
lognot_longest(v1) 
  LONGEST v1; 
{ 
 v1.w0.l = (~ v1.w0.l);
 return v1;
}


LONGEST
int_to_longest(i1)
  int i1;
{
  LONGEST rv;
  rv.w0.l = i1;
  rv.w1.l = 0;
  return rv;
}

LONGEST
char_to_longest(c1)
  char c1;
{
  LONGEST rv;
  rv.w0.l = c1;
  rv.w1.l = 0;
  return rv;
}

LONGEST
short_to_longest(s1)
  short s1;
{
  LONGEST rv;
  rv.w0.l = s1;
  rv.w1.l = 0;
  return rv;
}
  
LONGEST
long_to_longest(l1)
  unsigned long l1;
{
  LONGEST rv;
  rv.w0.l = l1;
  rv.w1.u = 0;
  return rv;
}

LONGEST
unsigned_long_to_longest(u1)
  unsigned long u1;
{
  LONGEST rv;
  rv.w0.u = u1;
  rv.w1.u = 0;
  return rv;
}

LONGEST
unsigned_char_to_longest(c1)
  unsigned char c1;
{
  LONGEST rv;
  rv.w0.u = c1;
  rv.w1.u = 0;
  return rv;
}

LONGEST
unsigned_short_to_longest(s1)
  unsigned short s1;
{
  LONGEST rv;
  rv.w0.u = s1;
  rv.w1.u = 0;
  return rv;
}

LONGEST
unsigned_int_to_longest(i1)
  unsigned int i1;
{
  LONGEST rv;
  rv.w0.u = i1;
  rv.w1.u = 0;
  return rv;
}

LONGEST
core_addr_to_long(i1)
  CORE_ADDR i1;
{
  LONGEST rv;
  rv.w0.u = i1.w0.u & ADDR_BITS;
  rv.w1.u = 0;
  return rv;
}

int
equal_longest(v1,v2)
  LONGEST v1,v2;
{
 
 return ((v1.w0.l&WORD_BITS) == (v2.w0.l&WORD_BITS))?1:0;
}

int
less_unsigned_longest(v1,v2)
  LONGEST v1,v2;
{
 int rv;
 rv= (v1.w0.u < v2.w0.u)?1:0;
return (rv);
}

int
less_longest(v1,v2)
  LONGEST v1,v2;
{
 int rv;
 rv= (v1.w0.l < v2.w0.l)?1:0;
 return (rv);
}

int
equal_double(v1,v2)
  double v1,v2; 
{ 
 return (v1 == v2)? 1:0; 
}

int
equal_ptr(v1,v2)
  LONGEST v1,v2; 
{ 
 return ((v1.w0.u&ADDR_BITS) == (v2.w0.u&ADDR_BITS) &&
         (v1.w1.mape == v2.w1.mape))? 1:0; 
}

int
less_ptr(v1,v2)
  LONGEST v1,v2; 
{ 
 return ((v1.w0.u&ADDR_BITS) < (v2.w0.u&ADDR_BITS))? 1:0; 
}

double
add_double(v1,v2) 
  double v1,v2;  
{  
 return (v1+ v2); 
}

double
sub_double(v1,v2) 
  double v1,v2;  
{  
 return (v1 - v2); 
}

double
mul_double(v1,v2)
  double v1,v2;
{
 return (v1 * v2);
}

double
div_double(v1,v2) 
  double v1,v2; 
{ 
 return (v1 / v2); 
} 

double
neg_double(v1) 
  double v1; 
{ 
 return ( - v1); 
}

int 
less_double(v1,v2)
  double v1,v2;
{
  return (v1 < v2)? 1 : 0 ;
} 


LONGEST
mul_unsigned_longest(v1,v2)
  LONGEST v1,v2;
{
 v1.w0.u *= v2.w0.u;
 return v1;
}

LONGEST
div_unsigned_longest(v1,v2)
  LONGEST v1,v2;
{
 v1.w0.u /= v2.w0.u;
 return v1;
}

LONGEST
rem_unsigned_longest(v1,v2)
  LONGEST v1,v2;
{
 v1.w0.u %= v2.w0.u;
 return v1;
}
 
LONGEST
rsh_unsigned_longest(v1,v2)
  LONGEST v1,v2;
{
 v1.w0.u >>= v2.w0.u;
 return v1;
}



LONGEST
unpack_field_as_longest(valaddr,bitpos,bitsize) 
  char *valaddr;
  int bitpos,bitsize;
{
 unsigned long vu[3]; 
 LONGEST v1,vmask;
 int wordoffset_start= bitpos/ (sizeof(long)*8);
 int bitoffset = bitpos% (SIZEOF_INT*8);
 int wordoffset_end= wordoffset_start+
     (((bitoffset+bitsize-1)/TARGET_WORD_NUM_BITS)*(SIZEOF_INT/sizeof(long)));
 int wordoffset_mid= ((wordoffset_end-wordoffset_start)>(SIZEOF_INT/sizeof(long)))?wordoffset_start+(SIZEOF_INT/sizeof(long)):wordoffset_end;
 vmask=longest_zero;

 vu[0] = *((( unsigned long *) valaddr)+wordoffset_start); 
 vu[1] = (wordoffset_mid>wordoffset_start)?
 *((( unsigned long *) valaddr)+wordoffset_mid):0;
 vu[2] = (wordoffset_end>wordoffset_mid)?
 *((( unsigned long *) valaddr)+wordoffset_end):0;

 while (bitoffset-- >0){
   vu[0] >>=1;
   if (vu[1] & 1)
      vu[0] |= SIGN_TEST_BIT;
   vu[1] >>=1;
   if (vu[2] & 1)
      vu[1] |= SIGN_TEST_BIT;
   vu[2] >>=1;
   }

 while (bitsize-- >0){
   vmask.w1.u<<=1;
   if (vmask.w0.u&SIGN_TEST_BIT) vmask.w1.u|=1;
   vmask.w0.u<<=1;
   vmask.w0.u|=1;
   }
 v1.w0.u = vu[0] & vmask.w0.u &  WORD_BITS;
 v1.w1.u = vu[1] & vmask.w1.u & WORD_BITS;
 return v1;
}

  
modify_field_longest(addr,fieldval,bitpos,bitsize) 
  char *addr;
  LONGEST fieldval;
  int bitpos,bitsize;
{
 unsigned long vf[3];
 unsigned long vm[3];

 int wordoffset_start= bitpos/ (sizeof(long)*8);
 int bitoffset = bitpos% (SIZEOF_INT*8);
 int wordoffset_end= wordoffset_start+
     (((bitoffset+bitsize-1)/TARGET_WORD_NUM_BITS)*(SIZEOF_INT/sizeof(long)));
 int wordoffset_mid= ((wordoffset_end-wordoffset_start)>(SIZEOF_INT/sizeof(long)))?wordoffset_start+(SIZEOF_INT/sizeof(long)):wordoffset_end;

 vm[2]=0;
 if (bitsize>TARGET_WORD_NUM_BITS){
   int upperbits= bitsize - TARGET_WORD_NUM_BITS;
   vm[0]=WORD_BITS;
   vm[1]=(1l << upperbits) - 1l;
   }
 else{
   vm[1]=0;
   vm[0]=(1l << bitsize) -1l;
   }

 vf[2]=0;
 vf[1]=fieldval.w1.u&vm[1];
 vf[0]=fieldval.w0.u&vm[0];

 while (bitoffset-- >0){
   vf[2]<<=1;
   if (vf[1]&SIGN_TEST_BIT) vf[2]|=1;
   vf[1]<<=1;
   if (vf[0]&SIGN_TEST_BIT) vf[1]|=1;
   vf[0]<<=1;
   vm[2]<<=1;
   if (vm[1]&SIGN_TEST_BIT) vm[2]|=1;
   vm[1]<<=1;
   if (vm[0]&SIGN_TEST_BIT) vm[1]|=1;
   vm[0]<<=1;
   }

  *((( unsigned long *) addr)+wordoffset_start)&= ~(vm[0]&WORD_BITS);
  *((( unsigned long *) addr)+wordoffset_start)|= vf[0]&WORD_BITS;
  if (wordoffset_mid>wordoffset_start){
   *((( unsigned long *) addr)+wordoffset_mid)&= ~(vm[1]&WORD_BITS);
   *((( unsigned long *) addr)+wordoffset_mid)|= vf[1]&WORD_BITS;
   if (wordoffset_end>wordoffset_mid){
    *((( unsigned long *) addr)+wordoffset_end)&= ~(vm[2]&WORD_BITS);
    *((( unsigned long *) addr)+wordoffset_end)|= vf[2]&WORD_BITS;
    }
   }
}  
 
  
LONGEST
min_unsigned_longest(v1,v2)
  LONGEST v1,v2;
{  
  if (v1.w0.u > v2.w0.u)
     v1 = v2; /* return value */
 return v1;
}
 
LONGEST
max_unsigned_longest(v1,v2)
  LONGEST v1,v2;
{ /* returns (v1>v2)?v1:v2 */
  if (v1.w0.u < v2.w0.u)
       v1 = v2; /* return value */
 return v1;
}
 
LONGEST
longest_to_target_int(v1)
  LONGEST v1;
{
 v1.w0.l = (v1.w0.l)&WORD_BITS;
 v1.w1.l = 0;
 return v1;
}

LONGEST
longest_to_target_unsigned_int(v1)
  LONGEST v1;
{
 v1.w0.l = (v1.w0.l)&WORD_BITS;
 v1.w1.l = 0;
 return v1;
}
 
LONGEST longest_to_target_long(v1)
LONGEST v1;
{
 v1.w0.u &=WORD_BITS;
 v1.w1.u = 0 ;
 return (v1);
}

LONGEST longest_to_target_pointer(v1)
LONGEST v1;
{
 v1.w0.u&= ADDR_BITS;
 return (v1);
}

do_registers_info(regnum)
  int regnum;
{
  register int i;
  int regsize;

  if (regnum == -1)
    printf_filtered (
      "Register       Contents (relative to selected stack frame)\n\n");

  for (i = 0; i < NUM_REGS; i++) 
    {
      unsigned char raw_buffer[MAX_REGISTER_RAW_SIZE];
      unsigned char virtual_buffer[MAX_REGISTER_VIRTUAL_SIZE];

      if (regnum != -1 && i != regnum)
   continue;

      /* Get the data in raw format, then convert also to virtual format.  */
      read_relative_register_raw_bytes (i, raw_buffer);
      REGISTER_CONVERT_TO_VIRTUAL (i, raw_buffer, virtual_buffer);

      fputs_filtered (reg_names[i], stdout);
      print_spaces_filtered (15 - strlen (reg_names[i]), stdout);
 
      /* If virtual format is floating, print it that way.  */
      if (TYPE_CODE (REGISTER_VIRTUAL_TYPE (i)) == TYPE_CODE_FLT
     && ! INVALID_FLOAT (virtual_buffer, REGISTER_VIRTUAL_SIZE (i)))
   val_print (REGISTER_VIRTUAL_TYPE (i), virtual_buffer, core_zero,
         stdout, 0, 1, 0, Val_pretty_default);
      /* Else if virtual format is too long for printf,
    print in hex a byte at a time.  */
      else if ((regsize=dsp_96k_reg_info[i].real_size) == 8)
   { /* only for long registers */
     LONGEST tl;
     bcopy (virtual_buffer, &tl, SIZEOF_LONG);
     printf_filtered ("0x%08x%08x",tl.w1.u,tl.w0.u);
   }
      /* Else print as integer in hex and in decimal.  */
      else
   {
     long lval;
 
     bcopy (virtual_buffer, &lval, sizeof (long));
     if (lval == 0)

    printf_filtered ("0");
     else
       printf_filtered ("0x%08x  %d", lval, lval);
   }

      /* If register has different raw and virtual formats,
    print the raw format in hex now.  */

      if (REGISTER_CONVERTIBLE (i))
   {
     register int j;

     printf_filtered ("  (raw 0x");
     for (j = 0; j < REGISTER_RAW_SIZE (i); j++)
       printf_filtered ("%02x", raw_buffer[j]);
     printf_filtered (")");
   }
      printf_filtered ("\n");
    }
}

static char retstringbuf[80];

char *
int_to_xstring(v1)
LONGEST v1;
{
 sprintf(retstringbuf,"0x%x",v1.w0.u&WORD_BITS); 
 return (retstringbuf);
}

char *
int_to_0xstring(v1)
LONGEST v1;
{
 sprintf(retstringbuf,"0x%08x",v1.w0.u&WORD_BITS); 
 return (retstringbuf);
}

char *
int_to_ostring(v1)
LONGEST v1;
{
 sprintf(retstringbuf,"0%o",v1.w0.u&WORD_BITS); 
 return (retstringbuf);
}

char *
long_to_ostring(v1)
LONGEST v1;
{
 sprintf(retstringbuf,"0%o",v1.w0.u); 
 return (retstringbuf);
}

char *
long_to_xstring(v1)
LONGEST v1;
{
 sprintf(retstringbuf,"0x%x",v1.w0.u); 
 return (retstringbuf);
}

char *
long_to_0xstring(v1)
LONGEST v1;
{
 sprintf(retstringbuf,"0x%08x",v1.w0.u);
 return (retstringbuf);
}

char *
int_to_ustring(v1)
LONGEST v1;
{
 sprintf(retstringbuf,"%u",v1.w0.u&WORD_BITS); 
 return (retstringbuf);
}

char *
int_to_dstring(v1)
LONGEST v1;
{
 sprintf(retstringbuf,"%d",v1.w0.l); 
 return (retstringbuf);
}

char *
long_to_dstring(v1)
LONGEST v1;
{
 sprintf(retstringbuf,"%d",v1.w0.l); 
 return (retstringbuf);
}

char *
long_to_ustring(v1)
LONGEST v1;
{
 sprintf(retstringbuf,"%u",v1.w0.u&WORD_BITS); 
 return (retstringbuf);
}

double
target_double_to_double(v1)
LONGEST v1;
{
double result;
union sev_dubl dbl;
if (LMAP){
    dbl.dul.lo=v1.w0.l;
    dbl.dul.hi=v1.w1.l;
    }
else{
    dbl.dul.lo=v1.w1.l;
    dbl.dul.hi=v1.w0.l;
    }

return (dbl.df);
}

  
LONGEST
double_to_target_double(dval)
double dval;
{
LONGEST rv;
union sev_dubl dbl;
dbl.df=dval;
if (LMAP){
    rv.w0.l=dbl.dul.lo;
    rv.w1.l=dbl.dul.hi;
    }
else{
    rv.w1.l=dbl.dul.lo;
    rv.w0.l=dbl.dul.hi;
    }

  return (rv);
}


double
target_float_to_double(v1)
LONGEST v1;
{
double result;
long dst[3];
union sev_dubl dbl;
m96k_sp_to_dep(&v1.w0.l,dst);
m96k_dep_to_dp(dst,&v1.w0.l);
if (LMAP){
    dbl.dul.lo=v1.w0.l;
    dbl.dul.hi=v1.w1.l;
    }
else{
    dbl.dul.lo=v1.w1.l;
    dbl.dul.hi=v1.w0.l;
    }
return (dbl.df);
}

  
LONGEST
double_to_target_float(dval)
double dval;
{
LONGEST rv;
long dst[3];
long src[2];
union sev_dubl dbl;
dbl.df=dval;
if (LMAP){
    src[0]=dbl.dul.lo;
    src[1]=dbl.dul.hi;
    }
else{
    src[1]=dbl.dul.lo;
    src[0]=dbl.dul.hi;
    }

m96k_dp_to_dep(src,dst);
m96k_dep_to_sp(dst,&rv.w0.l);
rv.w1.l=0;
  return (rv);
}

register_convert_to_virtual(regnum,from,to)
int regnum;
char *from,*to;
{
   long *fp,*tp,hi,lo;

   if ((!(LMAP))&&(REGISTER_VIRTUAL_TYPE(regnum)== builtin_type_double)){
       fp= (long *)from;
       tp= (long *)to;
       lo= *fp++;
       hi= *fp;
       *tp++ = hi;
       *tp++ = lo;
       }
    else
	bcopy(from,to,REGISTER_RAW_SIZE(regnum));
}

static
char default_dsp_device_number[]="96002";
extern
char *dsp_device_number;

_initialize_m96k()
{
int i;
CORE_ADDR_MAP(core_zero)= memory_map_p;
CORE_ADDR_MAP(frame_zero_init)= STACK_MAP;
CORE_ADDR_MAP(stack_end_addr)= STACK_MAP;
CORE_ADDR_MAP(stack_zero)= STACK_MAP;
stmap= (CORE_ADDR_MAP(stack_zero)==memory_map_x)?memory_map_x:memory_map_y;
longest_minus_1.w0.l=WORD_BITS;
longest_minus_1.w1.l=WORD_BITS;
longest_one.w0.l=1l;
init_reg_info();

init_host_io_structures ( );

dsp_startup();
if (!dsp_device_number)
    dsp_device_number= default_dsp_device_number;

if (!dsp_new(0,dsp_device_number))
    fatal ("unable to create device number:%s",dsp_device_number);

hspr=dv_var->periph[0].regval;
for (i=0;i<NUM_REGS;i++)
 if(dsp_96k_reg_info[i].regname)
  dsp_findreg(0,dsp_96k_reg_info[i].regname,&dsp_96k_reg_info[i].periph,&dsp_96k_reg_info[i].regnum);

}






